/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return pattern5 (x3); /* [-1, 9] */

    case PLUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern6 (x3, 
E_V2DImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern7 (x3, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern8 (x3, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16QImode:
          if (pattern9 (x3, 
E_V16QImode) != 0)
            return -1;
          return 13;

        case E_V4DImode:
          if (pattern6 (x3, 
E_V4DImode) != 0)
            return -1;
          return 14;

        case E_V8SImode:
          if (pattern7 (x3, 
E_V8SImode) != 0)
            return -1;
          return 15;

        case E_V16HImode:
          if (pattern8 (x3, 
E_V16HImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern9 (x3, 
E_V32QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !const_uimm3_operand (operands[2], E_VOIDmode))
                return -1;
              return 0;

            case E_QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !const_uimm4_operand (operands[2], E_VOIDmode))
                return -1;
              return 1;

            case E_SImode:
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !const_0_to_3_operand (operands[2], E_VOIDmode))
                    return -1;
                  return 2;

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !const_0_to_7_operand (operands[2], E_VOIDmode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern36 (x1, 
E_V4SFmode, 
E_SFmode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern36 (x1, 
E_V4DImode, 
E_DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 8LL:
          if (XWINT (x6, 0) != 9LL
              || XWINT (x7, 0) != 10LL
              || XWINT (x8, 0) != 11LL
              || pattern38 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL
              || XWINT (x9, 0) != 4LL
              || XWINT (x10, 0) != 5LL
              || XWINT (x11, 0) != 6LL
              || XWINT (x12, 0) != 7LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern37 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
                return -1;
              return 7;

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x1) != E_V8SImode)
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V16HImode))
                    return -1;
                  return 8;

                case E_V8QImode:
                  if (!register_operand (operands[1], E_V32QImode))
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4LL:
          if (XWINT (x6, 0) != 5LL
              || XWINT (x7, 0) != 6LL
              || XWINT (x8, 0) != 7LL
              || pattern38 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 4LL:
          if (XWINT (x6, 0) != 5LL
              || pattern39 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern37 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                return -1;
              return 12;

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x1) != E_V4DImode)
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  return 13;

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V16HImode))
                    return -1;
                  return 14;

                case E_V4QImode:
                  if (!register_operand (operands[1], E_V32QImode))
                    return -1;
                  return 15;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2LL:
          if (XWINT (x6, 0) != 3LL
              || pattern39 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 16;

        default:
          return -1;
        }

    case 2:
      res = pattern41 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case 16:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x19) != CONST_INT)
        return -1;
      x20 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x20) != CONST_INT
          || !register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL
              || XWINT (x9, 0) != 4LL
              || XWINT (x10, 0) != 5LL
              || XWINT (x11, 0) != 6LL
              || XWINT (x12, 0) != 7LL
              || XWINT (x13, 0) != 8LL
              || XWINT (x14, 0) != 9LL
              || XWINT (x15, 0) != 10LL
              || XWINT (x16, 0) != 11LL
              || XWINT (x17, 0) != 12LL
              || XWINT (x18, 0) != 13LL
              || XWINT (x19, 0) != 14LL
              || XWINT (x20, 0) != 15LL)
            return -1;
          return 19;

        case 8LL:
          if (XWINT (x6, 0) != 9LL
              || XWINT (x7, 0) != 10LL
              || XWINT (x8, 0) != 11LL
              || XWINT (x9, 0) != 12LL
              || XWINT (x10, 0) != 13LL
              || XWINT (x11, 0) != 14LL
              || XWINT (x12, 0) != 15LL
              || XWINT (x13, 0) != 24LL
              || XWINT (x14, 0) != 25LL
              || XWINT (x15, 0) != 26LL
              || XWINT (x16, 0) != 27LL
              || XWINT (x17, 0) != 28LL
              || XWINT (x18, 0) != 29LL
              || XWINT (x19, 0) != 30LL
              || XWINT (x20, 0) != 31LL)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aq12d_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern191 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern200 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1)
      || !scratch_operand (operands[8], i1))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 561; /* lsx_vfrint_d */

    case 1:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 566; /* lsx_vfrint_s */

    case 2:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 571; /* lasx_xvfrint_d */

    case 3:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 576; /* lasx_xvfrint_s */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern139 (x3, 
E_V2DImode) != 0
          || !
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1263; /* lsx_vreplvei_mirror_d */

    case E_V4SImode:
      if (pattern140 (x3, 
E_V4SImode) != 0
          || !
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1264; /* lsx_vreplvei_mirror_w */

    case E_V8HImode:
      if (pattern66 (x3, 
E_V8HImode) != 0
          || !
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1265; /* lsx_vreplvei_mirror_h */

    case E_V16QImode:
      if (pattern65 (x3, 
E_V16QImode) != 0
          || !
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1266; /* lsx_vreplvei_mirror_b */

    case E_V2DFmode:
      if (pattern139 (x3, 
E_V2DFmode) != 0
          || !
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1267; /* lsx_vreplvei_mirror_d_f */

    case E_V4SFmode:
      if (pattern140 (x3, 
E_V4SFmode) != 0
          || !
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1268; /* lsx_vreplvei_mirror_w_f */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1386; /* lsx_vbsll_d */

    case 1:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1387; /* lsx_vbsll_w */

    case 2:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1388; /* lsx_vbsll_h */

    case 3:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1389; /* lsx_vbsll_b */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2000; /* lasx_xvbsll_d */

    case 1:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2001; /* lasx_xvbsll_w */

    case 2:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2002; /* lasx_xvbsll_h */

    case 3:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2003; /* lasx_xvbsll_b */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1713; /* lasx_xvbitset_d */

    case 1:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1714; /* lasx_xvbitset_w */

    case 2:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1715; /* lasx_xvbitset_h */

    case 3:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1716; /* lasx_xvbitset_b */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1398; /* lsx_vsigncov_d */

    case 1:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1399; /* lsx_vsigncov_w */

    case 2:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1400; /* lsx_vsigncov_h */

    case 3:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1401; /* lsx_vsigncov_b */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1096; /* lsx_vbitrev_d */

    case 1:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1097; /* lsx_vbitrev_w */

    case 2:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1098; /* lsx_vbitrev_h */

    case 3:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1099; /* lsx_vbitrev_b */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1558; /* lasx_vecinit_merge_v4di */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1559; /* lasx_vecinit_merge_v8si */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1560; /* lasx_vecinit_merge_v16hi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1561; /* lasx_vecinit_merge_v32qi */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1562; /* lasx_vecinit_merge_v4df */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1563; /* lasx_vecinit_merge_v8sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 4);
  if (!const_4_to_7_operand (x7, E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && pattern207 (x5) == 0
          && 
#line 2007 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return 1847; /* lasx_xvshuf4i_w_1 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      operands[3] = x7;
      x8 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x5, 0, 2);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (!rtx_equal_p (x13, operands[3])
          || !
#line 2142 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 4)))
        return -1;
      return 1879; /* lasx_xvrepl128vei_w_internal */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || pattern207 (x5) != 0
          || !
#line 2007 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return -1;
      return 1848; /* lasx_xvshuf4i_w_f_1 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 0);
  switch (XWINT (x10, 0))
    {
    case 0LL:
      x11 = XVECEXP (x3, 0, 1);
      switch (XWINT (x11, 0))
        {
        case 8LL:
          switch (XWINT (x4, 0))
            {
            case 2LL:
              if (XWINT (x5, 0) != 10LL
                  || XWINT (x6, 0) != 4LL
                  || XWINT (x7, 0) != 12LL
                  || XWINT (x8, 0) != 6LL
                  || XWINT (x9, 0) != 14LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 1315 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1172; /* lsx_vpackev_h */

                case E_V8SImode:
                  if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                      || !
#line 1454 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1777; /* lasx_xvpackev_w */

                case E_V8SFmode:
                  if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                      || !
#line 1469 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1778; /* lasx_xvpackev_w_f */

                default:
                  return -1;
                }

            case 1LL:
              if (XWINT (x5, 0) != 9LL)
                return -1;
              switch (XWINT (x6, 0))
                {
                case 2LL:
                  if (XWINT (x7, 0) != 10LL
                      || XWINT (x8, 0) != 3LL
                      || XWINT (x9, 0) != 11LL
                      || pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 1498 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1186; /* lsx_vilvl_h */

                case 4LL:
                  if (XWINT (x7, 0) != 12LL
                      || XWINT (x8, 0) != 5LL
                      || XWINT (x9, 0) != 13LL)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SImode:
                      if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                          || !
#line 1687 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                        return -1;
                      return 1791; /* lasx_xvilvl_w */

                    case E_V8SFmode:
                      if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                          || !
#line 1702 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                        return -1;
                      return 1792; /* lasx_xvilvl_w_f */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2LL:
          if (XWINT (x4, 0) != 8LL
              || XWINT (x5, 0) != 10LL
              || XWINT (x6, 0) != 4LL
              || XWINT (x7, 0) != 6LL
              || XWINT (x8, 0) != 12LL
              || XWINT (x9, 0) != 14LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SImode:
              if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                  || !
#line 1860 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1825; /* lasx_xvpickev_w */

            case E_V8SFmode:
              if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !
#line 1875 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1826; /* lasx_xvpickev_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4LL:
      x11 = XVECEXP (x3, 0, 1);
      if (XWINT (x11, 0) != 12LL
          || XWINT (x4, 0) != 5LL
          || XWINT (x5, 0) != 13LL
          || pattern216 (x3) != 0
          || pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1176; /* lsx_vilvh_h */

    case 1LL:
      if (XWINT (x5, 0) != 11LL
          || XWINT (x6, 0) != 5LL
          || XWINT (x9, 0) != 15LL)
        return -1;
      x11 = XVECEXP (x3, 0, 1);
      switch (XWINT (x11, 0))
        {
        case 9LL:
          if (XWINT (x4, 0) != 3LL
              || XWINT (x7, 0) != 13LL
              || XWINT (x8, 0) != 7LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 1438 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1182; /* lsx_vpackod_h */

            case E_V8SImode:
              if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                  || !
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1787; /* lasx_xvpackod_w */

            case E_V8SFmode:
              if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !
#line 1626 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1788; /* lasx_xvpackod_w_f */

            default:
              return -1;
            }

        case 3LL:
          if (XWINT (x4, 0) != 9LL
              || XWINT (x7, 0) != 7LL
              || XWINT (x8, 0) != 13LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SImode:
              if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                  || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1829; /* lasx_xvpickod_w */

            case E_V8SFmode:
              if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1830; /* lasx_xvpickod_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2LL:
      x11 = XVECEXP (x3, 0, 1);
      if (XWINT (x11, 0) != 10LL
          || XWINT (x4, 0) != 3LL
          || XWINT (x5, 0) != 11LL
          || pattern216 (x3) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1781; /* lasx_xvilvh_w */

        case E_V8SFmode:
          if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1782; /* lasx_xvilvh_w_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2; /* addsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 3; /* adddf3 */

        case E_SImode:
          if (pattern123 (x3) != 0)
            return -1;
          return 4; /* *addsi3 */

        case E_DImode:
          if (pattern124 (x3) != 0
              || !
#line 769 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 5; /* adddi3 */

        case E_V2DImode:
          if (pattern125 (x3, 
E_V2DImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 968; /* addv2di3 */

        case E_V4SImode:
          if (pattern125 (x3, 
E_V4SImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 969; /* addv4si3 */

        case E_V8HImode:
          if (pattern125 (x3, 
E_V8HImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 970; /* addv8hi3 */

        case E_V16QImode:
          if (pattern125 (x3, 
E_V16QImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 971; /* addv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 795 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1038; /* addv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 795 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1039; /* addv4sf3 */

        case E_V4DImode:
          if (pattern125 (x3, 
E_V4DImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1570; /* addv4di3 */

        case E_V8SImode:
          if (pattern125 (x3, 
E_V8SImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1571; /* addv8si3 */

        case E_V16HImode:
          if (pattern125 (x3, 
E_V16HImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1572; /* addv16hi3 */

        case E_V32QImode:
          if (pattern125 (x3, 
E_V32QImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1573; /* addv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1640; /* addv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1641; /* addv8sf3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern22 (x3))
        {
        case 0:
          if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)))
            return -1;
          return 107; /* *bstrins_si_for_ior_mask */

        case 1:
          if (!(
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 110; /* *bstrins_di_for_ior_mask */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      if (const_immalsl_operand (operands[2], E_VOIDmode))
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern175 (x3, 
E_SImode) == 0)
                return 254; /* alslsi3 */
              break;

            case E_DImode:
              if (pattern175 (x3, 
E_DImode) == 0
                  && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return 255; /* alsldi3 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 425; /* *bytepick_d_1_rev */

        case 1:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 426; /* *bytepick_d_2_rev */

        case 2:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 427; /* *bytepick_d_3_rev */

        case 3:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 428; /* *bytepick_d_4_rev */

        case 4:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 429; /* *bytepick_d_5_rev */

        case 5:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 430; /* *bytepick_d_6_rev */

        case 6:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 431; /* *bytepick_d_7_rev */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern25 (x3))
        {
        case 0:
          return 384; /* *bytepick_w_1 */

        case 1:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 408; /* *bytepick_d_5 */

        case 2:
          return 385; /* *bytepick_w_2 */

        case 3:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 409; /* *bytepick_d_6 */

        case 4:
          return 386; /* *bytepick_w_3 */

        case 5:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 410; /* *bytepick_d_7 */

        case 6:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 404; /* *bytepick_d_1 */

        case 7:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 405; /* *bytepick_d_2 */

        case 8:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 406; /* *bytepick_d_3 */

        case 9:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 407; /* *bytepick_d_4 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern28 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 791; /* simd_addw_evod_v2di_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V2DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 863; /* simd_haddw_v2di_s */

        case 1:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 797; /* simd_addw_evod_v4si_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 867; /* simd_haddw_v4si_s */

        case 2:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 803; /* simd_addw_evod_v8hi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 871; /* simd_haddw_v8hi_s */

        case 3:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 809; /* simd_addw_evod_v16qi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 875; /* simd_haddw_v16qi_s */

        case 4:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 815; /* simd_addw_evod_v4di_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 879; /* simd_haddw_v4di_s */

        case 5:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 821; /* simd_addw_evod_v8si_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 883; /* simd_haddw_v8si_s */

        case 6:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 827; /* simd_addw_evod_v16hi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 887; /* simd_haddw_v16hi_s */

        case 7:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 833; /* simd_addw_evod_v32qi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V32QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 891; /* simd_haddw_v32qi_s */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 794; /* simd_addw_evod_v2di_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V2DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 864; /* simd_haddw_v2di_u */

        case 1:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 800; /* simd_addw_evod_v4si_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 868; /* simd_haddw_v4si_u */

        case 2:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 806; /* simd_addw_evod_v8hi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 872; /* simd_haddw_v8hi_u */

        case 3:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 812; /* simd_addw_evod_v16qi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 876; /* simd_haddw_v16qi_u */

        case 4:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 818; /* simd_addw_evod_v4di_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 880; /* simd_haddw_v4di_u */

        case 5:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 824; /* simd_addw_evod_v8si_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 884; /* simd_haddw_v8si_u */

        case 6:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 830; /* simd_addw_evod_v16hi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 888; /* simd_haddw_v16hi_u */

        case 7:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 836; /* simd_addw_evod_v32qi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V32QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 892; /* simd_haddw_v32qi_u */

        case 8:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 839; /* simd_addw_evod_v2di_hetero */

        case 9:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 842; /* simd_addw_evod_v4si_hetero */

        case 10:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 845; /* simd_addw_evod_v8hi_hetero */

        case 11:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 848; /* simd_addw_evod_v16qi_hetero */

        case 12:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 851; /* simd_addw_evod_v4di_hetero */

        case 13:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 854; /* simd_addw_evod_v8si_hetero */

        case 14:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 857; /* simd_addw_evod_v16hi_hetero */

        case 15:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 860; /* simd_addw_evod_v32qi_hetero */

        default:
          return -1;
        }

    case MULT:
      return recog_1 (x1, insn, pnum_clobbers);

    case ABS:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ABS)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern23 (x3, 
E_V2DImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1052; /* lsx_vadda_d */

        case E_V4SImode:
          if (pattern23 (x3, 
E_V4SImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1053; /* lsx_vadda_w */

        case E_V8HImode:
          if (pattern23 (x3, 
E_V8HImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1054; /* lsx_vadda_h */

        case E_V16QImode:
          if (pattern23 (x3, 
E_V16QImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1055; /* lsx_vadda_b */

        case E_V4DImode:
          if (pattern23 (x3, 
E_V4DImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1654; /* lasx_xvadda_d */

        case E_V8SImode:
          if (pattern23 (x3, 
E_V8SImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1655; /* lasx_xvadda_w */

        case E_V16HImode:
          if (pattern23 (x3, 
E_V16HImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1656; /* lasx_xvadda_h */

        case E_V32QImode:
          if (pattern23 (x3, 
E_V32QImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1657; /* lasx_xvadda_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern164 (x3, 
E_SFmode) != 0
                  || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 45; /* fmasf4 */

            case E_DFmode:
              if (pattern164 (x3, 
E_DFmode) != 0
                  || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 46; /* fmadf4 */

            case E_V2DFmode:
              if (pattern164 (x3, 
E_V2DFmode) != 0
                  || !
#line 850 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1046; /* fmav2df4 */

            case E_V4SFmode:
              if (pattern164 (x3, 
E_V4SFmode) != 0
                  || !
#line 850 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1047; /* fmav4sf4 */

            case E_V4DFmode:
              if (pattern164 (x3, 
E_V4DFmode) != 0
                  || !
#line 991 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1648; /* fmav4df4 */

            case E_V8SFmode:
              if (pattern164 (x3, 
E_V8SFmode) != 0
                  || !
#line 991 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1649; /* fmav8sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern165 (x3, 
E_SFmode) != 0
                  || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 47; /* fmssf4 */

            case E_DFmode:
              if (pattern165 (x3, 
E_DFmode) != 0
                  || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 48; /* fmsdf4 */

            case E_V2DFmode:
              if (pattern165 (x3, 
E_V2DFmode) != 0
                  || !
#line 2376 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1406; /* fmsv2df4 */

            case E_V4SFmode:
              if (pattern165 (x3, 
E_V4SFmode) != 0
                  || !
#line 2376 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1407; /* fmsv4sf4 */

            case E_V4DFmode:
              if (pattern165 (x3, 
E_V4DFmode) != 0
                  || !
#line 2786 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2020; /* fmsv4df4 */

            case E_V8SFmode:
              if (pattern165 (x3, 
E_V8SFmode) != 0
                  || !
#line 2786 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2021; /* fmsv8sf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern166 (x3, 
E_SFmode) != 0
                  || !(
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 49; /* fnmasf4 */

            case E_DFmode:
              if (pattern166 (x3, 
E_DFmode) != 0
                  || !(
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 50; /* fnmadf4 */

            case E_V2DFmode:
              if (pattern166 (x3, 
E_V2DFmode) != 0
                  || !
#line 860 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1048; /* fnmav2df4 */

            case E_V4SFmode:
              if (pattern166 (x3, 
E_V4SFmode) != 0
                  || !
#line 860 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1049; /* fnmav4sf4 */

            case E_V4DFmode:
              if (pattern166 (x3, 
E_V4DFmode) != 0
                  || !
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1650; /* fnmav4df4 */

            case E_V8SFmode:
              if (pattern166 (x3, 
E_V8SFmode) != 0
                  || !
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1651; /* fnmav8sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern167 (x3, 
E_SFmode) != 0
                  || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 51; /* fnmssf4 */

            case E_DFmode:
              if (pattern167 (x3, 
E_DFmode) != 0
                  || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 52; /* fnmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern5 (x3))
    {
    case 0:
      return 242; /* *ashlsi3 */

    case 1:
      if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 245; /* *ashldi3 */

    case 2:
      if (const_uimm6_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 627; /* ashlv2di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V2DImode)
          || !
#line 771 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1034; /* vashlv2di3 */

    case 3:
      if (const_uimm5_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 631; /* ashlv4si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4SImode)
          || !
#line 771 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1035; /* vashlv4si3 */

    case 4:
      if (const_uimm4_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 635; /* ashlv8hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8HImode)
          || !
#line 771 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1036; /* vashlv8hi3 */

    case 5:
      if (const_uimm3_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 639; /* ashlv16qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16QImode)
          || !
#line 771 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1037; /* vashlv16qi3 */

    case 6:
      if (const_uimm6_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 643; /* ashlv4di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4DImode)
          || !
#line 912 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1636; /* vashlv4di3 */

    case 7:
      if (const_uimm5_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 647; /* ashlv8si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8SImode)
          || !
#line 912 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1637; /* vashlv8si3 */

    case 8:
      if (const_uimm4_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 651; /* ashlv16hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16HImode)
          || !
#line 912 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1638; /* vashlv16hi3 */

    case 9:
      if (const_uimm3_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 655; /* ashlv32qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V32QImode)
          || !
#line 912 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1639; /* vashlv32qi3 */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      switch (GET_CODE (x3))
        {
        case NE:
          res = recog_72 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case EQ:
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x3;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (register_operand (operands[2], E_FCCmode))
        {
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      if (
#line 3293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                        return 275; /* *branch_fp_FCCmode */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      if (
#line 3309 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                        return 276; /* *branch_fp_inverted_FCCmode */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      switch (pattern148 (x2))
        {
        case 0:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 281; /* branch_equalitysi */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 282; /* branch_equalitydi */

        case 2:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 283; /* *branch_equalitysi_inverted */

        case 3:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 284; /* *branch_equalitydi_inverted */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) == ABS)
        {
          res = recog_74 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!order_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      switch (pattern148 (x2))
        {
        case 0:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 277; /* *branch_ordersi */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 278; /* *branch_orderdi */

        case 2:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 279; /* *branch_ordersi_inverted */

        case 3:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 280; /* *branch_orderdi_inverted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern123 (x3) != 0
                  || !
#line 722 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[2]) && !IMM12_INT (operands[2])    && !ADDU16I_OPERAND (INTVAL (operands[2]))))
                return NULL;
              return gen_split_1 (insn, operands);

            case E_DImode:
              if (pattern124 (x3) != 0
                  || !(
#line 769 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( CONST_INT_P (operands[2]) && !IMM12_INT (operands[2])    && !ADDU16I_OPERAND (INTVAL (operands[2])))))
                return NULL;
              return gen_split_2 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern22 (x3))
            {
            case 0:
              if (!(
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_6 (insn, operands);

            case 1:
              if (!((
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_9 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (register_operand (operands[1], E_SImode))
        {
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (plus_si_extend_operand (operands[2], E_SImode)
              && 
#line 801 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[2]) && !IMM12_INT (operands[2])))
            return gen_split_3 (insn, operands);
        }
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 0);
      if (GET_MODE (x8) != E_DImode)
        return NULL;
      x7 = XEXP (x4, 1);
      operands[4] = x7;
      if (!register_operand (operands[4], E_SImode))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          if (pattern212 (x8) != 0
              || !(
#line 3175 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)) && 
#line 3179 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( reload_completed)))
            return NULL;
          return gen_split_22 (insn, operands);

        case IOR:
          if (pattern212 (x8) != 0
              || !(
#line 3175 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 3179 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( reload_completed)))
            return NULL;
          return gen_split_23 (insn, operands);

        case XOR:
          if (pattern212 (x8) != 0
              || !(
#line 3175 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 3179 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( reload_completed)))
            return NULL;
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          switch (pattern22 (x3))
            {
            case 0:
              if (!(
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_4 (insn, operands);

            case 1:
              if (!((
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_7 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern90 (x3))
            {
            case 0:
              if (!((
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 3141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_17 (insn, operands);

            case 1:
              if (!((
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 3141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          switch (pattern22 (x3))
            {
            case 0:
              if (!(
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_5 (insn, operands);

            case 1:
              if (!((
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern90 (x3))
            {
            case 0:
              if (!((
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 3141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (!((
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 3141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_21 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 1772 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( reload_completed
   && MEM_P (operands[1])
   && (loongarch_14bit_shifted_offset_address_p (XEXP (operands[1], 0), SImode)
       && !loongarch_12bit_offset_address_p (XEXP (operands[1], 0), SImode))
   && !paradoxical_subreg_p (operands[0]))))
        return NULL;
      return gen_split_10 (insn, operands);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !move_operand (operands[1], E_DImode)
              || !
#line 2198 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[1]) && REG_P (operands[0]) && GP_REG_P (REGNO
  (operands[0]))))
            return NULL;
          return gen_split_11 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !move_operand (operands[1], E_SImode)
              || !
#line 2306 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[1]) && REG_P (operands[0]) && GP_REG_P (REGNO
  (operands[0]))))
            return NULL;
          return gen_split_14 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !move_operand (operands[1], E_HImode)
              || !
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[1]) && REG_P (operands[0]) && GP_REG_P (REGNO
  (operands[0]))))
            return NULL;
          return gen_split_15 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ASHIFT)
        return NULL;
      switch (pattern90 (x3))
        {
        case 0:
          if (!((
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 3141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
            return NULL;
          return gen_split_16 (insn, operands);

        case 1:
          if (!((
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 3141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
            return NULL;
          return gen_split_19 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
