/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 14;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 15;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 16;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 17;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 18;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 19;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 20;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 21;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 22;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 23;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 24;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 25;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 26;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 27;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 28;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 29;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 30;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 31;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 32;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 33;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 34;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 35;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 36;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 37;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 38;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 39;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 40;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 41;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 42;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 43;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 44;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 45;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 46;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern192 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern192 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern192 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern192 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern192 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern192 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern192 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern192 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern192 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern192 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern192 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern192 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern192 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern192 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern192 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern192 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern192 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern192 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern192 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern192 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern192 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern192 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern192 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern192 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern192 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern192 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern192 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern192 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern192 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern192 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern192 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern192 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern192 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern192 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern192 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern192 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern192 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern192 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern192 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern192 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern192 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern192 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern192 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern192 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern192 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern192 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern192 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern192 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern192 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern192 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern192 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern192 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern192 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern192 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern192 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern192 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern192 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern192 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern192 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern192 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern192 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern192 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern192 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern192 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern192 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern192 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern192 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern192 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern192 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern192 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern192 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern192 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern192 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern192 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern192 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern192 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern192 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern192 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern192 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern192 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern192 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern192 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern192 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern192 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern192 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern192 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern192 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern192 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern192 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern192 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern192 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern192 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern192 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern192 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern192 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern192 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern192 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern192 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern192 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern192 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern192 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern192 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern192 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern192 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern192 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern192 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern192 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern192 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern192 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern192 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern192 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern192 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern192 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern192 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern192 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern192 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern192 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern192 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern192 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern192 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern192 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern192 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern168 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern168 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern168 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern168 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern168 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern168 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern168 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern168 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern168 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern168 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern168 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern168 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern168 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern168 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern168 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern168 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern168 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern168 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern168 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern168 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern168 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern168 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern168 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern168 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern168 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern168 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern168 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern168 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern168 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern168 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern168 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern168 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern168 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern168 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern168 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern168 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern168 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern168 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern168 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern168 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern168 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern168 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern168 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern168 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern168 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern168 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern168 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern168 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_all_trues_mask_operand (operands[3], i2)
      || !vector_const_0_operand (operands[5], i1)
      || !vector_merge_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vector_all_trues_mask_operand (operands[4], i1)
      || !vector_const_0_operand (operands[9], i2)
      || !vector_merge_operand (operands[10], i2)
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x1, 2);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          return pattern248 (x2, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
            return -1;
          return 5;

        case E_V1HImode:
          if (pattern248 (x2, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
            return -1;
          return 6;

        case E_V2HImode:
          if (pattern248 (x2, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
            return -1;
          return 7;

        case E_V4HImode:
          if (pattern248 (x2, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
            return -1;
          return 8;

        case E_V8HImode:
          if (pattern248 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V16HImode:
          if (pattern248 (x2, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
            return -1;
          return 10;

        case E_V32HImode:
          if (pattern248 (x2, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
            return -1;
          return 11;

        case E_V64HImode:
          if (pattern248 (x2, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
            return -1;
          return 12;

        case E_V128HImode:
          if (pattern248 (x2, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
            return -1;
          return 13;

        case E_V256HImode:
          if (pattern248 (x2, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
            return -1;
          return 14;

        case E_V512HImode:
          if (pattern248 (x2, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
            return -1;
          return 15;

        case E_V1024HImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
            return -1;
          return 16;

        case E_V2048HImode:
          if (pattern248 (x2, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 22;

        case E_V1SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V1BImode
              || GET_MODE (x3) != E_V1SImode
              || GET_MODE (x4) != E_V1SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V1SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V1BImode
              || !vector_all_trues_mask_operand (operands[4], E_V1BImode)
              || !vector_const_0_operand (operands[9], E_V1SImode)
              || !vector_merge_operand (operands[10], E_V1SImode)
              || !register_operand (operands[1], E_V1BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V1SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V1BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V1HImode:
              if (!register_operand (operands[3], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[3], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V2BImode
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V2SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V2BImode
              || !vector_all_trues_mask_operand (operands[4], E_V2BImode)
              || !vector_const_0_operand (operands[9], E_V2SImode)
              || !vector_merge_operand (operands[10], E_V2SImode)
              || !register_operand (operands[1], E_V2BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V2SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2HImode:
              if (!register_operand (operands[3], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V4BImode
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V4BImode
              || !vector_all_trues_mask_operand (operands[4], E_V4BImode)
              || !vector_const_0_operand (operands[9], E_V4SImode)
              || !vector_merge_operand (operands[10], E_V4SImode)
              || !register_operand (operands[1], E_V4BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V8BImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V8SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V8BImode
              || !vector_all_trues_mask_operand (operands[4], E_V8BImode)
              || !vector_const_0_operand (operands[9], E_V8SImode)
              || !vector_merge_operand (operands[10], E_V8SImode)
              || !register_operand (operands[1], E_V8BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V8SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[3], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V16BImode
              || GET_MODE (x3) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V16SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V16BImode
              || !vector_all_trues_mask_operand (operands[4], E_V16BImode)
              || !vector_const_0_operand (operands[9], E_V16SImode)
              || !vector_merge_operand (operands[10], E_V16SImode)
              || !register_operand (operands[1], E_V16BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V16SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V16BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V16HImode:
              if (!register_operand (operands[3], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[3], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V32BImode
              || GET_MODE (x3) != E_V32SImode
              || GET_MODE (x4) != E_V32SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V32SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V32BImode
              || !vector_all_trues_mask_operand (operands[4], E_V32BImode)
              || !vector_const_0_operand (operands[9], E_V32SImode)
              || !vector_merge_operand (operands[10], E_V32SImode)
              || !register_operand (operands[1], E_V32BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V32SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V32BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V32HImode:
              if (!register_operand (operands[3], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[3], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V64BImode
              || GET_MODE (x3) != E_V64SImode
              || GET_MODE (x4) != E_V64SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V64SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V64BImode
              || !vector_all_trues_mask_operand (operands[4], E_V64BImode)
              || !vector_const_0_operand (operands[9], E_V64SImode)
              || !vector_merge_operand (operands[10], E_V64SImode)
              || !register_operand (operands[1], E_V64BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V64SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V64BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V64HImode:
              if (!register_operand (operands[3], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[3], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V128BImode
              || GET_MODE (x3) != E_V128SImode
              || GET_MODE (x4) != E_V128SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V128SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V128BImode
              || !vector_all_trues_mask_operand (operands[4], E_V128BImode)
              || !vector_const_0_operand (operands[9], E_V128SImode)
              || !vector_merge_operand (operands[10], E_V128SImode)
              || !register_operand (operands[1], E_V128BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V128SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V128BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V128HImode:
              if (!register_operand (operands[3], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[3], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V256BImode
              || GET_MODE (x3) != E_V256SImode
              || GET_MODE (x4) != E_V256SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V256SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V256BImode
              || !vector_all_trues_mask_operand (operands[4], E_V256BImode)
              || !vector_const_0_operand (operands[9], E_V256SImode)
              || !vector_merge_operand (operands[10], E_V256SImode)
              || !register_operand (operands[1], E_V256BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V256SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V256BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V256HImode:
              if (!register_operand (operands[3], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[3], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V512BImode
              || GET_MODE (x3) != E_V512SImode
              || GET_MODE (x4) != E_V512SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V512SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V512BImode
              || !vector_all_trues_mask_operand (operands[4], E_V512BImode)
              || !vector_const_0_operand (operands[9], E_V512SImode)
              || !vector_merge_operand (operands[10], E_V512SImode)
              || !register_operand (operands[1], E_V512BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V512SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V512BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V512HImode:
              if (!register_operand (operands[3], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[3], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1SImode)
      || GET_MODE (x1) != E_RVVM1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 0;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 0;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern339 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !fp_native_comparison (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[2], E_HFmode)
          || !register_operand (operands[3], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XEXP (x8, 0);
  return pattern341 (x13); /* [-1, 3] */
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern350 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern350 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern362 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern362 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern362 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern362 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern362 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern362 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern362 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != AND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != NOT
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x11 = XEXP (x7, 1);
  operands[2] = x11;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x9, 0);
  operands[3] = x12;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i2
      || XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_two_s12 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != AND
      || GET_MODE (x9) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x10 = XEXP (x9, 1);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x14 = XEXP (x9, 0);
  return pattern378 (x14); /* [-1, 1] */
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return 0;
}

int
pattern397 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  return pattern227 (x2); /* [-1, 1] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern414 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 4;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 7;

    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      return 8;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 9;

    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      return 10;

    case E_V128DImode:
      if (!register_operand (operands[1], E_V128DImode))
        return -1;
      return 11;

    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 12;

    case E_V512DImode:
      if (!register_operand (operands[1], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern464 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern475 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern475 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern475 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern475 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern475 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern475 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern475 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern475 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern475 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern475 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern475 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern475 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern475 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern475 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern504 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern504 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern504 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern504 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern504 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern504 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern504 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern504 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern504 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern504 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern504 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern504 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern504 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern504 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern504 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern504 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern504 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern504 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern578 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern592 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern597 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !reg_or_0_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern603 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern603 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern603 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern603 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern603 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern603 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern603 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern603 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern603 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern603 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern603 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern603 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern603 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern603 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern603 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern603 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern603 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern603 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern603 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern603 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern603 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern603 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern603 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern603 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern603 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern603 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern603 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern603 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern603 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern603 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern603 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern603 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern603 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern603 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern603 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern603 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern603 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern603 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern603 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern603 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern603 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern603 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern603 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern603 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern603 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern603 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern603 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern603 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern603 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern603 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern603 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern603 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern603 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern603 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern603 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern603 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern603 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern603 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern603 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern603 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern603 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern603 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern603 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern603 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern603 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern603 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern603 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern603 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern630 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode)
          || !vector_arith_operand (operands[2], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode)
          || !vector_arith_operand (operands[2], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode)
          || !vector_arith_operand (operands[2], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode)
          || !vector_arith_operand (operands[2], E_RVVM1DImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode)
          || !vector_arith_operand (operands[2], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode)
          || !vector_arith_operand (operands[2], E_RVVMF4HImode))
        return -1;
      return 2;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode)
          || !vector_arith_operand (operands[2], E_RVVMF2SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern639 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !register_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !register_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !register_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern646 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern651 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 0;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern657 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern664 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern671 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern676 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 20:
      if (REGNO (x12) != 19)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2
          || GET_MODE (x20) != i1)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x17) != 18)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 9
          || GET_MODE (x27) != i1)
        return -1;
      x28 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x28) != SET)
        return -1;
      x29 = XEXP (x28, 1);
      if (GET_CODE (x29) != MEM
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != PLUS
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 2
          || GET_MODE (x31) != i1)
        return -1;
      x32 = XEXP (x30, 1);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x33 = XEXP (x28, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 8
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x34) != SET)
        return -1;
      x35 = XEXP (x34, 1);
      if (GET_CODE (x35) != MEM
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != PLUS
          || GET_MODE (x36) != i1)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 2
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XEXP (x36, 1);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x39 = XEXP (x34, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 1
          || GET_MODE (x39) != i1
          || !stack_pop_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x18 = XEXP (x16, 1);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2
          || GET_MODE (x20) != i1)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x17) != 8)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1)
        return -1;
      x28 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x28) != RETURN)
        return -1;
      x34 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x34) != USE)
        return -1;
      x39 = XEXP (x34, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 1
          || GET_MODE (x39) != E_SImode
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x18 = XEXP (x16, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x17) != 10)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 10
          || GET_MODE (x27) != i1)
        return -1;
      x28 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x28) != RETURN)
        return -1;
      x34 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x34) != USE)
        return -1;
      x39 = XEXP (x34, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 1
          || GET_MODE (x39) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern709 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern724 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      return pattern671 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM2QImode:
      if (pattern671 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (pattern671 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (pattern671 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (pattern671 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (pattern671 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (pattern671 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (pattern671 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (pattern671 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (pattern671 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (pattern671 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern671 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern671 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern671 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (pattern671 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1QImode:
      if (pattern671 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2QImode:
      if (pattern671 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4QImode:
      if (pattern671 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8QImode:
      if (pattern671 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16QImode:
      if (pattern671 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32QImode:
      if (pattern671 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64QImode:
      if (pattern671 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128QImode:
      if (pattern671 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256QImode:
      if (pattern671 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512QImode:
      if (pattern671 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024QImode:
      if (pattern671 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048QImode:
      if (pattern671 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1HImode:
      if (pattern671 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2HImode:
      if (pattern671 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4HImode:
      if (pattern671 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8HImode:
      if (pattern671 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16HImode:
      if (pattern671 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32HImode:
      if (pattern671 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64HImode:
      if (pattern671 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128HImode:
      if (pattern671 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256HImode:
      if (pattern671 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512HImode:
      if (pattern671 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024HImode:
      if (pattern671 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1SImode:
      if (pattern671 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2SImode:
      if (pattern671 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4SImode:
      if (pattern671 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8SImode:
      if (pattern671 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16SImode:
      if (pattern671 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32SImode:
      if (pattern671 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64SImode:
      if (pattern671 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128SImode:
      if (pattern671 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256SImode:
      if (pattern671 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512SImode:
      if (pattern671 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern737 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern738 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19)
        return -1;
      x23 = XEXP (x21, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x22) != 18)
        return -1;
      x27 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x27) != SET)
        return -1;
      x28 = XEXP (x27, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x32 = XEXP (x27, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 9
          || GET_MODE (x32) != i1)
        return -1;
      x33 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x33) != SET)
        return -1;
      x34 = XEXP (x33, 1);
      if (GET_CODE (x34) != MEM
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != PLUS
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != REG
          || REGNO (x36) != 2
          || GET_MODE (x36) != i1)
        return -1;
      x37 = XEXP (x35, 1);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x38 = XEXP (x33, 0);
      if (GET_CODE (x38) != REG
          || REGNO (x38) != 8
          || GET_MODE (x38) != i1)
        return -1;
      x39 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x39) != SET)
        return -1;
      x40 = XEXP (x39, 1);
      if (GET_CODE (x40) != MEM
          || GET_MODE (x40) != i1)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != PLUS
          || GET_MODE (x41) != i1)
        return -1;
      x42 = XEXP (x41, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 2
          || GET_MODE (x42) != i1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x44 = XEXP (x39, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 1
          || GET_MODE (x44) != i1
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 19:
      if (REGNO (x12) != 18
          || REGNO (x17) != 9)
        return -1;
      x23 = XEXP (x21, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x22) != 8)
        return -1;
      x27 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x27) != SET)
        return -1;
      x28 = XEXP (x27, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x32 = XEXP (x27, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 1
          || GET_MODE (x32) != i1)
        return -1;
      x33 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x33) != RETURN)
        return -1;
      x39 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x39) != USE)
        return -1;
      x44 = XEXP (x39, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 1
          || GET_MODE (x44) != E_SImode
          || !stack_pop_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 9:
      if (REGNO (x12) != 8
          || REGNO (x17) != 1)
        return -1;
      x23 = XEXP (x21, 1);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x22) != 10)
        return -1;
      x27 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x27) != USE)
        return -1;
      x32 = XEXP (x27, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 10
          || GET_MODE (x32) != i1)
        return -1;
      x33 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x33) != RETURN)
        return -1;
      x39 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x39) != USE)
        return -1;
      x44 = XEXP (x39, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 1
          || GET_MODE (x44) != E_SImode
          || !stack_pop_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern761 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern762 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern765 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x37, 1);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  return 0;
}

int
pattern771 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern774 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x47, 1);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  return 0;
}

int
pattern786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XVECEXP (x1, 0, 12);
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 1; /* addsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 2; /* adddf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 3; /* addhf3 */

    case E_SImode:
      return recog_2 (x1, insn, pnum_clobbers);

    case E_DImode:
      return recog_1 (x1, insn, pnum_clobbers);

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern337 (x2))
        {
        case 0:
          return 280; /* *addhihi3 */

        case 1:
          return 281; /* *addsihi3 */

        default:
          return -1;
        }

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24541; /* addrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24555; /* addrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24569; /* addrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24583; /* addrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24597; /* addrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24611; /* addrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24625; /* addrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24639; /* addrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24653; /* addrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24667; /* addrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24681; /* addrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24695; /* addrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24709; /* addrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24723; /* addrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24737; /* addrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24751; /* addrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24765; /* addrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24779; /* addrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24793; /* addrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24807; /* addrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24821; /* addrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24835; /* addrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24849; /* addv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24863; /* addv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24877; /* addv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24891; /* addv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24905; /* addv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24919; /* addv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24933; /* addv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24947; /* addv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24961; /* addv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24975; /* addv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24989; /* addv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25003; /* addv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25017; /* addv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25031; /* addv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25045; /* addv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25059; /* addv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25073; /* addv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25087; /* addv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25101; /* addv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25115; /* addv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25129; /* addv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25143; /* addv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25157; /* addv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25171; /* addv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25185; /* addv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25199; /* addv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25213; /* addv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25227; /* addv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25241; /* addv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25255; /* addv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25269; /* addv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25283; /* addv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25297; /* addv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25311; /* addv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25325; /* addv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25339; /* addv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25353; /* addv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25367; /* addv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25381; /* addv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25395; /* addv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25409; /* addv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25423; /* addv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25437; /* addv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25451; /* addv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25465; /* addv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern233 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25479; /* addv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27507; /* addrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27511; /* addrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27515; /* addrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27519; /* addrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27523; /* addrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27527; /* addrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27531; /* addrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27535; /* addrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27539; /* addrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27543; /* addrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27547; /* addrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27551; /* addrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27555; /* addrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27559; /* addrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27563; /* addrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27567; /* addv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27571; /* addv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27575; /* addv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27579; /* addv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27583; /* addv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27587; /* addv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27591; /* addv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27595; /* addv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27599; /* addv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27603; /* addv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27607; /* addv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27611; /* addv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27615; /* addv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27619; /* addv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27623; /* addv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27627; /* addv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27631; /* addv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27635; /* addv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27639; /* addv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27643; /* addv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27647; /* addv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27651; /* addv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27655; /* addv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27659; /* addv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27663; /* addv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27667; /* addv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27671; /* addv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27675; /* addv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27679; /* addv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27683; /* addv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27687; /* addv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27691; /* addv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27695; /* addv512df3 */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 23; /* mulsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 24; /* muldf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 25; /* mulhf3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_ZMMUL || TARGET_MUL))
        return -1;
      return 26; /* *mulsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 27; /* muldi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24550; /* mulrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24564; /* mulrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24578; /* mulrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24592; /* mulrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24606; /* mulrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24620; /* mulrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24634; /* mulrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24648; /* mulrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24662; /* mulrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24676; /* mulrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24690; /* mulrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24704; /* mulrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24718; /* mulrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24732; /* mulrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24746; /* mulrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24760; /* mulrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24774; /* mulrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24788; /* mulrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24802; /* mulrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24816; /* mulrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24830; /* mulrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24844; /* mulrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24858; /* mulv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24872; /* mulv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24886; /* mulv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24900; /* mulv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24914; /* mulv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24928; /* mulv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24942; /* mulv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24956; /* mulv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24970; /* mulv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24984; /* mulv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24998; /* mulv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25012; /* mulv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25026; /* mulv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25040; /* mulv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25054; /* mulv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25068; /* mulv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25082; /* mulv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25096; /* mulv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25110; /* mulv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25124; /* mulv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25138; /* mulv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25152; /* mulv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25166; /* mulv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25180; /* mulv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25194; /* mulv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25208; /* mulv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25222; /* mulv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25236; /* mulv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25250; /* mulv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25264; /* mulv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25278; /* mulv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25292; /* mulv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25306; /* mulv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25320; /* mulv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25334; /* mulv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25348; /* mulv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25362; /* mulv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25376; /* mulv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25390; /* mulv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25404; /* mulv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25418; /* mulv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25432; /* mulv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25446; /* mulv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25460; /* mulv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25474; /* mulv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25488; /* mulv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27508; /* mulrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27512; /* mulrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27516; /* mulrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27520; /* mulrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27524; /* mulrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27528; /* mulrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27532; /* mulrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27536; /* mulrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27540; /* mulrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27544; /* mulrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27548; /* mulrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27552; /* mulrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27556; /* mulrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27560; /* mulrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27564; /* mulrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27568; /* mulv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27572; /* mulv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27576; /* mulv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27580; /* mulv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27584; /* mulv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27588; /* mulv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27592; /* mulv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27596; /* mulv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27600; /* mulv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27604; /* mulv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27608; /* mulv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27612; /* mulv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27616; /* mulv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27620; /* mulv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27624; /* mulv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27628; /* mulv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27632; /* mulv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27636; /* mulv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27640; /* mulv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27644; /* mulv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27648; /* mulv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27652; /* mulv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27656; /* mulv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27660; /* mulv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27664; /* mulv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27668; /* mulv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27672; /* mulv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27676; /* mulv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27680; /* mulv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27684; /* mulv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27688; /* mulv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27692; /* mulv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27696; /* mulv512df3 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern530 (x2))
    {
    case 0:
      if (pattern580 (x2) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVM1BImode
          || !
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8835; /* pred_msbcrvvm8qi_overflow */

    case 1:
      if (!register_operand (operands[0], E_RVVMF2BImode)
          || GET_MODE (x2) != E_RVVMF2BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF2BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern635 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8836; /* pred_msbcrvvm4qi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8839; /* pred_msbcrvvm8hi_overflow */

        default:
          return -1;
        }

    case 2:
      if (!register_operand (operands[0], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVMF4BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF4BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern636 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8837; /* pred_msbcrvvm2qi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8840; /* pred_msbcrvvm4hi_overflow */

        case 2:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8843; /* pred_msbcrvvm8si_overflow */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVMF8BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF8BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern637 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8838; /* pred_msbcrvvm1qi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8841; /* pred_msbcrvvm2hi_overflow */

        case 2:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8844; /* pred_msbcrvvm4si_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8847; /* pred_msbcrvvm8di_overflow */

        default:
          return -1;
        }

    case 4:
      if (!register_operand (operands[0], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVMF16BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF16BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern638 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8842; /* pred_msbcrvvm1hi_overflow */

        case 1:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8845; /* pred_msbcrvvm2si_overflow */

        case 2:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8848; /* pred_msbcrvvm4di_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8851; /* pred_msbcrvvmf2qi_overflow */

        default:
          return -1;
        }

    case 5:
      if (!register_operand (operands[0], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVMF32BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF32BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern639 (x4))
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8846; /* pred_msbcrvvm1si_overflow */

        case 1:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8849; /* pred_msbcrvvm2di_overflow */

        case 2:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8852; /* pred_msbcrvvmf4qi_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8854; /* pred_msbcrvvmf2hi_overflow */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_RVVMF64BImode)
          || GET_MODE (x2) != E_RVVMF64BImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_RVVMF64BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern640 (x4))
        {
        case 0:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8850; /* pred_msbcrvvm1di_overflow */

        case 1:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8853; /* pred_msbcrvvmf8qi_overflow */

        case 2:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8855; /* pred_msbcrvvmf4hi_overflow */

        case 3:
          if (!(
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8856; /* pred_msbcrvvmf2si_overflow */

        default:
          return -1;
        }

    case 7:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8911; /* pred_msbcrvvm8qi_overflow_scalar */

    case 8:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8912; /* pred_msbcrvvm4qi_overflow_scalar */

    case 9:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8918; /* pred_msbcrvvm8hi_overflow_scalar */

    case 10:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8913; /* pred_msbcrvvm2qi_overflow_scalar */

    case 11:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8919; /* pred_msbcrvvm4hi_overflow_scalar */

    case 12:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8924; /* pred_msbcrvvm8si_overflow_scalar */

    case 13:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8914; /* pred_msbcrvvm1qi_overflow_scalar */

    case 14:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8920; /* pred_msbcrvvm2hi_overflow_scalar */

    case 15:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8925; /* pred_msbcrvvm4si_overflow_scalar */

    case 16:
      if (!(
#line 3856 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8973; /* *pred_msbcrvvm8di_overflow_scalar */

    case 17:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8915; /* pred_msbcrvvmf2qi_overflow_scalar */

    case 18:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8921; /* pred_msbcrvvm1hi_overflow_scalar */

    case 19:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8926; /* pred_msbcrvvm2si_overflow_scalar */

    case 20:
      if (!(
#line 3856 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8974; /* *pred_msbcrvvm4di_overflow_scalar */

    case 21:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8916; /* pred_msbcrvvmf4qi_overflow_scalar */

    case 22:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8922; /* pred_msbcrvvmf2hi_overflow_scalar */

    case 23:
      if (!
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8927; /* pred_msbcrvvm1si_overflow_scalar */

    case 24:
      if (!(
#line 3856 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8975; /* *pred_msbcrvvm2di_overflow_scalar */

    case 25:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8917; /* pred_msbcrvvmf8qi_overflow_scalar */

    case 26:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8923; /* pred_msbcrvvmf4hi_overflow_scalar */

    case 27:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8928; /* pred_msbcrvvmf2si_overflow_scalar */

    case 28:
      if (!(
#line 3856 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8976; /* *pred_msbcrvvm1di_overflow_scalar */

    case 29:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8929; /* pred_msbcv1qi_overflow_scalar */

    case 30:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8942; /* pred_msbcv1hi_overflow_scalar */

    case 31:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8954; /* pred_msbcv1si_overflow_scalar */

    case 32:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8930; /* pred_msbcv2qi_overflow_scalar */

    case 33:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8943; /* pred_msbcv2hi_overflow_scalar */

    case 34:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8955; /* pred_msbcv2si_overflow_scalar */

    case 35:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8931; /* pred_msbcv4qi_overflow_scalar */

    case 36:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8944; /* pred_msbcv4hi_overflow_scalar */

    case 37:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8956; /* pred_msbcv4si_overflow_scalar */

    case 38:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8932; /* pred_msbcv8qi_overflow_scalar */

    case 39:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8945; /* pred_msbcv8hi_overflow_scalar */

    case 40:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8957; /* pred_msbcv8si_overflow_scalar */

    case 41:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8933; /* pred_msbcv16qi_overflow_scalar */

    case 42:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8946; /* pred_msbcv16hi_overflow_scalar */

    case 43:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8958; /* pred_msbcv16si_overflow_scalar */

    case 44:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8934; /* pred_msbcv32qi_overflow_scalar */

    case 45:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8947; /* pred_msbcv32hi_overflow_scalar */

    case 46:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8959; /* pred_msbcv32si_overflow_scalar */

    case 47:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8935; /* pred_msbcv64qi_overflow_scalar */

    case 48:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8948; /* pred_msbcv64hi_overflow_scalar */

    case 49:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8960; /* pred_msbcv64si_overflow_scalar */

    case 50:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8936; /* pred_msbcv128qi_overflow_scalar */

    case 51:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8949; /* pred_msbcv128hi_overflow_scalar */

    case 52:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8961; /* pred_msbcv128si_overflow_scalar */

    case 53:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8937; /* pred_msbcv256qi_overflow_scalar */

    case 54:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8950; /* pred_msbcv256hi_overflow_scalar */

    case 55:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8962; /* pred_msbcv256si_overflow_scalar */

    case 56:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8938; /* pred_msbcv512qi_overflow_scalar */

    case 57:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8951; /* pred_msbcv512hi_overflow_scalar */

    case 58:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8963; /* pred_msbcv512si_overflow_scalar */

    case 59:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8939; /* pred_msbcv1024qi_overflow_scalar */

    case 60:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8952; /* pred_msbcv1024hi_overflow_scalar */

    case 61:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8964; /* pred_msbcv1024si_overflow_scalar */

    case 62:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8940; /* pred_msbcv2048qi_overflow_scalar */

    case 63:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8953; /* pred_msbcv2048hi_overflow_scalar */

    case 64:
      if (!(
#line 3739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8941; /* pred_msbcv4096qi_overflow_scalar */

    case 65:
      if (!(
#line 3877 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8977; /* *pred_msbcrvvm8di_overflow_extended_scalar */

    case 66:
      if (!(
#line 3877 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8978; /* *pred_msbcrvvm4di_overflow_extended_scalar */

    case 67:
      if (!(
#line 3877 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8979; /* *pred_msbcrvvm2di_overflow_extended_scalar */

    case 68:
      if (!(
#line 3877 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8980; /* *pred_msbcrvvm1di_overflow_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !(
#line 4150 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!rtx_equal_p (operands[0], operands[1])) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 473; /* stack_tiesi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode)
          || !(
#line 4150 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!rtx_equal_p (operands[0], operands[1])) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 474; /* stack_tiedi */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern360 (x3, 
E_SImode))
        {
        case 0:
          if (!(
#line 103 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 665; /* riscv_pack_sihi */

        case 1:
          if (!(
#line 103 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 666; /* riscv_pack_sisi */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern360 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 103 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 667; /* riscv_pack_dihi */

        case 1:
          if (!(
#line 103 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 668; /* riscv_pack_disi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode)
      || !
#line 1997 "../../gcc-15.0.1-20250313/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
    return -1;
  return 34037; /* riscv_cv_simd_shuffle_sci_b_si */
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (pattern338 (x3))
    {
    case 0:
      if (!(
#line 125 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 671; /* riscv_packh_si */

    case 1:
      if (!(
#line 125 "../../gcc-15.0.1-20250313/gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 672; /* riscv_packh_di */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern251 (x3))
    {
    case 0:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28143; /* reduc_plus_scal_rvvm8hf */

    case 1:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28144; /* reduc_plus_scal_rvvm4hf */

    case 2:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28145; /* reduc_plus_scal_rvvm2hf */

    case 3:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28146; /* reduc_plus_scal_rvvm1hf */

    case 4:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 28147; /* reduc_plus_scal_rvvmf2hf */

    case 5:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28148; /* reduc_plus_scal_rvvmf4hf */

    case 6:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 28158; /* reduc_plus_scal_v1hf */

    case 7:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 28159; /* reduc_plus_scal_v2hf */

    case 8:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 28160; /* reduc_plus_scal_v4hf */

    case 9:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 28161; /* reduc_plus_scal_v8hf */

    case 10:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 28162; /* reduc_plus_scal_v16hf */

    case 11:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28163; /* reduc_plus_scal_v32hf */

    case 12:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28164; /* reduc_plus_scal_v64hf */

    case 13:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28165; /* reduc_plus_scal_v128hf */

    case 14:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28166; /* reduc_plus_scal_v256hf */

    case 15:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28167; /* reduc_plus_scal_v512hf */

    case 16:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28168; /* reduc_plus_scal_v1024hf */

    case 17:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28169; /* reduc_plus_scal_v2048hf */

    case 18:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28149; /* reduc_plus_scal_rvvm8sf */

    case 19:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28150; /* reduc_plus_scal_rvvm4sf */

    case 20:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28151; /* reduc_plus_scal_rvvm2sf */

    case 21:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28152; /* reduc_plus_scal_rvvm1sf */

    case 22:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 28153; /* reduc_plus_scal_rvvmf2sf */

    case 23:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28170; /* reduc_plus_scal_v1sf */

    case 24:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28171; /* reduc_plus_scal_v2sf */

    case 25:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28172; /* reduc_plus_scal_v4sf */

    case 26:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 28173; /* reduc_plus_scal_v8sf */

    case 27:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28174; /* reduc_plus_scal_v16sf */

    case 28:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28175; /* reduc_plus_scal_v32sf */

    case 29:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28176; /* reduc_plus_scal_v64sf */

    case 30:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28177; /* reduc_plus_scal_v128sf */

    case 31:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28178; /* reduc_plus_scal_v256sf */

    case 32:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28179; /* reduc_plus_scal_v512sf */

    case 33:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28180; /* reduc_plus_scal_v1024sf */

    case 34:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28154; /* reduc_plus_scal_rvvm8df */

    case 35:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28155; /* reduc_plus_scal_rvvm4df */

    case 36:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28156; /* reduc_plus_scal_rvvm2df */

    case 37:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28157; /* reduc_plus_scal_rvvm1df */

    case 38:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28181; /* reduc_plus_scal_v1df */

    case 39:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28182; /* reduc_plus_scal_v2df */

    case 40:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 28183; /* reduc_plus_scal_v4df */

    case 41:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28184; /* reduc_plus_scal_v8df */

    case 42:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28185; /* reduc_plus_scal_v16df */

    case 43:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28186; /* reduc_plus_scal_v32df */

    case 44:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28187; /* reduc_plus_scal_v64df */

    case 45:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28188; /* reduc_plus_scal_v128df */

    case 46:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28189; /* reduc_plus_scal_v256df */

    case 47:
      if (!(
#line 2300 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28190; /* reduc_plus_scal_v512df */

    case 48:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31220; /* *widen_reduc_plus_scal_rvvm4hf */

    case 49:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31221; /* *widen_reduc_plus_scal_rvvm2hf */

    case 50:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31222; /* *widen_reduc_plus_scal_rvvm1hf */

    case 51:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 31223; /* *widen_reduc_plus_scal_rvvmf2hf */

    case 52:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31224; /* *widen_reduc_plus_scal_rvvmf4hf */

    case 53:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 31229; /* *widen_reduc_plus_scal_v1hf */

    case 54:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 31230; /* *widen_reduc_plus_scal_v2hf */

    case 55:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 31231; /* *widen_reduc_plus_scal_v4hf */

    case 56:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 31232; /* *widen_reduc_plus_scal_v8hf */

    case 57:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 31233; /* *widen_reduc_plus_scal_v16hf */

    case 58:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31234; /* *widen_reduc_plus_scal_v32hf */

    case 59:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31235; /* *widen_reduc_plus_scal_v64hf */

    case 60:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31236; /* *widen_reduc_plus_scal_v128hf */

    case 61:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31237; /* *widen_reduc_plus_scal_v256hf */

    case 62:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31238; /* *widen_reduc_plus_scal_v512hf */

    case 63:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31239; /* *widen_reduc_plus_scal_v1024hf */

    case 64:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31225; /* *widen_reduc_plus_scal_rvvm4sf */

    case 65:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31226; /* *widen_reduc_plus_scal_rvvm2sf */

    case 66:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31227; /* *widen_reduc_plus_scal_rvvm1sf */

    case 67:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 31228; /* *widen_reduc_plus_scal_rvvmf2sf */

    case 68:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31240; /* *widen_reduc_plus_scal_v1sf */

    case 69:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31241; /* *widen_reduc_plus_scal_v2sf */

    case 70:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31242; /* *widen_reduc_plus_scal_v4sf */

    case 71:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 31243; /* *widen_reduc_plus_scal_v8sf */

    case 72:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31244; /* *widen_reduc_plus_scal_v16sf */

    case 73:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31245; /* *widen_reduc_plus_scal_v32sf */

    case 74:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31246; /* *widen_reduc_plus_scal_v64sf */

    case 75:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31247; /* *widen_reduc_plus_scal_v128sf */

    case 76:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31248; /* *widen_reduc_plus_scal_v256sf */

    case 77:
      if (!(
#line 882 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31249; /* *widen_reduc_plus_scal_v512sf */

    case 78:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32030; /* *cond_widen_reduc_plus_scal_rvvm4hf */

    case 79:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32031; /* *cond_widen_reduc_plus_scal_rvvm2hf */

    case 80:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32032; /* *cond_widen_reduc_plus_scal_rvvm1hf */

    case 81:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32033; /* *cond_widen_reduc_plus_scal_rvvmf2hf */

    case 82:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 32034; /* *cond_widen_reduc_plus_scal_rvvmf4hf */

    case 83:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 32039; /* *cond_widen_reduc_plus_scal_v1hf */

    case 84:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 32040; /* *cond_widen_reduc_plus_scal_v2hf */

    case 85:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 32041; /* *cond_widen_reduc_plus_scal_v4hf */

    case 86:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 32042; /* *cond_widen_reduc_plus_scal_v8hf */

    case 87:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 32043; /* *cond_widen_reduc_plus_scal_v16hf */

    case 88:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32044; /* *cond_widen_reduc_plus_scal_v32hf */

    case 89:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32045; /* *cond_widen_reduc_plus_scal_v64hf */

    case 90:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32046; /* *cond_widen_reduc_plus_scal_v128hf */

    case 91:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32047; /* *cond_widen_reduc_plus_scal_v256hf */

    case 92:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32048; /* *cond_widen_reduc_plus_scal_v512hf */

    case 93:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32049; /* *cond_widen_reduc_plus_scal_v1024hf */

    case 94:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32035; /* *cond_widen_reduc_plus_scal_rvvm4sf */

    case 95:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32036; /* *cond_widen_reduc_plus_scal_rvvm2sf */

    case 96:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32037; /* *cond_widen_reduc_plus_scal_rvvm1sf */

    case 97:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 32038; /* *cond_widen_reduc_plus_scal_rvvmf2sf */

    case 98:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32050; /* *cond_widen_reduc_plus_scal_v1sf */

    case 99:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32051; /* *cond_widen_reduc_plus_scal_v2sf */

    case 100:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32052; /* *cond_widen_reduc_plus_scal_v4sf */

    case 101:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32053; /* *cond_widen_reduc_plus_scal_v8sf */

    case 102:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32054; /* *cond_widen_reduc_plus_scal_v16sf */

    case 103:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32055; /* *cond_widen_reduc_plus_scal_v32sf */

    case 104:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32056; /* *cond_widen_reduc_plus_scal_v64sf */

    case 105:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32057; /* *cond_widen_reduc_plus_scal_v128sf */

    case 106:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32058; /* *cond_widen_reduc_plus_scal_v256sf */

    case 107:
      if (!(
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32059; /* *cond_widen_reduc_plus_scal_v512sf */

    case 108:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32060; /* *cond_len_widen_reduc_plus_scal_rvvm4hf */

    case 109:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32061; /* *cond_len_widen_reduc_plus_scal_rvvm2hf */

    case 110:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32062; /* *cond_len_widen_reduc_plus_scal_rvvm1hf */

    case 111:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 32063; /* *cond_len_widen_reduc_plus_scal_rvvmf2hf */

    case 112:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 32064; /* *cond_len_widen_reduc_plus_scal_rvvmf4hf */

    case 113:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 32069; /* *cond_len_widen_reduc_plus_scal_v1hf */

    case 114:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 32070; /* *cond_len_widen_reduc_plus_scal_v2hf */

    case 115:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 32071; /* *cond_len_widen_reduc_plus_scal_v4hf */

    case 116:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 32072; /* *cond_len_widen_reduc_plus_scal_v8hf */

    case 117:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 32073; /* *cond_len_widen_reduc_plus_scal_v16hf */

    case 118:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32074; /* *cond_len_widen_reduc_plus_scal_v32hf */

    case 119:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32075; /* *cond_len_widen_reduc_plus_scal_v64hf */

    case 120:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32076; /* *cond_len_widen_reduc_plus_scal_v128hf */

    case 121:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32077; /* *cond_len_widen_reduc_plus_scal_v256hf */

    case 122:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32078; /* *cond_len_widen_reduc_plus_scal_v512hf */

    case 123:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32079; /* *cond_len_widen_reduc_plus_scal_v1024hf */

    case 124:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32065; /* *cond_len_widen_reduc_plus_scal_rvvm4sf */

    case 125:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32066; /* *cond_len_widen_reduc_plus_scal_rvvm2sf */

    case 126:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32067; /* *cond_len_widen_reduc_plus_scal_rvvm1sf */

    case 127:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 32068; /* *cond_len_widen_reduc_plus_scal_rvvmf2sf */

    case 128:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32080; /* *cond_len_widen_reduc_plus_scal_v1sf */

    case 129:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32081; /* *cond_len_widen_reduc_plus_scal_v2sf */

    case 130:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32082; /* *cond_len_widen_reduc_plus_scal_v4sf */

    case 131:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 32083; /* *cond_len_widen_reduc_plus_scal_v8sf */

    case 132:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32084; /* *cond_len_widen_reduc_plus_scal_v16sf */

    case 133:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32085; /* *cond_len_widen_reduc_plus_scal_v32sf */

    case 134:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32086; /* *cond_len_widen_reduc_plus_scal_v64sf */

    case 135:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32087; /* *cond_len_widen_reduc_plus_scal_v128sf */

    case 136:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32088; /* *cond_len_widen_reduc_plus_scal_v256sf */

    case 137:
      if (!(
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32089; /* *cond_len_widen_reduc_plus_scal_v512sf */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18126; /* pred_redmaxurvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18134; /* pred_redmaxurvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18142; /* pred_redmaxurvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18150; /* pred_redmaxurvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18254; /* pred_redmaxurvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18262; /* pred_redmaxurvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18270; /* pred_redmaxurvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18302; /* pred_redmaxuv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18310; /* pred_redmaxuv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18318; /* pred_redmaxuv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18326; /* pred_redmaxuv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18334; /* pred_redmaxuv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18342; /* pred_redmaxuv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18350; /* pred_redmaxuv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18358; /* pred_redmaxuv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18366; /* pred_redmaxuv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18374; /* pred_redmaxuv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18382; /* pred_redmaxuv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18390; /* pred_redmaxuv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18398; /* pred_redmaxuv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18158; /* pred_redmaxurvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18166; /* pred_redmaxurvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18174; /* pred_redmaxurvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18182; /* pred_redmaxurvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18278; /* pred_redmaxurvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18286; /* pred_redmaxurvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18406; /* pred_redmaxuv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18414; /* pred_redmaxuv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18422; /* pred_redmaxuv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18430; /* pred_redmaxuv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18438; /* pred_redmaxuv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18446; /* pred_redmaxuv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18454; /* pred_redmaxuv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18462; /* pred_redmaxuv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18470; /* pred_redmaxuv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18478; /* pred_redmaxuv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18486; /* pred_redmaxuv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18494; /* pred_redmaxuv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18190; /* pred_redmaxurvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18198; /* pred_redmaxurvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18206; /* pred_redmaxurvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18214; /* pred_redmaxurvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18294; /* pred_redmaxurvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18502; /* pred_redmaxuv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18510; /* pred_redmaxuv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18518; /* pred_redmaxuv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18526; /* pred_redmaxuv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18534; /* pred_redmaxuv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18542; /* pred_redmaxuv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18550; /* pred_redmaxuv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18558; /* pred_redmaxuv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18566; /* pred_redmaxuv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18574; /* pred_redmaxuv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18582; /* pred_redmaxuv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18222; /* pred_redmaxurvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18230; /* pred_redmaxurvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18238; /* pred_redmaxurvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18246; /* pred_redmaxurvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18590; /* pred_redmaxuv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18598; /* pred_redmaxuv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18606; /* pred_redmaxuv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18614; /* pred_redmaxuv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18622; /* pred_redmaxuv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18630; /* pred_redmaxuv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18638; /* pred_redmaxuv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18646; /* pred_redmaxuv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18654; /* pred_redmaxuv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18662; /* pred_redmaxuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern254 (x2, 
PLUS))
    {
    case 0:
      if (pattern579 (x2) != 0
          || !register_operand (operands[3], E_RVVM1BImode))
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (GET_MODE (x3) != E_RVVM1BImode
          || !
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8645; /* pred_madcrvvm8qi */

    case 1:
      if (pattern589 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern629 (x4))
        {
        case 0:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8646; /* pred_madcrvvm4qi */

        case 1:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8649; /* pred_madcrvvm8hi */

        default:
          return -1;
        }

    case 2:
      if (pattern589 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern630 (x4))
        {
        case 0:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8647; /* pred_madcrvvm2qi */

        case 1:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8650; /* pred_madcrvvm4hi */

        case 2:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8653; /* pred_madcrvvm8si */

        default:
          return -1;
        }

    case 3:
      if (pattern589 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern631 (x4))
        {
        case 0:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8648; /* pred_madcrvvm1qi */

        case 1:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8651; /* pred_madcrvvm2hi */

        case 2:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8654; /* pred_madcrvvm4si */

        case 3:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8657; /* pred_madcrvvm8di */

        default:
          return -1;
        }

    case 4:
      if (pattern589 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern632 (x4))
        {
        case 0:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8652; /* pred_madcrvvm1hi */

        case 1:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8655; /* pred_madcrvvm2si */

        case 2:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8658; /* pred_madcrvvm4di */

        case 3:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8661; /* pred_madcrvvmf2qi */

        default:
          return -1;
        }

    case 5:
      if (pattern589 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern633 (x4))
        {
        case 0:
          if (!
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8656; /* pred_madcrvvm1si */

        case 1:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8659; /* pred_madcrvvm2di */

        case 2:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8662; /* pred_madcrvvmf4qi */

        case 3:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8664; /* pred_madcrvvmf2hi */

        default:
          return -1;
        }

    case 6:
      if (pattern589 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (pattern634 (x4))
        {
        case 0:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8660; /* pred_madcrvvm1di */

        case 1:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8663; /* pred_madcrvvmf8qi */

        case 2:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8665; /* pred_madcrvvmf4hi */

        case 3:
          if (!(
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8666; /* pred_madcrvvmf2si */

        default:
          return -1;
        }

    case 7:
      if (pattern596 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0
          || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8689; /* pred_madcrvvm8qi_scalar */

    case 8:
      if (!register_operand (operands[0], E_RVVMF2BImode)
          || GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[3], E_RVVMF2BImode))
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (GET_MODE (x3) != E_RVVMF2BImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_RVVM4QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_RVVM4QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_RVVM4QImode)
              || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8690; /* pred_madcrvvm4qi_scalar */

        case E_RVVM8HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_RVVM8HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_RVVM8HImode)
              || !
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8696; /* pred_madcrvvm8hi_scalar */

        default:
          return -1;
        }

    case 9:
      return recog_60 (x1, insn, pnum_clobbers);

    case 10:
      return recog_56 (x1, insn, pnum_clobbers);

    case 11:
      return recog_59 (x1, insn, pnum_clobbers);

    case 12:
      return recog_58 (x1, insn, pnum_clobbers);

    case 13:
      return recog_57 (x1, insn, pnum_clobbers);

    case 14:
      if (pattern589 (x2, 
E_V1BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V1QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V1QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V1QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 8707; /* pred_madcv1qi_scalar */

        case E_V1HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V1HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V1HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 8720; /* pred_madcv1hi_scalar */

        case E_V1SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V1SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V1SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 8732; /* pred_madcv1si_scalar */

        default:
          return -1;
        }

    case 15:
      if (pattern589 (x2, 
E_V2BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V2QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V2QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V2QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 8708; /* pred_madcv2qi_scalar */

        case E_V2HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V2HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V2HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 8721; /* pred_madcv2hi_scalar */

        case E_V2SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V2SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V2SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 8733; /* pred_madcv2si_scalar */

        default:
          return -1;
        }

    case 16:
      if (pattern589 (x2, 
E_V4BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V4QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V4QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V4QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 8709; /* pred_madcv4qi_scalar */

        case E_V4HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V4HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V4HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 8722; /* pred_madcv4hi_scalar */

        case E_V4SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V4SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V4SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 8734; /* pred_madcv4si_scalar */

        default:
          return -1;
        }

    case 17:
      if (pattern589 (x2, 
E_V8BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V8QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V8QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V8QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 8710; /* pred_madcv8qi_scalar */

        case E_V8HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V8HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V8HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 8723; /* pred_madcv8hi_scalar */

        case E_V8SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V8SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V8SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 8735; /* pred_madcv8si_scalar */

        default:
          return -1;
        }

    case 18:
      if (pattern589 (x2, 
E_V16BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V16QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V16QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 8711; /* pred_madcv16qi_scalar */

        case E_V16HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V16HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V16HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 8724; /* pred_madcv16hi_scalar */

        case E_V16SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V16SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V16SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 8736; /* pred_madcv16si_scalar */

        default:
          return -1;
        }

    case 19:
      if (pattern589 (x2, 
E_V32BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V32QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V32QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V32QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 8712; /* pred_madcv32qi_scalar */

        case E_V32HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V32HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V32HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 8725; /* pred_madcv32hi_scalar */

        case E_V32SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V32SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V32SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 8737; /* pred_madcv32si_scalar */

        default:
          return -1;
        }

    case 20:
      if (pattern589 (x2, 
E_V64BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V64QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V64QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V64QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 8713; /* pred_madcv64qi_scalar */

        case E_V64HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V64HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V64HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 8726; /* pred_madcv64hi_scalar */

        case E_V64SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V64SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V64SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 8738; /* pred_madcv64si_scalar */

        default:
          return -1;
        }

    case 21:
      if (pattern589 (x2, 
E_V128BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V128QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V128QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V128QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 8714; /* pred_madcv128qi_scalar */

        case E_V128HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V128HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V128HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 8727; /* pred_madcv128hi_scalar */

        case E_V128SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V128SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V128SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 8739; /* pred_madcv128si_scalar */

        default:
          return -1;
        }

    case 22:
      if (pattern589 (x2, 
E_V256BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V256QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V256QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V256QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 8715; /* pred_madcv256qi_scalar */

        case E_V256HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V256HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V256HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 8728; /* pred_madcv256hi_scalar */

        case E_V256SImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V256SImode
              || !register_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_V256SImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 8740; /* pred_madcv256si_scalar */

        default:
          return -1;
        }

    case 23:
      return recog_62 (x1, insn, pnum_clobbers);

    case 24:
      return recog_61 (x1, insn, pnum_clobbers);

    case 25:
      if (pattern589 (x2, 
E_V2048BImode) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x4))
        {
        case E_V2048QImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V2048QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[1], E_V2048QImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 8718; /* pred_madcv2048qi_scalar */

        case E_V2048HImode:
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_V2048HImode
              || !register_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_V2048HImode)
              || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 8731; /* pred_madcv2048hi_scalar */

        default:
          return -1;
        }

    case 26:
      if (pattern596 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0
          || !(
#line 3496 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8719; /* pred_madcv4096qi_scalar */

    case 27:
      if (!(
#line 3589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8801; /* *pred_madcrvvm8di_extended_scalar */

    case 28:
      if (!(
#line 3589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8802; /* *pred_madcrvvm4di_extended_scalar */

    case 29:
      if (!(
#line 3589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8803; /* *pred_madcrvvm2di_extended_scalar */

    case 30:
      if (!(
#line 3589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8804; /* *pred_madcrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_RVVMF8x2QImode:
      if (!register_operand (operands[2], E_RVVMF8x2QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21273; /* pred_unit_strided_storervvmf8x2qi */

    case E_RVVMF8x3QImode:
      if (!register_operand (operands[2], E_RVVMF8x3QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21274; /* pred_unit_strided_storervvmf8x3qi */

    case E_RVVMF8x4QImode:
      if (!register_operand (operands[2], E_RVVMF8x4QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21275; /* pred_unit_strided_storervvmf8x4qi */

    case E_RVVMF8x5QImode:
      if (!register_operand (operands[2], E_RVVMF8x5QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21276; /* pred_unit_strided_storervvmf8x5qi */

    case E_RVVMF8x6QImode:
      if (!register_operand (operands[2], E_RVVMF8x6QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21277; /* pred_unit_strided_storervvmf8x6qi */

    case E_RVVMF8x7QImode:
      if (!register_operand (operands[2], E_RVVMF8x7QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21278; /* pred_unit_strided_storervvmf8x7qi */

    case E_RVVMF8x8QImode:
      if (!register_operand (operands[2], E_RVVMF8x8QImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21279; /* pred_unit_strided_storervvmf8x8qi */

    case E_RVVMF4x2HImode:
      if (!register_operand (operands[2], E_RVVMF4x2HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21280; /* pred_unit_strided_storervvmf4x2hi */

    case E_RVVMF4x3HImode:
      if (!register_operand (operands[2], E_RVVMF4x3HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21281; /* pred_unit_strided_storervvmf4x3hi */

    case E_RVVMF4x4HImode:
      if (!register_operand (operands[2], E_RVVMF4x4HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21282; /* pred_unit_strided_storervvmf4x4hi */

    case E_RVVMF4x5HImode:
      if (!register_operand (operands[2], E_RVVMF4x5HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21283; /* pred_unit_strided_storervvmf4x5hi */

    case E_RVVMF4x6HImode:
      if (!register_operand (operands[2], E_RVVMF4x6HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21284; /* pred_unit_strided_storervvmf4x6hi */

    case E_RVVMF4x7HImode:
      if (!register_operand (operands[2], E_RVVMF4x7HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21285; /* pred_unit_strided_storervvmf4x7hi */

    case E_RVVMF4x8HImode:
      if (!register_operand (operands[2], E_RVVMF4x8HImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21286; /* pred_unit_strided_storervvmf4x8hi */

    case E_RVVMF2x2SImode:
      if (!register_operand (operands[2], E_RVVMF2x2SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21287; /* pred_unit_strided_storervvmf2x2si */

    case E_RVVMF2x3SImode:
      if (!register_operand (operands[2], E_RVVMF2x3SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21288; /* pred_unit_strided_storervvmf2x3si */

    case E_RVVMF2x4SImode:
      if (!register_operand (operands[2], E_RVVMF2x4SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21289; /* pred_unit_strided_storervvmf2x4si */

    case E_RVVMF2x5SImode:
      if (!register_operand (operands[2], E_RVVMF2x5SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21290; /* pred_unit_strided_storervvmf2x5si */

    case E_RVVMF2x6SImode:
      if (!register_operand (operands[2], E_RVVMF2x6SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21291; /* pred_unit_strided_storervvmf2x6si */

    case E_RVVMF2x7SImode:
      if (!register_operand (operands[2], E_RVVMF2x7SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21292; /* pred_unit_strided_storervvmf2x7si */

    case E_RVVMF2x8SImode:
      if (!register_operand (operands[2], E_RVVMF2x8SImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 21293; /* pred_unit_strided_storervvmf2x8si */

    case E_RVVM1x2DImode:
      if (!register_operand (operands[2], E_RVVM1x2DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21294; /* pred_unit_strided_storervvm1x2di */

    case E_RVVM1x3DImode:
      if (!register_operand (operands[2], E_RVVM1x3DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21295; /* pred_unit_strided_storervvm1x3di */

    case E_RVVM1x4DImode:
      if (!register_operand (operands[2], E_RVVM1x4DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21296; /* pred_unit_strided_storervvm1x4di */

    case E_RVVM1x5DImode:
      if (!register_operand (operands[2], E_RVVM1x5DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21297; /* pred_unit_strided_storervvm1x5di */

    case E_RVVM1x6DImode:
      if (!register_operand (operands[2], E_RVVM1x6DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21298; /* pred_unit_strided_storervvm1x6di */

    case E_RVVM1x7DImode:
      if (!register_operand (operands[2], E_RVVM1x7DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21299; /* pred_unit_strided_storervvm1x7di */

    case E_RVVM1x8DImode:
      if (!register_operand (operands[2], E_RVVM1x8DImode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21300; /* pred_unit_strided_storervvm1x8di */

    case E_RVVMF4x2BFmode:
      if (!register_operand (operands[2], E_RVVMF4x2BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21301; /* pred_unit_strided_storervvmf4x2bf */

    case E_RVVMF4x3BFmode:
      if (!register_operand (operands[2], E_RVVMF4x3BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21302; /* pred_unit_strided_storervvmf4x3bf */

    case E_RVVMF4x4BFmode:
      if (!register_operand (operands[2], E_RVVMF4x4BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21303; /* pred_unit_strided_storervvmf4x4bf */

    case E_RVVMF4x5BFmode:
      if (!register_operand (operands[2], E_RVVMF4x5BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21304; /* pred_unit_strided_storervvmf4x5bf */

    case E_RVVMF4x6BFmode:
      if (!register_operand (operands[2], E_RVVMF4x6BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21305; /* pred_unit_strided_storervvmf4x6bf */

    case E_RVVMF4x7BFmode:
      if (!register_operand (operands[2], E_RVVMF4x7BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21306; /* pred_unit_strided_storervvmf4x7bf */

    case E_RVVMF4x8BFmode:
      if (!register_operand (operands[2], E_RVVMF4x8BFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21307; /* pred_unit_strided_storervvmf4x8bf */

    case E_RVVMF4x2HFmode:
      if (!register_operand (operands[2], E_RVVMF4x2HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21308; /* pred_unit_strided_storervvmf4x2hf */

    case E_RVVMF4x3HFmode:
      if (!register_operand (operands[2], E_RVVMF4x3HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21309; /* pred_unit_strided_storervvmf4x3hf */

    case E_RVVMF4x4HFmode:
      if (!register_operand (operands[2], E_RVVMF4x4HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21310; /* pred_unit_strided_storervvmf4x4hf */

    case E_RVVMF4x5HFmode:
      if (!register_operand (operands[2], E_RVVMF4x5HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21311; /* pred_unit_strided_storervvmf4x5hf */

    case E_RVVMF4x6HFmode:
      if (!register_operand (operands[2], E_RVVMF4x6HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21312; /* pred_unit_strided_storervvmf4x6hf */

    case E_RVVMF4x7HFmode:
      if (!register_operand (operands[2], E_RVVMF4x7HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21313; /* pred_unit_strided_storervvmf4x7hf */

    case E_RVVMF4x8HFmode:
      if (!register_operand (operands[2], E_RVVMF4x8HFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21314; /* pred_unit_strided_storervvmf4x8hf */

    case E_RVVMF2x2SFmode:
      if (!register_operand (operands[2], E_RVVMF2x2SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21315; /* pred_unit_strided_storervvmf2x2sf */

    case E_RVVMF2x3SFmode:
      if (!register_operand (operands[2], E_RVVMF2x3SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21316; /* pred_unit_strided_storervvmf2x3sf */

    case E_RVVMF2x4SFmode:
      if (!register_operand (operands[2], E_RVVMF2x4SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21317; /* pred_unit_strided_storervvmf2x4sf */

    case E_RVVMF2x5SFmode:
      if (!register_operand (operands[2], E_RVVMF2x5SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21318; /* pred_unit_strided_storervvmf2x5sf */

    case E_RVVMF2x6SFmode:
      if (!register_operand (operands[2], E_RVVMF2x6SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21319; /* pred_unit_strided_storervvmf2x6sf */

    case E_RVVMF2x7SFmode:
      if (!register_operand (operands[2], E_RVVMF2x7SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21320; /* pred_unit_strided_storervvmf2x7sf */

    case E_RVVMF2x8SFmode:
      if (!register_operand (operands[2], E_RVVMF2x8SFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21321; /* pred_unit_strided_storervvmf2x8sf */

    case E_RVVM1x2DFmode:
      if (!register_operand (operands[2], E_RVVM1x2DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21322; /* pred_unit_strided_storervvm1x2df */

    case E_RVVM1x3DFmode:
      if (!register_operand (operands[2], E_RVVM1x3DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21323; /* pred_unit_strided_storervvm1x3df */

    case E_RVVM1x4DFmode:
      if (!register_operand (operands[2], E_RVVM1x4DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21324; /* pred_unit_strided_storervvm1x4df */

    case E_RVVM1x5DFmode:
      if (!register_operand (operands[2], E_RVVM1x5DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21325; /* pred_unit_strided_storervvm1x5df */

    case E_RVVM1x6DFmode:
      if (!register_operand (operands[2], E_RVVM1x6DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21326; /* pred_unit_strided_storervvm1x6df */

    case E_RVVM1x7DFmode:
      if (!register_operand (operands[2], E_RVVM1x7DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21327; /* pred_unit_strided_storervvm1x7df */

    case E_RVVM1x8DFmode:
      if (!register_operand (operands[2], E_RVVM1x8DFmode)
          || !(
#line 8396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21328; /* pred_unit_strided_storervvm1x8df */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern195 (x1))
    {
    case 0:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20324; /* pred_slide1downrvvm8qi */

    case 1:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20326; /* pred_slide1downrvvm4qi */

    case 2:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20328; /* pred_slide1downrvvm2qi */

    case 3:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20330; /* pred_slide1downrvvm1qi */

    case 4:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20332; /* pred_slide1downrvvmf2qi */

    case 5:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20334; /* pred_slide1downrvvmf4qi */

    case 6:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20336; /* pred_slide1downrvvmf8qi */

    case 7:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20338; /* pred_slide1downrvvm8hi */

    case 8:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20340; /* pred_slide1downrvvm4hi */

    case 9:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20342; /* pred_slide1downrvvm2hi */

    case 10:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20344; /* pred_slide1downrvvm1hi */

    case 11:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20346; /* pred_slide1downrvvmf2hi */

    case 12:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20348; /* pred_slide1downrvvmf4hi */

    case 13:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20350; /* pred_slide1downrvvm8si */

    case 14:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20352; /* pred_slide1downrvvm4si */

    case 15:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20354; /* pred_slide1downrvvm2si */

    case 16:
      if (!
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20356; /* pred_slide1downrvvm1si */

    case 17:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 20358; /* pred_slide1downrvvmf2si */

    case 18:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20360; /* pred_slide1downv1qi */

    case 19:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20362; /* pred_slide1downv2qi */

    case 20:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20364; /* pred_slide1downv4qi */

    case 21:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20366; /* pred_slide1downv8qi */

    case 22:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20368; /* pred_slide1downv16qi */

    case 23:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 20370; /* pred_slide1downv32qi */

    case 24:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20372; /* pred_slide1downv64qi */

    case 25:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20374; /* pred_slide1downv128qi */

    case 26:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20376; /* pred_slide1downv256qi */

    case 27:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20378; /* pred_slide1downv512qi */

    case 28:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20380; /* pred_slide1downv1024qi */

    case 29:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20382; /* pred_slide1downv2048qi */

    case 30:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20384; /* pred_slide1downv4096qi */

    case 31:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20386; /* pred_slide1downv1hi */

    case 32:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20388; /* pred_slide1downv2hi */

    case 33:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20390; /* pred_slide1downv4hi */

    case 34:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20392; /* pred_slide1downv8hi */

    case 35:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20394; /* pred_slide1downv16hi */

    case 36:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20396; /* pred_slide1downv32hi */

    case 37:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20398; /* pred_slide1downv64hi */

    case 38:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20400; /* pred_slide1downv128hi */

    case 39:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20402; /* pred_slide1downv256hi */

    case 40:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20404; /* pred_slide1downv512hi */

    case 41:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20406; /* pred_slide1downv1024hi */

    case 42:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20408; /* pred_slide1downv2048hi */

    case 43:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20410; /* pred_slide1downv1si */

    case 44:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20412; /* pred_slide1downv2si */

    case 45:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20414; /* pred_slide1downv4si */

    case 46:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20416; /* pred_slide1downv8si */

    case 47:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20418; /* pred_slide1downv16si */

    case 48:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20420; /* pred_slide1downv32si */

    case 49:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20422; /* pred_slide1downv64si */

    case 50:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20424; /* pred_slide1downv128si */

    case 51:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20426; /* pred_slide1downv256si */

    case 52:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20428; /* pred_slide1downv512si */

    case 53:
      if (!(
#line 8134 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20430; /* pred_slide1downv1024si */

    case 54:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20432; /* *pred_slide1downrvvm8di */

    case 55:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20434; /* *pred_slide1downrvvm4di */

    case 56:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20436; /* *pred_slide1downrvvm2di */

    case 57:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20438; /* *pred_slide1downrvvm1di */

    case 58:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20440; /* *pred_slide1downv1di */

    case 59:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20442; /* *pred_slide1downv2di */

    case 60:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20444; /* *pred_slide1downv4di */

    case 61:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20446; /* *pred_slide1downv8di */

    case 62:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20448; /* *pred_slide1downv16di */

    case 63:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20450; /* *pred_slide1downv32di */

    case 64:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20452; /* *pred_slide1downv64di */

    case 65:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20454; /* *pred_slide1downv128di */

    case 66:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20456; /* *pred_slide1downv256di */

    case 67:
      if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20458; /* *pred_slide1downv512di */

    case 68:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20460; /* *pred_slide1downrvvm8di_extended */

    case 69:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20462; /* *pred_slide1downrvvm4di_extended */

    case 70:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20464; /* *pred_slide1downrvvm2di_extended */

    case 71:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20466; /* *pred_slide1downrvvm1di_extended */

    case 72:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20468; /* *pred_slide1downv1di_extended */

    case 73:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20470; /* *pred_slide1downv2di_extended */

    case 74:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20472; /* *pred_slide1downv4di_extended */

    case 75:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20474; /* *pred_slide1downv8di_extended */

    case 76:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20476; /* *pred_slide1downv16di_extended */

    case 77:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20478; /* *pred_slide1downv32di_extended */

    case 78:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20480; /* *pred_slide1downv64di_extended */

    case 79:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20482; /* *pred_slide1downv128di_extended */

    case 80:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20484; /* *pred_slide1downv256di_extended */

    case 81:
      if (!(
#line 8198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20486; /* *pred_slide1downv512di_extended */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 105; /* *andsi3 */
          if (
#line 1771 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 111; /* *andsi3_internal */
        }
      if (not_single_bit_mask_operand (operands[2], E_SImode)
          && (
#line 838 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 629; /* *bclrisi */
      if (const_nottwobits_not_arith_operand (operands[2], E_SImode)
          && (
#line 847 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 631; /* *bclrisi_nottwobits */
      if (!not_uimm_extra_bit_or_nottwobits (operands[2], E_SImode)
          || !(
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 648; /* *andisi_extrabit */

    case E_DImode:
      if (pattern268 (x2) != 0
          || !
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 106; /* *anddi3 */

    case E_RVVM8QImode:
      if (pattern233 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24543; /* andrvvm8qi3 */

    case E_RVVM4QImode:
      if (pattern233 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24557; /* andrvvm4qi3 */

    case E_RVVM2QImode:
      if (pattern233 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24571; /* andrvvm2qi3 */

    case E_RVVM1QImode:
      if (pattern233 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24585; /* andrvvm1qi3 */

    case E_RVVM8HImode:
      if (pattern233 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24599; /* andrvvm8hi3 */

    case E_RVVM4HImode:
      if (pattern233 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24613; /* andrvvm4hi3 */

    case E_RVVM2HImode:
      if (pattern233 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24627; /* andrvvm2hi3 */

    case E_RVVM1HImode:
      if (pattern233 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24641; /* andrvvm1hi3 */

    case E_RVVM8SImode:
      if (pattern233 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24655; /* andrvvm8si3 */

    case E_RVVM4SImode:
      if (pattern233 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24669; /* andrvvm4si3 */

    case E_RVVM2SImode:
      if (pattern233 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24683; /* andrvvm2si3 */

    case E_RVVM1SImode:
      if (pattern233 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24697; /* andrvvm1si3 */

    case E_RVVM8DImode:
      if (pattern233 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24711; /* andrvvm8di3 */

    case E_RVVM4DImode:
      if (pattern233 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24725; /* andrvvm4di3 */

    case E_RVVM2DImode:
      if (pattern233 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24739; /* andrvvm2di3 */

    case E_RVVM1DImode:
      if (pattern233 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24753; /* andrvvm1di3 */

    case E_RVVMF2QImode:
      if (pattern233 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24767; /* andrvvmf2qi3 */

    case E_RVVMF4QImode:
      if (pattern233 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24781; /* andrvvmf4qi3 */

    case E_RVVMF8QImode:
      if (pattern233 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24795; /* andrvvmf8qi3 */

    case E_RVVMF2HImode:
      if (pattern233 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24809; /* andrvvmf2hi3 */

    case E_RVVMF4HImode:
      if (pattern233 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24823; /* andrvvmf4hi3 */

    case E_RVVMF2SImode:
      if (pattern233 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24837; /* andrvvmf2si3 */

    case E_V1QImode:
      if (pattern233 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24851; /* andv1qi3 */

    case E_V2QImode:
      if (pattern233 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24865; /* andv2qi3 */

    case E_V4QImode:
      if (pattern233 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24879; /* andv4qi3 */

    case E_V8QImode:
      if (pattern233 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24893; /* andv8qi3 */

    case E_V16QImode:
      if (pattern233 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24907; /* andv16qi3 */

    case E_V32QImode:
      if (pattern233 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24921; /* andv32qi3 */

    case E_V64QImode:
      if (pattern233 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24935; /* andv64qi3 */

    case E_V128QImode:
      if (pattern233 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24949; /* andv128qi3 */

    case E_V256QImode:
      if (pattern233 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24963; /* andv256qi3 */

    case E_V512QImode:
      if (pattern233 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24977; /* andv512qi3 */

    case E_V1024QImode:
      if (pattern233 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24991; /* andv1024qi3 */

    case E_V2048QImode:
      if (pattern233 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25005; /* andv2048qi3 */

    case E_V4096QImode:
      if (pattern233 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25019; /* andv4096qi3 */

    case E_V1HImode:
      if (pattern233 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25033; /* andv1hi3 */

    case E_V2HImode:
      if (pattern233 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25047; /* andv2hi3 */

    case E_V4HImode:
      if (pattern233 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25061; /* andv4hi3 */

    case E_V8HImode:
      if (pattern233 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25075; /* andv8hi3 */

    case E_V16HImode:
      if (pattern233 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25089; /* andv16hi3 */

    case E_V32HImode:
      if (pattern233 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25103; /* andv32hi3 */

    case E_V64HImode:
      if (pattern233 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25117; /* andv64hi3 */

    case E_V128HImode:
      if (pattern233 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25131; /* andv128hi3 */

    case E_V256HImode:
      if (pattern233 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25145; /* andv256hi3 */

    case E_V512HImode:
      if (pattern233 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25159; /* andv512hi3 */

    case E_V1024HImode:
      if (pattern233 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25173; /* andv1024hi3 */

    case E_V2048HImode:
      if (pattern233 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25187; /* andv2048hi3 */

    case E_V1SImode:
      if (pattern233 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25201; /* andv1si3 */

    case E_V2SImode:
      if (pattern233 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25215; /* andv2si3 */

    case E_V4SImode:
      if (pattern233 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25229; /* andv4si3 */

    case E_V8SImode:
      if (pattern233 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25243; /* andv8si3 */

    case E_V16SImode:
      if (pattern233 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25257; /* andv16si3 */

    case E_V32SImode:
      if (pattern233 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25271; /* andv32si3 */

    case E_V64SImode:
      if (pattern233 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25285; /* andv64si3 */

    case E_V128SImode:
      if (pattern233 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25299; /* andv128si3 */

    case E_V256SImode:
      if (pattern233 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25313; /* andv256si3 */

    case E_V512SImode:
      if (pattern233 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25327; /* andv512si3 */

    case E_V1024SImode:
      if (pattern233 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25341; /* andv1024si3 */

    case E_V1DImode:
      if (pattern233 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25355; /* andv1di3 */

    case E_V2DImode:
      if (pattern233 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25369; /* andv2di3 */

    case E_V4DImode:
      if (pattern233 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25383; /* andv4di3 */

    case E_V8DImode:
      if (pattern233 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25397; /* andv8di3 */

    case E_V16DImode:
      if (pattern233 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25411; /* andv16di3 */

    case E_V32DImode:
      if (pattern233 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25425; /* andv32di3 */

    case E_V64DImode:
      if (pattern233 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25439; /* andv64di3 */

    case E_V128DImode:
      if (pattern233 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25453; /* andv128di3 */

    case E_V256DImode:
      if (pattern233 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25467; /* andv256di3 */

    case E_V512DImode:
      if (pattern233 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25481; /* andv512di3 */

    case E_RVVMF64BImode:
      if (pattern0 (x2, 
E_RVVMF64BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 25901; /* andrvvmf64bi3 */

    case E_RVVMF32BImode:
      if (pattern0 (x2, 
E_RVVMF32BImode) != 0
          || !
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25904; /* andrvvmf32bi3 */

    case E_RVVMF16BImode:
      if (pattern0 (x2, 
E_RVVMF16BImode) != 0
          || !
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25907; /* andrvvmf16bi3 */

    case E_RVVMF8BImode:
      if (pattern0 (x2, 
E_RVVMF8BImode) != 0
          || !
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25910; /* andrvvmf8bi3 */

    case E_RVVMF4BImode:
      if (pattern0 (x2, 
E_RVVMF4BImode) != 0
          || !
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25913; /* andrvvmf4bi3 */

    case E_RVVMF2BImode:
      if (pattern0 (x2, 
E_RVVMF2BImode) != 0
          || !
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25916; /* andrvvmf2bi3 */

    case E_RVVM1BImode:
      if (pattern0 (x2, 
E_RVVM1BImode) != 0
          || !
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25919; /* andrvvm1bi3 */

    case E_V1BImode:
      if (pattern0 (x2, 
E_V1BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25922; /* andv1bi3 */

    case E_V2BImode:
      if (pattern0 (x2, 
E_V2BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25925; /* andv2bi3 */

    case E_V4BImode:
      if (pattern0 (x2, 
E_V4BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25928; /* andv4bi3 */

    case E_V8BImode:
      if (pattern0 (x2, 
E_V8BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25931; /* andv8bi3 */

    case E_V16BImode:
      if (pattern0 (x2, 
E_V16BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25934; /* andv16bi3 */

    case E_V32BImode:
      if (pattern0 (x2, 
E_V32BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25937; /* andv32bi3 */

    case E_V64BImode:
      if (pattern0 (x2, 
E_V64BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25940; /* andv64bi3 */

    case E_V128BImode:
      if (pattern0 (x2, 
E_V128BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25943; /* andv128bi3 */

    case E_V256BImode:
      if (pattern0 (x2, 
E_V256BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25946; /* andv256bi3 */

    case E_V512BImode:
      if (pattern0 (x2, 
E_V512BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25949; /* andv512bi3 */

    case E_V1024BImode:
      if (pattern0 (x2, 
E_V1024BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25952; /* andv1024bi3 */

    case E_V2048BImode:
      if (pattern0 (x2, 
E_V2048BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25955; /* andv2048bi3 */

    case E_V4096BImode:
      if (pattern0 (x2, 
E_V4096BImode) != 0
          || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25958; /* andv4096bi3 */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096BImode)
      && reg_or_mem_operand (operands[1], E_V4096BImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3334; /* *movv4096bisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3335; /* *movv4096bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096BImode)
      || !register_operand (operands[1], E_V4096BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3506; /* *movv4096bi_vls */
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024BImode)
      && reg_or_mem_operand (operands[1], E_V1024BImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3330; /* *movv1024bisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3331; /* *movv1024bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024BImode)
      || !register_operand (operands[1], E_V1024BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3504; /* *movv1024bi_vls */
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256BImode)
      && reg_or_mem_operand (operands[1], E_V256BImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3326; /* *movv256bisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3327; /* *movv256bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256BImode)
      || !register_operand (operands[1], E_V256BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3502; /* *movv256bi_vls */
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64BImode)
      && reg_or_mem_operand (operands[1], E_V64BImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3322; /* *movv64bisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3323; /* *movv64bidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64BImode)
      || !register_operand (operands[1], E_V64BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3500; /* *movv64bi_vls */
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3316; /* *movv256dfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3317; /* *movv256dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3413; /* *movv256df_vls */
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024SFmode)
      && reg_or_mem_operand (operands[1], E_V1024SFmode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3308; /* *movv1024sfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3309; /* *movv1024sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024SFmode)
      || !register_operand (operands[1], E_V1024SFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3404; /* *movv1024sf_vls */
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32SFmode)
      && reg_or_mem_operand (operands[1], E_V32SFmode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3298; /* *movv32sfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3299; /* *movv32sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32SFmode)
      || !register_operand (operands[1], E_V32SFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3399; /* *movv32sf_vls */
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64HFmode)
      && reg_or_mem_operand (operands[1], E_V64HFmode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3286; /* *movv64hfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3287; /* *movv64hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64HFmode)
      || !register_operand (operands[1], E_V64HFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3388; /* *movv64hf_vls */
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32DImode)
      && reg_or_mem_operand (operands[1], E_V32DImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3274; /* *movv32disi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3275; /* *movv32didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32DImode)
      || !register_operand (operands[1], E_V32DImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3377; /* *movv32di_vls */
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32SImode)
      && reg_or_mem_operand (operands[1], E_V32SImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3262; /* *movv32sisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3263; /* *movv32sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32SImode)
      || !register_operand (operands[1], E_V32SImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3366; /* *movv32si_vls */
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64HImode)
      && reg_or_mem_operand (operands[1], E_V64HImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3250; /* *movv64hisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3251; /* *movv64hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64HImode)
      || !register_operand (operands[1], E_V64HImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3355; /* *movv64hi_vls */
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256QImode)
      && reg_or_mem_operand (operands[1], E_V256QImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3238; /* *movv256qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3239; /* *movv256qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256QImode)
      || !register_operand (operands[1], E_V256QImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3344; /* *movv256qi_vls */
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4BImode)
      && register_operand (operands[1], E_RVVMF4BImode)
      && 
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2816; /* *movrvvmf4bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4BImode))
    return -1;
  if ((
#line 1354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2856; /* *movrvvmf4bisi_lra */
    }
  if (!(
#line 1354 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2857; /* *movrvvmf4bidi_lra */
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2SImode)
      && register_operand (operands[1], E_RVVMF2SImode)
      && (
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 2799; /* *movrvvmf2si_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2SImode))
    return -1;
  if ((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2835; /* *movrvvmf2sisi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2846; /* *movrvvmf2sidi_lra */
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4HImode)
      && register_operand (operands[1], E_RVVMF4HImode)
      && (
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
    return 2794; /* *movrvvmf4hi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4HImode))
    return -1;
  if ((
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2830; /* *movrvvmf4hisi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2841; /* *movrvvmf4hidi_lra */
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return 3230; /* *movv8bi */
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return -1;
  return 3497; /* *movv8bi_vls */
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4336 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3224; /* *movv4df */
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3407; /* *movv4df_vls */
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3218; /* *movv2sf */
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3395; /* *movv2sf_vls */
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4324 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3212; /* *movv1hf */
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3382; /* *movv1hf_vls */
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4318 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 3206; /* *movv16si */
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3365; /* *movv16si_vls */
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HImode)
      && reg_or_mem_operand (operands[1], E_V4HImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))) && 
#line 4311 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 3199; /* *movv4hi */
  if (!register_operand (operands[0], E_V4HImode)
      || !register_operand (operands[1], E_V4HImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 3351; /* *movv4hi_vls */
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode)
      && (
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 3192; /* *movv1qi */
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 3336; /* *movv1qi_vls */
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3180; /* *movrvvm2x3qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3181; /* *movrvvm2x3qi_di */
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3170; /* *movrvvm2x2hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3171; /* *movrvvm2x2hf_di */
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3156; /* *movrvvm2x2hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3157; /* *movrvvm2x2hi_di */
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3142; /* *movrvvm1x2qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3143; /* *movrvvm1x2qi_di */
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3128; /* *movrvvm1x6hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3129; /* *movrvvm1x6hf_di */
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3114; /* *movrvvm1x6bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3115; /* *movrvvm1x6bf_di */
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3098; /* *movrvvm2x2si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3099; /* *movrvvm2x2si_di */
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3086; /* *movrvvm1x3hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3087; /* *movrvvm1x3hi_di */
}

 int
recog_287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3070; /* *movrvvmf2x2qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3071; /* *movrvvmf2x2qi_di */
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3054; /* *movrvvm1x4sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3055; /* *movrvvm1x4sf_di */
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3038; /* *movrvvmf2x3hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3039; /* *movrvvmf2x3hf_di */
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3022; /* *movrvvmf2x2bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3023; /* *movrvvmf2x2bf_di */
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3006; /* *movrvvm1x4si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3007; /* *movrvvm1x4si_di */
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2992; /* *movrvvmf2x4hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2993; /* *movrvvmf2x4hi_di */
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2976; /* *movrvvmf4x3qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2977; /* *movrvvmf4x3qi_di */
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2960; /* *movrvvm1x2df_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2961; /* *movrvvm1x2df_di */
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2944; /* *movrvvmf4x8hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2945; /* *movrvvmf4x8hf_di */
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2928; /* *movrvvmf4x7bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2929; /* *movrvvmf4x7bf_di */
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2912; /* *movrvvm1x6di_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2913; /* *movrvvm1x6di_di */
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2896; /* *movrvvmf2x5si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2897; /* *movrvvmf2x5si_di */
}

 int
recog_382 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern328 (x2))
    {
    case 0:
      return 298; /* *lshrsi3 */

    case 1:
      if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 301; /* lshrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25495; /* lshrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25699; /* vlshrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25498; /* lshrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25702; /* vlshrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25501; /* lshrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25705; /* vlshrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25504; /* lshrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25708; /* vlshrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25507; /* lshrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25711; /* vlshrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25510; /* lshrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25714; /* vlshrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25513; /* lshrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25717; /* vlshrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25516; /* lshrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25720; /* vlshrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25519; /* lshrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25723; /* vlshrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25522; /* lshrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25726; /* vlshrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25525; /* lshrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25729; /* vlshrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25528; /* lshrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25732; /* vlshrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25531; /* lshrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25735; /* vlshrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25534; /* lshrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25738; /* vlshrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25537; /* lshrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25741; /* vlshrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25540; /* lshrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25744; /* vlshrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25543; /* lshrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25747; /* vlshrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25546; /* lshrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25750; /* vlshrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25549; /* lshrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25753; /* vlshrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25552; /* lshrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25756; /* vlshrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25555; /* lshrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25759; /* vlshrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25558; /* lshrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25762; /* vlshrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 25561; /* lshrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25765; /* vlshrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 25564; /* lshrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25768; /* vlshrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 25567; /* lshrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25771; /* vlshrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 25570; /* lshrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25774; /* vlshrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 25573; /* lshrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25777; /* vlshrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 25576; /* lshrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25780; /* vlshrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 25579; /* lshrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25783; /* vlshrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 25582; /* lshrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25786; /* vlshrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 25585; /* lshrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25789; /* vlshrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 25588; /* lshrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25792; /* vlshrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 25591; /* lshrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25795; /* vlshrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 25594; /* lshrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25798; /* vlshrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 25597; /* lshrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25801; /* vlshrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 25600; /* lshrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25804; /* vlshrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 25603; /* lshrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25807; /* vlshrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 25606; /* lshrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25810; /* vlshrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 25609; /* lshrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25813; /* vlshrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 25612; /* lshrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25816; /* vlshrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 25615; /* lshrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25819; /* vlshrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 25618; /* lshrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25822; /* vlshrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 25621; /* lshrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25825; /* vlshrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 25624; /* lshrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25828; /* vlshrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 25627; /* lshrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25831; /* vlshrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 25630; /* lshrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25834; /* vlshrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 25633; /* lshrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25837; /* vlshrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 25636; /* lshrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25840; /* vlshrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 25639; /* lshrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25843; /* vlshrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 25642; /* lshrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25846; /* vlshrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 25645; /* lshrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25849; /* vlshrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 25648; /* lshrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25852; /* vlshrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 25651; /* lshrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25855; /* vlshrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 25654; /* lshrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25858; /* vlshrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 25657; /* lshrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25861; /* vlshrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 25660; /* lshrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25864; /* vlshrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 25663; /* lshrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25867; /* vlshrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 25666; /* lshrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25870; /* vlshrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 25669; /* lshrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25873; /* vlshrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 25672; /* lshrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25876; /* vlshrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 25675; /* lshrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25879; /* vlshrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 25678; /* lshrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25882; /* vlshrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 25681; /* lshrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25885; /* vlshrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 25684; /* lshrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25888; /* vlshrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 25687; /* lshrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25891; /* vlshrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 25690; /* lshrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25894; /* vlshrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 25693; /* lshrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25897; /* vlshrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 25696; /* lshrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25900; /* vlshrv512di3 */

    default:
      return -1;
    }
}

 int
recog_403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33507; /* pred_crypto_vvsm4rvvrvvm8si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33567; /* pred_crypto_vvsm4rvvx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33627; /* pred_crypto_vvsm4rvvx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33675; /* pred_crypto_vvsm4rvvx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33711; /* pred_crypto_vvsm4rvvx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33735; /* pred_crypto_vvsm4rvvx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33519; /* pred_crypto_vvsm4rvvrvvm4si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33579; /* pred_crypto_vvsm4rvvx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33639; /* pred_crypto_vvsm4rvvx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33687; /* pred_crypto_vvsm4rvvx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33723; /* pred_crypto_vvsm4rvvx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33531; /* pred_crypto_vvsm4rvvrvvm2si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33591; /* pred_crypto_vvsm4rvvx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33651; /* pred_crypto_vvsm4rvvx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33699; /* pred_crypto_vvsm4rvvx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33543; /* pred_crypto_vvsm4rvvrvvm1si */
      if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33603; /* pred_crypto_vvsm4rvvx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33663; /* pred_crypto_vvsm4rvvx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33555; /* pred_crypto_vvsm4rvvrvvmf2si */
      if (!(
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33615; /* pred_crypto_vvsm4rvvx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 33380; /* pred_vsha2clrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 33384; /* pred_vsha2clrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 33388; /* pred_vsha2clrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
        return -1;
      return 33392; /* pred_vsha2clrvvm1si */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33396; /* pred_vsha2clrvvmf2si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33400; /* pred_vsha2clrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33404; /* pred_vsha2clrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33408; /* pred_vsha2clrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33412; /* pred_vsha2clrvvm1di */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33416; /* pred_vsha2clv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33420; /* pred_vsha2clv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33424; /* pred_vsha2clv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33428; /* pred_vsha2clv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33432; /* pred_vsha2clv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33436; /* pred_vsha2clv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33440; /* pred_vsha2clv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33444; /* pred_vsha2clv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33448; /* pred_vsha2clv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33452; /* pred_vsha2clv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33456; /* pred_vsha2clv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33460; /* pred_vsha2clv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33464; /* pred_vsha2clv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33468; /* pred_vsha2clv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33472; /* pred_vsha2clv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33476; /* pred_vsha2clv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33480; /* pred_vsha2clv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33484; /* pred_vsha2clv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33488; /* pred_vsha2clv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33492; /* pred_vsha2clv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 480 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33496; /* pred_vsha2clv512di */

    default:
      return -1;
    }
}

 int
recog_412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_410 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_409 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_408 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern442 (x2))
        {
        case 0:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14153; /* pred_andrvvmf64bi */

        case 1:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14156; /* pred_andrvvmf32bi */

        case 2:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14159; /* pred_andrvvmf16bi */

        case 3:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14162; /* pred_andrvvmf8bi */

        case 4:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14165; /* pred_andrvvmf4bi */

        case 5:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14168; /* pred_andrvvmf2bi */

        case 6:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14171; /* pred_andrvvm1bi */

        case 7:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14174; /* pred_andv1bi */

        case 8:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14177; /* pred_andv2bi */

        case 9:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14180; /* pred_andv4bi */

        case 10:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14183; /* pred_andv8bi */

        case 11:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14186; /* pred_andv16bi */

        case 12:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14189; /* pred_andv32bi */

        case 13:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14192; /* pred_andv64bi */

        case 14:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14195; /* pred_andv128bi */

        case 15:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14198; /* pred_andv256bi */

        case 16:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14201; /* pred_andv512bi */

        case 17:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14204; /* pred_andv1024bi */

        case 18:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14207; /* pred_andv2048bi */

        case 19:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14210; /* pred_andv4096bi */

        case 20:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14273; /* pred_andnotrvvmf64bi */

        case 21:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14275; /* pred_andnotrvvmf32bi */

        case 22:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14277; /* pred_andnotrvvmf16bi */

        case 23:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14279; /* pred_andnotrvvmf8bi */

        case 24:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14281; /* pred_andnotrvvmf4bi */

        case 25:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14283; /* pred_andnotrvvmf2bi */

        case 26:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14285; /* pred_andnotrvvm1bi */

        case 27:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14287; /* pred_andnotv1bi */

        case 28:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14289; /* pred_andnotv2bi */

        case 29:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14291; /* pred_andnotv4bi */

        case 30:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14293; /* pred_andnotv8bi */

        case 31:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14295; /* pred_andnotv16bi */

        case 32:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14297; /* pred_andnotv32bi */

        case 33:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14299; /* pred_andnotv64bi */

        case 34:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14301; /* pred_andnotv128bi */

        case 35:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14303; /* pred_andnotv256bi */

        case 36:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14305; /* pred_andnotv512bi */

        case 37:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14307; /* pred_andnotv1024bi */

        case 38:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14309; /* pred_andnotv2048bi */

        case 39:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14311; /* pred_andnotv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern442 (x2))
        {
        case 0:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14154; /* pred_iorrvvmf64bi */

        case 1:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14157; /* pred_iorrvvmf32bi */

        case 2:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14160; /* pred_iorrvvmf16bi */

        case 3:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14163; /* pred_iorrvvmf8bi */

        case 4:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14166; /* pred_iorrvvmf4bi */

        case 5:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14169; /* pred_iorrvvmf2bi */

        case 6:
          if (!
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14172; /* pred_iorrvvm1bi */

        case 7:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14175; /* pred_iorv1bi */

        case 8:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14178; /* pred_iorv2bi */

        case 9:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14181; /* pred_iorv4bi */

        case 10:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14184; /* pred_iorv8bi */

        case 11:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14187; /* pred_iorv16bi */

        case 12:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14190; /* pred_iorv32bi */

        case 13:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14193; /* pred_iorv64bi */

        case 14:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14196; /* pred_iorv128bi */

        case 15:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14199; /* pred_iorv256bi */

        case 16:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14202; /* pred_iorv512bi */

        case 17:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14205; /* pred_iorv1024bi */

        case 18:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14208; /* pred_iorv2048bi */

        case 19:
          if (!(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14211; /* pred_iorv4096bi */

        case 20:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14274; /* pred_iornotrvvmf64bi */

        case 21:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14276; /* pred_iornotrvvmf32bi */

        case 22:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14278; /* pred_iornotrvvmf16bi */

        case 23:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14280; /* pred_iornotrvvmf8bi */

        case 24:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14282; /* pred_iornotrvvmf4bi */

        case 25:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14284; /* pred_iornotrvvmf2bi */

        case 26:
          if (!
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14286; /* pred_iornotrvvm1bi */

        case 27:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14288; /* pred_iornotv1bi */

        case 28:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14290; /* pred_iornotv2bi */

        case 29:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14292; /* pred_iornotv4bi */

        case 30:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14294; /* pred_iornotv8bi */

        case 31:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14296; /* pred_iornotv16bi */

        case 32:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14298; /* pred_iornotv32bi */

        case 33:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14300; /* pred_iornotv64bi */

        case 34:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14302; /* pred_iornotv128bi */

        case 35:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14304; /* pred_iornotv256bi */

        case 36:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14306; /* pred_iornotv512bi */

        case 37:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14308; /* pred_iornotv1024bi */

        case 38:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14310; /* pred_iornotv2048bi */

        case 39:
          if (!(
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14312; /* pred_iornotv4096bi */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[5] = x6;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      operands[6] = x7;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern440 (x2, 
E_RVVMF64BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 14155; /* pred_xorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern440 (x2, 
E_RVVMF32BImode) != 0
              || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14158; /* pred_xorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern440 (x2, 
E_RVVMF16BImode) != 0
              || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14161; /* pred_xorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern440 (x2, 
E_RVVMF8BImode) != 0
              || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14164; /* pred_xorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern440 (x2, 
E_RVVMF4BImode) != 0
              || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14167; /* pred_xorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern440 (x2, 
E_RVVMF2BImode) != 0
              || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14170; /* pred_xorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern440 (x2, 
E_RVVM1BImode) != 0
              || !
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14173; /* pred_xorrvvm1bi */

        case E_V1BImode:
          if (pattern440 (x2, 
E_V1BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14176; /* pred_xorv1bi */

        case E_V2BImode:
          if (pattern440 (x2, 
E_V2BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14179; /* pred_xorv2bi */

        case E_V4BImode:
          if (pattern440 (x2, 
E_V4BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14182; /* pred_xorv4bi */

        case E_V8BImode:
          if (pattern440 (x2, 
E_V8BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14185; /* pred_xorv8bi */

        case E_V16BImode:
          if (pattern440 (x2, 
E_V16BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14188; /* pred_xorv16bi */

        case E_V32BImode:
          if (pattern440 (x2, 
E_V32BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14191; /* pred_xorv32bi */

        case E_V64BImode:
          if (pattern440 (x2, 
E_V64BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14194; /* pred_xorv64bi */

        case E_V128BImode:
          if (pattern440 (x2, 
E_V128BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14197; /* pred_xorv128bi */

        case E_V256BImode:
          if (pattern440 (x2, 
E_V256BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14200; /* pred_xorv256bi */

        case E_V512BImode:
          if (pattern440 (x2, 
E_V512BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14203; /* pred_xorv512bi */

        case E_V1024BImode:
          if (pattern440 (x2, 
E_V1024BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14206; /* pred_xorv1024bi */

        case E_V2048BImode:
          if (pattern440 (x2, 
E_V2048BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14209; /* pred_xorv2048bi */

        case E_V4096BImode:
          if (pattern440 (x2, 
E_V4096BImode) != 0
              || !(
#line 6018 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14212; /* pred_xorv4096bi */

        default:
          return -1;
        }

    case NOT:
      return recog_411 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1DFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4343; /* *pred_broadcastv1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1DFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4465; /* *pred_broadcastv1df_imm */
}

 int
recog_428 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 4339; /* *pred_broadcastv128sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4461; /* *pred_broadcastv128sf_imm */
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4335; /* *pred_broadcastv8sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4457; /* *pred_broadcastv8sf_imm */
}

 int
recog_436 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2048BImode)
      && vector_const_0_operand (operands[3], E_V2048HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return 4331; /* *pred_broadcastv2048hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2048BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2048HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4453; /* *pred_broadcastv2048hf_imm */
}

 int
recog_440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return 4327; /* *pred_broadcastv128hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4449; /* *pred_broadcastv128hf_imm */
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4323; /* *pred_broadcastv8hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4445; /* *pred_broadcastv8hf_imm */
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512DImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 4319; /* *pred_broadcastv512di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512DImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4441; /* *pred_broadcastv512di_imm */
}

 int
recog_452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V32BImode)
      && vector_const_0_operand (operands[3], E_V32DImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 4315; /* *pred_broadcastv32di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V32DImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4437; /* *pred_broadcastv32di_imm */
}

 int
recog_457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1DImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 4310; /* *pred_broadcastv1di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1DImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4432; /* *pred_broadcastv1di_imm */
}

 int
recog_462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64SImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 4305; /* *pred_broadcastv64si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64SImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4427; /* *pred_broadcastv64si_imm */
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2SImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 4300; /* *pred_broadcastv2si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2SImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 4422; /* *pred_broadcastv2si_imm */
}

 int
recog_472 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 4295; /* *pred_broadcastv256hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4417; /* *pred_broadcastv256hi_imm */
}

 int
recog_478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 4289; /* *pred_broadcastv4hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 4411; /* *pred_broadcastv4hi_imm */
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 4282; /* *pred_broadcastv256qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4404; /* *pred_broadcastv256qi_imm */
}

 int
recog_492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V2BImode)
      && vector_const_0_operand (operands[3], E_V2QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 4275; /* *pred_broadcastv2qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V2QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 4397; /* *pred_broadcastv2qi_imm */
}

 int
recog_499 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
      && vector_const_0_operand (operands[3], E_RVVM1SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4268; /* *pred_broadcastrvvm1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4390; /* *pred_broadcastrvvm1sf_imm */
}

 int
recog_506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM2HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4261; /* *pred_broadcastrvvm2hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4383; /* *pred_broadcastrvvm2hf_imm */
}

 int
recog_513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 20703; /* pred_gatherv256df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20825; /* pred_gatherv256df_scalar */
}

 int
recog_517 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 20699; /* pred_gatherv16df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20821; /* pred_gatherv16df_scalar */
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20695; /* pred_gatherv1df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20817; /* pred_gatherv1df_scalar */
}

 int
recog_526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 20690; /* pred_gatherv64sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20812; /* pred_gatherv64sf_scalar */
}

 int
recog_531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 20685; /* pred_gatherv2sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 20807; /* pred_gatherv2sf_scalar */
}

 int
recog_536 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return 20680; /* pred_gatherv256hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20802; /* pred_gatherv256hf_scalar */
}

 int
recog_541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20675; /* pred_gatherv8hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20797; /* pred_gatherv8hf_scalar */
}

 int
recog_546 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V256DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 20670; /* pred_gatherv256di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20792; /* pred_gatherv256di_scalar */
}

 int
recog_551 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V8DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 20665; /* pred_gatherv8di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20787; /* pred_gatherv8di_scalar */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 20660; /* pred_gatherv512si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20782; /* pred_gatherv512si_scalar */
}

 int
recog_561 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 20655; /* pred_gatherv16si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20777; /* pred_gatherv16si_scalar */
}

 int
recog_566 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 20650; /* pred_gatherv2048hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20772; /* pred_gatherv2048hi_scalar */
}

 int
recog_571 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 20645; /* pred_gatherv64hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20767; /* pred_gatherv64hi_scalar */
}

 int
recog_576 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 20640; /* pred_gatherv2hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 20762; /* pred_gatherv2hi_scalar */
}

 int
recog_581 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 20635; /* pred_gatherv512qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20757; /* pred_gatherv512qi_scalar */
}

 int
recog_586 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return 20630; /* pred_gatherv16qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 20752; /* pred_gatherv16qi_scalar */
}

 int
recog_591 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM1DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20625; /* pred_gatherrvvm1df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20747; /* pred_gatherrvvm1df_scalar */
}

 int
recog_596 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[3] = x9;
  x10 = XVECEXP (x8, 0, 1);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern603 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20583; /* pred_gatherrvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20705; /* pred_gatherrvvm8qi_scalar */

    case E_RVVM4QImode:
      if (pattern603 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20584; /* pred_gatherrvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20706; /* pred_gatherrvvm4qi_scalar */

    case E_RVVM2QImode:
      if (pattern603 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20585; /* pred_gatherrvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20707; /* pred_gatherrvvm2qi_scalar */

    case E_RVVM1QImode:
      if (pattern603 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20586; /* pred_gatherrvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20708; /* pred_gatherrvvm1qi_scalar */

    case E_RVVM8HImode:
      if (pattern603 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20587; /* pred_gatherrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20709; /* pred_gatherrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern603 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20588; /* pred_gatherrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20710; /* pred_gatherrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern603 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20589; /* pred_gatherrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20711; /* pred_gatherrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern603 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20590; /* pred_gatherrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20712; /* pred_gatherrvvm1hi_scalar */

    case E_RVVM8SImode:
      if (pattern603 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20591; /* pred_gatherrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20713; /* pred_gatherrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern603 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20592; /* pred_gatherrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20714; /* pred_gatherrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern603 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20593; /* pred_gatherrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20715; /* pred_gatherrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern603 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 20594; /* pred_gatherrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20716; /* pred_gatherrvvm1si_scalar */

    case E_RVVM8DImode:
      if (pattern603 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 20595; /* pred_gatherrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20717; /* pred_gatherrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern603 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 20596; /* pred_gatherrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20718; /* pred_gatherrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern603 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 20597; /* pred_gatherrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20719; /* pred_gatherrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern603 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 20598; /* pred_gatherrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20720; /* pred_gatherrvvm1di_scalar */

    case E_RVVMF2QImode:
      if (pattern603 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 20599; /* pred_gatherrvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 20721; /* pred_gatherrvvmf2qi_scalar */

    case E_RVVMF4QImode:
      if (pattern603 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 20600; /* pred_gatherrvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 20722; /* pred_gatherrvvmf4qi_scalar */

    case E_RVVMF8QImode:
      if (pattern603 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 20601; /* pred_gatherrvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 20723; /* pred_gatherrvvmf8qi_scalar */

    case E_RVVMF2HImode:
      if (pattern603 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 20602; /* pred_gatherrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 20724; /* pred_gatherrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern603 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 20603; /* pred_gatherrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 20725; /* pred_gatherrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      if (pattern603 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 20604; /* pred_gatherrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 20726; /* pred_gatherrvvmf2si_scalar */

    case E_RVVM8BFmode:
      if (pattern603 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 20605; /* pred_gatherrvvm8bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20727; /* pred_gatherrvvm8bf_scalar */

    case E_RVVM4BFmode:
      if (pattern603 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 20606; /* pred_gatherrvvm4bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20728; /* pred_gatherrvvm4bf_scalar */

    case E_RVVM2BFmode:
      if (pattern603 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 20607; /* pred_gatherrvvm2bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20729; /* pred_gatherrvvm2bf_scalar */

    case E_RVVM1BFmode:
      if (pattern603 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 20608; /* pred_gatherrvvm1bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20730; /* pred_gatherrvvm1bf_scalar */

    case E_RVVMF2BFmode:
      if (pattern603 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 20609; /* pred_gatherrvvmf2bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20731; /* pred_gatherrvvmf2bf_scalar */

    case E_RVVMF4BFmode:
      if (pattern603 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return 20610; /* pred_gatherrvvmf4bf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20732; /* pred_gatherrvvmf4bf_scalar */

    case E_RVVM8HFmode:
      if (pattern603 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 20611; /* pred_gatherrvvm8hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20733; /* pred_gatherrvvm8hf_scalar */

    case E_RVVM4HFmode:
      if (pattern603 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 20612; /* pred_gatherrvvm4hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20734; /* pred_gatherrvvm4hf_scalar */

    case E_RVVM2HFmode:
      if (pattern603 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 20613; /* pred_gatherrvvm2hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20735; /* pred_gatherrvvm2hf_scalar */

    case E_RVVM1HFmode:
      if (pattern603 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 20614; /* pred_gatherrvvm1hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20736; /* pred_gatherrvvm1hf_scalar */

    case E_RVVMF2HFmode:
      if (pattern603 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return 20615; /* pred_gatherrvvmf2hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20737; /* pred_gatherrvvmf2hf_scalar */

    case E_RVVMF4HFmode:
      if (pattern603 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return 20616; /* pred_gatherrvvmf4hf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20738; /* pred_gatherrvvmf4hf_scalar */

    case E_RVVM8SFmode:
      if (pattern603 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM8SImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 20617; /* pred_gatherrvvm8sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20739; /* pred_gatherrvvm8sf_scalar */

    case E_RVVM4SFmode:
      if (pattern603 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM4SImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 20618; /* pred_gatherrvvm4sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20740; /* pred_gatherrvvm4sf_scalar */

    case E_RVVM2SFmode:
      if (pattern603 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM2SImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 20619; /* pred_gatherrvvm2sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20741; /* pred_gatherrvvm2sf_scalar */

    case E_RVVM1SFmode:
      if (pattern603 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVM1SImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 20620; /* pred_gatherrvvm1sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20742; /* pred_gatherrvvm1sf_scalar */

    case E_RVVMF2SFmode:
      if (pattern603 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 8239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 20621; /* pred_gatherrvvmf2sf */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 8259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20743; /* pred_gatherrvvmf2sf_scalar */

    case E_RVVM8DFmode:
      return recog_594 (x1, insn, pnum_clobbers);

    case E_RVVM4DFmode:
      return recog_593 (x1, insn, pnum_clobbers);

    case E_RVVM2DFmode:
      return recog_592 (x1, insn, pnum_clobbers);

    case E_RVVM1DFmode:
      return recog_591 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_590 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_589 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_588 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_587 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_586 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_585 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_584 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_583 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_582 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_581 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_580 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_579 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_578 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_577 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_576 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_575 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_574 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_573 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_572 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_571 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_570 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_569 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_568 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_567 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_566 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_565 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_564 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_563 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_562 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_561 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_560 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_559 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_558 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_557 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_556 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_555 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_554 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_553 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_552 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_551 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_550 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_549 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_548 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_547 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_546 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_545 (x1, insn, pnum_clobbers);

    case E_V1HFmode:
      return recog_544 (x1, insn, pnum_clobbers);

    case E_V2HFmode:
      return recog_543 (x1, insn, pnum_clobbers);

    case E_V4HFmode:
      return recog_542 (x1, insn, pnum_clobbers);

    case E_V8HFmode:
      return recog_541 (x1, insn, pnum_clobbers);

    case E_V16HFmode:
      return recog_540 (x1, insn, pnum_clobbers);

    case E_V32HFmode:
      return recog_539 (x1, insn, pnum_clobbers);

    case E_V64HFmode:
      return recog_538 (x1, insn, pnum_clobbers);

    case E_V128HFmode:
      return recog_537 (x1, insn, pnum_clobbers);

    case E_V256HFmode:
      return recog_536 (x1, insn, pnum_clobbers);

    case E_V512HFmode:
      return recog_535 (x1, insn, pnum_clobbers);

    case E_V1024HFmode:
      return recog_534 (x1, insn, pnum_clobbers);

    case E_V2048HFmode:
      return recog_533 (x1, insn, pnum_clobbers);

    case E_V1SFmode:
      return recog_532 (x1, insn, pnum_clobbers);

    case E_V2SFmode:
      return recog_531 (x1, insn, pnum_clobbers);

    case E_V4SFmode:
      return recog_530 (x1, insn, pnum_clobbers);

    case E_V8SFmode:
      return recog_529 (x1, insn, pnum_clobbers);

    case E_V16SFmode:
      return recog_528 (x1, insn, pnum_clobbers);

    case E_V32SFmode:
      return recog_527 (x1, insn, pnum_clobbers);

    case E_V64SFmode:
      return recog_526 (x1, insn, pnum_clobbers);

    case E_V128SFmode:
      return recog_525 (x1, insn, pnum_clobbers);

    case E_V256SFmode:
      return recog_524 (x1, insn, pnum_clobbers);

    case E_V512SFmode:
      return recog_523 (x1, insn, pnum_clobbers);

    case E_V1024SFmode:
      return recog_522 (x1, insn, pnum_clobbers);

    case E_V1DFmode:
      return recog_521 (x1, insn, pnum_clobbers);

    case E_V2DFmode:
      return recog_520 (x1, insn, pnum_clobbers);

    case E_V4DFmode:
      return recog_519 (x1, insn, pnum_clobbers);

    case E_V8DFmode:
      return recog_518 (x1, insn, pnum_clobbers);

    case E_V16DFmode:
      return recog_517 (x1, insn, pnum_clobbers);

    case E_V32DFmode:
      return recog_516 (x1, insn, pnum_clobbers);

    case E_V64DFmode:
      return recog_515 (x1, insn, pnum_clobbers);

    case E_V128DFmode:
      return recog_514 (x1, insn, pnum_clobbers);

    case E_V256DFmode:
      return recog_513 (x1, insn, pnum_clobbers);

    case E_V512DFmode:
      return recog_512 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_603 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern604 (x2))
    {
    case 0:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32947; /* pred_vrev8rvvm8qi */

    case 1:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32950; /* pred_vrev8rvvm4qi */

    case 2:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32953; /* pred_vrev8rvvm2qi */

    case 3:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32956; /* pred_vrev8rvvm1qi */

    case 4:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32959; /* pred_vrev8rvvm8hi */

    case 5:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32962; /* pred_vrev8rvvm4hi */

    case 6:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32965; /* pred_vrev8rvvm2hi */

    case 7:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32968; /* pred_vrev8rvvm1hi */

    case 8:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32971; /* pred_vrev8rvvm8si */

    case 9:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32974; /* pred_vrev8rvvm4si */

    case 10:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32977; /* pred_vrev8rvvm2si */

    case 11:
      if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32980; /* pred_vrev8rvvm1si */

    case 12:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32983; /* pred_vrev8rvvm8di */

    case 13:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32986; /* pred_vrev8rvvm4di */

    case 14:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32989; /* pred_vrev8rvvm2di */

    case 15:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32992; /* pred_vrev8rvvm1di */

    case 16:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32995; /* pred_vrev8rvvmf2qi */

    case 17:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32998; /* pred_vrev8rvvmf4qi */

    case 18:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33001; /* pred_vrev8rvvmf8qi */

    case 19:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33004; /* pred_vrev8rvvmf2hi */

    case 20:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33007; /* pred_vrev8rvvmf4hi */

    case 21:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33010; /* pred_vrev8rvvmf2si */

    case 22:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 33013; /* pred_vrev8v1qi */

    case 23:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 33016; /* pred_vrev8v2qi */

    case 24:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 33019; /* pred_vrev8v4qi */

    case 25:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 33022; /* pred_vrev8v8qi */

    case 26:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 33025; /* pred_vrev8v16qi */

    case 27:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 33028; /* pred_vrev8v32qi */

    case 28:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33031; /* pred_vrev8v64qi */

    case 29:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33034; /* pred_vrev8v128qi */

    case 30:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33037; /* pred_vrev8v256qi */

    case 31:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33040; /* pred_vrev8v512qi */

    case 32:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33043; /* pred_vrev8v1024qi */

    case 33:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33046; /* pred_vrev8v2048qi */

    case 34:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33049; /* pred_vrev8v4096qi */

    case 35:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 33052; /* pred_vrev8v1hi */

    case 36:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 33055; /* pred_vrev8v2hi */

    case 37:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 33058; /* pred_vrev8v4hi */

    case 38:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 33061; /* pred_vrev8v8hi */

    case 39:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 33064; /* pred_vrev8v16hi */

    case 40:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33067; /* pred_vrev8v32hi */

    case 41:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33070; /* pred_vrev8v64hi */

    case 42:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33073; /* pred_vrev8v128hi */

    case 43:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33076; /* pred_vrev8v256hi */

    case 44:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33079; /* pred_vrev8v512hi */

    case 45:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33082; /* pred_vrev8v1024hi */

    case 46:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33085; /* pred_vrev8v2048hi */

    case 47:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33088; /* pred_vrev8v1si */

    case 48:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33091; /* pred_vrev8v2si */

    case 49:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33094; /* pred_vrev8v4si */

    case 50:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33097; /* pred_vrev8v8si */

    case 51:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33100; /* pred_vrev8v16si */

    case 52:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33103; /* pred_vrev8v32si */

    case 53:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33106; /* pred_vrev8v64si */

    case 54:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33109; /* pred_vrev8v128si */

    case 55:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33112; /* pred_vrev8v256si */

    case 56:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33115; /* pred_vrev8v512si */

    case 57:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33118; /* pred_vrev8v1024si */

    case 58:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33121; /* pred_vrev8v1di */

    case 59:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33124; /* pred_vrev8v2di */

    case 60:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33127; /* pred_vrev8v4di */

    case 61:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33130; /* pred_vrev8v8di */

    case 62:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33133; /* pred_vrev8v16di */

    case 63:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33136; /* pred_vrev8v32di */

    case 64:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33139; /* pred_vrev8v64di */

    case 65:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33142; /* pred_vrev8v128di */

    case 66:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33145; /* pred_vrev8v256di */

    case 67:
      if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33148; /* pred_vrev8v512di */

    default:
      return -1;
    }
}

 int
recog_618 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4SImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13090; /* *pred_mul_plusrvvm4si_undef */
}

 int
recog_620 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1SImode)
      || !
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 13092; /* *pred_mul_plusrvvm1si_undef */
}

 int
recog_622 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM4DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM4DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM4DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13094; /* *pred_mul_plusrvvm4di_undef */
}

 int
recog_626 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF4QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF4QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF4QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13098; /* *pred_mul_plusrvvmf4qi_undef */
}

 int
recog_630 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13102; /* *pred_mul_plusrvvmf2si_undef */
}

 int
recog_634 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 13106; /* *pred_mul_plusv8qi_undef */
}

 int
recog_638 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13110; /* *pred_mul_plusv128qi_undef */
}

 int
recog_643 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4096QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4096QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4096QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13115; /* *pred_mul_plusv4096qi_undef */
}

 int
recog_648 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13120; /* *pred_mul_plusv16hi_undef */
}

 int
recog_653 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13125; /* *pred_mul_plusv512hi_undef */
}

 int
recog_658 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13130; /* *pred_mul_plusv4si_undef */
}

 int
recog_663 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V128SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V128SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V128SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13135; /* *pred_mul_plusv128si_undef */
}

 int
recog_669 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V4DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V4DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V4DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13141; /* *pred_mul_plusv4di_undef */
}

 int
recog_675 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13147; /* *pred_mul_plusv256di_undef */
}

 int
recog_681 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_672 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V32DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13212; /* *pred_maddv32di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13280; /* *pred_maccv32di */
}

 int
recog_687 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_666 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13206; /* *pred_maddv1024si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13274; /* *pred_maccv1024si */
}

 int
recog_694 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_659 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13199; /* *pred_maddv8si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13267; /* *pred_maccv8si */
}

 int
recog_701 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_652 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13192; /* *pred_maddv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13260; /* *pred_maccv256hi */
}

 int
recog_708 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_645 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13185; /* *pred_maddv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13253; /* *pred_maccv2hi */
}

 int
recog_715 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_638 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13178; /* *pred_maddv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13246; /* *pred_maccv128qi */
}

 int
recog_723 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 13346; /* *pred_maddv8di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13414; /* *pred_maccv8di_scalar */
}

 int
recog_730 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13339; /* *pred_maddv128si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13407; /* *pred_maccv128si_scalar */
}

 int
recog_737 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return 13332; /* *pred_maddv1si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
    return -1;
  return 13400; /* *pred_maccv1si_scalar */
}

 int
recog_744 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13325; /* *pred_maddv32hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13393; /* *pred_maccv32hi_scalar */
}

 int
recog_751 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      switch (pattern566 (x2))
        {
        case 0:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9301; /* pred_dual_widen_addsrvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9307; /* pred_dual_widen_addsrvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9313; /* pred_dual_widen_addsrvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9319; /* pred_dual_widen_addsrvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9325; /* pred_dual_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9331; /* pred_dual_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9337; /* pred_dual_widen_addsrvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9343; /* pred_dual_widen_addsrvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9349; /* pred_dual_widen_addsrvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9355; /* pred_dual_widen_addsrvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9361; /* pred_dual_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9367; /* pred_dual_widen_addsrvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9373; /* pred_dual_widen_addsrvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9379; /* pred_dual_widen_addsrvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9385; /* pred_dual_widen_addsrvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9391; /* pred_dual_widen_addsv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9397; /* pred_dual_widen_addsv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9403; /* pred_dual_widen_addsv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9409; /* pred_dual_widen_addsv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9415; /* pred_dual_widen_addsv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9421; /* pred_dual_widen_addsv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9427; /* pred_dual_widen_addsv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9433; /* pred_dual_widen_addsv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9439; /* pred_dual_widen_addsv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9445; /* pred_dual_widen_addsv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9451; /* pred_dual_widen_addsv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9457; /* pred_dual_widen_addsv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9463; /* pred_dual_widen_addsv1si */

        case 28:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9469; /* pred_dual_widen_addsv2si */

        case 29:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9475; /* pred_dual_widen_addsv4si */

        case 30:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9481; /* pred_dual_widen_addsv8si */

        case 31:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9487; /* pred_dual_widen_addsv16si */

        case 32:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9493; /* pred_dual_widen_addsv32si */

        case 33:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9499; /* pred_dual_widen_addsv64si */

        case 34:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9505; /* pred_dual_widen_addsv128si */

        case 35:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9511; /* pred_dual_widen_addsv256si */

        case 36:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9517; /* pred_dual_widen_addsv512si */

        case 37:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9523; /* pred_dual_widen_addsv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9529; /* pred_dual_widen_addsv1di */

        case 39:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9535; /* pred_dual_widen_addsv2di */

        case 40:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9541; /* pred_dual_widen_addsv4di */

        case 41:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9547; /* pred_dual_widen_addsv8di */

        case 42:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9553; /* pred_dual_widen_addsv16di */

        case 43:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9559; /* pred_dual_widen_addsv32di */

        case 44:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9565; /* pred_dual_widen_addsv64di */

        case 45:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9571; /* pred_dual_widen_addsv128di */

        case 46:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9577; /* pred_dual_widen_addsv256di */

        case 47:
          if (!(
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9583; /* pred_dual_widen_addsv512di */

        case 48:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9589; /* pred_dual_widen_addsrvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9595; /* pred_dual_widen_addsrvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9601; /* pred_dual_widen_addsrvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9607; /* pred_dual_widen_addsrvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9613; /* pred_dual_widen_addsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9619; /* pred_dual_widen_addsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9625; /* pred_dual_widen_addsrvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9631; /* pred_dual_widen_addsrvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9637; /* pred_dual_widen_addsrvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9643; /* pred_dual_widen_addsrvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9649; /* pred_dual_widen_addsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9655; /* pred_dual_widen_addsrvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9661; /* pred_dual_widen_addsrvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9667; /* pred_dual_widen_addsrvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9673; /* pred_dual_widen_addsrvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9679; /* pred_dual_widen_addsv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9685; /* pred_dual_widen_addsv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9691; /* pred_dual_widen_addsv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9697; /* pred_dual_widen_addsv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9703; /* pred_dual_widen_addsv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9709; /* pred_dual_widen_addsv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9715; /* pred_dual_widen_addsv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9721; /* pred_dual_widen_addsv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9727; /* pred_dual_widen_addsv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9733; /* pred_dual_widen_addsv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9739; /* pred_dual_widen_addsv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9745; /* pred_dual_widen_addsv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9751; /* pred_dual_widen_addsv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9757; /* pred_dual_widen_addsv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9763; /* pred_dual_widen_addsv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9769; /* pred_dual_widen_addsv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9775; /* pred_dual_widen_addsv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9781; /* pred_dual_widen_addsv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9787; /* pred_dual_widen_addsv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9793; /* pred_dual_widen_addsv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9799; /* pred_dual_widen_addsv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9805; /* pred_dual_widen_addsv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9811; /* pred_dual_widen_addsv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9817; /* pred_dual_widen_addsv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9823; /* pred_dual_widen_addsv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9829; /* pred_dual_widen_addsv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9835; /* pred_dual_widen_addsv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9841; /* pred_dual_widen_addsv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9847; /* pred_dual_widen_addsv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9853; /* pred_dual_widen_addsv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9859; /* pred_dual_widen_addsv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9865; /* pred_dual_widen_addsv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9871; /* pred_dual_widen_addsv512di_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern567 (x2))
        {
        case 0:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9973; /* pred_single_widen_addsrvvm8hi */

        case 1:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9975; /* pred_single_widen_addsrvvm4hi */

        case 2:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9977; /* pred_single_widen_addsrvvm2hi */

        case 3:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9979; /* pred_single_widen_addsrvvm1hi */

        case 4:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9981; /* pred_single_widen_addsrvvmf2hi */

        case 5:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9983; /* pred_single_widen_addsrvvmf4hi */

        case 6:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9985; /* pred_single_widen_addsrvvm8si */

        case 7:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9987; /* pred_single_widen_addsrvvm4si */

        case 8:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9989; /* pred_single_widen_addsrvvm2si */

        case 9:
          if (!
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9991; /* pred_single_widen_addsrvvm1si */

        case 10:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9993; /* pred_single_widen_addsrvvmf2si */

        case 11:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9995; /* pred_single_widen_addsrvvm8di */

        case 12:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9997; /* pred_single_widen_addsrvvm4di */

        case 13:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9999; /* pred_single_widen_addsrvvm2di */

        case 14:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10001; /* pred_single_widen_addsrvvm1di */

        case 15:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10003; /* pred_single_widen_addsv1hi */

        case 16:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10005; /* pred_single_widen_addsv2hi */

        case 17:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10007; /* pred_single_widen_addsv4hi */

        case 18:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10009; /* pred_single_widen_addsv8hi */

        case 19:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10011; /* pred_single_widen_addsv16hi */

        case 20:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10013; /* pred_single_widen_addsv32hi */

        case 21:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10015; /* pred_single_widen_addsv64hi */

        case 22:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10017; /* pred_single_widen_addsv128hi */

        case 23:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10019; /* pred_single_widen_addsv256hi */

        case 24:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10021; /* pred_single_widen_addsv512hi */

        case 25:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10023; /* pred_single_widen_addsv1024hi */

        case 26:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10025; /* pred_single_widen_addsv2048hi */

        case 27:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10027; /* pred_single_widen_addsv1si */

        case 28:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10029; /* pred_single_widen_addsv2si */

        case 29:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10031; /* pred_single_widen_addsv4si */

        case 30:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10033; /* pred_single_widen_addsv8si */

        case 31:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10035; /* pred_single_widen_addsv16si */

        case 32:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10037; /* pred_single_widen_addsv32si */

        case 33:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10039; /* pred_single_widen_addsv64si */

        case 34:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10041; /* pred_single_widen_addsv128si */

        case 35:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10043; /* pred_single_widen_addsv256si */

        case 36:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10045; /* pred_single_widen_addsv512si */

        case 37:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10047; /* pred_single_widen_addsv1024si */

        case 38:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10049; /* pred_single_widen_addsv1di */

        case 39:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10051; /* pred_single_widen_addsv2di */

        case 40:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10053; /* pred_single_widen_addsv4di */

        case 41:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10055; /* pred_single_widen_addsv8di */

        case 42:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10057; /* pred_single_widen_addsv16di */

        case 43:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10059; /* pred_single_widen_addsv32di */

        case 44:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10061; /* pred_single_widen_addsv64di */

        case 45:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10063; /* pred_single_widen_addsv128di */

        case 46:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10065; /* pred_single_widen_addsv256di */

        case 47:
          if (!(
#line 4070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10067; /* pred_single_widen_addsv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern569 (x2))
        {
        case 0:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10549; /* pred_extendrvvm8hi */

        case 1:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10551; /* pred_extendrvvm4hi */

        case 2:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10553; /* pred_extendrvvm2hi */

        case 3:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10555; /* pred_extendrvvm1hi */

        case 4:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10557; /* pred_extendrvvmf2hi */

        case 5:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10559; /* pred_extendrvvmf4hi */

        case 6:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10561; /* pred_extendrvvm8si */

        case 7:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10563; /* pred_extendrvvm4si */

        case 8:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10565; /* pred_extendrvvm2si */

        case 9:
          if (!
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10567; /* pred_extendrvvm1si */

        case 10:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10569; /* pred_extendrvvmf2si */

        case 11:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10571; /* pred_extendrvvm8di */

        case 12:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10573; /* pred_extendrvvm4di */

        case 13:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10575; /* pred_extendrvvm2di */

        case 14:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10577; /* pred_extendrvvm1di */

        case 15:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10579; /* pred_extendv1hi */

        case 16:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10581; /* pred_extendv2hi */

        case 17:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10583; /* pred_extendv4hi */

        case 18:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10585; /* pred_extendv8hi */

        case 19:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10587; /* pred_extendv16hi */

        case 20:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10589; /* pred_extendv32hi */

        case 21:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10591; /* pred_extendv64hi */

        case 22:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10593; /* pred_extendv128hi */

        case 23:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10595; /* pred_extendv256hi */

        case 24:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10597; /* pred_extendv512hi */

        case 25:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10599; /* pred_extendv1024hi */

        case 26:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10601; /* pred_extendv2048hi */

        case 27:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10603; /* pred_extendv1si */

        case 28:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10605; /* pred_extendv2si */

        case 29:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10607; /* pred_extendv4si */

        case 30:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10609; /* pred_extendv8si */

        case 31:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10611; /* pred_extendv16si */

        case 32:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10613; /* pred_extendv32si */

        case 33:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10615; /* pred_extendv64si */

        case 34:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10617; /* pred_extendv128si */

        case 35:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10619; /* pred_extendv256si */

        case 36:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10621; /* pred_extendv512si */

        case 37:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10623; /* pred_extendv1024si */

        case 38:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10625; /* pred_extendv1di */

        case 39:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10627; /* pred_extendv2di */

        case 40:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10629; /* pred_extendv4di */

        case 41:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10631; /* pred_extendv8di */

        case 42:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10633; /* pred_extendv16di */

        case 43:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10635; /* pred_extendv32di */

        case 44:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10637; /* pred_extendv64di */

        case 45:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10639; /* pred_extendv128di */

        case 46:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10641; /* pred_extendv256di */

        case 47:
          if (!(
#line 4206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10643; /* pred_extendv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_794 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V64QImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13477; /* *pred_minus_mulv64qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13545; /* *pred_nmsubv64qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13613; /* *pred_nmsacv64qi */
}

 int
recog_802 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_RVVMF4HImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13469; /* *pred_minus_mulrvvmf4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13537; /* *pred_nmsubrvvmf4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13605; /* *pred_nmsacrvvmf4hi */
}

 int
recog_814 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 13710; /* *pred_nmsubv1024si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13778; /* *pred_nmsacv1024si_scalar */
}

 int
recog_822 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13702; /* *pred_nmsubv4si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13770; /* *pred_nmsacv4si_scalar */
}

 int
recog_830 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13694; /* *pred_nmsubv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13762; /* *pred_nmsacv64hi_scalar */
}

 int
recog_838 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_836 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_835 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_837 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern545 (x2))
        {
        case 0:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9878; /* pred_single_widen_suburvvm8hi */

        case 1:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9880; /* pred_single_widen_suburvvm4hi */

        case 2:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9882; /* pred_single_widen_suburvvm2hi */

        case 3:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9884; /* pred_single_widen_suburvvm1hi */

        case 4:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9886; /* pred_single_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9888; /* pred_single_widen_suburvvmf4hi */

        case 6:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9890; /* pred_single_widen_suburvvm8si */

        case 7:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9892; /* pred_single_widen_suburvvm4si */

        case 8:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9894; /* pred_single_widen_suburvvm2si */

        case 9:
          if (!
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9896; /* pred_single_widen_suburvvm1si */

        case 10:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9898; /* pred_single_widen_suburvvmf2si */

        case 11:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9900; /* pred_single_widen_suburvvm8di */

        case 12:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9902; /* pred_single_widen_suburvvm4di */

        case 13:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9904; /* pred_single_widen_suburvvm2di */

        case 14:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9906; /* pred_single_widen_suburvvm1di */

        case 15:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9908; /* pred_single_widen_subuv1hi */

        case 16:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9910; /* pred_single_widen_subuv2hi */

        case 17:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9912; /* pred_single_widen_subuv4hi */

        case 18:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9914; /* pred_single_widen_subuv8hi */

        case 19:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9916; /* pred_single_widen_subuv16hi */

        case 20:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9918; /* pred_single_widen_subuv32hi */

        case 21:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9920; /* pred_single_widen_subuv64hi */

        case 22:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9922; /* pred_single_widen_subuv128hi */

        case 23:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9924; /* pred_single_widen_subuv256hi */

        case 24:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9926; /* pred_single_widen_subuv512hi */

        case 25:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9928; /* pred_single_widen_subuv1024hi */

        case 26:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9930; /* pred_single_widen_subuv2048hi */

        case 27:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9932; /* pred_single_widen_subuv1si */

        case 28:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9934; /* pred_single_widen_subuv2si */

        case 29:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9936; /* pred_single_widen_subuv4si */

        case 30:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9938; /* pred_single_widen_subuv8si */

        case 31:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9940; /* pred_single_widen_subuv16si */

        case 32:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9942; /* pred_single_widen_subuv32si */

        case 33:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9944; /* pred_single_widen_subuv64si */

        case 34:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9946; /* pred_single_widen_subuv128si */

        case 35:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9948; /* pred_single_widen_subuv256si */

        case 36:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9950; /* pred_single_widen_subuv512si */

        case 37:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9952; /* pred_single_widen_subuv1024si */

        case 38:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9954; /* pred_single_widen_subuv1di */

        case 39:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9956; /* pred_single_widen_subuv2di */

        case 40:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9958; /* pred_single_widen_subuv4di */

        case 41:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9960; /* pred_single_widen_subuv8di */

        case 42:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9962; /* pred_single_widen_subuv16di */

        case 43:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9964; /* pred_single_widen_subuv32di */

        case 44:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9966; /* pred_single_widen_subuv64di */

        case 45:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9968; /* pred_single_widen_subuv128di */

        case 46:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9970; /* pred_single_widen_subuv256di */

        case 47:
          if (!(
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9972; /* pred_single_widen_subuv512di */

        case 48:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10072; /* pred_single_widen_suburvvm8hi_scalar */

        case 49:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10076; /* pred_single_widen_suburvvm4hi_scalar */

        case 50:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10080; /* pred_single_widen_suburvvm2hi_scalar */

        case 51:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10084; /* pred_single_widen_suburvvm1hi_scalar */

        case 52:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10088; /* pred_single_widen_suburvvmf2hi_scalar */

        case 53:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10092; /* pred_single_widen_suburvvmf4hi_scalar */

        case 54:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10096; /* pred_single_widen_suburvvm8si_scalar */

        case 55:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10100; /* pred_single_widen_suburvvm4si_scalar */

        case 56:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10104; /* pred_single_widen_suburvvm2si_scalar */

        case 57:
          if (!
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10108; /* pred_single_widen_suburvvm1si_scalar */

        case 58:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10112; /* pred_single_widen_suburvvmf2si_scalar */

        case 59:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10116; /* pred_single_widen_suburvvm8di_scalar */

        case 60:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10120; /* pred_single_widen_suburvvm4di_scalar */

        case 61:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10124; /* pred_single_widen_suburvvm2di_scalar */

        case 62:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10128; /* pred_single_widen_suburvvm1di_scalar */

        case 63:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10132; /* pred_single_widen_subuv1hi_scalar */

        case 64:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10136; /* pred_single_widen_subuv2hi_scalar */

        case 65:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10140; /* pred_single_widen_subuv4hi_scalar */

        case 66:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10144; /* pred_single_widen_subuv8hi_scalar */

        case 67:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10148; /* pred_single_widen_subuv16hi_scalar */

        case 68:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10152; /* pred_single_widen_subuv32hi_scalar */

        case 69:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10156; /* pred_single_widen_subuv64hi_scalar */

        case 70:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10160; /* pred_single_widen_subuv128hi_scalar */

        case 71:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10164; /* pred_single_widen_subuv256hi_scalar */

        case 72:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10168; /* pred_single_widen_subuv512hi_scalar */

        case 73:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10172; /* pred_single_widen_subuv1024hi_scalar */

        case 74:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10176; /* pred_single_widen_subuv2048hi_scalar */

        case 75:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10180; /* pred_single_widen_subuv1si_scalar */

        case 76:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10184; /* pred_single_widen_subuv2si_scalar */

        case 77:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10188; /* pred_single_widen_subuv4si_scalar */

        case 78:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10192; /* pred_single_widen_subuv8si_scalar */

        case 79:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10196; /* pred_single_widen_subuv16si_scalar */

        case 80:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10200; /* pred_single_widen_subuv32si_scalar */

        case 81:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10204; /* pred_single_widen_subuv64si_scalar */

        case 82:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10208; /* pred_single_widen_subuv128si_scalar */

        case 83:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10212; /* pred_single_widen_subuv256si_scalar */

        case 84:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10216; /* pred_single_widen_subuv512si_scalar */

        case 85:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10220; /* pred_single_widen_subuv1024si_scalar */

        case 86:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10224; /* pred_single_widen_subuv1di_scalar */

        case 87:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10228; /* pred_single_widen_subuv2di_scalar */

        case 88:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10232; /* pred_single_widen_subuv4di_scalar */

        case 89:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10236; /* pred_single_widen_subuv8di_scalar */

        case 90:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10240; /* pred_single_widen_subuv16di_scalar */

        case 91:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10244; /* pred_single_widen_subuv32di_scalar */

        case 92:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10248; /* pred_single_widen_subuv64di_scalar */

        case 93:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10252; /* pred_single_widen_subuv128di_scalar */

        case 94:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10256; /* pred_single_widen_subuv256di_scalar */

        case 95:
          if (!(
#line 4092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10260; /* pred_single_widen_subuv512di_scalar */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return recog_834 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x6 = XEXP (x2, 0);
          x7 = XVECEXP (x6, 0, 1);
          operands[5] = x7;
          x8 = XVECEXP (x6, 0, 2);
          operands[6] = x8;
          x9 = XVECEXP (x6, 0, 3);
          operands[7] = x9;
          x10 = XVECEXP (x6, 0, 4);
          operands[8] = x10;
          x11 = XEXP (x3, 0);
          operands[4] = x11;
          x12 = XEXP (x4, 1);
          operands[3] = x12;
          x13 = XEXP (x5, 0);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              return recog_833 (x1, insn, pnum_clobbers);

            case SIGN_EXTEND:
              if (GET_MODE (x13) != E_DImode)
                return -1;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!reg_or_0_operand (operands[2], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVM8DImode:
                  if (pattern732 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13789; /* *pred_nmsubrvvm8di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13803; /* *pred_nmsacrvvm8di_extended_scalar */

                case E_RVVM4DImode:
                  if (pattern732 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13790; /* *pred_nmsubrvvm4di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13804; /* *pred_nmsacrvvm4di_extended_scalar */

                case E_RVVM2DImode:
                  if (pattern732 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13791; /* *pred_nmsubrvvm2di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13805; /* *pred_nmsacrvvm2di_extended_scalar */

                case E_RVVM1DImode:
                  if (pattern732 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return 13792; /* *pred_nmsubrvvm1di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13806; /* *pred_nmsacrvvm1di_extended_scalar */

                case E_V1DImode:
                  if (pattern732 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13793; /* *pred_nmsubv1di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13807; /* *pred_nmsacv1di_extended_scalar */

                case E_V2DImode:
                  if (pattern732 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13794; /* *pred_nmsubv2di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13808; /* *pred_nmsacv2di_extended_scalar */

                case E_V4DImode:
                  if (pattern732 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return 13795; /* *pred_nmsubv4di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13809; /* *pred_nmsacv4di_extended_scalar */

                case E_V8DImode:
                  if (pattern732 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return 13796; /* *pred_nmsubv8di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13810; /* *pred_nmsacv8di_extended_scalar */

                case E_V16DImode:
                  if (pattern732 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return 13797; /* *pred_nmsubv16di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13811; /* *pred_nmsacv16di_extended_scalar */

                case E_V32DImode:
                  if (pattern732 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return 13798; /* *pred_nmsubv32di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13812; /* *pred_nmsacv32di_extended_scalar */

                case E_V64DImode:
                  if (pattern732 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return 13799; /* *pred_nmsubv64di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13813; /* *pred_nmsacv64di_extended_scalar */

                case E_V128DImode:
                  if (pattern732 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return 13800; /* *pred_nmsubv128di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13814; /* *pred_nmsacv128di_extended_scalar */

                case E_V256DImode:
                  if (pattern732 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return 13801; /* *pred_nmsubv256di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13815; /* *pred_nmsacv256di_extended_scalar */

                case E_V512DImode:
                  if (pattern732 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                    return -1;
                  x15 = XEXP (x2, 2);
                  if (rtx_equal_p (x15, operands[3])
                      && (
#line 5815 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return 13802; /* *pred_nmsubv512di_extended_scalar */
                  if (!rtx_equal_p (x15, operands[4])
                      || !(
#line 5846 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13816; /* *pred_nmsacv512di_extended_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_886 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern673 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10886; /* pred_sssubrvvm8qi */

    case E_RVVM4QImode:
      if (pattern673 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10890; /* pred_sssubrvvm4qi */

    case E_RVVM2QImode:
      if (pattern673 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10894; /* pred_sssubrvvm2qi */

    case E_RVVM1QImode:
      if (pattern673 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10898; /* pred_sssubrvvm1qi */

    case E_RVVM8HImode:
      if (pattern673 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10902; /* pred_sssubrvvm8hi */

    case E_RVVM4HImode:
      if (pattern673 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10906; /* pred_sssubrvvm4hi */

    case E_RVVM2HImode:
      if (pattern673 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10910; /* pred_sssubrvvm2hi */

    case E_RVVM1HImode:
      if (pattern673 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10914; /* pred_sssubrvvm1hi */

    case E_RVVM8SImode:
      if (pattern673 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10918; /* pred_sssubrvvm8si */

    case E_RVVM4SImode:
      if (pattern673 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10922; /* pred_sssubrvvm4si */

    case E_RVVM2SImode:
      if (pattern673 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10926; /* pred_sssubrvvm2si */

    case E_RVVM1SImode:
      if (pattern673 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10930; /* pred_sssubrvvm1si */

    case E_RVVM8DImode:
      if (pattern673 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10934; /* pred_sssubrvvm8di */

    case E_RVVM4DImode:
      if (pattern673 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10938; /* pred_sssubrvvm4di */

    case E_RVVM2DImode:
      if (pattern673 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10942; /* pred_sssubrvvm2di */

    case E_RVVM1DImode:
      if (pattern673 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10946; /* pred_sssubrvvm1di */

    case E_RVVMF2QImode:
      if (pattern673 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10950; /* pred_sssubrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern673 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10954; /* pred_sssubrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern673 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10958; /* pred_sssubrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern673 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10962; /* pred_sssubrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern673 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10966; /* pred_sssubrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern673 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10970; /* pred_sssubrvvmf2si */

    case E_V1QImode:
      if (pattern673 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 10974; /* pred_sssubv1qi */

    case E_V2QImode:
      if (pattern673 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 10978; /* pred_sssubv2qi */

    case E_V4QImode:
      if (pattern673 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 10982; /* pred_sssubv4qi */

    case E_V8QImode:
      if (pattern673 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 10986; /* pred_sssubv8qi */

    case E_V16QImode:
      if (pattern673 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 10990; /* pred_sssubv16qi */

    case E_V32QImode:
      if (pattern673 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 10994; /* pred_sssubv32qi */

    case E_V64QImode:
      if (pattern673 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10998; /* pred_sssubv64qi */

    case E_V128QImode:
      if (pattern673 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11002; /* pred_sssubv128qi */

    case E_V256QImode:
      if (pattern673 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11006; /* pred_sssubv256qi */

    case E_V512QImode:
      if (pattern673 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11010; /* pred_sssubv512qi */

    case E_V1024QImode:
      if (pattern673 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11014; /* pred_sssubv1024qi */

    case E_V2048QImode:
      if (pattern673 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11018; /* pred_sssubv2048qi */

    case E_V4096QImode:
      if (pattern673 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11022; /* pred_sssubv4096qi */

    case E_V1HImode:
      if (pattern673 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11026; /* pred_sssubv1hi */

    case E_V2HImode:
      if (pattern673 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11030; /* pred_sssubv2hi */

    case E_V4HImode:
      if (pattern673 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11034; /* pred_sssubv4hi */

    case E_V8HImode:
      if (pattern673 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11038; /* pred_sssubv8hi */

    case E_V16HImode:
      if (pattern673 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11042; /* pred_sssubv16hi */

    case E_V32HImode:
      if (pattern673 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11046; /* pred_sssubv32hi */

    case E_V64HImode:
      if (pattern673 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11050; /* pred_sssubv64hi */

    case E_V128HImode:
      if (pattern673 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11054; /* pred_sssubv128hi */

    case E_V256HImode:
      if (pattern673 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11058; /* pred_sssubv256hi */

    case E_V512HImode:
      if (pattern673 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11062; /* pred_sssubv512hi */

    case E_V1024HImode:
      if (pattern673 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11066; /* pred_sssubv1024hi */

    case E_V2048HImode:
      if (pattern673 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11070; /* pred_sssubv2048hi */

    case E_V1SImode:
      if (pattern673 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11074; /* pred_sssubv1si */

    case E_V2SImode:
      if (pattern673 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11078; /* pred_sssubv2si */

    case E_V4SImode:
      if (pattern673 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11082; /* pred_sssubv4si */

    case E_V8SImode:
      if (pattern673 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11086; /* pred_sssubv8si */

    case E_V16SImode:
      if (pattern673 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11090; /* pred_sssubv16si */

    case E_V32SImode:
      if (pattern673 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11094; /* pred_sssubv32si */

    case E_V64SImode:
      if (pattern673 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11098; /* pred_sssubv64si */

    case E_V128SImode:
      if (pattern673 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11102; /* pred_sssubv128si */

    case E_V256SImode:
      if (pattern673 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11106; /* pred_sssubv256si */

    case E_V512SImode:
      if (pattern673 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11110; /* pred_sssubv512si */

    case E_V1024SImode:
      if (pattern673 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11114; /* pred_sssubv1024si */

    case E_V1DImode:
      if (pattern673 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11118; /* pred_sssubv1di */

    case E_V2DImode:
      if (pattern673 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11122; /* pred_sssubv2di */

    case E_V4DImode:
      if (pattern673 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11126; /* pred_sssubv4di */

    case E_V8DImode:
      if (pattern673 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11130; /* pred_sssubv8di */

    case E_V16DImode:
      if (pattern673 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11134; /* pred_sssubv16di */

    case E_V32DImode:
      if (pattern673 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11138; /* pred_sssubv32di */

    case E_V64DImode:
      if (pattern673 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11142; /* pred_sssubv64di */

    case E_V128DImode:
      if (pattern673 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11146; /* pred_sssubv128di */

    case E_V256DImode:
      if (pattern673 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11150; /* pred_sssubv256di */

    case E_V512DImode:
      if (pattern673 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 4328 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11154; /* pred_sssubv512di */

    default:
      return -1;
    }
}

 int
recog_890 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern497 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5507; /* pred_sminrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5524; /* pred_sminrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5541; /* pred_sminrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5558; /* pred_sminrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5575; /* pred_sminrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5592; /* pred_sminrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5609; /* pred_sminrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5626; /* pred_sminrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5643; /* pred_sminrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5660; /* pred_sminrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5677; /* pred_sminrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5694; /* pred_sminrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5711; /* pred_sminrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5728; /* pred_sminrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5745; /* pred_sminrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5762; /* pred_sminrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5779; /* pred_sminrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5796; /* pred_sminrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5813; /* pred_sminrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5830; /* pred_sminrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5847; /* pred_sminrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5864; /* pred_sminrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5881; /* pred_sminv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5898; /* pred_sminv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5915; /* pred_sminv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5932; /* pred_sminv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5949; /* pred_sminv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5966; /* pred_sminv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5983; /* pred_sminv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6000; /* pred_sminv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6017; /* pred_sminv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6034; /* pred_sminv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6051; /* pred_sminv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6068; /* pred_sminv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6085; /* pred_sminv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6102; /* pred_sminv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6119; /* pred_sminv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6136; /* pred_sminv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6153; /* pred_sminv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6170; /* pred_sminv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6187; /* pred_sminv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6204; /* pred_sminv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6221; /* pred_sminv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6238; /* pred_sminv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6255; /* pred_sminv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6272; /* pred_sminv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6289; /* pred_sminv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6306; /* pred_sminv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6323; /* pred_sminv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6340; /* pred_sminv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6357; /* pred_sminv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6374; /* pred_sminv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6391; /* pred_sminv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6408; /* pred_sminv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6425; /* pred_sminv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6442; /* pred_sminv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6459; /* pred_sminv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6476; /* pred_sminv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6493; /* pred_sminv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6510; /* pred_sminv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6527; /* pred_sminv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6544; /* pred_sminv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6561; /* pred_sminv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6578; /* pred_sminv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6595; /* pred_sminv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6612; /* pred_sminv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6629; /* pred_sminv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6646; /* pred_sminv512di */

    case 68:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14691; /* pred_sminrvvm8hf */

    case 69:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14693; /* pred_sminrvvm4hf */

    case 70:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14695; /* pred_sminrvvm2hf */

    case 71:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14697; /* pred_sminrvvm1hf */

    case 72:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14699; /* pred_sminrvvmf2hf */

    case 73:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14701; /* pred_sminrvvmf4hf */

    case 74:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14703; /* pred_sminrvvm8sf */

    case 75:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14705; /* pred_sminrvvm4sf */

    case 76:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14707; /* pred_sminrvvm2sf */

    case 77:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14709; /* pred_sminrvvm1sf */

    case 78:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14711; /* pred_sminrvvmf2sf */

    case 79:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14713; /* pred_sminrvvm8df */

    case 80:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14715; /* pred_sminrvvm4df */

    case 81:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14717; /* pred_sminrvvm2df */

    case 82:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14719; /* pred_sminrvvm1df */

    case 83:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 14721; /* pred_sminv1hf */

    case 84:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 14723; /* pred_sminv2hf */

    case 85:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 14725; /* pred_sminv4hf */

    case 86:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 14727; /* pred_sminv8hf */

    case 87:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 14729; /* pred_sminv16hf */

    case 88:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14731; /* pred_sminv32hf */

    case 89:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14733; /* pred_sminv64hf */

    case 90:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14735; /* pred_sminv128hf */

    case 91:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14737; /* pred_sminv256hf */

    case 92:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14739; /* pred_sminv512hf */

    case 93:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14741; /* pred_sminv1024hf */

    case 94:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14743; /* pred_sminv2048hf */

    case 95:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14745; /* pred_sminv1sf */

    case 96:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14747; /* pred_sminv2sf */

    case 97:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14749; /* pred_sminv4sf */

    case 98:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14751; /* pred_sminv8sf */

    case 99:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14753; /* pred_sminv16sf */

    case 100:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14755; /* pred_sminv32sf */

    case 101:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14757; /* pred_sminv64sf */

    case 102:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14759; /* pred_sminv128sf */

    case 103:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14761; /* pred_sminv256sf */

    case 104:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14763; /* pred_sminv512sf */

    case 105:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14765; /* pred_sminv1024sf */

    case 106:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14767; /* pred_sminv1df */

    case 107:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14769; /* pred_sminv2df */

    case 108:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14771; /* pred_sminv4df */

    case 109:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 14773; /* pred_sminv8df */

    case 110:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 14775; /* pred_sminv16df */

    case 111:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 14777; /* pred_sminv32df */

    case 112:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 14779; /* pred_sminv64df */

    case 113:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 14781; /* pred_sminv128df */

    case 114:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 14783; /* pred_sminv256df */

    case 115:
      if (!(
#line 6224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 14785; /* pred_sminv512df */

    case 116:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6863; /* pred_sminrvvm8qi_scalar */

    case 117:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6872; /* pred_sminrvvm4qi_scalar */

    case 118:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6881; /* pred_sminrvvm2qi_scalar */

    case 119:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6890; /* pred_sminrvvm1qi_scalar */

    case 120:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6899; /* pred_sminrvvmf2qi_scalar */

    case 121:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6908; /* pred_sminrvvmf4qi_scalar */

    case 122:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6917; /* pred_sminrvvmf8qi_scalar */

    case 123:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6926; /* pred_sminrvvm8hi_scalar */

    case 124:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6935; /* pred_sminrvvm4hi_scalar */

    case 125:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6944; /* pred_sminrvvm2hi_scalar */

    case 126:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6953; /* pred_sminrvvm1hi_scalar */

    case 127:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6962; /* pred_sminrvvmf2hi_scalar */

    case 128:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6971; /* pred_sminrvvmf4hi_scalar */

    case 129:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6980; /* pred_sminrvvm8si_scalar */

    case 130:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6989; /* pred_sminrvvm4si_scalar */

    case 131:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6998; /* pred_sminrvvm2si_scalar */

    case 132:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7007; /* pred_sminrvvm1si_scalar */

    case 133:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7016; /* pred_sminrvvmf2si_scalar */

    case 134:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7025; /* pred_sminv1qi_scalar */

    case 135:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7034; /* pred_sminv2qi_scalar */

    case 136:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7043; /* pred_sminv4qi_scalar */

    case 137:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7052; /* pred_sminv8qi_scalar */

    case 138:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7061; /* pred_sminv16qi_scalar */

    case 139:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7070; /* pred_sminv32qi_scalar */

    case 140:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7079; /* pred_sminv64qi_scalar */

    case 141:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7088; /* pred_sminv128qi_scalar */

    case 142:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7097; /* pred_sminv256qi_scalar */

    case 143:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7106; /* pred_sminv512qi_scalar */

    case 144:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7115; /* pred_sminv1024qi_scalar */

    case 145:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7124; /* pred_sminv2048qi_scalar */

    case 146:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7133; /* pred_sminv4096qi_scalar */

    case 147:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7142; /* pred_sminv1hi_scalar */

    case 148:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7151; /* pred_sminv2hi_scalar */

    case 149:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7160; /* pred_sminv4hi_scalar */

    case 150:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7169; /* pred_sminv8hi_scalar */

    case 151:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7178; /* pred_sminv16hi_scalar */

    case 152:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7187; /* pred_sminv32hi_scalar */

    case 153:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7196; /* pred_sminv64hi_scalar */

    case 154:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7205; /* pred_sminv128hi_scalar */

    case 155:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7214; /* pred_sminv256hi_scalar */

    case 156:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7223; /* pred_sminv512hi_scalar */

    case 157:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7232; /* pred_sminv1024hi_scalar */

    case 158:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7241; /* pred_sminv2048hi_scalar */

    case 159:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7250; /* pred_sminv1si_scalar */

    case 160:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7259; /* pred_sminv2si_scalar */

    case 161:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7268; /* pred_sminv4si_scalar */

    case 162:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7277; /* pred_sminv8si_scalar */

    case 163:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7286; /* pred_sminv16si_scalar */

    case 164:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7295; /* pred_sminv32si_scalar */

    case 165:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7304; /* pred_sminv64si_scalar */

    case 166:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7313; /* pred_sminv128si_scalar */

    case 167:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7322; /* pred_sminv256si_scalar */

    case 168:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7331; /* pred_sminv512si_scalar */

    case 169:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7340; /* pred_sminv1024si_scalar */

    case 170:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7673; /* *pred_sminrvvm8di_scalar */

    case 171:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7682; /* *pred_sminrvvm4di_scalar */

    case 172:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7691; /* *pred_sminrvvm2di_scalar */

    case 173:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7700; /* *pred_sminrvvm1di_scalar */

    case 174:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7709; /* *pred_sminv1di_scalar */

    case 175:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7718; /* *pred_sminv2di_scalar */

    case 176:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7727; /* *pred_sminv4di_scalar */

    case 177:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7736; /* *pred_sminv8di_scalar */

    case 178:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7745; /* *pred_sminv16di_scalar */

    case 179:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7754; /* *pred_sminv32di_scalar */

    case 180:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7763; /* *pred_sminv64di_scalar */

    case 181:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7772; /* *pred_sminv128di_scalar */

    case 182:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7781; /* *pred_sminv256di_scalar */

    case 183:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7790; /* *pred_sminv512di_scalar */

    case 184:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14913; /* pred_sminrvvm8hf_scalar */

    case 185:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14915; /* pred_sminrvvm4hf_scalar */

    case 186:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14917; /* pred_sminrvvm2hf_scalar */

    case 187:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14919; /* pred_sminrvvm1hf_scalar */

    case 188:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 14921; /* pred_sminrvvmf2hf_scalar */

    case 189:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14923; /* pred_sminrvvmf4hf_scalar */

    case 190:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14925; /* pred_sminrvvm8sf_scalar */

    case 191:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14927; /* pred_sminrvvm4sf_scalar */

    case 192:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14929; /* pred_sminrvvm2sf_scalar */

    case 193:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 14931; /* pred_sminrvvm1sf_scalar */

    case 194:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 14933; /* pred_sminrvvmf2sf_scalar */

    case 195:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14935; /* pred_sminrvvm8df_scalar */

    case 196:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14937; /* pred_sminrvvm4df_scalar */

    case 197:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14939; /* pred_sminrvvm2df_scalar */

    case 198:
      if (!(
#line 6291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 14941; /* pred_sminrvvm1df_scalar */

    case 199:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7799; /* *pred_sminrvvm8di_extended_scalar */

    case 200:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7808; /* *pred_sminrvvm4di_extended_scalar */

    case 201:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7817; /* *pred_sminrvvm2di_extended_scalar */

    case 202:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7826; /* *pred_sminrvvm1di_extended_scalar */

    case 203:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7835; /* *pred_sminv1di_extended_scalar */

    case 204:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7844; /* *pred_sminv2di_extended_scalar */

    case 205:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7853; /* *pred_sminv4di_extended_scalar */

    case 206:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7862; /* *pred_sminv8di_extended_scalar */

    case 207:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7871; /* *pred_sminv16di_extended_scalar */

    case 208:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7880; /* *pred_sminv32di_extended_scalar */

    case 209:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7889; /* *pred_sminv64di_extended_scalar */

    case 210:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7898; /* *pred_sminv128di_extended_scalar */

    case 211:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7907; /* *pred_sminv256di_extended_scalar */

    case 212:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7916; /* *pred_sminv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_903 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5508; /* pred_uminrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5525; /* pred_uminrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5542; /* pred_uminrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5559; /* pred_uminrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5576; /* pred_uminrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5593; /* pred_uminrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5610; /* pred_uminrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5627; /* pred_uminrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5644; /* pred_uminrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5661; /* pred_uminrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5678; /* pred_uminrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5695; /* pred_uminrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5712; /* pred_uminrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5729; /* pred_uminrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5746; /* pred_uminrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5763; /* pred_uminrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5780; /* pred_uminrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5797; /* pred_uminrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5814; /* pred_uminrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5831; /* pred_uminrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5848; /* pred_uminrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5865; /* pred_uminrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5882; /* pred_uminv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5899; /* pred_uminv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5916; /* pred_uminv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5933; /* pred_uminv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5950; /* pred_uminv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5967; /* pred_uminv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5984; /* pred_uminv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6001; /* pred_uminv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6018; /* pred_uminv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6035; /* pred_uminv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6052; /* pred_uminv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6069; /* pred_uminv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6086; /* pred_uminv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6103; /* pred_uminv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6120; /* pred_uminv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6137; /* pred_uminv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6154; /* pred_uminv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6171; /* pred_uminv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6188; /* pred_uminv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6205; /* pred_uminv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6222; /* pred_uminv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6239; /* pred_uminv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6256; /* pred_uminv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6273; /* pred_uminv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6290; /* pred_uminv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6307; /* pred_uminv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6324; /* pred_uminv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6341; /* pred_uminv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6358; /* pred_uminv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6375; /* pred_uminv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6392; /* pred_uminv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6409; /* pred_uminv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6426; /* pred_uminv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6443; /* pred_uminv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6460; /* pred_uminv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6477; /* pred_uminv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6494; /* pred_uminv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6511; /* pred_uminv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6528; /* pred_uminv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6545; /* pred_uminv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6562; /* pred_uminv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6579; /* pred_uminv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6596; /* pred_uminv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6613; /* pred_uminv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6630; /* pred_uminv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6647; /* pred_uminv512di */

    case 68:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6864; /* pred_uminrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6873; /* pred_uminrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6882; /* pred_uminrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6891; /* pred_uminrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6900; /* pred_uminrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6909; /* pred_uminrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6918; /* pred_uminrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6927; /* pred_uminrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6936; /* pred_uminrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6945; /* pred_uminrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6954; /* pred_uminrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6963; /* pred_uminrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6972; /* pred_uminrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6981; /* pred_uminrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6990; /* pred_uminrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6999; /* pred_uminrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7008; /* pred_uminrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7017; /* pred_uminrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7026; /* pred_uminv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7035; /* pred_uminv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7044; /* pred_uminv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7053; /* pred_uminv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7062; /* pred_uminv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7071; /* pred_uminv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7080; /* pred_uminv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7089; /* pred_uminv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7098; /* pred_uminv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7107; /* pred_uminv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7116; /* pred_uminv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7125; /* pred_uminv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7134; /* pred_uminv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7143; /* pred_uminv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7152; /* pred_uminv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7161; /* pred_uminv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7170; /* pred_uminv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7179; /* pred_uminv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7188; /* pred_uminv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7197; /* pred_uminv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7206; /* pred_uminv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7215; /* pred_uminv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7224; /* pred_uminv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7233; /* pred_uminv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7242; /* pred_uminv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7251; /* pred_uminv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7260; /* pred_uminv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7269; /* pred_uminv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7278; /* pred_uminv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7287; /* pred_uminv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7296; /* pred_uminv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7305; /* pred_uminv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7314; /* pred_uminv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7323; /* pred_uminv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7332; /* pred_uminv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7341; /* pred_uminv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7674; /* *pred_uminrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7683; /* *pred_uminrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7692; /* *pred_uminrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7701; /* *pred_uminrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7710; /* *pred_uminv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7719; /* *pred_uminv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7728; /* *pred_uminv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7737; /* *pred_uminv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7746; /* *pred_uminv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7755; /* *pred_uminv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7764; /* *pred_uminv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7773; /* *pred_uminv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7782; /* *pred_uminv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7791; /* *pred_uminv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7800; /* *pred_uminrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7809; /* *pred_uminrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7818; /* *pred_uminrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7827; /* *pred_uminrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7836; /* *pred_uminv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7845; /* *pred_uminv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7854; /* *pred_uminv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7863; /* *pred_uminv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7872; /* *pred_uminv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7881; /* *pred_uminv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7890; /* *pred_uminv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7899; /* *pred_uminv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7908; /* *pred_uminv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7917; /* *pred_uminv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_913 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern507 (x2))
    {
    case 0:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17376; /* pred_fixuns_truncrvvm8hf */

    case 1:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17378; /* pred_fixuns_truncrvvm4hf */

    case 2:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17922; /* pred_narrow_fixuns_truncrvvm8sf */

    case 3:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17380; /* pred_fixuns_truncrvvm2hf */

    case 4:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17924; /* pred_narrow_fixuns_truncrvvm4sf */

    case 5:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17382; /* pred_fixuns_truncrvvm1hf */

    case 6:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17926; /* pred_narrow_fixuns_truncrvvm2sf */

    case 7:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17384; /* pred_fixuns_truncrvvmf2hf */

    case 8:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17928; /* pred_narrow_fixuns_truncrvvm1sf */

    case 9:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17386; /* pred_fixuns_truncrvvmf4hf */

    case 10:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17930; /* pred_narrow_fixuns_truncrvvmf2sf */

    case 11:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17388; /* pred_fixuns_truncrvvm8sf */

    case 12:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17628; /* pred_widen_fixuns_truncrvvm8si */

    case 13:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17390; /* pred_fixuns_truncrvvm4sf */

    case 14:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17630; /* pred_widen_fixuns_truncrvvm4si */

    case 15:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17932; /* pred_narrow_fixuns_truncrvvm8df */

    case 16:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17392; /* pred_fixuns_truncrvvm2sf */

    case 17:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17632; /* pred_widen_fixuns_truncrvvm2si */

    case 18:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17934; /* pred_narrow_fixuns_truncrvvm4df */

    case 19:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17394; /* pred_fixuns_truncrvvm1sf */

    case 20:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17634; /* pred_widen_fixuns_truncrvvm1si */

    case 21:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17936; /* pred_narrow_fixuns_truncrvvm2df */

    case 22:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17396; /* pred_fixuns_truncrvvmf2sf */

    case 23:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17636; /* pred_widen_fixuns_truncrvvmf2si */

    case 24:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17938; /* pred_narrow_fixuns_truncrvvm1df */

    case 25:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17398; /* pred_fixuns_truncrvvm8df */

    case 26:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17638; /* pred_widen_fixuns_truncrvvm8di */

    case 27:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17400; /* pred_fixuns_truncrvvm4df */

    case 28:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17640; /* pred_widen_fixuns_truncrvvm4di */

    case 29:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17402; /* pred_fixuns_truncrvvm2df */

    case 30:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17642; /* pred_widen_fixuns_truncrvvm2di */

    case 31:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17404; /* pred_fixuns_truncrvvm1df */

    case 32:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17644; /* pred_widen_fixuns_truncrvvm1di */

    case 33:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17406; /* pred_fixuns_truncv1hf */

    case 34:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17964; /* pred_narrow_fixuns_truncv1sf */

    case 35:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17408; /* pred_fixuns_truncv2hf */

    case 36:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17966; /* pred_narrow_fixuns_truncv2sf */

    case 37:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17410; /* pred_fixuns_truncv4hf */

    case 38:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17968; /* pred_narrow_fixuns_truncv4sf */

    case 39:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17412; /* pred_fixuns_truncv8hf */

    case 40:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17970; /* pred_narrow_fixuns_truncv8sf */

    case 41:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17414; /* pred_fixuns_truncv16hf */

    case 42:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17972; /* pred_narrow_fixuns_truncv16sf */

    case 43:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17416; /* pred_fixuns_truncv32hf */

    case 44:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17974; /* pred_narrow_fixuns_truncv32sf */

    case 45:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17418; /* pred_fixuns_truncv64hf */

    case 46:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17976; /* pred_narrow_fixuns_truncv64sf */

    case 47:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17420; /* pred_fixuns_truncv128hf */

    case 48:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17978; /* pred_narrow_fixuns_truncv128sf */

    case 49:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17422; /* pred_fixuns_truncv256hf */

    case 50:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17980; /* pred_narrow_fixuns_truncv256sf */

    case 51:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17424; /* pred_fixuns_truncv512hf */

    case 52:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17982; /* pred_narrow_fixuns_truncv512sf */

    case 53:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17426; /* pred_fixuns_truncv1024hf */

    case 54:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17984; /* pred_narrow_fixuns_truncv1024sf */

    case 55:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17428; /* pred_fixuns_truncv2048hf */

    case 56:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17430; /* pred_fixuns_truncv1sf */

    case 57:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 17646; /* pred_widen_fixuns_truncv1si */

    case 58:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17986; /* pred_narrow_fixuns_truncv1df */

    case 59:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17432; /* pred_fixuns_truncv2sf */

    case 60:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 17648; /* pred_widen_fixuns_truncv2si */

    case 61:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17988; /* pred_narrow_fixuns_truncv2df */

    case 62:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17434; /* pred_fixuns_truncv4sf */

    case 63:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 17650; /* pred_widen_fixuns_truncv4si */

    case 64:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17990; /* pred_narrow_fixuns_truncv4df */

    case 65:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17436; /* pred_fixuns_truncv8sf */

    case 66:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 17652; /* pred_widen_fixuns_truncv8si */

    case 67:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17992; /* pred_narrow_fixuns_truncv8df */

    case 68:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17438; /* pred_fixuns_truncv16sf */

    case 69:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17654; /* pred_widen_fixuns_truncv16si */

    case 70:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17994; /* pred_narrow_fixuns_truncv16df */

    case 71:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17440; /* pred_fixuns_truncv32sf */

    case 72:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17656; /* pred_widen_fixuns_truncv32si */

    case 73:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17996; /* pred_narrow_fixuns_truncv32df */

    case 74:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17442; /* pred_fixuns_truncv64sf */

    case 75:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17658; /* pred_widen_fixuns_truncv64si */

    case 76:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17998; /* pred_narrow_fixuns_truncv64df */

    case 77:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17444; /* pred_fixuns_truncv128sf */

    case 78:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17660; /* pred_widen_fixuns_truncv128si */

    case 79:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18000; /* pred_narrow_fixuns_truncv128df */

    case 80:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17446; /* pred_fixuns_truncv256sf */

    case 81:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17662; /* pred_widen_fixuns_truncv256si */

    case 82:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18002; /* pred_narrow_fixuns_truncv256df */

    case 83:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17448; /* pred_fixuns_truncv512sf */

    case 84:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17664; /* pred_widen_fixuns_truncv512si */

    case 85:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18004; /* pred_narrow_fixuns_truncv512df */

    case 86:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17450; /* pred_fixuns_truncv1024sf */

    case 87:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17666; /* pred_widen_fixuns_truncv1024si */

    case 88:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17452; /* pred_fixuns_truncv1df */

    case 89:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17668; /* pred_widen_fixuns_truncv1di */

    case 90:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17454; /* pred_fixuns_truncv2df */

    case 91:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17670; /* pred_widen_fixuns_truncv2di */

    case 92:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17456; /* pred_fixuns_truncv4df */

    case 93:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17672; /* pred_widen_fixuns_truncv4di */

    case 94:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17458; /* pred_fixuns_truncv8df */

    case 95:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17674; /* pred_widen_fixuns_truncv8di */

    case 96:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17460; /* pred_fixuns_truncv16df */

    case 97:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17676; /* pred_widen_fixuns_truncv16di */

    case 98:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17462; /* pred_fixuns_truncv32df */

    case 99:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17678; /* pred_widen_fixuns_truncv32di */

    case 100:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17464; /* pred_fixuns_truncv64df */

    case 101:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17680; /* pred_widen_fixuns_truncv64di */

    case 102:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17466; /* pred_fixuns_truncv128df */

    case 103:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17682; /* pred_widen_fixuns_truncv128di */

    case 104:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17468; /* pred_fixuns_truncv256df */

    case 105:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17684; /* pred_widen_fixuns_truncv256di */

    case 106:
      if (!(
#line 7517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17470; /* pred_fixuns_truncv512df */

    case 107:
      if (!(
#line 7589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17686; /* pred_widen_fixuns_truncv512di */

    case 108:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17910; /* pred_narrow_fixuns_truncrvvm8hf */

    case 109:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17912; /* pred_narrow_fixuns_truncrvvm4hf */

    case 110:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17914; /* pred_narrow_fixuns_truncrvvm2hf */

    case 111:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17916; /* pred_narrow_fixuns_truncrvvm1hf */

    case 112:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17918; /* pred_narrow_fixuns_truncrvvmf2hf */

    case 113:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17920; /* pred_narrow_fixuns_truncrvvmf4hf */

    case 114:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17940; /* pred_narrow_fixuns_truncv1hf */

    case 115:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17942; /* pred_narrow_fixuns_truncv2hf */

    case 116:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17944; /* pred_narrow_fixuns_truncv4hf */

    case 117:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17946; /* pred_narrow_fixuns_truncv8hf */

    case 118:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17948; /* pred_narrow_fixuns_truncv16hf */

    case 119:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17950; /* pred_narrow_fixuns_truncv32hf */

    case 120:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17952; /* pred_narrow_fixuns_truncv64hf */

    case 121:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17954; /* pred_narrow_fixuns_truncv128hf */

    case 122:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17956; /* pred_narrow_fixuns_truncv256hf */

    case 123:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17958; /* pred_narrow_fixuns_truncv512hf */

    case 124:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17960; /* pred_narrow_fixuns_truncv1024hf */

    case 125:
      if (!(
#line 7677 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17962; /* pred_narrow_fixuns_truncv2048hf */

    default:
      return -1;
    }
}

 int
recog_929 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern478 (x2, 
190))
    {
    case 0:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2215; /* pred_indexed_load_widthwrvvm8qi */

    case 1:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2221; /* pred_indexed_load_widthwrvvm4qi */

    case 2:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2227; /* pred_indexed_load_widthwrvvm2qi */

    case 3:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2233; /* pred_indexed_load_widthwrvvm1qi */

    case 4:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2239; /* pred_indexed_load_widthwrvvm8hi */

    case 5:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2245; /* pred_indexed_load_widthwrvvm4hi */

    case 6:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2251; /* pred_indexed_load_widthwrvvm2hi */

    case 7:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2257; /* pred_indexed_load_widthwrvvm1hi */

    case 8:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2263; /* pred_indexed_load_widthwrvvm8si */

    case 9:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2269; /* pred_indexed_load_widthwrvvm4si */

    case 10:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2275; /* pred_indexed_load_widthwrvvm2si */

    case 11:
      if (!
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2281; /* pred_indexed_load_widthwrvvm1si */

    case 12:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2287; /* pred_indexed_load_widthwrvvm8di */

    case 13:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2293; /* pred_indexed_load_widthwrvvm4di */

    case 14:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2299; /* pred_indexed_load_widthwrvvm2di */

    case 15:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2305; /* pred_indexed_load_widthwrvvm1di */

    case 16:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2311; /* pred_indexed_load_widthwrvvmf8qi */

    case 17:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2317; /* pred_indexed_load_widthwrvvmf4hi */

    case 18:
      if (!(
#line 310 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2323; /* pred_indexed_load_widthwrvvmf2si */

    default:
      return -1;
    }
}

 int
recog_931 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11409; /* pred_smulrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11885; /* pred_smulrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11416; /* pred_smulrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11890; /* pred_smulrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11423; /* pred_smulrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11895; /* pred_smulrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11430; /* pred_smulrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11900; /* pred_smulrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11437; /* pred_smulrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11920; /* pred_smulrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11444; /* pred_smulrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11925; /* pred_smulrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11451; /* pred_smulrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11930; /* pred_smulrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11458; /* pred_smulrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11935; /* pred_smulrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11465; /* pred_smulrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11950; /* pred_smulrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11472; /* pred_smulrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11955; /* pred_smulrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11479; /* pred_smulrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11960; /* pred_smulrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11486; /* pred_smulrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11965; /* pred_smulrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11493; /* pred_smulrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12199; /* *pred_smulrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11500; /* pred_smulrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12204; /* *pred_smulrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11507; /* pred_smulrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12209; /* *pred_smulrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11514; /* pred_smulrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12214; /* *pred_smulrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11521; /* pred_smulrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11905; /* pred_smulrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11528; /* pred_smulrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11910; /* pred_smulrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11535; /* pred_smulrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11915; /* pred_smulrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11542; /* pred_smulrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11940; /* pred_smulrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11549; /* pred_smulrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11945; /* pred_smulrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11556; /* pred_smulrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11970; /* pred_smulrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11563; /* pred_smulv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11975; /* pred_smulv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11570; /* pred_smulv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11980; /* pred_smulv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11577; /* pred_smulv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11985; /* pred_smulv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11584; /* pred_smulv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11990; /* pred_smulv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11591; /* pred_smulv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11995; /* pred_smulv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11598; /* pred_smulv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12000; /* pred_smulv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11605; /* pred_smulv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12005; /* pred_smulv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11612; /* pred_smulv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12010; /* pred_smulv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11619; /* pred_smulv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12015; /* pred_smulv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11626; /* pred_smulv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12020; /* pred_smulv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11633; /* pred_smulv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12025; /* pred_smulv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11640; /* pred_smulv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12030; /* pred_smulv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11647; /* pred_smulv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12035; /* pred_smulv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11654; /* pred_smulv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12040; /* pred_smulv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11661; /* pred_smulv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12045; /* pred_smulv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11668; /* pred_smulv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12050; /* pred_smulv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11675; /* pred_smulv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12055; /* pred_smulv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11682; /* pred_smulv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12060; /* pred_smulv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11689; /* pred_smulv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12065; /* pred_smulv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11696; /* pred_smulv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12070; /* pred_smulv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11703; /* pred_smulv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12075; /* pred_smulv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11710; /* pred_smulv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12080; /* pred_smulv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11717; /* pred_smulv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12085; /* pred_smulv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11724; /* pred_smulv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12090; /* pred_smulv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11731; /* pred_smulv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12095; /* pred_smulv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11738; /* pred_smulv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12100; /* pred_smulv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11745; /* pred_smulv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12105; /* pred_smulv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11752; /* pred_smulv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12110; /* pred_smulv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11759; /* pred_smulv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12115; /* pred_smulv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11766; /* pred_smulv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12120; /* pred_smulv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11773; /* pred_smulv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12125; /* pred_smulv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11780; /* pred_smulv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12130; /* pred_smulv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11787; /* pred_smulv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12135; /* pred_smulv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11794; /* pred_smulv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12140; /* pred_smulv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11801; /* pred_smulv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12145; /* pred_smulv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11808; /* pred_smulv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12150; /* pred_smulv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11815; /* pred_smulv1di */

    case 59:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11822; /* pred_smulv2di */

    case 60:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11829; /* pred_smulv4di */

    case 61:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11836; /* pred_smulv8di */

    case 62:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11843; /* pred_smulv16di */

    case 63:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11850; /* pred_smulv32di */

    case 64:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11857; /* pred_smulv64di */

    case 65:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11864; /* pred_smulv128di */

    case 66:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11871; /* pred_smulv256di */

    case 67:
      if (!(
#line 4553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11878; /* pred_smulv512di */

    case 68:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12219; /* *pred_smulrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12224; /* *pred_smulrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12229; /* *pred_smulrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12234; /* *pred_smulrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_940 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15256; /* *pred_mul_addrvvm4hf_undef */
}

 int
recog_943 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15262; /* *pred_mul_addrvvmf2hf_undef */
}

 int
recog_947 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15270; /* *pred_mul_addrvvm2sf_undef */
}

 int
recog_952 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15280; /* *pred_mul_addrvvm2df_undef */
}

 int
recog_957 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15290; /* *pred_mul_addv8hf_undef */
}

 int
recog_962 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15300; /* *pred_mul_addv256hf_undef */
}

 int
recog_967 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15310; /* *pred_mul_addv2sf_undef */
}

 int
recog_972 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15320; /* *pred_mul_addv64sf_undef */
}

 int
recog_977 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15330; /* *pred_mul_addv1df_undef */
}

 int
recog_981 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15338; /* *pred_mul_addv16df_undef */
}

 int
recog_986 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15348; /* *pred_mul_addv512df_undef */
}

 int
recog_991 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16763; /* pred_widen_mul_addrvvm8sf_scalar */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 130 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33777; /* pred_widen_bf16_mul_rvvm8sf_scalar */

    default:
      return -1;
    }
}

 int
recog_996 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16703; /* pred_widen_mul_addrvvm8sf */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 101 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33772; /* pred_widen_bf16_mul_rvvm8sf */

    default:
      return -1;
    }
}

 int
recog_1001 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_982 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15436; /* *pred_maddv32df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15532; /* *pred_maccv32df */
}

 int
recog_1006 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_977 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15426; /* *pred_maddv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15522; /* *pred_maccv1df */
}

 int
recog_1011 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_972 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15416; /* *pred_maddv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15512; /* *pred_maccv64sf */
}

 int
recog_1016 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_967 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15406; /* *pred_maddv2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15502; /* *pred_maccv2sf */
}

 int
recog_1021 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_962 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15396; /* *pred_maddv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15492; /* *pred_maccv256hf */
}

 int
recog_1026 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_957 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15386; /* *pred_maddv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15482; /* *pred_maccv8hf */
}

 int
recog_1031 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_952 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15376; /* *pred_maddrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15472; /* *pred_maccrvvm2df */
}

 int
recog_1037 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_946 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15364; /* *pred_maddrvvm4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15460; /* *pred_maccrvvm4sf */
}

 int
recog_1043 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_940 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15352; /* *pred_maddrvvm4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15448; /* *pred_maccrvvm4hf */
}

 int
recog_1051 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15746; /* *pred_mul_neg_addrvvm8sf_undef */
}

 int
recog_1059 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15762; /* *pred_mul_neg_addrvvm1df_undef */
}

 int
recog_1067 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15778; /* *pred_mul_neg_addv128hf_undef */
}

 int
recog_1075 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15794; /* *pred_mul_neg_addv8sf_undef */
}

 int
recog_1083 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15810; /* *pred_mul_neg_addv1df_undef */
}

 int
recog_1092 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15828; /* *pred_mul_neg_addv512df_undef */
}

 int
recog_1102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1083 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15906; /* *pred_nmsubv1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 16002; /* *pred_nmsacv1df */
}

 int
recog_1112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1073 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15886; /* *pred_nmsubv2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15982; /* *pred_nmsacv2sf */
}

 int
recog_1122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1063 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15866; /* *pred_nmsubv8hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15962; /* *pred_nmsacv8hf */
}

 int
recog_1132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1053 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15846; /* *pred_nmsubrvvm2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15942; /* *pred_nmsacrvvm2sf */
}

 int
recog_1142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern588 (x2))
    {
    case 0:
      return recog_1140 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1139 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1138 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1137 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1136 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1135 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1134 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1133 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1132 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1131 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1130 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1129 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1128 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1127 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1126 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1125 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1124 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1123 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1122 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1121 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1120 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1119 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1118 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1117 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1116 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1115 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1114 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1113 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1112 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1111 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1110 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1109 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1108 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1107 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1106 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1105 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1104 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1103 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1102 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1101 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1100 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1099 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1098 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1097 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1096 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1095 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1094 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1093 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16022; /* *pred_nmsubrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16118; /* *pred_nmsacrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16024; /* *pred_nmsubrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16120; /* *pred_nmsacrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16026; /* *pred_nmsubrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16122; /* *pred_nmsacrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16028; /* *pred_nmsubrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16124; /* *pred_nmsacrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16030; /* *pred_nmsubrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16126; /* *pred_nmsacrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 16032; /* *pred_nmsubrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16128; /* *pred_nmsacrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16034; /* *pred_nmsubrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16130; /* *pred_nmsacrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16036; /* *pred_nmsubrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16132; /* *pred_nmsacrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16038; /* *pred_nmsubrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16134; /* *pred_nmsacrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16040; /* *pred_nmsubrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16136; /* *pred_nmsacrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 16042; /* *pred_nmsubrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16138; /* *pred_nmsacrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16044; /* *pred_nmsubrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16140; /* *pred_nmsacrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16046; /* *pred_nmsubrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16142; /* *pred_nmsacrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16048; /* *pred_nmsubrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16144; /* *pred_nmsacrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16050; /* *pred_nmsubrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16146; /* *pred_nmsacrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 16052; /* *pred_nmsubv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16148; /* *pred_nmsacv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 16054; /* *pred_nmsubv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16150; /* *pred_nmsacv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 16056; /* *pred_nmsubv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16152; /* *pred_nmsacv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 16058; /* *pred_nmsubv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16154; /* *pred_nmsacv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 16060; /* *pred_nmsubv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16156; /* *pred_nmsacv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 16062; /* *pred_nmsubv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16158; /* *pred_nmsacv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 16064; /* *pred_nmsubv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16160; /* *pred_nmsacv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 16066; /* *pred_nmsubv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16162; /* *pred_nmsacv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 16068; /* *pred_nmsubv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16164; /* *pred_nmsacv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 16070; /* *pred_nmsubv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16166; /* *pred_nmsacv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 16072; /* *pred_nmsubv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16168; /* *pred_nmsacv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 16074; /* *pred_nmsubv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16170; /* *pred_nmsacv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16076; /* *pred_nmsubv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16172; /* *pred_nmsacv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16078; /* *pred_nmsubv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16174; /* *pred_nmsacv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16080; /* *pred_nmsubv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16176; /* *pred_nmsacv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16082; /* *pred_nmsubv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16178; /* *pred_nmsacv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 16084; /* *pred_nmsubv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16180; /* *pred_nmsacv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 16086; /* *pred_nmsubv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16182; /* *pred_nmsacv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 16088; /* *pred_nmsubv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16184; /* *pred_nmsacv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 16090; /* *pred_nmsubv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16186; /* *pred_nmsacv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 16092; /* *pred_nmsubv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16188; /* *pred_nmsacv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 16094; /* *pred_nmsubv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16190; /* *pred_nmsacv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 16096; /* *pred_nmsubv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16192; /* *pred_nmsacv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16098; /* *pred_nmsubv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16194; /* *pred_nmsacv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16100; /* *pred_nmsubv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16196; /* *pred_nmsacv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16102; /* *pred_nmsubv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16198; /* *pred_nmsacv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 16104; /* *pred_nmsubv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16200; /* *pred_nmsacv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 16106; /* *pred_nmsubv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16202; /* *pred_nmsacv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 16108; /* *pred_nmsubv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16204; /* *pred_nmsacv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 16110; /* *pred_nmsubv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16206; /* *pred_nmsacv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 16112; /* *pred_nmsubv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16208; /* *pred_nmsacv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 16114; /* *pred_nmsubv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16210; /* *pred_nmsacv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 16116; /* *pred_nmsubv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16212; /* *pred_nmsacv512df_scalar */

    case 96:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16823; /* pred_widen_mul_neg_addrvvm8sf */

    case 97:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16825; /* pred_widen_mul_neg_addrvvm4sf */

    case 98:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16827; /* pred_widen_mul_neg_addrvvm2sf */

    case 99:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16829; /* pred_widen_mul_neg_addrvvm1sf */

    case 100:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16831; /* pred_widen_mul_neg_addrvvmf2sf */

    case 101:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16833; /* pred_widen_mul_neg_addrvvm8df */

    case 102:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16835; /* pred_widen_mul_neg_addrvvm4df */

    case 103:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16837; /* pred_widen_mul_neg_addrvvm2df */

    case 104:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16839; /* pred_widen_mul_neg_addrvvm1df */

    case 105:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16841; /* pred_widen_mul_neg_addv1sf */

    case 106:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16843; /* pred_widen_mul_neg_addv2sf */

    case 107:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16845; /* pred_widen_mul_neg_addv4sf */

    case 108:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16847; /* pred_widen_mul_neg_addv8sf */

    case 109:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16849; /* pred_widen_mul_neg_addv16sf */

    case 110:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16851; /* pred_widen_mul_neg_addv32sf */

    case 111:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16853; /* pred_widen_mul_neg_addv64sf */

    case 112:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16855; /* pred_widen_mul_neg_addv128sf */

    case 113:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16857; /* pred_widen_mul_neg_addv256sf */

    case 114:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16859; /* pred_widen_mul_neg_addv512sf */

    case 115:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16861; /* pred_widen_mul_neg_addv1024sf */

    case 116:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16863; /* pred_widen_mul_neg_addv1df */

    case 117:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16865; /* pred_widen_mul_neg_addv2df */

    case 118:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16867; /* pred_widen_mul_neg_addv4df */

    case 119:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16869; /* pred_widen_mul_neg_addv8df */

    case 120:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16871; /* pred_widen_mul_neg_addv16df */

    case 121:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16873; /* pred_widen_mul_neg_addv32df */

    case 122:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16875; /* pred_widen_mul_neg_addv64df */

    case 123:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16877; /* pred_widen_mul_neg_addv128df */

    case 124:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16879; /* pred_widen_mul_neg_addv256df */

    case 125:
      if (!(
#line 7234 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16881; /* pred_widen_mul_neg_addv512df */

    case 126:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16883; /* pred_widen_mul_neg_addrvvm8sf_scalar */

    case 127:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16885; /* pred_widen_mul_neg_addrvvm4sf_scalar */

    case 128:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16887; /* pred_widen_mul_neg_addrvvm2sf_scalar */

    case 129:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16889; /* pred_widen_mul_neg_addrvvm1sf_scalar */

    case 130:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16891; /* pred_widen_mul_neg_addrvvmf2sf_scalar */

    case 131:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16893; /* pred_widen_mul_neg_addrvvm8df_scalar */

    case 132:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16895; /* pred_widen_mul_neg_addrvvm4df_scalar */

    case 133:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16897; /* pred_widen_mul_neg_addrvvm2df_scalar */

    case 134:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16899; /* pred_widen_mul_neg_addrvvm1df_scalar */

    case 135:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16901; /* pred_widen_mul_neg_addv1sf_scalar */

    case 136:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16903; /* pred_widen_mul_neg_addv2sf_scalar */

    case 137:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16905; /* pred_widen_mul_neg_addv4sf_scalar */

    case 138:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16907; /* pred_widen_mul_neg_addv8sf_scalar */

    case 139:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16909; /* pred_widen_mul_neg_addv16sf_scalar */

    case 140:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16911; /* pred_widen_mul_neg_addv32sf_scalar */

    case 141:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16913; /* pred_widen_mul_neg_addv64sf_scalar */

    case 142:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16915; /* pred_widen_mul_neg_addv128sf_scalar */

    case 143:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16917; /* pred_widen_mul_neg_addv256sf_scalar */

    case 144:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16919; /* pred_widen_mul_neg_addv512sf_scalar */

    case 145:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16921; /* pred_widen_mul_neg_addv1024sf_scalar */

    case 146:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16923; /* pred_widen_mul_neg_addv1df_scalar */

    case 147:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16925; /* pred_widen_mul_neg_addv2df_scalar */

    case 148:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16927; /* pred_widen_mul_neg_addv4df_scalar */

    case 149:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16929; /* pred_widen_mul_neg_addv8df_scalar */

    case 150:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16931; /* pred_widen_mul_neg_addv16df_scalar */

    case 151:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16933; /* pred_widen_mul_neg_addv32df_scalar */

    case 152:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16935; /* pred_widen_mul_neg_addv64df_scalar */

    case 153:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16937; /* pred_widen_mul_neg_addv128df_scalar */

    case 154:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16939; /* pred_widen_mul_neg_addv256df_scalar */

    case 155:
      if (!(
#line 7264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16941; /* pred_widen_mul_neg_addv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern576 (x2))
    {
    case 0:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17471; /* pred_floatrvvm8hf */

    case 1:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17473; /* pred_floatrvvm4hf */

    case 2:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18005; /* pred_narrow_floatrvvm8si */

    case 3:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17475; /* pred_floatrvvm2hf */

    case 4:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18007; /* pred_narrow_floatrvvm4si */

    case 5:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17477; /* pred_floatrvvm1hf */

    case 6:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18009; /* pred_narrow_floatrvvm2si */

    case 7:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17479; /* pred_floatrvvmf2hf */

    case 8:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18011; /* pred_narrow_floatrvvm1si */

    case 9:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17481; /* pred_floatrvvmf4hf */

    case 10:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 18013; /* pred_narrow_floatrvvmf2si */

    case 11:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17483; /* pred_floatrvvm8sf */

    case 12:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17485; /* pred_floatrvvm4sf */

    case 13:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18015; /* pred_narrow_floatrvvm8di */

    case 14:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17487; /* pred_floatrvvm2sf */

    case 15:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18017; /* pred_narrow_floatrvvm4di */

    case 16:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17489; /* pred_floatrvvm1sf */

    case 17:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18019; /* pred_narrow_floatrvvm2di */

    case 18:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 17491; /* pred_floatrvvmf2sf */

    case 19:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18021; /* pred_narrow_floatrvvm1di */

    case 20:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17493; /* pred_floatrvvm8df */

    case 21:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17495; /* pred_floatrvvm4df */

    case 22:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17497; /* pred_floatrvvm2df */

    case 23:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17499; /* pred_floatrvvm1df */

    case 24:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 17501; /* pred_floatv1hf */

    case 25:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 18023; /* pred_narrow_floatv1si */

    case 26:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 17503; /* pred_floatv2hf */

    case 27:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 18025; /* pred_narrow_floatv2si */

    case 28:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17505; /* pred_floatv4hf */

    case 29:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 18027; /* pred_narrow_floatv4si */

    case 30:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17507; /* pred_floatv8hf */

    case 31:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 18029; /* pred_narrow_floatv8si */

    case 32:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17509; /* pred_floatv16hf */

    case 33:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18031; /* pred_narrow_floatv16si */

    case 34:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17511; /* pred_floatv32hf */

    case 35:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18033; /* pred_narrow_floatv32si */

    case 36:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17513; /* pred_floatv64hf */

    case 37:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18035; /* pred_narrow_floatv64si */

    case 38:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17515; /* pred_floatv128hf */

    case 39:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18037; /* pred_narrow_floatv128si */

    case 40:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17517; /* pred_floatv256hf */

    case 41:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18039; /* pred_narrow_floatv256si */

    case 42:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17519; /* pred_floatv512hf */

    case 43:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18041; /* pred_narrow_floatv512si */

    case 44:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17521; /* pred_floatv1024hf */

    case 45:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18043; /* pred_narrow_floatv1024si */

    case 46:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17523; /* pred_floatv2048hf */

    case 47:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17525; /* pred_floatv1sf */

    case 48:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18045; /* pred_narrow_floatv1di */

    case 49:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17527; /* pred_floatv2sf */

    case 50:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18047; /* pred_narrow_floatv2di */

    case 51:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17529; /* pred_floatv4sf */

    case 52:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 18049; /* pred_narrow_floatv4di */

    case 53:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17531; /* pred_floatv8sf */

    case 54:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 18051; /* pred_narrow_floatv8di */

    case 55:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17533; /* pred_floatv16sf */

    case 56:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 18053; /* pred_narrow_floatv16di */

    case 57:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17535; /* pred_floatv32sf */

    case 58:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 18055; /* pred_narrow_floatv32di */

    case 59:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17537; /* pred_floatv64sf */

    case 60:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 18057; /* pred_narrow_floatv64di */

    case 61:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17539; /* pred_floatv128sf */

    case 62:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 18059; /* pred_narrow_floatv128di */

    case 63:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17541; /* pred_floatv256sf */

    case 64:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 18061; /* pred_narrow_floatv256di */

    case 65:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17543; /* pred_floatv512sf */

    case 66:
      if (!(
#line 7698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 18063; /* pred_narrow_floatv512di */

    case 67:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17545; /* pred_floatv1024sf */

    case 68:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17547; /* pred_floatv1df */

    case 69:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17549; /* pred_floatv2df */

    case 70:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17551; /* pred_floatv4df */

    case 71:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17553; /* pred_floatv8df */

    case 72:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17555; /* pred_floatv16df */

    case 73:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17557; /* pred_floatv32df */

    case 74:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17559; /* pred_floatv64df */

    case 75:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17561; /* pred_floatv128df */

    case 76:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17563; /* pred_floatv256df */

    case 77:
      if (!(
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17565; /* pred_floatv512df */

    default:
      return -1;
    }
}

 int
recog_1356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode)
          || !vector_arith_operand (operands[4], E_V8QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12452; /* *pred_cmpv8qi_merge_tie_mask */

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode)
          || !vector_arith_operand (operands[4], E_V8HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12465; /* *pred_cmpv8hi_merge_tie_mask */

    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !vector_arith_operand (operands[4], E_V8SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12477; /* *pred_cmpv8si_merge_tie_mask */

    case E_V8DImode:
      if (!register_operand (operands[3], E_V8DImode)
          || !vector_arith_operand (operands[4], E_V8DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12488; /* *pred_cmpv8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || !vector_arith_operand (operands[4], E_V512QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12458; /* *pred_cmpv512qi_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || !vector_arith_operand (operands[4], E_V512HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12471; /* *pred_cmpv512hi_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || !vector_arith_operand (operands[4], E_V512SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12483; /* *pred_cmpv512si_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || !vector_arith_operand (operands[4], E_V512DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12494; /* *pred_cmpv512di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1358 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32QImode:
      if (!register_operand (operands[4], E_V32QImode)
          || !vector_arith_operand (operands[5], E_V32QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32QImode)) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 12522; /* *pred_cmpv32qi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32QImode)) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12590; /* *pred_cmpv32qi_narrow */

    case E_V32HImode:
      if (!register_operand (operands[4], E_V32HImode)
          || !vector_arith_operand (operands[5], E_V32HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HImode)) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12535; /* *pred_cmpv32hi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HImode)) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12603; /* *pred_cmpv32hi_narrow */

    case E_V32SImode:
      if (!register_operand (operands[4], E_V32SImode)
          || !vector_arith_operand (operands[5], E_V32SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SImode)) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12547; /* *pred_cmpv32si */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SImode)) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12615; /* *pred_cmpv32si_narrow */

    case E_V32DImode:
      if (!register_operand (operands[4], E_V32DImode)
          || !vector_arith_operand (operands[5], E_V32DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode)) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12558; /* *pred_cmpv32di */
      if (!(
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode)) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12626; /* *pred_cmpv32di_narrow */

    default:
      return -1;
    }
}

 int
recog_1376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1QImode)
          || !
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12634; /* *pred_ltgervvm1qi_merge_tie_mask */

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2HImode)
          || !
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12637; /* *pred_ltgervvm2hi_merge_tie_mask */

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM4SImode)
          || !
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12640; /* *pred_ltgervvm4si_merge_tie_mask */

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM8DImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12643; /* *pred_ltgervvm8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2QImode:
      if (!register_operand (operands[3], E_V2QImode)
          || !vector_neg_arith_operand (operands[4], E_V2QImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 12654; /* *pred_ltgev2qi_merge_tie_mask */

    case E_V2HImode:
      if (!register_operand (operands[3], E_V2HImode)
          || !vector_neg_arith_operand (operands[4], E_V2HImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12667; /* *pred_ltgev2hi_merge_tie_mask */

    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode)
          || !vector_neg_arith_operand (operands[4], E_V2SImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12679; /* *pred_ltgev2si_merge_tie_mask */

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode)
          || !vector_neg_arith_operand (operands[4], E_V2DImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12690; /* *pred_ltgev2di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1388 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256QImode:
      if (!register_operand (operands[3], E_V256QImode)
          || !vector_neg_arith_operand (operands[4], E_V256QImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12661; /* *pred_ltgev256qi_merge_tie_mask */

    case E_V256HImode:
      if (!register_operand (operands[3], E_V256HImode)
          || !vector_neg_arith_operand (operands[4], E_V256HImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12674; /* *pred_ltgev256hi_merge_tie_mask */

    case E_V256SImode:
      if (!register_operand (operands[3], E_V256SImode)
          || !vector_neg_arith_operand (operands[4], E_V256SImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12686; /* *pred_ltgev256si_merge_tie_mask */

    case E_V256DImode:
      if (!register_operand (operands[3], E_V256DImode)
          || !vector_neg_arith_operand (operands[4], E_V256DImode)
          || !(
#line 4851 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12697; /* *pred_ltgev256di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V64BImode))
    {
      res = recog_1386 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64QImode:
      if (!register_operand (operands[4], E_V64QImode)
          || !vector_neg_arith_operand (operands[5], E_V64QImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64QImode)) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 12727; /* *pred_ltgev64qi */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64QImode)) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12795; /* *pred_ltgev64qi_narrow */

    case E_V64HImode:
      if (!register_operand (operands[4], E_V64HImode)
          || !vector_neg_arith_operand (operands[5], E_V64HImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64HImode)) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12740; /* *pred_ltgev64hi */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64HImode)) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12808; /* *pred_ltgev64hi_narrow */

    case E_V64SImode:
      if (!register_operand (operands[4], E_V64SImode)
          || !vector_neg_arith_operand (operands[5], E_V64SImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64SImode)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12752; /* *pred_ltgev64si */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64SImode)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12820; /* *pred_ltgev64si_narrow */

    case E_V64DImode:
      if (!register_operand (operands[4], E_V64DImode)
          || !vector_neg_arith_operand (operands[5], E_V64DImode))
        return -1;
      if ((
#line 4875 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DImode)) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 12763; /* *pred_ltgev64di */
      if (!(
#line 4896 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DImode)) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12831; /* *pred_ltgev64di_narrow */

    default:
      return -1;
    }
}

 int
recog_1402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[3], E_RVVM2QImode)
          || GET_MODE (x9) != E_RVVM2QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12837; /* *pred_cmprvvm2qi_scalar_merge_tie_mask */

    case E_RVVM4HImode:
      if (!register_operand (operands[3], E_RVVM4HImode)
          || GET_MODE (x9) != E_RVVM4HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12843; /* *pred_cmprvvm4hi_scalar_merge_tie_mask */

    case E_RVVM8SImode:
      if (!register_operand (operands[3], E_RVVM8SImode)
          || GET_MODE (x9) != E_RVVM8SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12848; /* *pred_cmprvvm8si_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12855; /* *pred_cmpv4qi_scalar_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12868; /* *pred_cmpv4hi_scalar_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12880; /* *pred_cmpv4si_scalar_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13003; /* *pred_cmpv4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12862; /* *pred_cmpv512qi_scalar_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12875; /* *pred_cmpv512hi_scalar_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12887; /* *pred_cmpv512si_scalar_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13010; /* *pred_cmpv512di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1410 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || GET_MODE (x9) != E_V8QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12910; /* *pred_cmpv8qi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 733 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12964; /* *pred_cmpv8qi_scalar_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || GET_MODE (x9) != E_V8HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12923; /* *pred_cmpv8hi_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12977; /* *pred_cmpv8hi_scalar_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || GET_MODE (x9) != E_V8SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12935; /* *pred_cmpv8si_scalar */
      if (!(
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12989; /* *pred_cmpv8si_scalar_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || GET_MODE (x9) != E_V8DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 13018; /* *pred_cmpv8di_scalar */
      if (!(
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13032; /* *pred_cmpv8di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1430 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != VEC_DUPLICATE)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_1429 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (!register_operand (x6, E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF8BImode:
          if (pattern571 (x2, 
E_RVVMF8BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13039; /* *pred_cmprvvm8di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode) && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13053; /* *pred_cmprvvm8di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode) && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13067; /* *pred_cmprvvm8di_extended_scalar_narrow */

        case E_RVVMF16BImode:
          if (pattern571 (x2, 
E_RVVMF16BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13040; /* *pred_cmprvvm4di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode) && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13054; /* *pred_cmprvvm4di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode) && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13068; /* *pred_cmprvvm4di_extended_scalar_narrow */

        case E_RVVMF32BImode:
          if (pattern571 (x2, 
E_RVVMF32BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13041; /* *pred_cmprvvm2di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode) && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13055; /* *pred_cmprvvm2di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode) && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13069; /* *pred_cmprvvm2di_extended_scalar_narrow */

        case E_RVVMF64BImode:
          if (pattern571 (x2, 
E_RVVMF64BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13042; /* *pred_cmprvvm1di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode) && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13056; /* *pred_cmprvvm1di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode) && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13070; /* *pred_cmprvvm1di_extended_scalar_narrow */

        case E_V1BImode:
          if (pattern571 (x2, 
E_V1BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V1DImode, 
E_V1BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 13043; /* *pred_cmpv1di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V1BImode, 
E_V1DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode) && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 13057; /* *pred_cmpv1di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode) && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13071; /* *pred_cmpv1di_extended_scalar_narrow */

        case E_V2BImode:
          if (pattern571 (x2, 
E_V2BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V2DImode, 
E_V2BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 13044; /* *pred_cmpv2di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V2BImode, 
E_V2DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode) && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 13058; /* *pred_cmpv2di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode) && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13072; /* *pred_cmpv2di_extended_scalar_narrow */

        case E_V4BImode:
          if (pattern571 (x2, 
E_V4BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V4DImode, 
E_V4BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return 13045; /* *pred_cmpv4di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V4BImode, 
E_V4DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode) && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return 13059; /* *pred_cmpv4di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode) && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13073; /* *pred_cmpv4di_extended_scalar_narrow */

        case E_V8BImode:
          if (pattern571 (x2, 
E_V8BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V8DImode, 
E_V8BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return 13046; /* *pred_cmpv8di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V8BImode, 
E_V8DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode) && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return 13060; /* *pred_cmpv8di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode) && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13074; /* *pred_cmpv8di_extended_scalar_narrow */

        case E_V16BImode:
          if (pattern571 (x2, 
E_V16BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V16DImode, 
E_V16BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return 13047; /* *pred_cmpv16di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V16BImode, 
E_V16DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DImode) && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return 13061; /* *pred_cmpv16di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DImode) && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13075; /* *pred_cmpv16di_extended_scalar_narrow */

        case E_V32BImode:
          if (pattern571 (x2, 
E_V32BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V32DImode, 
E_V32BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return 13048; /* *pred_cmpv32di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V32BImode, 
E_V32DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode) && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return 13062; /* *pred_cmpv32di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode) && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13076; /* *pred_cmpv32di_extended_scalar_narrow */

        case E_V64BImode:
          if (pattern571 (x2, 
E_V64BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V64DImode, 
E_V64BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return 13049; /* *pred_cmpv64di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V64BImode, 
E_V64DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DImode) && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return 13063; /* *pred_cmpv64di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DImode) && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13077; /* *pred_cmpv64di_extended_scalar_narrow */

        case E_V128BImode:
          if (pattern571 (x2, 
E_V128BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V128DImode, 
E_V128BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return 13050; /* *pred_cmpv128di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V128BImode, 
E_V128DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V128DImode) && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return 13064; /* *pred_cmpv128di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V128DImode) && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13078; /* *pred_cmpv128di_extended_scalar_narrow */

        case E_V256BImode:
          if (pattern571 (x2, 
E_V256BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V256DImode, 
E_V256BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return 13051; /* *pred_cmpv256di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V256BImode, 
E_V256DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode) && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return 13065; /* *pred_cmpv256di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode) && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13079; /* *pred_cmpv256di_extended_scalar_narrow */

        case E_V512BImode:
          if (pattern571 (x2, 
E_V512BImode) != 0)
            return -1;
          operands[2] = x3;
          if (pattern693 (x2, 
E_V512DImode, 
E_V512BImode) == 0
              && (
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return 13052; /* *pred_cmpv512di_extended_scalar_merge_tie_mask */
          operands[3] = x3;
          if (pattern694 (x2, 
E_V512BImode, 
E_V512DImode) != 0)
            return -1;
          if ((
#line 5140 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode) && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return 13066; /* *pred_cmpv512di_extended_scalar */
          if (!(
#line 5162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode) && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13080; /* *pred_cmpv512di_extended_scalar_narrow */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern107 (x3))
        {
        case 0:
          if (!
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
            return -1;
          return 527; /* *popcountsi2 */

        case 1:
          if (!
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
            return -1;
          return 539; /* *popcountdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 5
          || XINT (x4, 1) != 93
          || pattern329 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          if (!vector_length_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern549 (x3, 
E_SImode))
                {
                case 0:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                    return -1;
                  return 14333; /* pred_popcountrvvmf64bisi */

                case 1:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14335; /* pred_popcountrvvmf32bisi */

                case 2:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14337; /* pred_popcountrvvmf16bisi */

                case 3:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14339; /* pred_popcountrvvmf8bisi */

                case 4:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14341; /* pred_popcountrvvmf4bisi */

                case 5:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14343; /* pred_popcountrvvmf2bisi */

                case 6:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 14345; /* pred_popcountrvvm1bisi */

                case 7:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14347; /* pred_popcountv1bisi */

                case 8:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14349; /* pred_popcountv2bisi */

                case 9:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14351; /* pred_popcountv4bisi */

                case 10:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14353; /* pred_popcountv8bisi */

                case 11:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14355; /* pred_popcountv16bisi */

                case 12:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14357; /* pred_popcountv32bisi */

                case 13:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14359; /* pred_popcountv64bisi */

                case 14:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14361; /* pred_popcountv128bisi */

                case 15:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14363; /* pred_popcountv256bisi */

                case 16:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14365; /* pred_popcountv512bisi */

                case 17:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14367; /* pred_popcountv1024bisi */

                case 18:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14369; /* pred_popcountv2048bisi */

                case 19:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14371; /* pred_popcountv4096bisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern549 (x3, 
E_DImode))
                {
                case 0:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                    return -1;
                  return 14334; /* pred_popcountrvvmf64bidi */

                case 1:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14336; /* pred_popcountrvvmf32bidi */

                case 2:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14338; /* pred_popcountrvvmf16bidi */

                case 3:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14340; /* pred_popcountrvvmf8bidi */

                case 4:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14342; /* pred_popcountrvvmf4bidi */

                case 5:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14344; /* pred_popcountrvvmf2bidi */

                case 6:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 14346; /* pred_popcountrvvm1bidi */

                case 7:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                    return -1;
                  return 14348; /* pred_popcountv1bidi */

                case 8:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                    return -1;
                  return 14350; /* pred_popcountv2bidi */

                case 9:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                    return -1;
                  return 14352; /* pred_popcountv4bidi */

                case 10:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                    return -1;
                  return 14354; /* pred_popcountv8bidi */

                case 11:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                    return -1;
                  return 14356; /* pred_popcountv16bidi */

                case 12:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                    return -1;
                  return 14358; /* pred_popcountv32bidi */

                case 13:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                    return -1;
                  return 14360; /* pred_popcountv64bidi */

                case 14:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                    return -1;
                  return 14362; /* pred_popcountv128bidi */

                case 15:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                    return -1;
                  return 14364; /* pred_popcountv256bidi */

                case 16:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                    return -1;
                  return 14366; /* pred_popcountv512bidi */

                case 17:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                    return -1;
                  return 14368; /* pred_popcountv1024bidi */

                case 18:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                    return -1;
                  return 14370; /* pred_popcountv2048bidi */

                case 19:
                  if (!(
#line 6097 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                    return -1;
                  return 14372; /* pred_popcountv4096bidi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 5
              || XINT (x5, 1) != 171)
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern456 (x3))
            {
            case 0:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 32205; /* *vcond_mask_len_popcount_rvvmf64bisi */

            case 1:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32207; /* *vcond_mask_len_popcount_rvvmf32bisi */

            case 2:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32209; /* *vcond_mask_len_popcount_rvvmf16bisi */

            case 3:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32211; /* *vcond_mask_len_popcount_rvvmf8bisi */

            case 4:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32213; /* *vcond_mask_len_popcount_rvvmf4bisi */

            case 5:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32215; /* *vcond_mask_len_popcount_rvvmf2bisi */

            case 6:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 32217; /* *vcond_mask_len_popcount_rvvm1bisi */

            case 7:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 32219; /* *vcond_mask_len_popcount_v1bisi */

            case 8:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 32221; /* *vcond_mask_len_popcount_v2bisi */

            case 9:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 32223; /* *vcond_mask_len_popcount_v4bisi */

            case 10:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 32225; /* *vcond_mask_len_popcount_v8bisi */

            case 11:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 32227; /* *vcond_mask_len_popcount_v16bisi */

            case 12:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 32229; /* *vcond_mask_len_popcount_v32bisi */

            case 13:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 32231; /* *vcond_mask_len_popcount_v64bisi */

            case 14:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 32233; /* *vcond_mask_len_popcount_v128bisi */

            case 15:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 32235; /* *vcond_mask_len_popcount_v256bisi */

            case 16:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 32237; /* *vcond_mask_len_popcount_v512bisi */

            case 17:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 32239; /* *vcond_mask_len_popcount_v1024bisi */

            case 18:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 32241; /* *vcond_mask_len_popcount_v2048bisi */

            case 19:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 32243; /* *vcond_mask_len_popcount_v4096bisi */

            case 20:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 32206; /* *vcond_mask_len_popcount_rvvmf64bidi */

            case 21:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32208; /* *vcond_mask_len_popcount_rvvmf32bidi */

            case 22:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32210; /* *vcond_mask_len_popcount_rvvmf16bidi */

            case 23:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32212; /* *vcond_mask_len_popcount_rvvmf8bidi */

            case 24:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32214; /* *vcond_mask_len_popcount_rvvmf4bidi */

            case 25:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32216; /* *vcond_mask_len_popcount_rvvmf2bidi */

            case 26:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 32218; /* *vcond_mask_len_popcount_rvvm1bidi */

            case 27:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))))
                return -1;
              return 32220; /* *vcond_mask_len_popcount_v1bidi */

            case 28:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))))
                return -1;
              return 32222; /* *vcond_mask_len_popcount_v2bidi */

            case 29:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))))
                return -1;
              return 32224; /* *vcond_mask_len_popcount_v4bidi */

            case 30:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))))
                return -1;
              return 32226; /* *vcond_mask_len_popcount_v8bidi */

            case 31:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))))
                return -1;
              return 32228; /* *vcond_mask_len_popcount_v16bidi */

            case 32:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))))
                return -1;
              return 32230; /* *vcond_mask_len_popcount_v32bidi */

            case 33:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))))
                return -1;
              return 32232; /* *vcond_mask_len_popcount_v64bidi */

            case 34:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))))
                return -1;
              return 32234; /* *vcond_mask_len_popcount_v128bidi */

            case 35:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))))
                return -1;
              return 32236; /* *vcond_mask_len_popcount_v256bidi */

            case 36:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))))
                return -1;
              return 32238; /* *vcond_mask_len_popcount_v512bidi */

            case 37:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))))
                return -1;
              return 32240; /* *vcond_mask_len_popcount_v1024bidi */

            case 38:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))))
                return -1;
              return 32242; /* *vcond_mask_len_popcount_v2048bidi */

            case 39:
              if (!(
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))))
                return -1;
              return 32244; /* *vcond_mask_len_popcount_v4096bidi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33151; /* pred_vpopcountrvvm8qi */

        case 1:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33154; /* pred_vpopcountrvvm4qi */

        case 2:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33157; /* pred_vpopcountrvvm2qi */

        case 3:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33160; /* pred_vpopcountrvvm1qi */

        case 4:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33163; /* pred_vpopcountrvvm8hi */

        case 5:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33166; /* pred_vpopcountrvvm4hi */

        case 6:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33169; /* pred_vpopcountrvvm2hi */

        case 7:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33172; /* pred_vpopcountrvvm1hi */

        case 8:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33175; /* pred_vpopcountrvvm8si */

        case 9:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33178; /* pred_vpopcountrvvm4si */

        case 10:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33181; /* pred_vpopcountrvvm2si */

        case 11:
          if (!
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
            return -1;
          return 33184; /* pred_vpopcountrvvm1si */

        case 12:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33187; /* pred_vpopcountrvvm8di */

        case 13:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33190; /* pred_vpopcountrvvm4di */

        case 14:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33193; /* pred_vpopcountrvvm2di */

        case 15:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33196; /* pred_vpopcountrvvm1di */

        case 16:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 33199; /* pred_vpopcountrvvmf2qi */

        case 17:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 33202; /* pred_vpopcountrvvmf4qi */

        case 18:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 33205; /* pred_vpopcountrvvmf8qi */

        case 19:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 33208; /* pred_vpopcountrvvmf2hi */

        case 20:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 33211; /* pred_vpopcountrvvmf4hi */

        case 21:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 33214; /* pred_vpopcountrvvmf2si */

        case 22:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 33217; /* pred_vpopcountv1qi */

        case 23:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 33220; /* pred_vpopcountv2qi */

        case 24:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 33223; /* pred_vpopcountv4qi */

        case 25:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 33226; /* pred_vpopcountv8qi */

        case 26:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 33229; /* pred_vpopcountv16qi */

        case 27:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 33232; /* pred_vpopcountv32qi */

        case 28:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33235; /* pred_vpopcountv64qi */

        case 29:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33238; /* pred_vpopcountv128qi */

        case 30:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33241; /* pred_vpopcountv256qi */

        case 31:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33244; /* pred_vpopcountv512qi */

        case 32:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33247; /* pred_vpopcountv1024qi */

        case 33:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33250; /* pred_vpopcountv2048qi */

        case 34:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33253; /* pred_vpopcountv4096qi */

        case 35:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 33256; /* pred_vpopcountv1hi */

        case 36:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 33259; /* pred_vpopcountv2hi */

        case 37:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 33262; /* pred_vpopcountv4hi */

        case 38:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 33265; /* pred_vpopcountv8hi */

        case 39:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 33268; /* pred_vpopcountv16hi */

        case 40:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33271; /* pred_vpopcountv32hi */

        case 41:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33274; /* pred_vpopcountv64hi */

        case 42:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33277; /* pred_vpopcountv128hi */

        case 43:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33280; /* pred_vpopcountv256hi */

        case 44:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33283; /* pred_vpopcountv512hi */

        case 45:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33286; /* pred_vpopcountv1024hi */

        case 46:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33289; /* pred_vpopcountv2048hi */

        case 47:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33292; /* pred_vpopcountv1si */

        case 48:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33295; /* pred_vpopcountv2si */

        case 49:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33298; /* pred_vpopcountv4si */

        case 50:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33301; /* pred_vpopcountv8si */

        case 51:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33304; /* pred_vpopcountv16si */

        case 52:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33307; /* pred_vpopcountv32si */

        case 53:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33310; /* pred_vpopcountv64si */

        case 54:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33313; /* pred_vpopcountv128si */

        case 55:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33316; /* pred_vpopcountv256si */

        case 56:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33319; /* pred_vpopcountv512si */

        case 57:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33322; /* pred_vpopcountv1024si */

        case 58:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33325; /* pred_vpopcountv1di */

        case 59:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33328; /* pred_vpopcountv2di */

        case 60:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33331; /* pred_vpopcountv4di */

        case 61:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33334; /* pred_vpopcountv8di */

        case 62:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33337; /* pred_vpopcountv16di */

        case 63:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33340; /* pred_vpopcountv32di */

        case 64:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33343; /* pred_vpopcountv64di */

        case 65:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33346; /* pred_vpopcountv128di */

        case 66:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33349; /* pred_vpopcountv256di */

        case 67:
          if (!(
#line 359 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33352; /* pred_vpopcountv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      return recog_28 (x1, insn, pnum_clobbers);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 93
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_DImode
          || pattern333 (x4) != 0
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[1], E_RVVM8DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20017; /* pred_extract_first_truncrvvm8di */

        case E_RVVM4DImode:
          if (!register_operand (operands[1], E_RVVM4DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20018; /* pred_extract_first_truncrvvm4di */

        case E_RVVM2DImode:
          if (!register_operand (operands[1], E_RVVM2DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20019; /* pred_extract_first_truncrvvm2di */

        case E_RVVM1DImode:
          if (!register_operand (operands[1], E_RVVM1DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20020; /* pred_extract_first_truncrvvm1di */

        case E_V1DImode:
          if (!register_operand (operands[1], E_V1DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20021; /* pred_extract_first_truncv1di */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20022; /* pred_extract_first_truncv2di */

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20023; /* pred_extract_first_truncv4di */

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20024; /* pred_extract_first_truncv8di */

        case E_V16DImode:
          if (!register_operand (operands[1], E_V16DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20025; /* pred_extract_first_truncv16di */

        case E_V32DImode:
          if (!register_operand (operands[1], E_V32DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20026; /* pred_extract_first_truncv32di */

        case E_V64DImode:
          if (!register_operand (operands[1], E_V64DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20027; /* pred_extract_first_truncv64di */

        case E_V128DImode:
          if (!register_operand (operands[1], E_V128DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20028; /* pred_extract_first_truncv128di */

        case E_V256DImode:
          if (!register_operand (operands[1], E_V256DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20029; /* pred_extract_first_truncv256di */

        case E_V512DImode:
          if (!register_operand (operands[1], E_V512DImode)
              || !(
#line 8065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20030; /* pred_extract_first_truncv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern156 (x3))
        {
        case 0:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26287; /* truncrvvm8hirvvm4qi2 */

        case 1:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26288; /* truncrvvm4hirvvm2qi2 */

        case 2:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26289; /* truncrvvm2hirvvm1qi2 */

        case 3:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26290; /* truncrvvm1hirvvmf2qi2 */

        case 4:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26291; /* truncrvvmf2hirvvmf4qi2 */

        case 5:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26292; /* truncrvvmf4hirvvmf8qi2 */

        case 6:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26293; /* truncrvvm8sirvvm4hi2 */

        case 7:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26294; /* truncrvvm4sirvvm2hi2 */

        case 8:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26295; /* truncrvvm2sirvvm1hi2 */

        case 9:
          if (!
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 26296; /* truncrvvm1sirvvmf2hi2 */

        case 10:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 26297; /* truncrvvmf2sirvvmf4hi2 */

        case 11:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26298; /* truncrvvm8dirvvm4si2 */

        case 12:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26299; /* truncrvvm4dirvvm2si2 */

        case 13:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26300; /* truncrvvm2dirvvm1si2 */

        case 14:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26301; /* truncrvvm1dirvvmf2si2 */

        case 15:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 26302; /* truncv1hiv1qi2 */

        case 16:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 26303; /* truncv2hiv2qi2 */

        case 17:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 26304; /* truncv4hiv4qi2 */

        case 18:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 26305; /* truncv8hiv8qi2 */

        case 19:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 26306; /* truncv16hiv16qi2 */

        case 20:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26307; /* truncv32hiv32qi2 */

        case 21:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26308; /* truncv64hiv64qi2 */

        case 22:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26309; /* truncv128hiv128qi2 */

        case 23:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26310; /* truncv256hiv256qi2 */

        case 24:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26311; /* truncv512hiv512qi2 */

        case 25:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26312; /* truncv1024hiv1024qi2 */

        case 26:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26313; /* truncv2048hiv2048qi2 */

        case 27:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 26314; /* truncv1siv1hi2 */

        case 28:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 26315; /* truncv2siv2hi2 */

        case 29:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 26316; /* truncv4siv4hi2 */

        case 30:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 26317; /* truncv8siv8hi2 */

        case 31:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26318; /* truncv16siv16hi2 */

        case 32:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26319; /* truncv32siv32hi2 */

        case 33:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26320; /* truncv64siv64hi2 */

        case 34:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26321; /* truncv128siv128hi2 */

        case 35:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26322; /* truncv256siv256hi2 */

        case 36:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26323; /* truncv512siv512hi2 */

        case 37:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26324; /* truncv1024siv1024hi2 */

        case 38:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26325; /* truncv1div1si2 */

        case 39:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26326; /* truncv2div2si2 */

        case 40:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 26327; /* truncv4div4si2 */

        case 41:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 26328; /* truncv8div8si2 */

        case 42:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 26329; /* truncv16div16si2 */

        case 43:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 26330; /* truncv32div32si2 */

        case 44:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 26331; /* truncv64div64si2 */

        case 45:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 26332; /* truncv128div128si2 */

        case 46:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 26333; /* truncv256div256si2 */

        case 47:
          if (!(
#line 777 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 26334; /* truncv512div512si2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_30 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_29 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern118 (x3))
    {
    case 0:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27940; /* umulrvvm8qi3_highpart */

    case 1:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27942; /* umulrvvm4qi3_highpart */

    case 2:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27944; /* umulrvvm2qi3_highpart */

    case 3:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27946; /* umulrvvm1qi3_highpart */

    case 4:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27948; /* umulrvvmf2qi3_highpart */

    case 5:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27950; /* umulrvvmf4qi3_highpart */

    case 6:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27952; /* umulrvvmf8qi3_highpart */

    case 7:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27954; /* umulrvvm8hi3_highpart */

    case 8:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27956; /* umulrvvm4hi3_highpart */

    case 9:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27958; /* umulrvvm2hi3_highpart */

    case 10:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27960; /* umulrvvm1hi3_highpart */

    case 11:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27962; /* umulrvvmf2hi3_highpart */

    case 12:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27964; /* umulrvvmf4hi3_highpart */

    case 13:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27966; /* umulrvvm8si3_highpart */

    case 14:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27968; /* umulrvvm4si3_highpart */

    case 15:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27970; /* umulrvvm2si3_highpart */

    case 16:
      if (!
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27972; /* umulrvvm1si3_highpart */

    case 17:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 27974; /* umulrvvmf2si3_highpart */

    case 18:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27976; /* umulrvvm8di3_highpart */

    case 19:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27978; /* umulrvvm4di3_highpart */

    case 20:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27980; /* umulrvvm2di3_highpart */

    case 21:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27982; /* umulrvvm1di3_highpart */

    case 22:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27984; /* umulv1qi3_highpart */

    case 23:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27986; /* umulv2qi3_highpart */

    case 24:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27988; /* umulv4qi3_highpart */

    case 25:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27990; /* umulv8qi3_highpart */

    case 26:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27992; /* umulv16qi3_highpart */

    case 27:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27994; /* umulv32qi3_highpart */

    case 28:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27996; /* umulv64qi3_highpart */

    case 29:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27998; /* umulv128qi3_highpart */

    case 30:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28000; /* umulv256qi3_highpart */

    case 31:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28002; /* umulv512qi3_highpart */

    case 32:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28004; /* umulv1024qi3_highpart */

    case 33:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28006; /* umulv2048qi3_highpart */

    case 34:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28008; /* umulv4096qi3_highpart */

    case 35:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28010; /* umulv1hi3_highpart */

    case 36:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28012; /* umulv2hi3_highpart */

    case 37:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28014; /* umulv4hi3_highpart */

    case 38:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28016; /* umulv8hi3_highpart */

    case 39:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28018; /* umulv16hi3_highpart */

    case 40:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28020; /* umulv32hi3_highpart */

    case 41:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28022; /* umulv64hi3_highpart */

    case 42:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28024; /* umulv128hi3_highpart */

    case 43:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28026; /* umulv256hi3_highpart */

    case 44:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28028; /* umulv512hi3_highpart */

    case 45:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28030; /* umulv1024hi3_highpart */

    case 46:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28032; /* umulv2048hi3_highpart */

    case 47:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28034; /* umulv1si3_highpart */

    case 48:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28036; /* umulv2si3_highpart */

    case 49:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28038; /* umulv4si3_highpart */

    case 50:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28040; /* umulv8si3_highpart */

    case 51:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28042; /* umulv16si3_highpart */

    case 52:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28044; /* umulv32si3_highpart */

    case 53:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28046; /* umulv64si3_highpart */

    case 54:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28048; /* umulv128si3_highpart */

    case 55:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28050; /* umulv256si3_highpart */

    case 56:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28052; /* umulv512si3_highpart */

    case 57:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28054; /* umulv1024si3_highpart */

    case 58:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28056; /* umulv1di3_highpart */

    case 59:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28058; /* umulv2di3_highpart */

    case 60:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28060; /* umulv4di3_highpart */

    case 61:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28062; /* umulv8di3_highpart */

    case 62:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28064; /* umulv16di3_highpart */

    case 63:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28066; /* umulv32di3_highpart */

    case 64:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28068; /* umulv64di3_highpart */

    case 65:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28070; /* umulv128di3_highpart */

    case 66:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28072; /* umulv256di3_highpart */

    case 67:
      if (!(
#line 1684 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28074; /* umulv512di3_highpart */

    default:
      return -1;
    }
}

 int
recog_1515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2801; /* *movrvvmf2qi_fract_vtype */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2802; /* *movrvvmf4qi_fract_vtype */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2803; /* *movrvvmf8qi_fract_vtype */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2804; /* *movrvvmf2hi_fract_vtype */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2805; /* *movrvvmf4hi_fract_vtype */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[0], E_RVVMF2BFmode)
          || !register_operand (operands[1], E_RVVMF2BFmode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2806; /* *movrvvmf2bf_fract_vtype */

    case E_RVVMF4BFmode:
      if (!register_operand (operands[0], E_RVVMF4BFmode)
          || !register_operand (operands[1], E_RVVMF4BFmode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2807; /* *movrvvmf4bf_fract_vtype */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2808; /* *movrvvmf2hf_fract_vtype */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2809; /* *movrvvmf4hf_fract_vtype */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2810; /* *movrvvmf2si_fract_vtype */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 1270 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 2811; /* *movrvvmf2sf_fract_vtype */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode)
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 2819; /* *movrvvmf64bi_vtype */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode)
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2820; /* *movrvvmf32bi_vtype */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode)
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2821; /* *movrvvmf16bi_vtype */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode)
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2822; /* *movrvvmf8bi_vtype */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode)
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2823; /* *movrvvmf4bi_vtype */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode)
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2824; /* *movrvvmf2bi_vtype */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode)
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 1307 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2825; /* *movrvvm1bi_vtype */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3415; /* *movv1qi_vls_vtype */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3416; /* *movv2qi_vls_vtype */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3417; /* *movv4qi_vls_vtype */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3418; /* *movv8qi_vls_vtype */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3419; /* *movv16qi_vls_vtype */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3420; /* *movv32qi_vls_vtype */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3421; /* *movv64qi_vls_vtype */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3422; /* *movv128qi_vls_vtype */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3423; /* *movv256qi_vls_vtype */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3424; /* *movv512qi_vls_vtype */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3425; /* *movv1024qi_vls_vtype */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3426; /* *movv2048qi_vls_vtype */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode)
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3427; /* *movv4096qi_vls_vtype */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3428; /* *movv1hi_vls_vtype */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3429; /* *movv2hi_vls_vtype */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3430; /* *movv4hi_vls_vtype */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3431; /* *movv8hi_vls_vtype */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3432; /* *movv16hi_vls_vtype */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3433; /* *movv32hi_vls_vtype */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3434; /* *movv64hi_vls_vtype */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3435; /* *movv128hi_vls_vtype */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3436; /* *movv256hi_vls_vtype */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3437; /* *movv512hi_vls_vtype */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3438; /* *movv1024hi_vls_vtype */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3439; /* *movv2048hi_vls_vtype */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3440; /* *movv1si_vls_vtype */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3441; /* *movv2si_vls_vtype */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3442; /* *movv4si_vls_vtype */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3443; /* *movv8si_vls_vtype */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3444; /* *movv16si_vls_vtype */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3445; /* *movv32si_vls_vtype */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3446; /* *movv64si_vls_vtype */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3447; /* *movv128si_vls_vtype */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3448; /* *movv256si_vls_vtype */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3449; /* *movv512si_vls_vtype */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3450; /* *movv1024si_vls_vtype */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3451; /* *movv1di_vls_vtype */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3452; /* *movv2di_vls_vtype */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3453; /* *movv4di_vls_vtype */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3454; /* *movv8di_vls_vtype */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3455; /* *movv16di_vls_vtype */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3456; /* *movv32di_vls_vtype */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3457; /* *movv64di_vls_vtype */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3458; /* *movv128di_vls_vtype */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3459; /* *movv256di_vls_vtype */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3460; /* *movv512di_vls_vtype */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || !register_operand (operands[1], E_V1HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3461; /* *movv1hf_vls_vtype */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || !register_operand (operands[1], E_V2HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3462; /* *movv2hf_vls_vtype */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3463; /* *movv4hf_vls_vtype */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3464; /* *movv8hf_vls_vtype */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || !register_operand (operands[1], E_V16HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3465; /* *movv16hf_vls_vtype */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || !register_operand (operands[1], E_V32HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3466; /* *movv32hf_vls_vtype */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || !register_operand (operands[1], E_V64HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3467; /* *movv64hf_vls_vtype */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || !register_operand (operands[1], E_V128HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3468; /* *movv128hf_vls_vtype */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || !register_operand (operands[1], E_V256HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3469; /* *movv256hf_vls_vtype */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || !register_operand (operands[1], E_V512HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3470; /* *movv512hf_vls_vtype */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || !register_operand (operands[1], E_V1024HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3471; /* *movv1024hf_vls_vtype */

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || !register_operand (operands[1], E_V2048HFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3472; /* *movv2048hf_vls_vtype */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3473; /* *movv1sf_vls_vtype */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3474; /* *movv2sf_vls_vtype */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3475; /* *movv4sf_vls_vtype */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3476; /* *movv8sf_vls_vtype */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3477; /* *movv16sf_vls_vtype */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3478; /* *movv32sf_vls_vtype */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3479; /* *movv64sf_vls_vtype */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3480; /* *movv128sf_vls_vtype */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3481; /* *movv256sf_vls_vtype */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3482; /* *movv512sf_vls_vtype */

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3483; /* *movv1024sf_vls_vtype */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3484; /* *movv1df_vls_vtype */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3485; /* *movv2df_vls_vtype */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3486; /* *movv4df_vls_vtype */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3487; /* *movv8df_vls_vtype */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3488; /* *movv16df_vls_vtype */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3489; /* *movv32df_vls_vtype */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3490; /* *movv64df_vls_vtype */

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3491; /* *movv128df_vls_vtype */

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3492; /* *movv256df_vls_vtype */

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3493; /* *movv512df_vls_vtype */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode)
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 3507; /* *movv1bi_vls_vtype */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode)
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 3508; /* *movv2bi_vls_vtype */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode)
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 3509; /* *movv4bi_vls_vtype */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode)
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 3510; /* *movv8bi_vls_vtype */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode)
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 3511; /* *movv16bi_vls_vtype */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode)
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 3512; /* *movv32bi_vls_vtype */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode)
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3513; /* *movv64bi_vls_vtype */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode)
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3514; /* *movv128bi_vls_vtype */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode)
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3515; /* *movv256bi_vls_vtype */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode)
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3516; /* *movv512bi_vls_vtype */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode)
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3517; /* *movv1024bi_vls_vtype */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode)
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3518; /* *movv2048bi_vls_vtype */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode)
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3519; /* *movv4096bi_vls_vtype */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5225 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5226 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5227 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5228 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5229 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5230 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5231 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5232 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5233 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5234 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5235 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5236 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5237 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5238 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5239 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5240 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5241 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5242 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5243 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5244 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5245 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5246 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5247 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5248 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5249 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5250 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5251 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5252 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5253 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5254 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5255 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5256 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5257 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2048QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5258 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4096QImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5259 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5260 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5261 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5262 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5263 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5264 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5265 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5266 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5267 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5268 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5269 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5270 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2048HImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5271 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5272 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5273 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5274 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5275 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5276 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5277 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5278 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5279 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5280 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5281 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024SImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5282 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5283 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5284 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5285 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5286 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5287 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5288 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5289 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5290 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5291 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512DImode) != 0
          || !((
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5292 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5361 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5362 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5363 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5364 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5365 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5366 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5367 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5368 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5369 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5370 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5371 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5372 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5373 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5374 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5375 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5376 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5377 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5378 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5379 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5380 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5381 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5382 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5383 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5384 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5385 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5386 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5387 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5388 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5389 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5390 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5391 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5392 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5393 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5394 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5395 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5396 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5397 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5398 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5399 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5400 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5401 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5402 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5403 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5404 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5405 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5406 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5407 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512DFmode) != 0
          || !((
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5408 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_303 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4330 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2SFmode)
       || !register_operand (operands[1], V2SFmode)))))
        return gen_split_1973 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2150 (insn, operands);
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HFmode)
      && reg_or_mem_operand (operands[1], E_V4HFmode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_292 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))) && 
#line 4326 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4HFmode)
       || !register_operand (operands[1], V4HFmode)))))
        return gen_split_1969 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4HFmode)
      || !register_operand (operands[1], E_V4HFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2139 (insn, operands);
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DImode)
      && reg_or_mem_operand (operands[1], E_V8DImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return gen_split_283 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))) && 
#line 4322 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8DImode)
       || !register_operand (operands[1], V8DImode)))))
        return gen_split_1965 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8DImode)
      || !register_operand (operands[1], E_V8DImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2130 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return gen_split_273 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4318 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SImode)
       || !register_operand (operands[1], V16SImode)))))
        return gen_split_1961 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2120 (insn, operands);
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SImode)
      && reg_or_mem_operand (operands[1], E_V1SImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return gen_split_269 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SImode)
       || register_operand (operands[1], V1SImode))) && 
#line 4314 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SImode)
       || !register_operand (operands[1], V1SImode)))))
        return gen_split_1957 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SImode)
      || !register_operand (operands[1], E_V1SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2116 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16QImode)
      && reg_or_mem_operand (operands[1], E_V16QImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return gen_split_248 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))) && 
#line 4308 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16QImode)
       || !register_operand (operands[1], V16QImode)))))
        return gen_split_1951 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2095 (insn, operands);
}

 rtx_insn *
split_46 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && ((
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8BImode)
       || !register_operand (operands[1], V8BImode)))))
    return gen_split_1985 (insn, operands);
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !((
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1532 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2173 (insn, operands);
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DFmode)
      && reg_or_mem_operand (operands[1], E_V256DFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_321 (insn, operands);
  if (!register_operand (operands[0], E_V256DFmode)
      || !register_operand (operands[1], E_V256DFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2168 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SFmode)
      && reg_or_mem_operand (operands[1], E_V256SFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_310 (insn, operands);
  if (!register_operand (operands[0], E_V256SFmode)
      || !register_operand (operands[1], E_V256SFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2157 (insn, operands);
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512HFmode)
      && reg_or_mem_operand (operands[1], E_V512HFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_299 (insn, operands);
  if (!register_operand (operands[0], E_V512HFmode)
      || !register_operand (operands[1], E_V512HFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2146 (insn, operands);
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DImode)
      && reg_or_mem_operand (operands[1], E_V256DImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_288 (insn, operands);
  if (!register_operand (operands[0], E_V256DImode)
      || !register_operand (operands[1], E_V256DImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2135 (insn, operands);
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SImode)
      && reg_or_mem_operand (operands[1], E_V256SImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return gen_split_277 (insn, operands);
  if (!register_operand (operands[0], E_V256SImode)
      || !register_operand (operands[1], E_V256SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2124 (insn, operands);
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HImode)
      && reg_or_mem_operand (operands[1], E_V256HImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_265 (insn, operands);
  if (!register_operand (operands[0], E_V256HImode)
      || !register_operand (operands[1], E_V256HImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2112 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512QImode)
      && reg_or_mem_operand (operands[1], E_V512QImode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_253 (insn, operands);
  if (!register_operand (operands[0], E_V512QImode)
      || !register_operand (operands[1], E_V512QImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2100 (insn, operands);
}

 rtx_insn *
split_96 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BImode)
      && 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_241 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BImode)
      || !register_operand (operands[1], E_RVVMF4BImode)
      || !(
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1578 (insn, operands);
}

 rtx_insn *
split_103 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 99 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return gen_split_226 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2HFmode)
      || !register_operand (operands[1], E_RVVMF2HFmode)
      || !((
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1570 (insn, operands);
}

 rtx_insn *
split_109 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_DImode)
      && splittable_const_int_operand (operands[1], E_DImode)
      && ((
#line 2471 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], DImode)
	|| high_mask_shift_operand (operands[1], DImode)
	|| exact_log2 (INTVAL (operands[1])) >= 0)) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2476 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
( 1)))
    return gen_split_19 (insn, operands);
  if (!nonimmediate_operand (operands[0], E_DImode)
      || !move_operand (operands[1], E_DImode)
      || !
#line 2733 "../../gcc-15.0.1-20250313/gcc/config/riscv/riscv.md"
(reload_completed
   && riscv_split_64bit_move_p (operands[0], operands[1])))
    return NULL;
  return gen_split_20 (insn, operands);
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern107 (x2))
        {
        case 0:
          if (const_nottwobits_not_arith_operand (operands[2], E_SImode)
              && ((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 849 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return gen_split_165 (insn, operands);
          if (!not_uimm_extra_bit_or_nottwobits (operands[2], E_SImode)
              || !((
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 1:
          if (const_nottwobits_not_arith_operand (operands[2], E_DImode))
            {
              if (((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 849 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_166 (insn, operands);
              if ((
#line 867 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (~UINTVAL (operands[2])) > 33) && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_167 (insn, operands);
            }
          if (not_uimm_extra_bit_or_nottwobits (operands[2], E_DImode)
              && ((
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return gen_split_181 (insn, operands);
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !(
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBA
   && !paradoxical_subreg_p (operands[1])
   /* Only profitable if synthesis takes more than one insn.  */
   && riscv_const_insns (operands[2], false) != 1
   /* We need the upper half to be zero.  */
   && (INTVAL (operands[2]) & HOST_WIDE_INT_C (0xffffffff00000000)) == 0
   /* And the the adjusted constant must either be something we can
      implement with andi or bclri.  */
   && ((SMALL_OPERAND (sext_hwi (INTVAL (operands[2]), 32))
        || (TARGET_ZBS && popcount_hwi (INTVAL (operands[2])) == 31))
       && INTVAL (operands[2]) != 0x7fffffff)) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/bitmanip.md"
( 1)))
            return NULL;
          return gen_split_182 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern233 (x2, 
E_RVVM8QImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2589 (insn, operands);

        case E_RVVM4QImode:
          if (pattern233 (x2, 
E_RVVM4QImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2603 (insn, operands);

        case E_RVVM2QImode:
          if (pattern233 (x2, 
E_RVVM2QImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2617 (insn, operands);

        case E_RVVM1QImode:
          if (pattern233 (x2, 
E_RVVM1QImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2631 (insn, operands);

        case E_RVVM8HImode:
          if (pattern233 (x2, 
E_RVVM8HImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2645 (insn, operands);

        case E_RVVM4HImode:
          if (pattern233 (x2, 
E_RVVM4HImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2659 (insn, operands);

        case E_RVVM2HImode:
          if (pattern233 (x2, 
E_RVVM2HImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2673 (insn, operands);

        case E_RVVM1HImode:
          if (pattern233 (x2, 
E_RVVM1HImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2687 (insn, operands);

        case E_RVVM8SImode:
          if (pattern233 (x2, 
E_RVVM8SImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2701 (insn, operands);

        case E_RVVM4SImode:
          if (pattern233 (x2, 
E_RVVM4SImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2715 (insn, operands);

        case E_RVVM2SImode:
          if (pattern233 (x2, 
E_RVVM2SImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2729 (insn, operands);

        case E_RVVM1SImode:
          if (pattern233 (x2, 
E_RVVM1SImode) != 0
              || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2743 (insn, operands);

        case E_RVVM8DImode:
          if (pattern233 (x2, 
E_RVVM8DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2757 (insn, operands);

        case E_RVVM4DImode:
          if (pattern233 (x2, 
E_RVVM4DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2771 (insn, operands);

        case E_RVVM2DImode:
          if (pattern233 (x2, 
E_RVVM2DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2785 (insn, operands);

        case E_RVVM1DImode:
          if (pattern233 (x2, 
E_RVVM1DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case E_RVVMF2QImode:
          if (pattern233 (x2, 
E_RVVMF2QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2813 (insn, operands);

        case E_RVVMF4QImode:
          if (pattern233 (x2, 
E_RVVMF4QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2827 (insn, operands);

        case E_RVVMF8QImode:
          if (pattern233 (x2, 
E_RVVMF8QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2841 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern233 (x2, 
E_RVVMF2HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2855 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern233 (x2, 
E_RVVMF4HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2869 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern233 (x2, 
E_RVVMF2SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2883 (insn, operands);

        case E_V1QImode:
          if (pattern233 (x2, 
E_V1QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2897 (insn, operands);

        case E_V2QImode:
          if (pattern233 (x2, 
E_V2QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2911 (insn, operands);

        case E_V4QImode:
          if (pattern233 (x2, 
E_V4QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2925 (insn, operands);

        case E_V8QImode:
          if (pattern233 (x2, 
E_V8QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2939 (insn, operands);

        case E_V16QImode:
          if (pattern233 (x2, 
E_V16QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2953 (insn, operands);

        case E_V32QImode:
          if (pattern233 (x2, 
E_V32QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2967 (insn, operands);

        case E_V64QImode:
          if (pattern233 (x2, 
E_V64QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2981 (insn, operands);

        case E_V128QImode:
          if (pattern233 (x2, 
E_V128QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2995 (insn, operands);

        case E_V256QImode:
          if (pattern233 (x2, 
E_V256QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3009 (insn, operands);

        case E_V512QImode:
          if (pattern233 (x2, 
E_V512QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3023 (insn, operands);

        case E_V1024QImode:
          if (pattern233 (x2, 
E_V1024QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3037 (insn, operands);

        case E_V2048QImode:
          if (pattern233 (x2, 
E_V2048QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3051 (insn, operands);

        case E_V4096QImode:
          if (pattern233 (x2, 
E_V4096QImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3065 (insn, operands);

        case E_V1HImode:
          if (pattern233 (x2, 
E_V1HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3079 (insn, operands);

        case E_V2HImode:
          if (pattern233 (x2, 
E_V2HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3093 (insn, operands);

        case E_V4HImode:
          if (pattern233 (x2, 
E_V4HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3107 (insn, operands);

        case E_V8HImode:
          if (pattern233 (x2, 
E_V8HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3121 (insn, operands);

        case E_V16HImode:
          if (pattern233 (x2, 
E_V16HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3135 (insn, operands);

        case E_V32HImode:
          if (pattern233 (x2, 
E_V32HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3149 (insn, operands);

        case E_V64HImode:
          if (pattern233 (x2, 
E_V64HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3163 (insn, operands);

        case E_V128HImode:
          if (pattern233 (x2, 
E_V128HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3177 (insn, operands);

        case E_V256HImode:
          if (pattern233 (x2, 
E_V256HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3191 (insn, operands);

        case E_V512HImode:
          if (pattern233 (x2, 
E_V512HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3205 (insn, operands);

        case E_V1024HImode:
          if (pattern233 (x2, 
E_V1024HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3219 (insn, operands);

        case E_V2048HImode:
          if (pattern233 (x2, 
E_V2048HImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3233 (insn, operands);

        case E_V1SImode:
          if (pattern233 (x2, 
E_V1SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3247 (insn, operands);

        case E_V2SImode:
          if (pattern233 (x2, 
E_V2SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3261 (insn, operands);

        case E_V4SImode:
          if (pattern233 (x2, 
E_V4SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3275 (insn, operands);

        case E_V8SImode:
          if (pattern233 (x2, 
E_V8SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3289 (insn, operands);

        case E_V16SImode:
          if (pattern233 (x2, 
E_V16SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3303 (insn, operands);

        case E_V32SImode:
          if (pattern233 (x2, 
E_V32SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3317 (insn, operands);

        case E_V64SImode:
          if (pattern233 (x2, 
E_V64SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3331 (insn, operands);

        case E_V128SImode:
          if (pattern233 (x2, 
E_V128SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3345 (insn, operands);

        case E_V256SImode:
          if (pattern233 (x2, 
E_V256SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3359 (insn, operands);

        case E_V512SImode:
          if (pattern233 (x2, 
E_V512SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3373 (insn, operands);

        case E_V1024SImode:
          if (pattern233 (x2, 
E_V1024SImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3387 (insn, operands);

        case E_V1DImode:
          if (pattern233 (x2, 
E_V1DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3401 (insn, operands);

        case E_V2DImode:
          if (pattern233 (x2, 
E_V2DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3415 (insn, operands);

        case E_V4DImode:
          if (pattern233 (x2, 
E_V4DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3429 (insn, operands);

        case E_V8DImode:
          if (pattern233 (x2, 
E_V8DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3443 (insn, operands);

        case E_V16DImode:
          if (pattern233 (x2, 
E_V16DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3457 (insn, operands);

        case E_V32DImode:
          if (pattern233 (x2, 
E_V32DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3471 (insn, operands);

        case E_V64DImode:
          if (pattern233 (x2, 
E_V64DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3485 (insn, operands);

        case E_V128DImode:
          if (pattern233 (x2, 
E_V128DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3499 (insn, operands);

        case E_V256DImode:
          if (pattern233 (x2, 
E_V256DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3513 (insn, operands);

        case E_V512DImode:
          if (pattern233 (x2, 
E_V512DImode) != 0
              || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3527 (insn, operands);

        case E_RVVMF64BImode:
          if (pattern0 (x2, 
E_RVVMF64BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3947 (insn, operands);

        case E_RVVMF32BImode:
          if (pattern0 (x2, 
E_RVVMF32BImode) != 0
              || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3950 (insn, operands);

        case E_RVVMF16BImode:
          if (pattern0 (x2, 
E_RVVMF16BImode) != 0
              || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3953 (insn, operands);

        case E_RVVMF8BImode:
          if (pattern0 (x2, 
E_RVVMF8BImode) != 0
              || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3956 (insn, operands);

        case E_RVVMF4BImode:
          if (pattern0 (x2, 
E_RVVMF4BImode) != 0
              || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3959 (insn, operands);

        case E_RVVMF2BImode:
          if (pattern0 (x2, 
E_RVVMF2BImode) != 0
              || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3962 (insn, operands);

        case E_RVVM1BImode:
          if (pattern0 (x2, 
E_RVVM1BImode) != 0
              || !(
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3965 (insn, operands);

        case E_V1BImode:
          if (pattern0 (x2, 
E_V1BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3968 (insn, operands);

        case E_V2BImode:
          if (pattern0 (x2, 
E_V2BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3971 (insn, operands);

        case E_V4BImode:
          if (pattern0 (x2, 
E_V4BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3974 (insn, operands);

        case E_V8BImode:
          if (pattern0 (x2, 
E_V8BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3977 (insn, operands);

        case E_V16BImode:
          if (pattern0 (x2, 
E_V16BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3980 (insn, operands);

        case E_V32BImode:
          if (pattern0 (x2, 
E_V32BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3983 (insn, operands);

        case E_V64BImode:
          if (pattern0 (x2, 
E_V64BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3986 (insn, operands);

        case E_V128BImode:
          if (pattern0 (x2, 
E_V128BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3989 (insn, operands);

        case E_V256BImode:
          if (pattern0 (x2, 
E_V256BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3992 (insn, operands);

        case E_V512BImode:
          if (pattern0 (x2, 
E_V512BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3995 (insn, operands);

        case E_V1024BImode:
          if (pattern0 (x2, 
E_V1024BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3998 (insn, operands);

        case E_V2048BImode:
          if (pattern0 (x2, 
E_V2048BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4001 (insn, operands);

        case E_V4096BImode:
          if (pattern0 (x2, 
E_V4096BImode) != 0
              || !((
#line 538 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4004 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_119 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern244 (x2))
    {
    case 0:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6237 (insn, operands);

    case 1:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6238 (insn, operands);

    case 2:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6239 (insn, operands);

    case 3:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6240 (insn, operands);

    case 4:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6241 (insn, operands);

    case 5:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6242 (insn, operands);

    case 6:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6252 (insn, operands);

    case 7:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6253 (insn, operands);

    case 8:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6254 (insn, operands);

    case 9:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6255 (insn, operands);

    case 10:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6256 (insn, operands);

    case 11:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6257 (insn, operands);

    case 12:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6258 (insn, operands);

    case 13:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6259 (insn, operands);

    case 14:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6260 (insn, operands);

    case 15:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6261 (insn, operands);

    case 16:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6262 (insn, operands);

    case 17:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6263 (insn, operands);

    case 18:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6243 (insn, operands);

    case 19:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6244 (insn, operands);

    case 20:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6245 (insn, operands);

    case 21:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6246 (insn, operands);

    case 22:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6247 (insn, operands);

    case 23:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6264 (insn, operands);

    case 24:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6265 (insn, operands);

    case 25:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6266 (insn, operands);

    case 26:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6267 (insn, operands);

    case 27:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6268 (insn, operands);

    case 28:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6269 (insn, operands);

    case 29:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6270 (insn, operands);

    case 30:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6271 (insn, operands);

    case 31:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6272 (insn, operands);

    case 32:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6273 (insn, operands);

    case 33:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6274 (insn, operands);

    case 34:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6248 (insn, operands);

    case 35:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6249 (insn, operands);

    case 36:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6250 (insn, operands);

    case 37:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6251 (insn, operands);

    case 38:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6275 (insn, operands);

    case 39:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6276 (insn, operands);

    case 40:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6277 (insn, operands);

    case 41:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6278 (insn, operands);

    case 42:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6279 (insn, operands);

    case 43:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6280 (insn, operands);

    case 44:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6281 (insn, operands);

    case 45:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6282 (insn, operands);

    case 46:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6283 (insn, operands);

    case 47:
      if (!((
#line 2387 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6284 (insn, operands);

    case 48:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9236 (insn, operands);

    case 49:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9237 (insn, operands);

    case 50:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9238 (insn, operands);

    case 51:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9239 (insn, operands);

    case 52:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9240 (insn, operands);

    case 53:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9245 (insn, operands);

    case 54:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9246 (insn, operands);

    case 55:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9247 (insn, operands);

    case 56:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9248 (insn, operands);

    case 57:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9249 (insn, operands);

    case 58:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9250 (insn, operands);

    case 59:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9251 (insn, operands);

    case 60:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9252 (insn, operands);

    case 61:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9253 (insn, operands);

    case 62:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9254 (insn, operands);

    case 63:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9255 (insn, operands);

    case 64:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9241 (insn, operands);

    case 65:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9242 (insn, operands);

    case 66:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9243 (insn, operands);

    case 67:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9244 (insn, operands);

    case 68:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9256 (insn, operands);

    case 69:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9257 (insn, operands);

    case 70:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9258 (insn, operands);

    case 71:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9259 (insn, operands);

    case 72:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9260 (insn, operands);

    case 73:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9261 (insn, operands);

    case 74:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9262 (insn, operands);

    case 75:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9263 (insn, operands);

    case 76:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9264 (insn, operands);

    case 77:
      if (!((
#line 904 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 906 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9265 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_126 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_800 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_806 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_812 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_818 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_824 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_830 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_836 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_842 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_848 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_854 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_860 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_866 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_872 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_878 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_884 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_890 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_896 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_902 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_908 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_914 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_920 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_926 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_932 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_938 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_944 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_950 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_956 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_962 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_968 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_974 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_980 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_986 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_992 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_998 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1004 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1010 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1016 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1022 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1028 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1034 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1040 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1046 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1052 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1058 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1064 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1070 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1076 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1082 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1088 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1094 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1100 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1106 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1112 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1118 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1124 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1130 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1136 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1142 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1148 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1154 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1160 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1166 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1172 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1178 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1184 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1190 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1196 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1202 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1208 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1214 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1220 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1226 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1232 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1238 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1244 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1250 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1256 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1262 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1268 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1274 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1280 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1286 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1292 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1298 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1304 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1310 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1316 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1322 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1328 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1334 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1340 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1346 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1352 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1358 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1364 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1370 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1376 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1382 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1388 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1394 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1400 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1406 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1412 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1418 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1424 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1430 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1436 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1442 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1448 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1454 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1460 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1466 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1472 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1478 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1484 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1490 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1496 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1502 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1508 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1514 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1520 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1526 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_134 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2588 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2602 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2616 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2630 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2644 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2658 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2672 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2686 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2700 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2714 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2728 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2742 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2756 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2770 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2784 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2798 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2812 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2826 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2840 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2854 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2868 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2882 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2896 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2910 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2924 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2938 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2952 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2966 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2980 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2994 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3008 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3022 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1024QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3036 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2048QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3050 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4096QImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3064 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3078 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3092 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3106 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3120 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3134 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3148 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3162 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3176 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3190 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3204 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1024HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3218 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2048HImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3232 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3246 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3260 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3274 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3288 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3302 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3316 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3330 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3344 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3358 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3372 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1024SImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3386 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3400 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3414 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3428 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3442 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3456 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3470 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3484 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3498 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3512 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512DImode) != 0
          || !((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3526 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5555 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5559 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5563 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5567 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5571 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5575 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5579 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5583 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5587 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5591 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5595 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5599 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5603 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5607 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5611 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5615 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5619 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5623 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5627 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5631 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5635 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5639 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5643 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5647 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5651 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5655 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5659 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5663 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5667 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5671 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5675 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5679 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5683 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5687 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5691 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5695 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5699 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5703 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5707 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5711 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5715 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5719 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5723 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5727 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5731 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5735 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5739 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !((
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5743 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_142 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4007 (insn, operands);

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !(
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4008 (insn, operands);

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !(
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4009 (insn, operands);

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !(
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4010 (insn, operands);

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !(
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4011 (insn, operands);

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !(
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4012 (insn, operands);

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !(
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4013 (insn, operands);

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4014 (insn, operands);

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4015 (insn, operands);

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4016 (insn, operands);

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4017 (insn, operands);

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4018 (insn, operands);

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4019 (insn, operands);

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4020 (insn, operands);

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4021 (insn, operands);

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4022 (insn, operands);

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4023 (insn, operands);

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4024 (insn, operands);

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4025 (insn, operands);

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !((
#line 560 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 562 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4026 (insn, operands);

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4946 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4948 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4950 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4952 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4954 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4956 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4958 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4960 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4962 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4964 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4966 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4968 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4970 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4972 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4974 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4976 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4978 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4980 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4982 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4984 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4986 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4988 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4990 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4992 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4994 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4996 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4998 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5000 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5002 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5004 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5006 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5008 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5010 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5012 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5014 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5016 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5018 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5020 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5022 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5024 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5026 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5028 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5030 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5032 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5034 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5036 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5038 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5040 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5042 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5044 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5046 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5048 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5050 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5052 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5054 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5056 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5058 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5060 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5062 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5064 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5066 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5068 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5070 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5072 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5074 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5076 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5078 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5080 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_151 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4537 (insn, operands);

    case 1:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4693 (insn, operands);

    case 2:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4539 (insn, operands);

    case 3:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4695 (insn, operands);

    case 4:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4885 (insn, operands);

    case 5:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4541 (insn, operands);

    case 6:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4697 (insn, operands);

    case 7:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4887 (insn, operands);

    case 8:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4543 (insn, operands);

    case 9:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4699 (insn, operands);

    case 10:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4889 (insn, operands);

    case 11:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4545 (insn, operands);

    case 12:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4701 (insn, operands);

    case 13:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4891 (insn, operands);

    case 14:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4547 (insn, operands);

    case 15:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4703 (insn, operands);

    case 16:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4893 (insn, operands);

    case 17:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4549 (insn, operands);

    case 18:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4705 (insn, operands);

    case 19:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4551 (insn, operands);

    case 20:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4707 (insn, operands);

    case 21:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4895 (insn, operands);

    case 22:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4553 (insn, operands);

    case 23:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4709 (insn, operands);

    case 24:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4897 (insn, operands);

    case 25:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4555 (insn, operands);

    case 26:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4711 (insn, operands);

    case 27:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4899 (insn, operands);

    case 28:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4557 (insn, operands);

    case 29:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4713 (insn, operands);

    case 30:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4901 (insn, operands);

    case 31:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4559 (insn, operands);

    case 32:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4715 (insn, operands);

    case 33:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4561 (insn, operands);

    case 34:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4717 (insn, operands);

    case 35:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4563 (insn, operands);

    case 36:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4719 (insn, operands);

    case 37:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4565 (insn, operands);

    case 38:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4721 (insn, operands);

    case 39:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4567 (insn, operands);

    case 40:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4723 (insn, operands);

    case 41:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4903 (insn, operands);

    case 42:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4569 (insn, operands);

    case 43:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4725 (insn, operands);

    case 44:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4905 (insn, operands);

    case 45:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4571 (insn, operands);

    case 46:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4727 (insn, operands);

    case 47:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4907 (insn, operands);

    case 48:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4573 (insn, operands);

    case 49:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4729 (insn, operands);

    case 50:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4909 (insn, operands);

    case 51:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4575 (insn, operands);

    case 52:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4731 (insn, operands);

    case 53:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4911 (insn, operands);

    case 54:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4577 (insn, operands);

    case 55:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4733 (insn, operands);

    case 56:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4913 (insn, operands);

    case 57:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4579 (insn, operands);

    case 58:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4735 (insn, operands);

    case 59:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4915 (insn, operands);

    case 60:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4581 (insn, operands);

    case 61:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4737 (insn, operands);

    case 62:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4917 (insn, operands);

    case 63:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4583 (insn, operands);

    case 64:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4739 (insn, operands);

    case 65:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4919 (insn, operands);

    case 66:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4585 (insn, operands);

    case 67:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4741 (insn, operands);

    case 68:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4921 (insn, operands);

    case 69:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4587 (insn, operands);

    case 70:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4743 (insn, operands);

    case 71:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4923 (insn, operands);

    case 72:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4589 (insn, operands);

    case 73:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4745 (insn, operands);

    case 74:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4591 (insn, operands);

    case 75:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4747 (insn, operands);

    case 76:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4925 (insn, operands);

    case 77:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4593 (insn, operands);

    case 78:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4749 (insn, operands);

    case 79:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4927 (insn, operands);

    case 80:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4595 (insn, operands);

    case 81:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4751 (insn, operands);

    case 82:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4929 (insn, operands);

    case 83:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4597 (insn, operands);

    case 84:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4753 (insn, operands);

    case 85:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4931 (insn, operands);

    case 86:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4599 (insn, operands);

    case 87:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4755 (insn, operands);

    case 88:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4933 (insn, operands);

    case 89:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4601 (insn, operands);

    case 90:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4757 (insn, operands);

    case 91:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4935 (insn, operands);

    case 92:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4603 (insn, operands);

    case 93:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4759 (insn, operands);

    case 94:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4937 (insn, operands);

    case 95:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4605 (insn, operands);

    case 96:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4761 (insn, operands);

    case 97:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4939 (insn, operands);

    case 98:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4607 (insn, operands);

    case 99:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4763 (insn, operands);

    case 100:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4941 (insn, operands);

    case 101:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4609 (insn, operands);

    case 102:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4765 (insn, operands);

    case 103:
      if (!((
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4943 (insn, operands);

    case 104:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4611 (insn, operands);

    case 105:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4767 (insn, operands);

    case 106:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4613 (insn, operands);

    case 107:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4769 (insn, operands);

    case 108:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4615 (insn, operands);

    case 109:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4771 (insn, operands);

    case 110:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4617 (insn, operands);

    case 111:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4773 (insn, operands);

    case 112:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4619 (insn, operands);

    case 113:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4775 (insn, operands);

    case 114:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4621 (insn, operands);

    case 115:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4777 (insn, operands);

    case 116:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4623 (insn, operands);

    case 117:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4779 (insn, operands);

    case 118:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4625 (insn, operands);

    case 119:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4781 (insn, operands);

    case 120:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4627 (insn, operands);

    case 121:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4783 (insn, operands);

    case 122:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4629 (insn, operands);

    case 123:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4785 (insn, operands);

    case 124:
      if (!((
#line 937 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 939 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4631 (insn, operands);

    case 125:
      if (!((
#line 985 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 987 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4787 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_158 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern123 (x2))
    {
    case 0:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2592 (insn, operands);

    case 1:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2606 (insn, operands);

    case 2:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2620 (insn, operands);

    case 3:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2634 (insn, operands);

    case 4:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2648 (insn, operands);

    case 5:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2662 (insn, operands);

    case 6:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2676 (insn, operands);

    case 7:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2690 (insn, operands);

    case 8:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2704 (insn, operands);

    case 9:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2718 (insn, operands);

    case 10:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2732 (insn, operands);

    case 11:
      if (!(
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2746 (insn, operands);

    case 12:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2760 (insn, operands);

    case 13:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2774 (insn, operands);

    case 14:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2788 (insn, operands);

    case 15:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2802 (insn, operands);

    case 16:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2816 (insn, operands);

    case 17:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2830 (insn, operands);

    case 18:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2844 (insn, operands);

    case 19:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2858 (insn, operands);

    case 20:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2872 (insn, operands);

    case 21:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2886 (insn, operands);

    case 22:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2900 (insn, operands);

    case 23:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2914 (insn, operands);

    case 24:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2928 (insn, operands);

    case 25:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2942 (insn, operands);

    case 26:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2956 (insn, operands);

    case 27:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2970 (insn, operands);

    case 28:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2984 (insn, operands);

    case 29:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2998 (insn, operands);

    case 30:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3012 (insn, operands);

    case 31:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3026 (insn, operands);

    case 32:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3040 (insn, operands);

    case 33:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3054 (insn, operands);

    case 34:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3068 (insn, operands);

    case 35:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3082 (insn, operands);

    case 36:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3096 (insn, operands);

    case 37:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3110 (insn, operands);

    case 38:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3124 (insn, operands);

    case 39:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3138 (insn, operands);

    case 40:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3152 (insn, operands);

    case 41:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3166 (insn, operands);

    case 42:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3180 (insn, operands);

    case 43:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3194 (insn, operands);

    case 44:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3208 (insn, operands);

    case 45:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3222 (insn, operands);

    case 46:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3236 (insn, operands);

    case 47:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3250 (insn, operands);

    case 48:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3264 (insn, operands);

    case 49:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3278 (insn, operands);

    case 50:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3292 (insn, operands);

    case 51:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3306 (insn, operands);

    case 52:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3320 (insn, operands);

    case 53:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3334 (insn, operands);

    case 54:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3348 (insn, operands);

    case 55:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3362 (insn, operands);

    case 56:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3376 (insn, operands);

    case 57:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3390 (insn, operands);

    case 58:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3404 (insn, operands);

    case 59:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3418 (insn, operands);

    case 60:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3432 (insn, operands);

    case 61:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3446 (insn, operands);

    case 62:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3460 (insn, operands);

    case 63:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3474 (insn, operands);

    case 64:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3488 (insn, operands);

    case 65:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3502 (insn, operands);

    case 66:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3516 (insn, operands);

    case 67:
      if (!((
#line 464 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3530 (insn, operands);

    case 68:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5745 (insn, operands);

    case 69:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5747 (insn, operands);

    case 70:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5749 (insn, operands);

    case 71:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5751 (insn, operands);

    case 72:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5753 (insn, operands);

    case 73:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5755 (insn, operands);

    case 74:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5757 (insn, operands);

    case 75:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5759 (insn, operands);

    case 76:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5761 (insn, operands);

    case 77:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5763 (insn, operands);

    case 78:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5765 (insn, operands);

    case 79:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5767 (insn, operands);

    case 80:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5769 (insn, operands);

    case 81:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5771 (insn, operands);

    case 82:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5773 (insn, operands);

    case 83:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5775 (insn, operands);

    case 84:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5777 (insn, operands);

    case 85:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5779 (insn, operands);

    case 86:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5781 (insn, operands);

    case 87:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5783 (insn, operands);

    case 88:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5785 (insn, operands);

    case 89:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5787 (insn, operands);

    case 90:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5789 (insn, operands);

    case 91:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5791 (insn, operands);

    case 92:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5793 (insn, operands);

    case 93:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5795 (insn, operands);

    case 94:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5797 (insn, operands);

    case 95:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5799 (insn, operands);

    case 96:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5801 (insn, operands);

    case 97:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5803 (insn, operands);

    case 98:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5805 (insn, operands);

    case 99:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5807 (insn, operands);

    case 100:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5809 (insn, operands);

    case 101:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5811 (insn, operands);

    case 102:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5813 (insn, operands);

    case 103:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5815 (insn, operands);

    case 104:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5817 (insn, operands);

    case 105:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5819 (insn, operands);

    case 106:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5821 (insn, operands);

    case 107:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5823 (insn, operands);

    case 108:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5825 (insn, operands);

    case 109:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5827 (insn, operands);

    case 110:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5829 (insn, operands);

    case 111:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5831 (insn, operands);

    case 112:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5833 (insn, operands);

    case 113:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5835 (insn, operands);

    case 114:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5837 (insn, operands);

    case 115:
      if (!((
#line 1561 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5839 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_171 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 5:
      x3 = XVECEXP (x2, 0, 2);
      operands[3] = x3;
      switch (XINT (x2, 1))
        {
        case 195:
          if (pattern181 (x2) != 0)
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!vector_length_operand (operands[2], E_VOIDmode))
            return NULL;
          return split_117 (x1, insn);

        case 91:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (pattern391 (x2))
            {
            case 0:
              if (!((
#line 1784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( epilogue_completed)))
                return NULL;
              return gen_split_2305 (insn, operands);

            case 1:
              if (!((
#line 1784 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1786 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector.md"
( epilogue_completed)))
                return NULL;
              return gen_split_2306 (insn, operands);

            default:
              return NULL;
            }

        case 145:
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          switch (pattern335 (x2))
            {
            case 0:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6285 (insn, operands);

            case 1:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6286 (insn, operands);

            case 2:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6287 (insn, operands);

            case 3:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6288 (insn, operands);

            case 4:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6289 (insn, operands);

            case 5:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6290 (insn, operands);

            case 6:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6291 (insn, operands);

            case 7:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6292 (insn, operands);

            case 8:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6293 (insn, operands);

            case 9:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6294 (insn, operands);

            case 10:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6295 (insn, operands);

            case 11:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6296 (insn, operands);

            case 12:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6297 (insn, operands);

            case 13:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6298 (insn, operands);

            case 14:
              if (!((
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6299 (insn, operands);

            case 15:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9266 (insn, operands);

            case 16:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9267 (insn, operands);

            case 17:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9268 (insn, operands);

            case 18:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9269 (insn, operands);

            case 19:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9270 (insn, operands);

            case 20:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9275 (insn, operands);

            case 21:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9276 (insn, operands);

            case 22:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9277 (insn, operands);

            case 23:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9278 (insn, operands);

            case 24:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9279 (insn, operands);

            case 25:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9280 (insn, operands);

            case 26:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9281 (insn, operands);

            case 27:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9282 (insn, operands);

            case 28:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9283 (insn, operands);

            case 29:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9284 (insn, operands);

            case 30:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9285 (insn, operands);

            case 31:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9271 (insn, operands);

            case 32:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9272 (insn, operands);

            case 33:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9273 (insn, operands);

            case 34:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9274 (insn, operands);

            case 35:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9286 (insn, operands);

            case 36:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9287 (insn, operands);

            case 37:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9288 (insn, operands);

            case 38:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9289 (insn, operands);

            case 39:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9290 (insn, operands);

            case 40:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9291 (insn, operands);

            case 41:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9292 (insn, operands);

            case 42:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9293 (insn, operands);

            case 43:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9294 (insn, operands);

            case 44:
              if (!((
#line 928 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 930 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec-opt.md"
( 1)))
                return NULL;
              return gen_split_9295 (insn, operands);

            default:
              return NULL;
            }

        case 171:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (pattern363 (x2))
            {
            case 0:
              if (!((
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && 
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6300 (insn, operands);

            case 1:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6301 (insn, operands);

            case 2:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6302 (insn, operands);

            case 3:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6303 (insn, operands);

            case 4:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6304 (insn, operands);

            case 5:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6305 (insn, operands);

            case 6:
              if (!(
#line 2866 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/riscv/autovec.md"
( 1)))
                return NULL;
              return gen_split_6306 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      return split_121 (x1, insn);

    case 1:
      return split_122 (x1, insn);

    default:
      return NULL;
    }
}
