/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode
      || !register_operand (operands[1], E_TImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern17 (x1); /* [-1, 1] */
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern30 (x3); /* [-1, 0] */

        case E_V16SImode:
          if (pattern31 (x3, 
E_V16SImode) != 0)
            return -1;
          return 1;

        case E_V8SImode:
          if (pattern31 (x3, 
E_V8SImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 3;

        case E_V8DImode:
          if (pattern31 (x3, 
E_V8DImode) != 0)
            return -1;
          return 4;

        case E_V4DImode:
          if (pattern31 (x3, 
E_V4DImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_V2DImode))
            return -1;
          return 6;

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_V16QImode)
              || !const_0_to_7_operand (operands[2], E_SImode))
            return -1;
          return 7;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_V8HImode)
              || !const_0_to_15_operand (operands[2], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern14 (x3, 
E_V16SImode) != 0)
            return -1;
          return 9;

        case E_V8SImode:
          if (pattern14 (x3, 
E_V8SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern14 (x3, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8DImode:
          if (pattern14 (x3, 
E_V8DImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern14 (x3, 
E_V4DImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern14 (x3, 
E_V2DImode) != 0)
            return -1;
          return 14;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !nonimmediate_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  return pattern67 (x3); /* [-1, 8] */
}

int
pattern72 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern71 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern71 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern89 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern88 (x2, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern88 (x2, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      return 0;

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode))
        return -1;
      res = pattern37 (x4, 
E_DImode, 
E_SImode);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern122 (x3, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern122 (x3, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern140 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      return pattern129 (x1, 
E_HImode, 
E_V16HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern129 (x1, 
E_QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern129 (x1, 
E_QImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern129 (x1, 
E_QImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern129 (x1, 
E_QImode, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern129 (x1, 
E_QImode, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V32HImode:
      if (pattern129 (x1, 
E_SImode, 
E_V32HImode) != 0)
        return -1;
      return 6;

    case E_V16SImode:
      if (pattern129 (x1, 
E_HImode, 
E_V16SImode) != 0)
        return -1;
      return 7;

    case E_V8DImode:
      if (pattern129 (x1, 
E_QImode, 
E_V8DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern152 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern152 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern152 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x3) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      return 0;

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x3) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode))
        return -1;
      return 1;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern189 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern189 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern189 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern215 (x7, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern215 (x7, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern225 (x5, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern225 (x5, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return pattern237 (x1, 
E_V32HImode); /* [-1, 0] */

        case E_V16SImode:
          if (pattern237 (x1, 
E_V16SImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern237 (x1, 
E_V8DImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_0_to_255_not_mul_8_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 8LL)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern269 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 2;

        case E_HImode:
          return 3;

        case E_SImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern291 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern61 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern61 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern308 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !nonimmediate_operand (operands[1], E_HImode)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 3)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[3] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      switch (XINT (x2, 1))
        {
        case 59:
          return 0;

        case 157:
          x7 = XVECEXP (x2, 0, 2);
          operands[5] = x7;
          if (!const_0_to_7_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern313 (x1, 
E_V16QImode, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_V8HImode:
              if (pattern313 (x1, 
E_V8HImode, 
E_QImode) != 0)
                return -1;
              return 2;

            case E_V4SImode:
              if (pattern313 (x1, 
E_V4SImode, 
E_QImode) != 0)
                return -1;
              return 3;

            case E_V2DImode:
              if (pattern313 (x1, 
E_V2DImode, 
E_QImode) != 0)
                return -1;
              return 4;

            case E_V32QImode:
              if (pattern313 (x1, 
E_V32QImode, 
E_SImode) != 0)
                return -1;
              return 5;

            case E_V16HImode:
              if (pattern313 (x1, 
E_V16HImode, 
E_HImode) != 0)
                return -1;
              return 6;

            case E_V8SImode:
              if (pattern313 (x1, 
E_V8SImode, 
E_QImode) != 0)
                return -1;
              return 7;

            case E_V4DImode:
              if (pattern313 (x1, 
E_V4DImode, 
E_QImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 59)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x8, 0, 1);
      operands[4] = x10;
      x11 = XVECEXP (x8, 0, 2);
      operands[5] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x1) != E_V8SImode
              || !vector_all_ones_operand (operands[1], E_V8SImode)
              || !const0_operand (operands[2], E_V8SImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8SFmode:
              if (!register_operand (operands[3], E_V8SFmode)
                  || !nonimmediate_operand (operands[4], E_V8SFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 9;

            case E_V8SImode:
              if (!nonimmediate_operand (operands[3], E_V8SImode)
                  || !nonimmediate_operand (operands[4], E_V8SImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !vector_all_ones_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[3], E_V4SFmode)
                  || !nonimmediate_operand (operands[4], E_V4SFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 11;

            case E_V4SImode:
              if (!nonimmediate_operand (operands[3], E_V4SImode)
                  || !nonimmediate_operand (operands[4], E_V4SImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 12;

            default:
              return -1;
            }

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x1) != E_V4DImode
              || !vector_all_ones_operand (operands[1], E_V4DImode)
              || !const0_operand (operands[2], E_V4DImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4DFmode:
              if (!register_operand (operands[3], E_V4DFmode)
                  || !nonimmediate_operand (operands[4], E_V4DFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 13;

            case E_V4DImode:
              if (!nonimmediate_operand (operands[3], E_V4DImode)
                  || !nonimmediate_operand (operands[4], E_V4DImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || !vector_all_ones_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x8) != E_QImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2DFmode:
              if (!register_operand (operands[3], E_V2DFmode)
                  || !nonimmediate_operand (operands[4], E_V2DFmode)
                  || !const_0_to_31_operand (operands[5], E_SImode))
                return -1;
              return 15;

            case E_V2DImode:
              if (!nonimmediate_operand (operands[3], E_V2DImode)
                  || !nonimmediate_operand (operands[4], E_V2DImode)
                  || !const_0_to_7_operand (operands[5], E_SImode))
                return -1;
              return 16;

            default:
              return -1;
            }

        case E_V16QImode:
          if (pattern314 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern314 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 18;

        case E_V32QImode:
          if (pattern314 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 19;

        case E_V16HImode:
          if (pattern314 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 20;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      return 21;

    default:
      return -1;
    }
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern378 (x3, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern378 (x3, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern390 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern398 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern405 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_operator (x3, i1))
    return -1;
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!memory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern430 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern443 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern448 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern447 (x1); /* [-1, 1] */

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern446 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern16 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern464 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i4)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x6;
      x7 = XEXP (x1, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 223)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x1) != E_V32HFmode
              || GET_MODE (x2) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HFmode)
              || !vector_operand (operands[2], E_V32HFmode)
              || !vector_operand (operands[3], E_V32HFmode)
              || !const0_operand (operands[4], E_V32HFmode)
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (pattern468 (x1, 
E_HImode, 
E_V16HFmode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern468 (x1, 
E_QImode, 
E_V8HFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x1, 2);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 223)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[4] = x8;
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x1) != E_V32HFmode
                  || GET_MODE (x2) != E_V32HFmode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !vector_operand (operands[2], E_V32HFmode)
                  || !vector_operand (operands[3], E_V32HFmode)
                  || GET_MODE (x7) != E_SImode
                  || !register_operand (operands[4], E_HImode))
                return -1;
              return 3;

            case E_V16HFmode:
              if (pattern469 (x1, 
E_HImode, 
E_V16HFmode) != 0)
                return -1;
              return 4;

            case E_V8HFmode:
              if (pattern469 (x1, 
E_QImode, 
E_V8HFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != 3LL
              || !register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode
              || GET_MODE (x2) != E_V8HFmode
              || !vector_operand (operands[1], E_V8HFmode)
              || !vector_operand (operands[2], E_V8HFmode)
              || !vector_operand (operands[3], E_V8HFmode)
              || !rtx_equal_p (x6, operands[2]))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern515 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!vector_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!vector_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1)
      || !regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern537 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern533 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern533 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern533 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V32BFmode:
      if (pattern533 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 3;

    case E_V16BFmode:
      if (pattern533 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 4;

    case E_V8BFmode:
      if (pattern533 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 5;

    case E_V16SFmode:
      if (pattern533 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern533 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V4SFmode:
      if (pattern533 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 8;

    case E_V8DFmode:
      if (pattern533 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 9;

    case E_V4DFmode:
      if (pattern533 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern533 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_XFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern553 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      return 0;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 38)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern559 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!bt_comparison_operator (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!nonimmediate_operand (operands[0], E_QImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern577 (x1); /* [-1, 3] */
}

int
pattern584 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0))
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != i1
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != SUBREG
          || maybe_ne (SUBREG_BYTE (x13), 0)
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != ZERO_EXTRACT)
            return -1;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x15, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x18 = XEXP (x2, 0);
          operands[4] = x18;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode))
            return -1;
          return pattern583 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern617 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern623 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SFmode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_V4SFmode)
          || !nonimm_or_0_operand (operands[2], E_V2DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern653 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[4] = x7;
  if (!const48_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      return pattern651 (x1, 
E_V16HImode, 
E_V16HFmode, 
E_HImode); /* [-1, 0] */

    case E_V32HImode:
      if (pattern651 (x1, 
E_V32HImode, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      res = pattern652 (x1, 
E_V8SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16SImode
          || GET_MODE (x3) != E_V16SImode
          || !nonimm_or_0_operand (operands[2], E_V16SImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 4;

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V8DImode:
      res = pattern652 (x1, 
E_V8DImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_V4DImode:
      if (pattern651 (x1, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  return 0;
}

int
pattern683 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  return 0;
}

int
pattern689 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern693 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern699 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern243 (x1); /* [-1, 1] */
}

int
pattern706 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern713 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern722 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      return 0;

    case PARALLEL:
      return 1;

    default:
      return -1;
    }
}

int
pattern732 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern735 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern734 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern734 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern744 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !sse_comparison_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern748 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4SImode
          || GET_MODE (x3) != E_V4SImode
          || GET_MODE (x5) != E_V4SImode
          || !register_mmxmem_operand (operands[1], E_V4HImode)
          || GET_MODE (x4) != E_V4SImode
          || !register_mmxmem_operand (operands[2], E_V4HImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[1], E_V2HImode)
          || GET_MODE (x4) != E_V2SImode
          || !register_operand (operands[2], E_V2HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern772 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern776 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern784 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern792 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern811 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern810 (x1, 
E_V32HImode, 
E_V32SImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern810 (x1, 
E_V16HImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern810 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern821 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 7
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern825 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE
      || !register_operand (operands[1], E_XFmode))
    return -1;
  return pattern824 (x1, pnum_clobbers); /* [-1, 2] */
}

int
pattern829 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern831 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return pattern438 (x1); /* [-1, 1] */
}

int
pattern835 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern842 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern846 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern854 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x4, 1);
  switch (XVECLEN (x10, 0))
    {
    case 4:
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XVECEXP (x10, 0, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x13 = XVECEXP (x10, 0, 2);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x14 = XVECEXP (x10, 0, 3);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x15 = XEXP (x2, 1);
      if (XVECLEN (x15, 0) != 4)
        return -1;
      x16 = XVECEXP (x15, 0, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XVECEXP (x15, 0, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x18 = XVECEXP (x15, 0, 2);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x19 = XVECEXP (x15, 0, 3);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern853 (x1, 
E_V8HImode, 
E_V4HImode) != 0)
        return -1;
      return 0;

    case 2:
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XVECEXP (x10, 0, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XEXP (x2, 1);
      if (XVECLEN (x15, 0) != 2)
        return -1;
      x16 = XVECEXP (x15, 0, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XVECEXP (x15, 0, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern853 (x1, 
E_V4SImode, 
E_V2SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern884 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern894 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!nonimmediate_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern904 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x3) != i2)
    return -1;
  x9 = XEXP (x3, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern135 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern135 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern916 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern918 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern917 (x1, 
E_V16SImode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern917 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern917 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V8DFmode:
      if (pattern917 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern917 (x1, 
E_V8SImode) != 0)
        return -1;
      return 4;

    case E_V8SFmode:
      if (pattern917 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 5;

    case E_V4DImode:
      if (pattern917 (x1, 
E_V4DImode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern917 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern917 (x1, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V4SFmode:
      if (pattern917 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern917 (x1, 
E_V2DImode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern917 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    case E_V64QImode:
      if (pattern917 (x1, 
E_V64QImode) != 0)
        return -1;
      return 12;

    case E_V16QImode:
      if (pattern917 (x1, 
E_V16QImode) != 0)
        return -1;
      return 13;

    case E_V32QImode:
      if (pattern917 (x1, 
E_V32QImode) != 0)
        return -1;
      return 14;

    case E_V32HImode:
      if (pattern917 (x1, 
E_V32HImode) != 0)
        return -1;
      return 15;

    case E_V16HImode:
      if (pattern917 (x1, 
E_V16HImode) != 0)
        return -1;
      return 16;

    case E_V8HImode:
      if (pattern917 (x1, 
E_V8HImode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern942 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern950 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode)
          || !scratch_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode)
          || !scratch_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_general_operand (operands[2], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !x86_64_general_operand (operands[2], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern966 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern968 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern973 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 3;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 4;

    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[2], E_V8HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 5;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[2], E_V8SFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 6;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[2], E_V4SFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 7;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[2], E_V8DFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 8;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[2], E_V4DFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 9;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[2], E_V2DFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 10;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern998 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern1003 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!nonimmediate_operand (x5, i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (!nonimmediate_operand (x6, i1))
    return -1;
  return 0;
}

int
pattern1016 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1024 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern1030 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1039 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern1038 (x6) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1099 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1104 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1111 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1118 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern1117 (x1, 
E_SImode, 
E_V32HImode, 
E_V32SImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern1117 (x1, 
E_HImode, 
E_V16HImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern1117 (x1, 
E_QImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern1131 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern1131 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1138 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 32LL)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern1171 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case STRICT_LOW_PART:
      return pattern555 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          return 2;

        case E_TImode:
          if (pattern563 (x2, 
E_TImode) != 0)
            return -1;
          return 3;

        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[2], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1194 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case COMPARE:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      x10 = XEXP (x2, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x5, 0);
      switch (GET_CODE (x11))
        {
        case REG:
          return pattern1189 (x1, 
i1); /* [-1, 0] */

        case ZERO_EXTEND:
          if (GET_MODE (x11) != i2)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != i2)
            return -1;
          x13 = XEXP (x12, 0);
          if (!ix86_carry_flag_operator (x13, i2))
            return -1;
          operands[4] = x13;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x15 = XEXP (x12, 1);
          if (GET_CODE (x15) != ZERO_EXTEND
              || GET_MODE (x15) != i2
              || GET_MODE (x6) != E_CCCmode
              || GET_MODE (x5) != E_CCCmode)
            return -1;
          x16 = XEXP (x11, 0);
          switch (GET_CODE (x16))
            {
            case PLUS:
              if (GET_MODE (x16) != i1)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != PLUS
                  || GET_MODE (x17) != i1)
                return -1;
              x18 = XEXP (x17, 0);
              if (!ix86_carry_flag_operator (x18, i1))
                return -1;
              operands[5] = x18;
              x19 = XEXP (x18, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_CODE (x8) != PLUS)
                return -1;
              x20 = XEXP (x8, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != i1)
                return -1;
              x21 = XEXP (x20, 0);
              switch (GET_CODE (x21))
                {
                case LTU:
                case UNLT:
                  if (!rtx_equal_p (x21, operands[5]))
                    return -1;
                  x22 = XEXP (x18, 0);
                  operands[3] = x22;
                  if (!flags_reg_operand (operands[3], E_VOIDmode))
                    return -1;
                  x23 = XEXP (x16, 1);
                  operands[2] = x23;
                  if (!memory_operand (operands[2], i1))
                    return -1;
                  x24 = XEXP (x17, 1);
                  if (!rtx_equal_p (x24, operands[0]))
                    return -1;
                  x25 = XEXP (x13, 0);
                  if (!rtx_equal_p (x25, operands[3]))
                    return -1;
                  x26 = XEXP (x15, 0);
                  if (!rtx_equal_p (x26, operands[2]))
                    return -1;
                  x27 = XEXP (x20, 1);
                  if (!rtx_equal_p (x27, operands[0]))
                    return -1;
                  x28 = XEXP (x8, 1);
                  if (!rtx_equal_p (x28, operands[2]))
                    return -1;
                  return 1;

                default:
                  return -1;
                }

            case REG:
              if (!rtx_equal_p (x16, operands[0])
                  || GET_CODE (x8) != MINUS)
                return -1;
              x20 = XEXP (x8, 0);
              if (GET_CODE (x20) != MINUS
                  || GET_MODE (x20) != i1)
                return -1;
              x27 = XEXP (x20, 1);
              if (!ix86_carry_flag_operator (x27, i1))
                return -1;
              operands[5] = x27;
              x29 = XEXP (x27, 1);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x25 = XEXP (x13, 0);
              operands[3] = x25;
              if (!flags_reg_operand (operands[3], E_VOIDmode))
                return -1;
              x26 = XEXP (x15, 0);
              operands[2] = x26;
              if (!memory_operand (operands[2], i1))
                return -1;
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[0]))
                return -1;
              x30 = XEXP (x27, 0);
              if (!rtx_equal_p (x30, operands[3]))
                return -1;
              x28 = XEXP (x8, 1);
              if (!rtx_equal_p (x28, operands[2]))
                return -1;
              return 2;

            default:
              return -1;
            }

        case PLUS:
          if (pattern1190 (x1, 
i1) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case PLUS:
      res = pattern1192 (x1, 
i1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case MINUS:
      res = pattern1193 (x1, 
i1);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1271 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern1277 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8HFmode
      || !register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode
      || GET_MODE (x2) != E_V8HFmode
      || !nonimmediate_operand (operands[1], E_V8HFmode)
      || !nonimm_or_0_operand (operands[3], E_V8HFmode)
      || !register_operand (operands[2], E_V8HFmode))
    return -1;
  return 0;
}

int
pattern1296 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1295 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1304 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1312 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1320 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode
          || !memory_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode
          || !memory_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1332 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1340 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1346 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  return pattern1345 (x8); /* [-1, 0] */
}

int
pattern1356 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  if (!const_0_to_255_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1373 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1372 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1381 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1380 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1391 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1380 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1400 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern1399 (x1, 
E_V8HFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern1399 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V2DFmode:
          if (pattern1399 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x4;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      x5 = XEXP (x3, 2);
      operands[5] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[6] = x6;
      x11 = XEXP (x2, 1);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1429 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1436 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1443 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1448 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1457 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1466 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], E_VOIDmode)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1475 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1480 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern1486 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_SImode:
      return pattern1493 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1493 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1522 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || pattern1521 () != 0)
    return -1;
  return 0;
}

int
pattern1530 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

int
pattern1541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1547 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1556 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1562 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x9, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1573 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1573 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1588 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1598 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern1606 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1616 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1625 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1632 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern1571 (x6, pnum_clobbers); /* [-1, 2] */
}

int
pattern1642 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i3
      || !vector_operand (operands[2], i2)
      || !const1_operand (operands[3], i2)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1657 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1665 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vs_operator (operands[7], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1676 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MINUS)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LTU:
    case UNLT:
      operands[5] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern1686 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1696 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  return 0;
}

int
pattern1706 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1711 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1710 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1710 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1724 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1723 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1723 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1735 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1742 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1741 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1741 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1753 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCZmode)
    return -1;
  return 0;
}

int
pattern1764 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1773 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1772 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1772 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1785 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1792 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1791 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1791 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1805 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 109)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 109)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != UNSPEC_VOLATILE
      || XVECLEN (x8, 0) != 1
      || XINT (x8, 1) != 109
      || GET_MODE (x8) != E_CCZmode)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x7, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 17
      || GET_MODE (x10) != E_CCZmode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 0);
  operands[3] = x12;
  x13 = XVECEXP (x3, 0, 2);
  operands[4] = x13;
  x14 = XVECEXP (x3, 0, 3);
  operands[5] = x14;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  x15 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x4, 0);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = PATTERN (peep2_next_insn (2));
  x18 = XEXP (x17, 1);
  x19 = XEXP (x18, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x18, 1);
  if (!rtx_equal_p (x20, operands[1]))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      return pattern1804 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1804 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1804 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1804 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1834 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1841 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_scalar_int_operand (operands[6], i2)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1852 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_0_to_15_operand (operands[11], E_VOIDmode)
      || !const_0_to_15_operand (operands[12], E_VOIDmode)
      || !const_0_to_15_operand (operands[13], E_VOIDmode)
      || !const_0_to_15_operand (operands[14], E_VOIDmode)
      || !const_0_to_15_operand (operands[15], E_VOIDmode)
      || !const_0_to_15_operand (operands[16], E_VOIDmode)
      || !const_0_to_15_operand (operands[17], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1860 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 28);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 29);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 30);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 31);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1865 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = PATTERN (peep2_next_insn (4));
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  return 0;
}

int
pattern1872 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1870 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1880 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      if (GET_MODE (x6) != E_CCmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 109
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!flags_reg_operand (operands[0], E_CCmode)
          || GET_MODE (x2) != E_CCmode
          || !comparison_operator (operands[1], E_VOIDmode)
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      x13 = XVECEXP (x9, 0, 0);
      operands[4] = x13;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !general_operand (operands[3], E_QImode)
              || !
#line 1539 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 1; /* ccmpqi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !general_operand (operands[3], E_HImode)
              || !
#line 1539 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 2; /* ccmphi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !x86_64_general_operand (operands[3], E_SImode)
              || !
#line 1539 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 3; /* ccmpsi */

        case E_DImode:
          if (!nonimmediate_operand (operands[2], E_DImode)
              || !x86_64_general_operand (operands[3], E_DImode)
              || !(
#line 1539 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_CCMP) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 4; /* ccmpdi */

        default:
          return -1;
        }

    case LABEL_REF:
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      return 1458; /* *jcc */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x6;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1197 (x2, 
E_HImode) != 0
              || !
#line 26319 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1803; /* *movhicc_noc */

        case E_QImode:
          if (pattern1198 (x2) != 0
              || !
#line 26393 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
            return -1;
          return 1808; /* *movqicc_noc */

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !fcmov_comparison_operator (operands[1], E_VOIDmode)
              || !register_operand (operands[2], E_XFmode)
              || !register_operand (operands[3], E_XFmode)
              || !
#line 26587 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
            return -1;
          return 1810; /* *movxfcc_1 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || pattern1260 (x2, 
E_DFmode) != 0
              || !
#line 26602 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1811; /* *movdfcc_1 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || pattern1260 (x2, 
E_SFmode) != 0
              || !
#line 26637 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1812; /* *movsfcc_1_387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 105:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!push_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3889 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2))
        return -1;
      return 159; /* push2_di */

    case 40:
      if (GET_MODE (x2) != E_CCCmode
          || pattern248 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case LTU:
          if (pattern716 (x4) != 0)
            return -1;
          x6 = XEXP (x4, 0);
          switch (GET_MODE (x6))
            {
            case E_CCmode:
              if (!
#line 9904 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
                return -1;
              return 532; /* *setcc_qi_negqi_ccc_2_cc */

            case E_CCCmode:
              if (!
#line 9904 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
                return -1;
              return 533; /* *setcc_qi_negqi_ccc_2_ccc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 984; /* *negqi_ccc_2 */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode))
                return -1;
              *pnum_clobbers = 1;
              return 985; /* *neghi_ccc_2 */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 986; /* *negsi_ccc_2 */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 987; /* *negdi_ccc_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 66:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_XFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_XFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24127 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      *pnum_clobbers = 1;
      return 1721; /* atan2xf3 */

    case 67:
      if (pnum_clobbers == NULL
          || pattern157 (x1, 
E_XFmode) != 0
          || !
#line 24430 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      *pnum_clobbers = 1;
      return 1722; /* fyl2xxf3_i387 */

    case 68:
      if (pnum_clobbers == NULL
          || pattern157 (x1, 
E_XFmode) != 0
          || !
#line 24527 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      *pnum_clobbers = 1;
      return 1723; /* fyl2xp1xf3_i387 */

    case 58:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern61 (x2, 
E_SFmode) != 0
              || !
#line 24836 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512F))
            return -1;
          return 1727; /* avx512f_scalefsf2 */

        case E_DFmode:
          if (pattern61 (x2, 
E_DFmode) != 0
              || !
#line 24836 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512F))
            return -1;
          return 1728; /* avx512f_scalefdf2 */

        default:
          return -1;
        }

    case 94:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_15_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !(
#line 24954 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE4_1) && 
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
            return -1;
          return 1729; /* sse4_1_roundhf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 24954 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE4_1))
            return -1;
          return 1730; /* sse4_1_roundsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 24954 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE4_1))
            return -1;
          return 1731; /* sse4_1_rounddf2 */

        default:
          return -1;
        }

    case 63:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 26755 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1821; /* *ieee_smaxhf3 */

        case 1:
          if (!
#line 26767 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return -1;
          return 1823; /* *ieee_smaxsf3 */

        case 2:
          if (!
#line 26767 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return -1;
          return 1825; /* *ieee_smaxdf3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 26755 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1822; /* *ieee_sminhf3 */

        case 1:
          if (!
#line 26767 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return -1;
          return 1824; /* *ieee_sminsf3 */

        case 2:
          if (!
#line 26767 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return -1;
          return 1826; /* *ieee_smindf3 */

        default:
          return -1;
        }

    case 113:
      if (pattern63 (x1, 
E_V2SFmode) != 0
          || !
#line 911 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2060; /* mmx_rcpit1v2sf3 */

    case 114:
      if (pattern63 (x1, 
E_V2SFmode) != 0
          || !
#line 922 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2061; /* mmx_rcpit2v2sf3 */

    case 116:
      if (pattern63 (x1, 
E_V2SFmode) != 0
          || !
#line 959 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2063; /* mmx_rsqit1v2sf3 */

    case 57:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 4792 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2293; /* mmx_packuswb */

        case 1:
          if (!
#line 4831 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return -1;
          return 2295; /* mmx_packusdw */

        default:
          return -1;
        }

    case 52:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vector_operand (operands[2], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 5489 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSSE3 && TARGET_MMX_WITH_SSE))
            return -1;
          return 2330; /* mmx_pshufbv8qi3 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x2) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 5507 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
            return -1;
          return 2331; /* mmx_pshufbv4qi3 */

        default:
          return -1;
        }

    case 56:
      if (GET_MODE (x2) != E_V1DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_mmxmem_operand (operands[1], E_V8QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_mmxmem_operand (operands[2], E_V8QImode)
          || !
#line 6477 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (PLUS, V8QImode, operands)))
        return -1;
      return 2383; /* *mmx_psadbw */

    case 176:
      if (pattern66 (x1) != 0)
        return -1;
      switch (pattern965 ())
        {
        case 0:
          if (!(
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return -1;
          return 2610; /* ktestqi */

        case 1:
          if (!(
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return -1;
          return 2611; /* ktesthi */

        case 2:
          if (!(
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2079 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2612; /* ktestsi */

        case 3:
          if (!(
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2079 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 2613; /* ktestdi */

        default:
          return -1;
        }

    case 178:
      return recog_9 (x1, insn, pnum_clobbers);

    case 61:
      return recog_10 (x1, insn, pnum_clobbers);

    case 158:
      switch (pattern68 (x1))
        {
        case 0:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8117; /* avx512vl_testmv16qi3 */

        case 1:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8121; /* avx512vl_testmv16hi3 */

        case 2:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8125; /* avx512f_testmv16si3 */

        case 3:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8123; /* avx512vl_testmv8hi3 */

        case 4:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8127; /* avx512vl_testmv8si3 */

        case 5:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8129; /* avx512vl_testmv4si3 */

        case 6:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8131; /* avx512f_testmv8di3 */

        case 7:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8133; /* avx512vl_testmv4di3 */

        case 8:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8135; /* avx512vl_testmv2di3 */

        default:
          return -1;
        }

    case 159:
      switch (pattern68 (x1))
        {
        case 0:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8141; /* avx512vl_testnmv16qi3 */

        case 1:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8145; /* avx512vl_testnmv16hi3 */

        case 2:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8149; /* avx512f_testnmv16si3 */

        case 3:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8147; /* avx512vl_testnmv8hi3 */

        case 4:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8151; /* avx512vl_testnmv8si3 */

        case 5:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8153; /* avx512vl_testnmv4si3 */

        case 6:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8155; /* avx512f_testnmv8di3 */

        case 7:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8157; /* avx512vl_testnmv4di3 */

        case 8:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8159; /* avx512vl_testnmv2di3 */

        default:
          return -1;
        }

    case 120:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern732 (x2, 
E_V8QImode) != 0
              || !
#line 23214 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 8641; /* ssse3_psignv8qi3 */

        case E_V4HImode:
          if (pattern64 (x2, 
E_V4HImode) != 0
              || !
#line 23214 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 8642; /* ssse3_psignv4hi3 */

        case E_V2SImode:
          if (pattern732 (x2, 
E_V2SImode) != 0
              || !
#line 23214 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return -1;
          return 8643; /* ssse3_psignv2si3 */

        default:
          return -1;
        }

    case 148:
      if (pattern66 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || !nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 25313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8938; /* avx_vtestps256 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || !nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 25313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8939; /* avx_vtestps */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || !nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 25313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8940; /* avx_vtestpd256 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || !nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 25313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8941; /* avx_vtestpd */

        default:
          return -1;
        }

    case 130:
      return recog_11 (x1, insn, pnum_clobbers);

    case 150:
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_V4HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode)
          || !
#line 29169 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return -1;
      return 9664; /* *vcvtps2ph_store */

    case 193:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern641 (x2, 
E_HImode))
            {
            case 0:
              if (!(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16HFmode)) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 9993; /* avx512dq_fpclassv16hf */

            case 1:
              if (!(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16SFmode)) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9997; /* avx512dq_fpclassv16sf */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 9995; /* avx512dq_fpclassv8hf */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8SFmode)) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9999; /* avx512dq_fpclassv8sf */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10001; /* avx512dq_fpclassv4sf */

            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode)
                  || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8DFmode)) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 10003; /* avx512dq_fpclassv8df */

            case E_V4DFmode:
              if (!vector_operand (operands[1], E_V4DFmode)
                  || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4DFmode)) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10005; /* avx512dq_fpclassv4df */

            case E_V2DFmode:
              if (!vector_operand (operands[1], E_V2DFmode)
                  || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10007; /* avx512dq_fpclassv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 214:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!nonimmediate_operand (operands[2], E_V16QImode)
          || !(
#line 30934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10329; /* avx512vl_vpshufbitqmbv16qi */

    case 215:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_P2QImode:
          if (!register_operand (operands[0], E_P2QImode)
              || GET_MODE (x2) != E_P2QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !vector_operand (operands[2], E_V8DImode)
                  || !(
#line 30974 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30940 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 10335; /* avx512vp2intersect_2intersectv8di */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !vector_operand (operands[2], E_V4DImode)
                  || !(
#line 30974 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30941 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10336; /* avx512vp2intersect_2intersectv4di */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !vector_operand (operands[2], E_V2DImode)
                  || !(
#line 30974 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30941 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10337; /* avx512vp2intersect_2intersectv2di */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !vector_operand (operands[2], E_V8SImode)
                  || !(
#line 30974 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30942 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10338; /* avx512vp2intersect_2intersectv8si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !vector_operand (operands[2], E_V4SImode)
                  || !(
#line 30974 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT) && 
#line 30942 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10339; /* avx512vp2intersect_2intersectv4si */

            default:
              return -1;
            }

        case E_P2HImode:
          if (pattern733 (x2, 
E_V16SImode, 
E_P2HImode) != 0
              || !
#line 30983 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT && TARGET_EVEX512))
            return -1;
          return 10340; /* avx512vp2intersect_2intersectv16si */

        default:
          return -1;
        }

    case 262:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_V16BFmode)
              || !
#line 32448 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10725; /* avx10_2_fpclassbf16_v16bf */

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_V8BFmode)
              || !
#line 32448 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10727; /* avx10_2_fpclassbf16_v8bf */

        default:
          return -1;
        }

    case 288:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonmemory_operand (operands[1], E_QImode))
            return -1;
          return 11018; /* atomic_storeqi_1 */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonmemory_operand (operands[1], E_HImode))
            return -1;
          return 11019; /* atomic_storehi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pnum_clobbers == NULL
          || pattern739 (x2, 
E_TImode) != 0)
        return -1;
      if ((
#line 13312 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 810; /* *andnti3_doubleword_bmi */
        }
      if (!(
#line 13330 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 812; /* *andnti3_doubleword */

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern610 (x2, 
E_QImode) != 0
          || !
#line 13362 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
        return -1;
      *pnum_clobbers = 1;
      return 815; /* *andnqi_1 */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern610 (x2, 
E_HImode) != 0
          || !
#line 13362 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
        return -1;
      *pnum_clobbers = 1;
      return 816; /* *andnhi_1 */

    case E_V2SFmode:
      if (pattern610 (x2, 
E_V2SFmode) != 0
          || !
#line 1343 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
        return -1;
      return 2076; /* *mmx_andnotv2sf3 */

    case E_V2BFmode:
      if (pattern610 (x2, 
E_V2BFmode) != 0
          || !
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE))
        return -1;
      return 2107; /* *mmx_andnotv2bf3 */

    case E_V4BFmode:
      if (pattern610 (x2, 
E_V4BFmode) != 0
          || !(
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
        return -1;
      return 2108; /* *mmx_andnotv4bf3 */

    case E_V2HFmode:
      if (pattern610 (x2, 
E_V2HFmode) != 0
          || !
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE))
        return -1;
      return 2109; /* *mmx_andnotv2hf3 */

    case E_V4HFmode:
      if (pattern610 (x2, 
E_V4HFmode) != 0
          || !(
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE) && 
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
        return -1;
      return 2110; /* *mmx_andnotv4hf3 */

    case E_V8QImode:
      if (pattern611 (x2, 
E_V8QImode) != 0
          || !
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 2268; /* mmx_andnotv8qi3 */

    case E_V4HImode:
      if (pattern611 (x2, 
E_V4HImode) != 0
          || !
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 2269; /* mmx_andnotv4hi3 */

    case E_V2SImode:
      if (pattern611 (x2, 
E_V2SImode) != 0
          || !
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 2270; /* mmx_andnotv2si3 */

    case E_V4QImode:
      if (pnum_clobbers == NULL
          || pattern610 (x2, 
E_V4QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2271; /* *andnotv4qi3 */

    case E_V2QImode:
      if (pnum_clobbers == NULL
          || pattern610 (x2, 
E_V2QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2272; /* *andnotv2qi3 */

    case E_V2HImode:
      if (pnum_clobbers == NULL
          || pattern610 (x2, 
E_V2HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2273; /* *andnotv2hi3 */

    case E_BFmode:
      if (pattern610 (x2, 
E_BFmode) != 0
          || !
#line 5531 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3779; /* *andnotbf3 */

    case E_HFmode:
      if (pattern610 (x2, 
E_HFmode) != 0
          || !
#line 5531 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3780; /* *andnothf3 */

    case E_SFmode:
      if (pattern610 (x2, 
E_SFmode) != 0
          || !
#line 5531 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3781; /* *andnotsf3 */

    case E_DFmode:
      if (pattern610 (x2, 
E_DFmode) != 0
          || !(
#line 5531 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE2)))
        return -1;
      return 3782; /* *andnotdf3 */

    case E_TFmode:
      if (pattern612 (x2, 
E_TFmode) != 0
          || !
#line 5601 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 3783; /* *andnottf3 */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern265 (x3, pnum_clobbers, 
E_TImode) != 0
          || !(
#line 14600 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 996; /* *absti2_doubleword */

    case E_QImode:
      if (pattern265 (x3, pnum_clobbers, 
E_QImode) != 0
          || !
#line 14687 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 999; /* *absqi2_1 */

    case E_HImode:
      if (pattern265 (x3, pnum_clobbers, 
E_HImode) != 0
          || !
#line 14687 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1000; /* *abshi2_1 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14810 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 1010; /* *abssf2_i387_1 */
        }
      if (!
#line 14932 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 1024; /* *abssf2_i387 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14810 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 1012; /* *absdf2_i387_1 */
        }
      if (!
#line 14932 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 1026; /* *absdf2_i387 */

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !register_operand (operands[1], E_XFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14810 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 1014; /* *absxf2_i387_1 */
        }
      if (!
#line 14932 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 1028; /* *absxf2_i387 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_mmxmem_operand (operands[1], E_V8QImode)
          || !
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 2192; /* ssse3_absv8qi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_mmxmem_operand (operands[1], E_V4HImode)
          || !
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 2193; /* ssse3_absv4hi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_mmxmem_operand (operands[1], E_V2SImode)
          || !
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 2194; /* ssse3_absv2si2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 2195; /* absv4qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 2196; /* absv2qi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 2197; /* absv2hi2 */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 19384 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1440; /* *btsi_setncqi_2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 19384 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1441; /* *btdi_setncqi_2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern8 (x2, 
E_V8QImode) != 0
              || !
#line 4141 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V8QImode, operands)))
            return -1;
          return 2217; /* *mmx_eqv8qi3 */

        case E_V4HImode:
          if (pattern8 (x2, 
E_V4HImode) != 0
              || !
#line 4141 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V4HImode, operands)))
            return -1;
          return 2218; /* *mmx_eqv4hi3 */

        case E_V2SImode:
          if (pattern8 (x2, 
E_V2SImode) != 0
              || !
#line 4141 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V2SImode, operands)))
            return -1;
          return 2219; /* *mmx_eqv2si3 */

        case E_V4QImode:
          if (pattern7 (x2, 
E_V4QImode) != 0
              || !
#line 4157 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2220; /* *eqv4qi3 */

        case E_V2QImode:
          if (pattern7 (x2, 
E_V2QImode) != 0
              || !
#line 4157 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2221; /* *eqv2qi3 */

        case E_V2HImode:
          if (pattern7 (x2, 
E_V2HImode) != 0
              || !
#line 4157 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2222; /* *eqv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern82 (x1, pnum_clobbers))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          x2 = XEXP (x1, 1);
          if (pattern73 (x2, pnum_clobbers) != 0
              || !(
#line 6465 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 267; /* *addti3_doubleword */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, 
E_HImode) != 0)
            return -1;
          if (
#line 6813 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 297; /* *addhi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 6813 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 298; /* *addhi_1 */

        case E_QImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, 
E_QImode) != 0)
            return -1;
          if (
#line 6870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 299; /* *addqi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 6870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 300; /* *addqi_1 */

        case E_HFmode:
          x2 = XEXP (x1, 1);
          if (pattern5 (x2, 
E_HFmode) != 0
              || !
#line 23445 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 1676; /* *addhf */

        case E_V8QImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V8QImode) != 0
              || !
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V8QImode, operands)))
            return -1;
          return 2124; /* *mmx_addv8qi3 */

        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V4HImode) != 0
              || !
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V4HImode, operands)))
            return -1;
          return 2126; /* *mmx_addv4hi3 */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V2SImode) != 0
              || !
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V2SImode, operands)))
            return -1;
          return 2128; /* *mmx_addv2si3 */

        case E_V1DImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V1DImode) != 0
              || !(
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V1DImode, operands)) && 
#line 50 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2)))
            return -1;
          return 2130; /* *mmx_addv1di3 */

        case E_V4QImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V4QImode) != 0
              || !
#line 3227 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2132; /* addv4qi3 */

        case E_V2HImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2HImode) != 0
              || !
#line 3227 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2134; /* addv2hi3 */

        case E_V2QImode:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2QImode) != 0
              || !
#line 3241 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          *pnum_clobbers = 1;
          return 2136; /* addv2qi3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 6946 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *addqi_1_slp */

    case 2:
      if (!
#line 6946 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 302; /* *addhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern95 (x3, 
E_V2SFmode, 
E_SFmode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_V2SFmode)
          || pattern1848 (x3) != 0
          || !
#line 995 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 2064; /* *mmx_haddv2sf3 */

    case MINUS:
      if (pattern96 (x4, 
E_SFmode) != 0
          || !register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x8 = XEXP (x4, 0);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x10 = XEXP (x4, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_CODE (x5))
        {
        case MINUS:
          if (pattern1555 (x5, 
E_SFmode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x12 = XEXP (x5, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
            return -1;
          return 2066; /* mmx_hsubv2sf3 */

        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT
              || GET_MODE (x6) != E_SFmode)
            return -1;
          x14 = XEXP (x6, 1);
          if (GET_CODE (x14) != PARALLEL
              || XVECLEN (x14, 0) != 1)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_SFmode)
            return -1;
          x15 = XEXP (x12, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x16 = XVECEXP (x14, 0, 0);
          operands[3] = x16;
          if (!const_0_to_1_operand (operands[3], E_SImode))
            return -1;
          x17 = XVECEXP (x15, 0, 0);
          operands[4] = x17;
          if (!const_0_to_1_operand (operands[4], E_SImode))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A
   && INTVAL (operands[3]) != INTVAL (operands[4])))
            return -1;
          return 2068; /* *mmx_haddsubv2sf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SFmode))
            {
              if (
#line 1755 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 2092; /* *mmx_concatv2sf */
              if (
#line 11766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 5291; /* *vec_concatv2sf_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SFmode)
              || !
#line 11830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 5292; /* *vec_concatv2sf_sse */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SImode))
            {
              if (
#line 5701 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 2348; /* *mmx_concatv2si */
              if (
#line 21518 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 8483; /* *vec_concatv2si_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !
#line 21567 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !TARGET_SSE4_1))
            return -1;
          return 8484; /* *vec_concatv2si */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      switch (pattern270 (x3))
        {
        case 0:
          if (!
#line 4771 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2292; /* mmx_packsswb */

        case 1:
          if (!
#line 4812 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2294; /* mmx_packssdw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (XWINT (x5, 0) != 16LL)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern748 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 3447 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MULT, V4HImode, operands)))
                    return -1;
                  return 2161; /* *mmx_smulv4hi3_highpart */

                case 1:
                  if (!
#line 3516 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 2163; /* smulv2hi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern748 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 3482 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (MULT, V4HImode, operands)))
                    return -1;
                  return 2162; /* *mmx_umulv4hi3_highpart */

                case 1:
                  if (!
#line 3516 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 2164; /* umulv2hi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case MULT:
              if (GET_MODE (x7) != E_V4SImode)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != SIGN_EXTEND
                  || GET_MODE (x8) != E_V4SImode)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_V4SImode)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR
                  || XVECLEN (x10, 0) != 4
                  || GET_MODE (x10) != E_V4SImode)
                return -1;
              x11 = XVECEXP (x10, 0, 0);
              if (GET_CODE (x11) != CONST_INT
                  || XWINT (x11, 0) != 32768LL)
                return -1;
              x12 = XVECEXP (x10, 0, 1);
              if (GET_CODE (x12) != CONST_INT
                  || XWINT (x12, 0) != 32768LL)
                return -1;
              x13 = XVECEXP (x10, 0, 2);
              if (GET_CODE (x13) != CONST_INT
                  || XWINT (x13, 0) != 32768LL)
                return -1;
              x14 = XVECEXP (x10, 0, 3);
              if (GET_CODE (x14) != CONST_INT
                  || XWINT (x14, 0) != 32768LL
                  || XWINT (x5, 0) != 16LL
                  || !register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x3) != E_V4HImode
                  || GET_MODE (x4) != E_V4SImode
                  || GET_MODE (x6) != E_V4SImode)
                return -1;
              x15 = XEXP (x8, 0);
              operands[1] = x15;
              if (!nonimmediate_operand (operands[1], E_V4HImode))
                return -1;
              x16 = XEXP (x9, 0);
              operands[2] = x16;
              if (!nonimmediate_operand (operands[2], E_V4HImode)
                  || !
#line 3605 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (MULT, V4HImode, operands)))
                return -1;
              return 2166; /* *mmx_pmulhrwv4hi3 */

            case PLUS:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x6, 1);
              if (GET_CODE (x10) != CONST_VECTOR
                  || XWINT (x5, 0) != 1LL)
                return -1;
              x15 = XEXP (x8, 0);
              operands[1] = x15;
              x16 = XEXP (x9, 0);
              operands[2] = x16;
              switch (XVECLEN (x10, 0))
                {
                case 8:
                  if (pattern1359 (x10, 
E_V8HImode) != 0
                      || pattern1634 (x3, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6332 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 2378; /* *mmx_uavgv8qi3 */

                case 4:
                  x11 = XVECEXP (x10, 0, 0);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x12 = XVECEXP (x10, 0, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x13 = XVECEXP (x10, 0, 2);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x14 = XVECEXP (x10, 0, 3);
                  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4HImode:
                      if (pattern1634 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                          || GET_MODE (x10) != E_V4SImode
                          || !
#line 6376 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                        return -1;
                      return 2379; /* *mmx_uavgv4hi3 */

                    case E_V4QImode:
                      if (pattern1538 (x3, 
E_V4HImode, 
E_V4QImode) != 0
                          || !
#line 6416 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return -1;
                      return 2380; /* uavgv4qi3_ceil */

                    default:
                      return -1;
                    }

                case 2:
                  x11 = XVECEXP (x10, 0, 0);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x12 = XVECEXP (x10, 0, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2QImode:
                      if (pattern1538 (x3, 
E_V2HImode, 
E_V2QImode) != 0
                          || !
#line 6436 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return -1;
                      return 2381; /* uavgv2qi3_ceil */

                    case E_V2HImode:
                      if (pattern1538 (x3, 
E_V2SImode, 
E_V2HImode) != 0
                          || !
#line 6456 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return -1;
                      return 2382; /* uavgv2hi3_ceil */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (pattern616 (x7) != 0
                  || XWINT (x5, 0) != 1LL)
                return -1;
              x8 = XEXP (x7, 0);
              x15 = XEXP (x8, 0);
              x17 = XEXP (x15, 0);
              operands[1] = x17;
              x18 = XEXP (x8, 1);
              x19 = XEXP (x18, 0);
              operands[2] = x19;
              x10 = XEXP (x6, 1);
              operands[3] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_V4HImode:
                  if (pattern1513 (x3, 
E_V4SImode, 
E_V4HImode) != 0
                      || !register_mmxmem_operand (operands[1], E_V4HImode)
                      || GET_MODE (x18) != E_V4SImode
                      || !register_mmxmem_operand (operands[2], E_V4HImode)
                      || !const1_operand (operands[3], E_V4HImode)
                      || !
#line 23068 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_SSSE3
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8626; /* *ssse3_pmulhrswv4hi3 */

                case E_V2HImode:
                  if (pattern1513 (x3, 
E_V2SImode, 
E_V2HImode) != 0
                      || !register_operand (operands[1], E_V2HImode)
                      || GET_MODE (x18) != E_V2SImode
                      || !register_operand (operands[2], E_V2HImode)
                      || !const1_operand (operands[3], E_V2HImode)
                      || !
#line 23113 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8627; /* *smulhrsv2hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4QImode:
          if (GET_MODE (x3) != E_V4QImode)
            return -1;
          if (register_operand (operands[0], E_V4QImode)
              && register_operand (operands[1], E_V4HImode)
              && (
#line 5144 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_AVX512BW) && 
#line 73 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE)))
            return 2312; /* avx512vl_truncv4hiv4qi2 */
          if (!memory_operand (operands[0], E_V4QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 15508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7315; /* *avx512vl_truncatev4siv4qi2_store_1 */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !
#line 15508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7318; /* *avx512vl_truncatev4div4qi2_store_1 */

            default:
              return -1;
            }

        case E_V2QImode:
          if (GET_MODE (x3) != E_V2QImode)
            return -1;
          if (register_operand (operands[0], E_V2QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2HImode:
                  if (register_operand (operands[1], E_V2HImode)
                      && 
#line 5144 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_AVX512BW))
                    return 2313; /* avx512vl_truncv2hiv2qi2 */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 5170 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_MMX_WITH_SSE))
                    return 2314; /* avx512vl_truncv2siv2qi2 */
                  break;

                default:
                  break;
                }
            }
          if (!memory_operand (operands[0], E_V2QImode)
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 15413 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7300; /* *avx512vl_truncatev2div2qi2_store_1 */

        case E_V2HImode:
          if (GET_MODE (x3) != E_V2HImode)
            return -1;
          if (register_operand (operands[0], E_V2HImode)
              && register_operand (operands[1], E_V2SImode)
              && 
#line 5170 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_AVX512VL && TARGET_MMX_WITH_SSE))
            return 2315; /* avx512vl_truncv2siv2hi2 */
          if (!memory_operand (operands[0], E_V2HImode)
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 15859 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7415; /* *avx512vl_truncatev2div2hi2_store_1 */

        case E_V8QImode:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 15606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return -1;
              return 7345; /* *avx512vl_truncatev8hiv8qi2_store_1 */

            case 1:
              if (!
#line 15606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7348; /* *avx512vl_truncatev8siv8qi2_store_1 */

            case 2:
              if (!
#line 16122 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 7452; /* *avx512f_truncatev8div16qi2_store_1 */

            default:
              return -1;
            }

        case E_V4HImode:
          switch (pattern11 (x3, 
E_V4HImode))
            {
            case 0:
              if (!
#line 15768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7385; /* *avx512vl_truncatev4siv4hi2_store_1 */

            case 1:
              if (!
#line 15768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 7388; /* *avx512vl_truncatev4div4hi2_store_1 */

            default:
              return -1;
            }

        case E_V2SImode:
          if (!memory_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 16009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7434; /* *avx512vl_truncatev2div2si2_store_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_HImode
          || !nonimmediate_operand (operands[1], E_HImode)
          || !immediate_operand (operands[2], E_HImode))
        return -1;
      if (
#line 10643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_ZU && TARGET_APX_NF))
        return 596; /* *imulhisizu_nf */
      if (pnum_clobbers == NULL
          || !
#line 10643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
        return -1;
      *pnum_clobbers = 1;
      return 597; /* *imulhisizu */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !immediate_operand (operands[2], E_HImode))
            return -1;
          if (
#line 10643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_ZU && TARGET_APX_NF))
            return 598; /* *imulhidizu_nf */
          if (pnum_clobbers == NULL
              || !
#line 10643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
            return -1;
          *pnum_clobbers = 1;
          return 599; /* *imulhidizu */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !x86_64_general_operand (operands[2], E_SImode))
            return -1;
          if (
#line 10655 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF))
            return 600; /* *mulsi3_1_zext_nf */
          if (pnum_clobbers == NULL
              || !
#line 10655 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 601; /* *mulsi3_1_zext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  if (
#line 15401 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF))
    return 1062; /* x86_64_shld_nf */
  if (pnum_clobbers == NULL
      || !
#line 15401 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && true))
    return -1;
  *pnum_clobbers = 1;
  return 1063; /* x86_64_shld */
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x6;
              operands[1] = x4;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern603 (x2, 
E_SImode) != 0
                      || !
#line 8039 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))))
                    return -1;
                  return 376; /* *leasi_general_4 */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode)
                    return -1;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && (
#line 8039 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 378; /* *leadi_general_4 */
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !(
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return -1;
                  return 929; /* *concatsidi3_5 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              operands[1] = x4;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x5;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !(
#line 14060 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 893; /* *concatsidi3_1 */

            case SUBREG:
              switch (pattern437 (x2, 
LSHIFTRT))
                {
                case 0:
                  operands[2] = x5;
                  if (pattern1360 (x2) == 0)
                    {
                      if (
#line 15437 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && TARGET_APX_NF))
                        return 1066; /* x86_64_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15437 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                        {
                          *pnum_clobbers = 1;
                          return 1067; /* x86_64_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1361 (x2) != 0)
                    return -1;
                  if (
#line 15459 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1068; /* x86_64_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15459 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  operands[2] = x5;
                  if (pattern1362 (x2) == 0)
                    {
                      if (
#line 15669 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && TARGET_APX_NF))
                        return 1078; /* x86_shld_1_nf */
                      if (pnum_clobbers != NULL
                          && 
#line 15669 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                        {
                          *pnum_clobbers = 1;
                          return 1079; /* x86_shld_1 */
                        }
                    }
                  operands[3] = x5;
                  if (pattern1363 (x2) != 0)
                    return -1;
                  if (
#line 15691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && TARGET_APX_NF))
                    return 1080; /* x86_shld_ndd_1_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern440 (x2, pnum_clobbers))
                {
                case 0:
                  if (
#line 15475 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_APX_NF
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1070; /* *x86_64_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15531 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (
#line 15707 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return 1082; /* *x86_shld_shrd_1_nozext_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 15763 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15584 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1072; /* *x86_64_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15605 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      operands[2] = x5;
                      if (rtx_equal_p (x4, operands[0]))
                        {
                          x8 = XEXP (x6, 1);
                          x9 = XEXP (x8, 1);
                          if (rtx_equal_p (x9, operands[2])
                              && 
#line 15815 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            {
                              *pnum_clobbers = 1;
                              return 1084; /* *x86_shld_2 */
                            }
                        }
                    }
                  operands[2] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x4;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  operands[3] = x5;
                  x8 = XEXP (x6, 1);
                  x9 = XEXP (x8, 1);
                  if (!rtx_equal_p (x9, operands[3])
                      || !
#line 15836 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          switch (pattern288 (x2, 
LSHIFTRT))
            {
            case 0:
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (nonimmediate_operand (operands[0], E_DImode))
                {
                  res = recog_78 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[2] = x11;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15422 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1064; /* x86_64_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15422 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1065; /* x86_64_shld_ndd */

            case 1:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || pattern287 (x2, 
E_SImode, 
E_DImode) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              x10 = XEXP (x7, 0);
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (rtx_equal_p (x4, operands[0]))
                {
                  x13 = XEXP (x7, 1);
                  x14 = XEXP (x13, 1);
                  x15 = XEXP (x14, 0);
                  if (rtx_equal_p (x15, operands[2]))
                    {
                      if (
#line 15631 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF))
                        return 1074; /* x86_shld_nf */
                      if (pnum_clobbers != NULL)
                        {
                          *pnum_clobbers = 1;
                          return 1075; /* x86_shld */
                        }
                    }
                }
              operands[2] = x11;
              operands[1] = x4;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x12;
              x13 = XEXP (x7, 1);
              x14 = XEXP (x13, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              if (
#line 15653 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
                return 1076; /* x86_shld_ndd_nf */
              if (pnum_clobbers == NULL
                  || !
#line 15653 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              *pnum_clobbers = 1;
              return 1077; /* x86_shld_ndd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern258 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 905; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 935; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern258 (x2, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!(
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 908; /* *concatsidi3_3 */

        case 1:
          if (!(
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 938; /* *concatsidi3_6 */

        default:
          return -1;
        }

    case CONST_INT:
      switch (pattern286 (x2, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern752 (x2))
                {
                case 0:
                  if (
#line 18805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    {
                      *pnum_clobbers = 1;
                      return 1391; /* *btssi */
                    }
                  break;

                case 1:
                  if ((
#line 18805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1393; /* *btsdi */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x5) != SUBREG)
            return -1;
          switch (pattern761 (x2))
            {
            case 0:
              if (!
#line 18824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18852 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18852 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern738 (x2, 
E_DImode, 
E_QImode) == 0
              && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 1;
              return 1131; /* ashrdi3_doubleword */
            }
        }
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_DImode)
          && const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17244 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1168; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17244 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1169; /* ashrdi3_cvt */
            }
        }
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[2], E_DImode)
          && (
#line 17313 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1174; /* *bmi2_ashrdi3_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1177; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1178; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern623 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 1175; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17323 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 1176; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19324 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1434; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19324 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1435; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1452 (x4, 
E_SImode) != 0
          || !
#line 19405 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1442; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1452 (x4, 
E_DImode) != 0
          || !(
#line 19405 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1443; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (XWINT (x3, 0) == 1LL)
    {
      res = recog_104 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  operands[2] = x3;
  if (!const_0_to_255_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_QImode))
    return -1;
  switch (pattern126 (x2))
    {
    case 0:
      if (!
#line 22152 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM))
        return -1;
      *pnum_clobbers = 1;
      return 1604; /* tbm_bextri_si */

    case 1:
      if (!(
#line 22152 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1605; /* tbm_bextri_di */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (register_operand (operands[1], E_DFmode)
              && 
#line 25481 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return 1759; /* movmsk_df */
          break;

        case E_V8QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 6823 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return 2384; /* mmx_pmovmskb */
          break;

        case E_V8SFmode:
          if (register_operand (operands[1], E_V8SFmode)
              && (
#line 21946 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 8512; /* avx_movmskps256 */
          break;

        case E_V4SFmode:
          if (register_operand (operands[1], E_V4SFmode)
              && 
#line 21946 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8513; /* sse_movmskps */
          break;

        case E_V4DFmode:
          if (register_operand (operands[1], E_V4DFmode)
              && (
#line 21946 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 8514; /* avx_movmskpd256 */
          break;

        case E_V2DFmode:
          if (register_operand (operands[1], E_V2DFmode)
              && (
#line 21946 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 8515; /* sse2_movmskpd */
          break;

        case E_V32QImode:
          if (register_operand (operands[1], E_V32QImode)
              && (
#line 22096 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 8560; /* avx2_pmovmskb */
          break;

        case E_V16QImode:
          if (register_operand (operands[1], E_V16QImode)
              && 
#line 22096 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 8561; /* sse2_pmovmskb */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_MERGE:
          switch (pattern1092 (x4))
            {
            case 0:
              if (!(
#line 21997 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8528; /* *avx_movmskps256_lt_avx512 */

            case 1:
              if (!
#line 21997 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 8529; /* *sse_movmskps_lt_avx512 */

            case 2:
              if (!(
#line 21997 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8530; /* *avx_movmskpd256_lt_avx512 */

            case 3:
              if (!(
#line 21997 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8531; /* *sse2_movmskpd_lt_avx512 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern1093 (x4))
            {
            case 0:
              if (!(
#line 22060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8548; /* *avx_movmskps256_shift */

            case 1:
              if (!
#line 22060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 8549; /* *sse_movmskps_shift */

            case 2:
              if (!(
#line 22060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8550; /* *avx_movmskpd256_shift */

            case 3:
              if (!(
#line 22060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8551; /* *sse2_movmskpd_shift */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LT:
      switch (pattern763 (x4))
        {
        case 0:
          if (!(
#line 21973 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8524; /* *avx_movmskps256_lt */

        case 1:
          if (!
#line 21973 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8525; /* *sse_movmskps_lt */

        case 2:
          if (!(
#line 21973 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8526; /* *avx_movmskpd256_lt */

        case 3:
          if (!(
#line 21973 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8527; /* *sse2_movmskpd_lt */

        case 4:
          if (!(
#line 22225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8566; /* *avx2_pmovmskb_lt */

        case 5:
          if (!
#line 22225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 8567; /* *sse2_pmovmskb_lt */

        default:
          return -1;
        }

    case VEC_MERGE:
      switch (pattern765 (x4))
        {
        case 0:
          if (!(
#line 22253 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8568; /* *avx2_pmovmskb_lt_avx512 */

        case 1:
          if (!
#line 22253 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 8569; /* *sse2_pmovmskb_lt_avx512 */

        case 2:
          if (!
#line 22381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8577; /* *pmovsk_kmask_v16qi_avx512 */

        case 3:
          if (!
#line 22395 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8578; /* *pmovsk_mask_v32qi_avx512 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern992 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2449; /* *avx512f_loadv16si_mask */

    case E_V8SImode:
      if (pattern992 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2450; /* *avx512vl_loadv8si_mask */

    case E_V4SImode:
      if (pattern992 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2451; /* *avx512vl_loadv4si_mask */

    case E_V8DImode:
      if (pattern992 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2452; /* *avx512f_loadv8di_mask */

    case E_V4DImode:
      if (pattern992 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2453; /* *avx512vl_loadv4di_mask */

    case E_V2DImode:
      if (pattern992 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2454; /* *avx512vl_loadv2di_mask */

    case E_V16SFmode:
      if (pattern992 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2455; /* *avx512f_loadv16sf_mask */

    case E_V8SFmode:
      if (pattern992 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2456; /* *avx512vl_loadv8sf_mask */

    case E_V4SFmode:
      if (pattern992 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2457; /* *avx512vl_loadv4sf_mask */

    case E_V8DFmode:
      if (pattern992 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2458; /* *avx512f_loadv8df_mask */

    case E_V4DFmode:
      if (pattern992 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2459; /* *avx512vl_loadv4df_mask */

    case E_V2DFmode:
      if (pattern992 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2460; /* *avx512vl_loadv2df_mask */

    case E_V64QImode:
      if (pattern992 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2473; /* *avx512bw_loadv64qi_mask */

    case E_V16QImode:
      if (pattern992 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2474; /* *avx512vl_loadv16qi_mask */

    case E_V32QImode:
      if (pattern992 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2475; /* *avx512vl_loadv32qi_mask */

    case E_V32HImode:
      if (pattern992 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2476; /* *avx512bw_loadv32hi_mask */

    case E_V16HImode:
      if (pattern992 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2477; /* *avx512vl_loadv16hi_mask */

    case E_V8HImode:
      if (pattern992 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2478; /* *avx512vl_loadv8hi_mask */

    case E_V32HFmode:
      if (pattern992 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2479; /* *avx512bw_loadv32hf_mask */

    case E_V16HFmode:
      if (pattern992 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2480; /* *avx512vl_loadv16hf_mask */

    case E_V8HFmode:
      if (pattern992 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2481; /* *avx512fp16_loadv8hf_mask */

    case E_V32BFmode:
      if (pattern992 (x2, 
E_V32BFmode, 
E_SImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2482; /* *avx512bw_loadv32bf_mask */

    case E_V16BFmode:
      if (pattern992 (x2, 
E_V16BFmode, 
E_HImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2483; /* *avx512vl_loadv16bf_mask */

    case E_V8BFmode:
      if (pattern992 (x2, 
E_V8BFmode, 
E_QImode) != 0
          || !(
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2484; /* *avx512vl_loadv8bf_mask */

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (pattern992 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 514 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10990; /* avx10_2_vmovrsbv64qi_mask */

    case E_V32QImode:
      if (pattern992 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10992; /* avx10_2_vmovrsbv32qi_mask */

    case E_V16QImode:
      if (pattern992 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10994; /* avx10_2_vmovrsbv16qi_mask */

    case E_V32HImode:
      if (pattern992 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 515 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10996; /* avx10_2_vmovrswv32hi_mask */

    case E_V16HImode:
      if (pattern992 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10998; /* avx10_2_vmovrswv16hi_mask */

    case E_V8HImode:
      if (pattern992 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 11000; /* avx10_2_vmovrswv8hi_mask */

    case E_V16SImode:
      if (pattern992 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 516 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 11002; /* avx10_2_vmovrsdv16si_mask */

    case E_V8SImode:
      if (pattern992 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 11004; /* avx10_2_vmovrsdv8si_mask */

    case E_V4SImode:
      if (pattern992 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 11006; /* avx10_2_vmovrsdv4si_mask */

    case E_V8DImode:
      if (pattern992 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 517 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 11008; /* avx10_2_vmovrsqv8di_mask */

    case E_V4DImode:
      if (pattern992 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 11010; /* avx10_2_vmovrsqv4di_mask */

    case E_V2DImode:
      if (pattern992 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 11012; /* avx10_2_vmovrsqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      x6 = XEXP (x2, 2);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1001 (x2, 
E_V16SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28157 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9367; /* *avx512f_vpermi2varv16si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9433; /* avx512f_vpermt2varv16si3_mask */
            }
          break;

        case E_V8DImode:
          if (pattern1001 (x2, 
E_V8DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28157 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9368; /* *avx512f_vpermi2varv8di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 9435; /* avx512f_vpermt2varv8di3_mask */
            }
          break;

        case E_V8SImode:
          if (pattern1001 (x2, 
E_V8SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9369; /* *avx512vl_vpermi2varv8si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9437; /* avx512vl_vpermt2varv8si3_mask */
            }
          break;

        case E_V4SImode:
          if (pattern1001 (x2, 
E_V4SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9370; /* *avx512vl_vpermi2varv4si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9441; /* avx512vl_vpermt2varv4si3_mask */
            }
          break;

        case E_V4DImode:
          if (pattern1001 (x2, 
E_V4DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9371; /* *avx512vl_vpermi2varv4di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9439; /* avx512vl_vpermt2varv4di3_mask */
            }
          break;

        case E_V2DImode:
          if (pattern1001 (x2, 
E_V2DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9372; /* *avx512vl_vpermi2varv2di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 9443; /* avx512vl_vpermt2varv2di3_mask */
            }
          break;

        case E_V32HImode:
          if (pattern1001 (x2, 
E_V32HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28160 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9373; /* *avx512bw_vpermi2varv32hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28149 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9445; /* avx512bw_vpermt2varv32hi3_mask */
            }
          break;

        case E_V16HImode:
          if (pattern1001 (x2, 
E_V16HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28161 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9374; /* *avx512vl_vpermi2varv16hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28150 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9446; /* avx512vl_vpermt2varv16hi3_mask */
            }
          break;

        case E_V8HImode:
          if (pattern1001 (x2, 
E_V8HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28162 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9375; /* *avx512vl_vpermi2varv8hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 9447; /* avx512vl_vpermt2varv8hi3_mask */
            }
          break;

        case E_V64QImode:
          if (pattern1001 (x2, 
E_V64QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28163 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 9376; /* *avx512bw_vpermi2varv64qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28152 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 9448; /* avx512bw_vpermt2varv64qi3_mask */
            }
          break;

        case E_V32QImode:
          if (pattern1001 (x2, 
E_V32QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28164 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9377; /* *avx512vl_vpermi2varv32qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28153 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9449; /* avx512vl_vpermt2varv32qi3_mask */
            }
          break;

        case E_V16QImode:
          if (pattern1001 (x2, 
E_V16QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28165 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9378; /* *avx512vl_vpermi2varv16qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 9450; /* avx512vl_vpermt2varv16qi3_mask */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          x7 = XVECEXP (x3, 0, 1);
          operands[1] = x7;
          x9 = XEXP (x5, 0);
          if (rtx_equal_p (x9, operands[2]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1453 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) == 0
                      && (
#line 28209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9379; /* *avx512f_vpermi2varv16sf3_mask */
                  break;

                case E_V8SFmode:
                  if (pattern1453 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) == 0
                      && (
#line 28209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9380; /* *avx512vl_vpermi2varv8sf3_mask */
                  break;

                case E_V4SFmode:
                  if (pattern1453 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) == 0
                      && (
#line 28209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9381; /* *avx512vl_vpermi2varv4sf3_mask */
                  break;

                case E_V8DFmode:
                  if (pattern1453 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) == 0
                      && (
#line 28209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 9382; /* *avx512f_vpermi2varv8df3_mask */
                  break;

                case E_V4DFmode:
                  if (pattern1453 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) == 0
                      && (
#line 28209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9383; /* *avx512vl_vpermi2varv4df3_mask */
                  break;

                case E_V2DFmode:
                  if (pattern1453 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) == 0
                      && (
#line 28209 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 9384; /* *avx512vl_vpermi2varv2df3_mask */
                  break;

                default:
                  break;
                }
            }
        }
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1278 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9434; /* avx512f_vpermt2varv16sf3_mask */

        case E_V8DFmode:
          if (pattern1278 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9436; /* avx512f_vpermt2varv8df3_mask */

        case E_V8SFmode:
          if (pattern1278 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9438; /* avx512vl_vpermt2varv8sf3_mask */

        case E_V4DFmode:
          if (pattern1278 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9440; /* avx512vl_vpermt2varv4df3_mask */

        case E_V4SFmode:
          if (pattern1278 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9442; /* avx512vl_vpermt2varv4sf3_mask */

        case E_V2DFmode:
          if (pattern1278 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28269 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9444; /* avx512vl_vpermt2varv2df3_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x5;
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      x6 = XEXP (x2, 2);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern480 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9386; /* avx512f_vpermt2varv16si3_maskz_1 */

        case E_V16SFmode:
          if (pattern1279 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9388; /* avx512f_vpermt2varv16sf3_maskz_1 */

        case E_V8DImode:
          if (pattern480 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9390; /* avx512f_vpermt2varv8di3_maskz_1 */

        case E_V8DFmode:
          if (pattern1279 (x2, 
E_V8DFmode, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9392; /* avx512f_vpermt2varv8df3_maskz_1 */

        case E_V8SImode:
          if (pattern480 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9394; /* avx512vl_vpermt2varv8si3_maskz_1 */

        case E_V8SFmode:
          if (pattern1279 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9396; /* avx512vl_vpermt2varv8sf3_maskz_1 */

        case E_V4DImode:
          if (pattern480 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9398; /* avx512vl_vpermt2varv4di3_maskz_1 */

        case E_V4DFmode:
          if (pattern1279 (x2, 
E_V4DFmode, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9400; /* avx512vl_vpermt2varv4df3_maskz_1 */

        case E_V4SImode:
          if (pattern480 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9402; /* avx512vl_vpermt2varv4si3_maskz_1 */

        case E_V4SFmode:
          if (pattern1279 (x2, 
E_V4SFmode, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9404; /* avx512vl_vpermt2varv4sf3_maskz_1 */

        case E_V2DImode:
          if (pattern480 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9406; /* avx512vl_vpermt2varv2di3_maskz_1 */

        case E_V2DFmode:
          if (pattern1279 (x2, 
E_V2DFmode, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9408; /* avx512vl_vpermt2varv2df3_maskz_1 */

        case E_V32HImode:
          if (pattern480 (x2, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28149 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 9410; /* avx512bw_vpermt2varv32hi3_maskz_1 */

        case E_V16HImode:
          if (pattern480 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28150 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9412; /* avx512vl_vpermt2varv16hi3_maskz_1 */

        case E_V8HImode:
          if (pattern480 (x2, 
E_V8HImode, 
E_QImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 9414; /* avx512vl_vpermt2varv8hi3_maskz_1 */

        case E_V64QImode:
          if (pattern480 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28152 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 9416; /* avx512bw_vpermt2varv64qi3_maskz_1 */

        case E_V32QImode:
          if (pattern480 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28153 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9418; /* avx512vl_vpermt2varv32qi3_maskz_1 */

        case E_V16QImode:
          if (pattern480 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 28236 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 9420; /* avx512vl_vpermt2varv16qi3_maskz_1 */

        case E_V32HFmode:
          if (pattern1279 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9422; /* avx512bw_vpermt2varv32hf3_maskz_1 */

        case E_V16HFmode:
          if (pattern1279 (x2, 
E_V16HFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9424; /* avx512vl_vpermt2varv16hf3_maskz_1 */

        case E_V8HFmode:
          if (pattern1279 (x2, 
E_V8HFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9426; /* avx512fp16_vpermt2varv8hf3_maskz_1 */

        case E_V32BFmode:
          if (pattern1279 (x2, 
E_V32BFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9428; /* avx512bw_vpermt2varv32bf3_maskz_1 */

        case E_V16BFmode:
          if (pattern1279 (x2, 
E_V16BFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9430; /* avx512vl_vpermt2varv16bf3_maskz_1 */

        case E_V8BFmode:
          if (pattern1279 (x2, 
E_V8BFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9432; /* avx512vl_vpermt2varv8bf3_maskz_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (pattern638 (x2))
    {
    case 0:
      if (pattern1385 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5927 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3945; /* fma_fnmadd_v32hf_maskz_1 */

    case 1:
      if (pattern1385 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3949; /* fma_fnmadd_v16hf_maskz_1 */

    case 2:
      if (pattern1385 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5929 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3953; /* fma_fnmadd_v8hf_maskz_1 */

    case 3:
      if (pattern1385 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3957; /* fma_fnmadd_v16sf_maskz_1 */

    case 4:
      if (pattern1385 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3961; /* fma_fnmadd_v8sf_maskz_1 */

    case 5:
      if (pattern1385 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3965; /* fma_fnmadd_v4sf_maskz_1 */

    case 6:
      if (pattern1385 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3968; /* fma_fnmadd_v8df_maskz_1 */

    case 7:
      if (pattern1385 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3972; /* fma_fnmadd_v4df_maskz_1 */

    case 8:
      if (pattern1385 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3976; /* fma_fnmadd_v2df_maskz_1 */

    case 9:
      if (pattern1386 (x2, 
E_SImode, 
E_V32BFmode) != 0
          || !(
#line 32211 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10646; /* avx10_2_fnmaddbf16_v32bf_maskz_1 */

    case 10:
      if (pattern1386 (x2, 
E_HImode, 
E_V16BFmode) != 0
          || !
#line 32211 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10648; /* avx10_2_fnmaddbf16_v16bf_maskz_1 */

    case 11:
      if (pattern1386 (x2, 
E_QImode, 
E_V8BFmode) != 0
          || !
#line 32211 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10650; /* avx10_2_fnmaddbf16_v8bf_maskz_1 */

    case 12:
      if (pattern1387 (x2, 
E_V4SFmode) != 0
          || !
#line 6987 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA4))
        return -1;
      return 4324; /* *fma4i_vmfnmadd_v4sf */

    case 13:
      if (pattern1387 (x2, 
E_V2DFmode) != 0
          || !(
#line 6987 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 4325; /* *fma4i_vmfnmadd_v2df */

    case 14:
      if (pattern1297 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && vector_operand (operands[3], E_V32HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 3977; /* avx512bw_fnmadd_v32hf_mask */
        }
      if (!vector_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3992; /* avx512bw_fnmadd_v32hf_mask3 */

    case 15:
      if (pattern1297 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[3], E_V16HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3979; /* avx512vl_fnmadd_v16hf_mask */
        }
      if (!vector_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3994; /* avx512vl_fnmadd_v16hf_mask3 */

    case 16:
      if (pattern1297 (x2, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[3], E_V8HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3981; /* avx512fp16_fnmadd_v8hf_mask */
        }
      if (!vector_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[3], E_V8HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3996; /* avx512fp16_fnmadd_v8hf_mask3 */

    case 17:
      if (pattern1297 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && vector_operand (operands[3], E_V16SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3982; /* avx512f_fnmadd_v16sf_mask */
        }
      if (!vector_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3997; /* avx512f_fnmadd_v16sf_mask3 */

    case 18:
      if (pattern1297 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[3], E_V8SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3984; /* avx512vl_fnmadd_v8sf_mask */
        }
      if (!vector_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3999; /* avx512vl_fnmadd_v8sf_mask3 */

    case 19:
      if (pattern1297 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[3], E_V4SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3986; /* avx512vl_fnmadd_v4sf_mask */
        }
      if (!vector_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[3], E_V4SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4001; /* avx512vl_fnmadd_v4sf_mask3 */

    case 20:
      if (pattern1297 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && vector_operand (operands[3], E_V8DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3987; /* avx512f_fnmadd_v8df_mask */
        }
      if (!vector_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4002; /* avx512f_fnmadd_v8df_mask3 */

    case 21:
      if (pattern1297 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[3], E_V4DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3989; /* avx512vl_fnmadd_v4df_mask */
        }
      if (!vector_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4004; /* avx512vl_fnmadd_v4df_mask3 */

    case 22:
      if (pattern1297 (x2, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[3], E_V2DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3991; /* avx512vl_fnmadd_v2df_mask */
        }
      if (!vector_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4006; /* avx512vl_fnmadd_v2df_mask3 */

    case 23:
      if (pattern1298 (x2, 
E_SImode, 
E_V32BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && (
#line 32230 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return 10651; /* avx10_2_fnmaddbf16_v32bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 32248 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10654; /* avx10_2_fnmaddbf16_v32bf_mask3 */

    case 24:
      if (pattern1298 (x2, 
E_HImode, 
E_V16BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32230 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return 10652; /* avx10_2_fnmaddbf16_v16bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32248 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10655; /* avx10_2_fnmaddbf16_v16bf_mask3 */

    case 25:
      if (pattern1298 (x2, 
E_QImode, 
E_V8BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32230 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return 10653; /* avx10_2_fnmaddbf16_v8bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32248 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10656; /* avx10_2_fnmaddbf16_v8bf_mask3 */

    case 26:
      if (pattern1388 (x2, 
E_V8HFmode) != 0
          || !(
#line 6632 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 4236; /* *fmai_fnmadd_v8hf */

    case 27:
      if (pattern1388 (x2, 
E_V4SFmode) != 0
          || !
#line 6632 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
        return -1;
      return 4238; /* *fmai_fnmadd_v4sf */

    case 28:
      if (pattern1388 (x2, 
E_V2DFmode) != 0
          || !(
#line 6632 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 4240; /* *fmai_fnmadd_v2df */

    case 29:
      return recog_159 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 1LL:
      x10 = XVECEXP (x8, 0, 1);
      if (XWINT (x10, 0) != 3LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1582 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 13397 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5409; /* avx512vl_unpckhpd128_mask */

        case E_V2DImode:
          if (pattern1583 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 7205; /* vec_interleave_highv2di_mask */

        default:
          return -1;
        }

    case 0LL:
      x10 = XVECEXP (x8, 0, 1);
      if (XWINT (x10, 0) != 2LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1582 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 13540 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5419; /* avx512vl_unpcklpd128_mask */

        case E_V2DImode:
          if (pattern1583 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 7211; /* vec_interleave_lowv2di_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  switch (XVECLEN (x6, 0))
    {
    case 16:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_161 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x16 = XVECEXP (x6, 0, 8);
      operands[11] = x16;
      x17 = XVECEXP (x6, 0, 9);
      operands[12] = x17;
      x18 = XVECEXP (x6, 0, 10);
      operands[13] = x18;
      x19 = XVECEXP (x6, 0, 11);
      operands[14] = x19;
      x20 = XVECEXP (x6, 0, 12);
      operands[15] = x20;
      x21 = XVECEXP (x6, 0, 13);
      operands[16] = x21;
      x22 = XVECEXP (x6, 0, 14);
      operands[17] = x22;
      x23 = XVECEXP (x6, 0, 15);
      operands[18] = x23;
      x24 = XEXP (x2, 1);
      operands[19] = x24;
      x25 = XEXP (x2, 2);
      operands[20] = x25;
      if (!register_operand (operands[20], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1641 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !nonimm_or_0_operand (operands[19], E_V16SFmode))
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_16_to_19_operand (operands[5], E_VOIDmode)
              && const_16_to_19_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_20_to_23_operand (operands[9], E_VOIDmode)
              && const_20_to_23_operand (operands[10], E_VOIDmode)
              && const_8_to_11_operand (operands[11], E_VOIDmode)
              && const_8_to_11_operand (operands[12], E_VOIDmode)
              && const_24_to_27_operand (operands[13], E_VOIDmode)
              && const_24_to_27_operand (operands[14], E_VOIDmode)
              && const_12_to_15_operand (operands[15], E_VOIDmode)
              && const_12_to_15_operand (operands[16], E_VOIDmode)
              && const_28_to_31_operand (operands[17], E_VOIDmode)
              && const_28_to_31_operand (operands[18], E_VOIDmode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12)))))
            return 7194; /* avx512f_shufps512_1_mask */
          if (!const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1869 () != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20426 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8434; /* avx512f_shuf_f32x4_1_mask */

        case E_V16SImode:
          if (pattern1641 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1869 () != 0
              || !nonimm_or_0_operand (operands[19], E_V16SImode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20426 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8436; /* avx512f_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 8:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_162 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x24 = XEXP (x2, 1);
      operands[11] = x24;
      x25 = XEXP (x2, 2);
      operands[12] = x25;
      if (!register_operand (operands[12], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1754 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_8_to_11_operand (operands[5], E_VOIDmode)
              && const_8_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_12_to_15_operand (operands[9], E_VOIDmode)
              && const_12_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11490 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && TARGET_AVX512VL
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)))))
            return 5276; /* avx_shufps256_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1844 () != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20347 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 8432; /* avx512vl_shuf_f32x4_1_mask */

        case E_V8DFmode:
          if (pattern1754 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_8_to_9_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_10_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_5_operand (operands[7], E_VOIDmode)
              && const_12_to_13_operand (operands[8], E_VOIDmode)
              && const_6_to_7_operand (operands[9], E_VOIDmode)
              && const_14_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 7196; /* avx512f_shufpd512_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1844 () != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20249 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8422; /* avx512f_shuf_f64x2_1_mask */

        case E_V8DImode:
          if (pattern1755 (x2, 
E_V8DImode, 
E_V16DImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20249 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8424; /* avx512f_shuf_i64x2_1_mask */

        case E_V8SImode:
          if (pattern1755 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20347 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 8430; /* avx512vl_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_163 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x24 = XEXP (x2, 1);
      operands[7] = x24;
      x25 = XEXP (x2, 2);
      operands[8] = x25;
      if (!register_operand (operands[8], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1640 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 11543 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5277; /* sse_shufps_v4sf_mask */

        case E_V4DFmode:
          if (pattern1641 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !nonimm_or_0_operand (operands[7], E_V4DFmode))
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_4_to_5_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_6_to_7_operand (operands[6], E_VOIDmode)
              && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return 7198; /* avx_shufpd256_1_mask */
          if (!const_0_to_3_operand (operands[3], E_VOIDmode)
              || !const_0_to_3_operand (operands[4], E_VOIDmode)
              || !const_4_to_7_operand (operands[5], E_VOIDmode)
              || !const_4_to_7_operand (operands[6], E_VOIDmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 8420; /* avx512dq_shuf_f64x2_1_mask */

        case E_V4DImode:
          if (pattern1640 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 8418; /* avx512dq_shuf_i64x2_1_mask */

        default:
          return -1;
        }

    case 2:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_164 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      if (!const_0_to_1_operand (operands[3], E_VOIDmode)
          || pattern1214 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0)
        return -1;
      operands[4] = x8;
      if (!const_2_to_3_operand (operands[4], E_VOIDmode))
        return -1;
      x24 = XEXP (x2, 1);
      operands[5] = x24;
      if (!nonimm_or_0_operand (operands[5], E_V2DFmode))
        return -1;
      x25 = XEXP (x2, 2);
      operands[6] = x25;
      if (!register_operand (operands[6], E_QImode)
          || !
#line 14453 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 7199; /* sse2_shufpd_v2df_mask */

    case 64:
      return recog_165 (x1, insn, pnum_clobbers);

    case 32:
      if (pattern899 (x6) != 0)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x24 = XEXP (x2, 1);
      operands[3] = x24;
      x25 = XEXP (x2, 2);
      operands[4] = x25;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      switch (XWINT (x7, 0))
        {
        case 8LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 40LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 9LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 41LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 10LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 42LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 11LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 43LL
              || pattern1884 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 24LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 56LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 25LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 57LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 26LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 58LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 27LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 59LL
              || pattern1889 (x6) != 0
              || pattern1582 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19465 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8326; /* avx2_interleave_highv32qi_mask */

        case 0LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 32LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 1LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 33LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 2LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 34LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 3LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 35LL)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 16LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 48LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 17LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 49LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 18LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 50LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 19LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 51LL)
            return -1;
          x16 = XVECEXP (x6, 0, 8);
          switch (XWINT (x16, 0))
            {
            case 4LL:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 36LL)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 5LL)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 37LL)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 6LL)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 38LL)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 7LL)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 39LL)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 20LL)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 52LL)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 21LL)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 53LL)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 22LL)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 54LL)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 23LL)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 55LL
                  || pattern1582 (x2, 
E_V32QImode, 
E_V64QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                return -1;
              return 8332; /* avx2_interleave_lowv32qi_mask */

            case 8LL:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 40LL)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 9LL)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 41LL)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 10LL)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 42LL)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 11LL)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 43LL)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 24LL)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 56LL)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 25LL)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 57LL)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 26LL)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 58LL)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 27LL)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 59LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1582 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 8354; /* avx512bw_interleave_lowv32hi_mask */

                case E_V32HFmode:
                  if (pattern1582 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 8356; /* avx512bw_interleave_lowv32hf_mask */

                case E_V32BFmode:
                  if (pattern1582 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                      || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 8358; /* avx512bw_interleave_lowv32bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4LL:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 36LL)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 5LL)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 37LL)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 6LL)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 38LL)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 7LL)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 39LL
              || pattern1884 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 20LL)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 52LL)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 21LL)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 53LL)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 22LL)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 54LL)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 23LL)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 55LL
              || pattern1889 (x6) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1582 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19613 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8336; /* avx512bw_interleave_highv32hi_mask */

            case E_V32HFmode:
              if (pattern1582 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19613 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8338; /* avx512bw_interleave_highv32hf_mask */

            case E_V32BFmode:
              if (pattern1582 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19613 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8340; /* avx512bw_interleave_highv32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern149 (x2))
    {
    case 0:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24130 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8758; /* avx2_sign_extendv16qiv16hi2_mask */

    case 1:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8766; /* avx512bw_sign_extendv32qiv32hi2_mask */

    case 2:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24254 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8778; /* *sse4_1_sign_extendv8qiv8hi2_mask_1 */

    case 3:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24379 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8790; /* avx512f_sign_extendv16qiv16si2_mask */

    case 4:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24522 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8818; /* avx512f_sign_extendv16hiv16si2_mask */

    case 5:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8798; /* *avx2_sign_extendv8qiv8si2_mask_1 */

    case 6:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8826; /* avx2_sign_extendv8hiv8si2_mask */

    case 7:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24472 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8810; /* *sse4_1_sign_extendv4qiv4si2_mask_1 */

    case 8:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24645 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8838; /* *sse4_1_sign_extendv4hiv4si2_mask_1 */

    case 9:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8854; /* *avx512f_sign_extendv8qiv8di2_mask_1 */

    case 10:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24947 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8885; /* avx512f_sign_extendv8hiv8di2_mask */

    case 11:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25084 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8913; /* avx512f_sign_extendv8siv8di2_mask */

    case 12:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24834 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8866; /* *avx2_sign_extendv4qiv4di2_mask_1 */

    case 13:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24977 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8893; /* *avx2_sign_extendv4hiv4di2_mask_1 */

    case 14:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25135 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8919; /* avx2_sign_extendv4siv4di2_mask */

    case 15:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24896 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8878; /* *sse4_1_sign_extendv2qiv2di2_mask_1 */

    case 16:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8905; /* *sse4_1_sign_extendv2hiv2di2_mask_1 */

    case 17:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25201 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8929; /* *sse4_1_sign_extendv2siv2di2_mask_1 */

    case 18:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern903 (x2))
        {
        case 0:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24242 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
            return 8774; /* sse4_1_sign_extendv8qiv8hi2_mask */
          break;

        case 1:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24400 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8794; /* avx2_sign_extendv8qiv8si2_mask */
          break;

        case 2:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 8850; /* avx512f_sign_extendv8qiv8di2_mask */
          break;

        case 3:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24460 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8806; /* sse4_1_sign_extendv4qiv4si2_mask */
          break;

        case 4:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24633 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8834; /* sse4_1_sign_extendv4hiv4si2_mask */
          break;

        case 5:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24823 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8862; /* avx2_sign_extendv4qiv4di2_mask */
          break;

        case 6:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24966 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8889; /* avx2_sign_extendv4hiv4di2_mask */
          break;

        case 7:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24884 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8874; /* sse4_1_sign_extendv2qiv2di2_mask */
          break;

        case 8:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25023 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8901; /* sse4_1_sign_extendv2hiv2di2_mask */
          break;

        case 9:
          if ((
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25189 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8925; /* sse4_1_sign_extendv2siv2di2_mask */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern906 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24278 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8782; /* *sse4_1_sign_extendv8qiv8hi2_mask_2 */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24430 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8802; /* *avx2_sign_extendv8qiv8si2_mask_2 */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24794 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ())))
            return -1;
          return 8858; /* *avx512f_sign_extendv8qiv8di2_mask_2 */

        case 3:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8842; /* *sse4_1_sign_extendv4hiv4si2_mask_2 */

        case 4:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8897; /* *avx2_sign_extendv4hiv4di2_mask_2 */

        case 5:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25219 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8933; /* *sse4_1_sign_extendv2siv2di2_mask_2 */

        case 6:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24495 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8814; /* *sse4_1_sign_extendv4qiv4si2_mask_2 */

        case 7:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24855 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8870; /* *avx2_sign_extendv4qiv4di2_mask_2 */

        case 8:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25057 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8909; /* *sse4_1_sign_extendv2hiv2di2_mask_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern127 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3728; /* *iorv8sf3_mask */

    case E_V4SFmode:
      if (pattern127 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 3734; /* *iorv4sf3_mask */

    case E_V4DFmode:
      if (pattern127 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 3740; /* *iorv4df3_mask */

    case E_V2DFmode:
      if (pattern127 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 3746; /* *iorv2df3_mask */

    case E_V16SFmode:
      if (pattern128 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3758; /* *iorv16sf3_mask */

    case E_V8DFmode:
      if (pattern128 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3764; /* *iorv8df3_mask */

    case E_V16SImode:
      if (pattern485 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V16SImode, operands)) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8011; /* *iorv16si3_mask */

    case E_V8SImode:
      if (pattern485 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V8SImode, operands)) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 8017; /* *iorv8si3_mask */

    case E_V4SImode:
      if (pattern485 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V4SImode, operands))))
        return -1;
      return 8023; /* *iorv4si3_mask */

    case E_V8DImode:
      if (pattern485 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V8DImode, operands)) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8029; /* *iorv8di3_mask */

    case E_V4DImode:
      if (pattern485 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V4DImode, operands)) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 8035; /* *iorv4di3_mask */

    case E_V2DImode:
      if (pattern485 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (IOR, V2DImode, operands))))
        return -1;
      return 8041; /* *iorv2di3_mask */

    default:
      return -1;
    }
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!memory_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2563; /* avx512f_movntv16sf */

    case E_V8SFmode:
      if (!memory_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2564; /* avx_movntv8sf */

    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2565; /* sse_movntv4sf */

    case E_V8DFmode:
      if (!memory_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2566; /* avx512f_movntv8df */

    case E_V4DFmode:
      if (!memory_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2567; /* avx_movntv4df */

    case E_V2DFmode:
      if (!memory_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 376 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2568; /* sse2_movntv2df */

    case E_V8DImode:
      if (!memory_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 614 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2569; /* avx512f_movntv8di */

    case E_V4DImode:
      if (!memory_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 614 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2570; /* avx_movntv4di */

    case E_V2DImode:
      if (!memory_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 2571; /* sse2_movntv2di */

    default:
      return -1;
    }
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 2);
  operands[3] = x7;
  x8 = XVECEXP (x2, 0, 1);
  operands[4] = x8;
  switch (XINT (x4, 1))
    {
    case 156:
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4425; /* avx512fp16_vcvtph2uw_v32hi_mask_round */

        case E_V16SImode:
          if (pattern1310 (x2, 
E_HImode, 
E_V16SImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4433; /* avx512fp16_vcvtph2udq_v16si_mask_round */

            case E_V16SFmode:
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4848; /* avx512f_fixuns_notruncv16sfv16si_mask_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1473 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4441; /* avx512fp16_vcvtph2uqq_v8di_mask_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8752 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4868; /* avx512dq_cvtps2uqqv8di_mask_round */

            case 2:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9734 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5114; /* fixuns_notruncv8dfv8di2_mask_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4449; /* avx512fp16_vcvtph2uw_v16hi_mask_round */

        case E_V8SImode:
          switch (pattern1473 (x2, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4457; /* avx512fp16_vcvtph2udq_v8si_mask_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4852; /* avx512vl_fixuns_notruncv8sfv8si_mask_round */

            case 2:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5020; /* fixuns_notruncv8dfv8si2_mask_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1474 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4465; /* avx512fp16_vcvtph2uqq_v4di_mask_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8752 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4872; /* avx512dq_cvtps2uqqv4di_mask_round */

            case 2:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9734 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5118; /* fixuns_notruncv4dfv4di2_mask_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1475 (x2, 
E_V4SImode) != 0
              || !nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimm_or_0_operand (operands[2], E_V4SImode)
              || !register_operand (operands[3], E_QImode)
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 5024; /* fixuns_notruncv4dfv4si2_mask_round */

        default:
          return -1;
        }

    case 46:
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4429; /* avx512fp16_vcvtph2w_v32hi_mask_round */

        case E_V16SImode:
          switch (pattern1476 (x2))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4437; /* avx512fp16_vcvtph2dq_v16si_mask_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8708 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 4844; /* avx512f_fix_notruncv16sfv16si_mask_round */

            default:
              return -1;
            }

        case E_V8DImode:
          if (pattern1310 (x2, 
E_QImode, 
E_V8DImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4445; /* avx512fp16_vcvtph2qq_v8di_mask_round */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8729 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4858; /* avx512dq_cvtps2qqv8di_mask_round */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5104; /* fix_notruncv8dfv8di2_mask_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4453; /* avx512fp16_vcvtph2w_v16hi_mask_round */

        case E_V8SImode:
          switch (pattern1477 (x2))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4461; /* avx512fp16_vcvtph2dq_v8si_mask_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8692 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 4838; /* avx_fix_notruncv8sfv8si_mask_round */

            case 2:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 5008; /* avx512f_cvtpd2dq512_mask_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1474 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4469; /* avx512fp16_vcvtph2qq_v4di_mask_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8729 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4862; /* avx512dq_cvtps2qqv4di_mask_round */

            case 2:
              if (!register_operand (operands[1], E_V4DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5108; /* fix_notruncv4dfv4di2_mask_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V4SImode, 
E_V4DFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL
   && (!true || TARGET_AVX10_2_256)))))
            return -1;
          return 5012; /* avx_cvtpd2dq256_mask_round */

        default:
          return -1;
        }

    case 172:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4573; /* unspec_avx512fp16_fix_truncv16hi2_mask_round */

        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4581; /* unspec_avx512fp16_fix_truncv32hi2_mask_round */

        case E_V8SImode:
          switch (pattern1477 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4589; /* unspec_avx512fp16_fix_truncv8si2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8796 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL
  && (!true || TARGET_AVX10_2_256)))))
                return -1;
              return 4894; /* unspec_fix_truncv8sfv8si2_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 5031; /* unspec_fix_truncv8dfv8si2_mask_round */

            default:
              return -1;
            }

        case E_V16SImode:
          switch (pattern1476 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4597; /* unspec_avx512fp16_fix_truncv16si2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 4878; /* unspec_fix_truncv16sfv16si2_mask_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1478 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4605; /* unspec_avx512fp16_fix_truncv8di2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5064; /* unspec_fix_truncv8dfv8di2_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5124; /* unspec_fix_truncv8sfv8di2_mask_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1479 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7906 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))))))
                return -1;
              return 4661; /* unspec_avx512fp16_fix_truncv4di2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5072; /* unspec_fix_truncv4dfv4di2_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5132; /* unspec_fix_truncv4sfv4di2_mask_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V4SImode, 
E_V4DFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL
   && (!true || TARGET_AVX10_2_256)))))
            return -1;
          return 5052; /* unspec_fix_truncv4dfv4si2_mask_round */

        default:
          return -1;
        }

    case 173:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4577; /* unspec_avx512fp16_fixuns_truncv16hi2_mask_round */

        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4585; /* unspec_avx512fp16_fixuns_truncv32hi2_mask_round */

        case E_V8SImode:
          switch (pattern1478 (x2, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4593; /* unspec_avx512fp16_fixuns_truncv8si2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 5035; /* unspec_fixuns_truncv8dfv8si2_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9916 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 5156; /* unspec_fixuns_truncv8sfv8si2_mask_round */

            default:
              return -1;
            }

        case E_V16SImode:
          switch (pattern1476 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4601; /* unspec_avx512fp16_fixuns_truncv16si2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 4882; /* unspec_fixuns_truncv16sfv16si2_mask_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1478 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4609; /* unspec_avx512fp16_fixuns_truncv8di2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5068; /* unspec_fixuns_truncv8dfv8di2_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 5128; /* unspec_fixuns_truncv8sfv8di2_mask_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1479 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7906 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))))))
                return -1;
              return 4665; /* unspec_avx512fp16_fixuns_truncv4di2_mask_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5076; /* unspec_fixuns_truncv4dfv4di2_mask_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 5136; /* unspec_fixuns_truncv4sfv4di2_mask_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V4SImode, 
E_V4DFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F
  && (!true || TARGET_AVX10_2_256)))))
            return -1;
          return 5058; /* unspec_fixuns_truncv4dfv4si2_mask_round */

        default:
          return -1;
        }

    case 165:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1480 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 7044; /* avx512bw_getexpv32hf_mask_round */

        case E_V16HFmode:
          if (pattern1480 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 7048; /* avx512vl_getexpv16hf_mask_round */

        case E_V16SFmode:
          if (pattern1480 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 7054; /* avx512f_getexpv16sf_mask_round */

        case E_V8SFmode:
          if (pattern1480 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 7058; /* avx512vl_getexpv8sf_mask_round */

        case E_V8DFmode:
          if (pattern1480 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 7064; /* avx512f_getexpv8df_mask_round */

        case E_V4DFmode:
          if (pattern1480 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 7068; /* avx512vl_getexpv4df_mask_round */

        default:
          return -1;
        }

    case 149:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1304 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29109 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL)
   && (!true || TARGET_AVX10_2_256)))))
            return -1;
          return 9657; /* vcvtph2ps256_mask_round */

        case E_V16SFmode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29122 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9661; /* avx512f_vcvtph2ps512_mask_round */

        default:
          return -1;
        }

    case 265:
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10762; /* avx10_2_cvtph2ibsv32hf_mask_round */

        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))))))
            return -1;
          return 10770; /* avx10_2_cvtph2ibsv16hf_mask_round */

        default:
          return -1;
        }

    case 266:
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10766; /* avx10_2_cvtph2iubsv32hf_mask_round */

        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))))))
            return -1;
          return 10774; /* avx10_2_cvtph2iubsv16hf_mask_round */

        default:
          return -1;
        }

    case 271:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10782; /* avx10_2_cvttph2ibsv32hf_mask_round */

        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))))))
            return -1;
          return 10790; /* avx10_2_cvttph2ibsv16hf_mask_round */

        default:
          return -1;
        }

    case 272:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1304 (x2, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10786; /* avx10_2_cvttph2iubsv32hf_mask_round */

        case E_V16HImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))))))
            return -1;
          return 10794; /* avx10_2_cvttph2iubsv16hf_mask_round */

        default:
          return -1;
        }

    case 267:
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10802; /* avx10_2_cvtps2ibsv16sf_mask_round */

        case E_V8SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))))))
            return -1;
          return 10810; /* avx10_2_cvtps2ibsv8sf_mask_round */

        default:
          return -1;
        }

    case 268:
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10806; /* avx10_2_cvtps2iubsv16sf_mask_round */

        case E_V8SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))))))
            return -1;
          return 10814; /* avx10_2_cvtps2iubsv8sf_mask_round */

        default:
          return -1;
        }

    case 273:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10822; /* avx10_2_cvttps2ibsv16sf_mask_round */

        case E_V8SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))))))
            return -1;
          return 10830; /* avx10_2_cvttps2ibsv8sf_mask_round */

        default:
          return -1;
        }

    case 274:
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1304 (x2, 
E_HImode, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10826; /* avx10_2_cvttps2iubsv16sf_mask_round */

        case E_V8SImode:
          if (pattern1304 (x2, 
E_QImode, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))))))
            return -1;
          return 10834; /* avx10_2_cvttps2iubsv8sf_mask_round */

        default:
          return -1;
        }

    case 275:
      switch (pattern1305 (x2))
        {
        case 0:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10842; /* avx10_2_vcvttps2dqsv16sf_mask_round */

        case 1:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))))))
            return -1;
          return 10850; /* avx10_2_vcvttps2dqsv8sf_mask_round */

        case 2:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10862; /* avx10_2_vcvttpd2dqsv8df_mask_round */

        case 3:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))))))
            return -1;
          return 10870; /* avx10_2_vcvttpd2dqsv4df_mask_round */

        case 4:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10882; /* avx10_2_vcvttpd2qqsv8df_mask_round */

        case 5:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 617 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10902; /* avx10_2_vcvttps2qqsv8di_mask_round */

        case 6:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))))))
            return -1;
          return 10890; /* avx10_2_vcvttpd2qqsv4df_mask_round */

        case 7:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))))))
            return -1;
          return 10910; /* avx10_2_vcvttps2qqsv4di_mask_round */

        default:
          return -1;
        }

    case 276:
      switch (pattern1305 (x2))
        {
        case 0:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10846; /* avx10_2_vcvttps2udqsv16sf_mask_round */

        case 1:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))))))
            return -1;
          return 10854; /* avx10_2_vcvttps2udqsv8sf_mask_round */

        case 2:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10866; /* avx10_2_vcvttpd2udqsv8df_mask_round */

        case 3:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))))))
            return -1;
          return 10874; /* avx10_2_vcvttpd2udqsv4df_mask_round */

        case 4:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10886; /* avx10_2_vcvttpd2uqqsv8df_mask_round */

        case 5:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 617 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10906; /* avx10_2_vcvttps2uqqsv8di_mask_round */

        case 6:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))))))
            return -1;
          return 10894; /* avx10_2_vcvttpd2uqqsv4df_mask_round */

        case 7:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))))))
            return -1;
          return 10914; /* avx10_2_vcvttps2uqqsv4di_mask_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  if (!register_operand (x4, E_QImode))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case FLOAT:
      switch (pattern500 (x2))
        {
        case 0:
          if (!
#line 7720 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4530; /* avx512fp16_vcvtdq2ph_v4si_mask_1 */

        case 1:
          if (!
#line 7720 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4532; /* avx512fp16_vcvtqq2ph_v4di_mask_1 */

        case 2:
          if (!
#line 7796 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4542; /* *avx512fp16_vcvtqq2ph_v2di_mask */

        case 3:
          if (!
#line 9323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4991; /* *floatv2div2sf2_mask */

        case 4:
          if (!
#line 7735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4536; /* *avx512fp16_vcvtdq2ph_v4si_mask_1 */

        case 5:
          if (!
#line 7735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4538; /* *avx512fp16_vcvtqq2ph_v4di_mask_1 */

        case 6:
          if (!
#line 7811 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4544; /* *avx512fp16_vcvtqq2ph_v2di_mask_1 */

        case 7:
          if (!
#line 9338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4993; /* *floatv2div2sf2_mask_1 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern500 (x2))
        {
        case 0:
          if (!
#line 7720 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4531; /* avx512fp16_vcvtudq2ph_v4si_mask_1 */

        case 1:
          if (!
#line 7720 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4534; /* avx512fp16_vcvtuqq2ph_v4di_mask_1 */

        case 2:
          if (!
#line 7796 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4543; /* *avx512fp16_vcvtuqq2ph_v2di_mask */

        case 3:
          if (!
#line 9323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4992; /* *floatunsv2div2sf2_mask */

        case 4:
          if (!
#line 7735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4537; /* *avx512fp16_vcvtudq2ph_v4si_mask_1 */

        case 5:
          if (!
#line 7735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4539; /* *avx512fp16_vcvtuqq2ph_v4di_mask_1 */

        case 6:
          if (!
#line 7811 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4545; /* *avx512fp16_vcvtuqq2ph_v2di_mask_1 */

        case 7:
          if (!
#line 9338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4994; /* *floatunsv2div2sf2_mask_1 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          operands[3] = x4;
          switch (XVECLEN (x9, 0))
            {
            case 4:
              if (pattern1215 (x9, 
3, 
2, 
1, 
0) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HFmode:
                  if (!register_operand (operands[0], E_V8HFmode)
                      || GET_MODE (x2) != E_V8HFmode
                      || GET_MODE (x3) != E_V4HFmode
                      || GET_MODE (x5) != E_V4HFmode
                      || GET_MODE (x8) != E_V4HFmode
                      || !nonimm_or_0_operand (operands[2], E_V8HFmode))
                    return -1;
                  switch (pattern1556 ())
                    {
                    case 0:
                      if (!
#line 8204 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
                        return -1;
                      return 4754; /* avx512fp16_vcvtpd2ph_v4df_mask_1 */

                    case 1:
                      if (!
#line 8204 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
                        return -1;
                      return 4756; /* avx512fp16_vcvtps2ph_v4sf_mask_1 */

                    default:
                      return -1;
                    }

                case E_V8BFmode:
                  if (pattern496 (x2, 
E_V4BFmode, 
E_V8BFmode, 
E_V4SFmode) != 0
                      || !
#line 31104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16 && TARGET_AVX512VL))
                    return -1;
                  return 10348; /* avx512f_cvtneps2bf16_v4sf_mask_1 */

                default:
                  return -1;
                }

            case 2:
              switch (pattern497 (x2, 
E_V2DFmode))
                {
                case 0:
                  if (!
#line 8280 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4760; /* *avx512fp16_vcvtpd2ph_v2df_mask */

                case 1:
                  if (!
#line 10191 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 5188; /* *sse2_cvtpd2ps_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[3] = x8;
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_V4HFmode:
                  if (GET_MODE (x5) != E_V4HFmode
                      || !const0_operand (operands[3], E_V4HFmode))
                    return -1;
                  switch (pattern1556 ())
                    {
                    case 0:
                      if (!
#line 8219 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4757; /* *avx512fp16_vcvtpd2ph_v4df_mask_1 */

                    case 1:
                      if (!
#line 8219 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4758; /* *avx512fp16_vcvtps2ph_v4sf_mask_1 */

                    default:
                      return -1;
                    }

                case E_V2HFmode:
                  if (pattern498 (x5, 
E_V2DFmode) != 0
                      || !
#line 8295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4761; /* *avx512fp16_vcvtpd2ph_v2df_mask_1 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern499 (x2, 
E_V2DFmode) != 0
                  || !
#line 10206 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 5189; /* *sse2_cvtpd2ps_mask_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 1:
          x11 = XVECEXP (x5, 0, 0);
          operands[1] = x11;
          switch (XINT (x5, 1))
            {
            case 46:
              switch (pattern920 (x2))
                {
                case 0:
                  if (!
#line 9483 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 5015; /* sse2_cvtpd2dq_mask */

                case 1:
                  if (!
#line 9498 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 5016; /* *sse2_cvtpd2dq_mask_1 */

                default:
                  return -1;
                }

            case 156:
              switch (pattern920 (x2))
                {
                case 0:
                  if (!
#line 9544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 5026; /* fixuns_notruncv2dfv2si2_mask */

                case 1:
                  if (!
#line 9560 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 5027; /* *fixuns_notruncv2dfv2si2_mask_1 */

                default:
                  return -1;
                }

            case 173:
              if (GET_MODE (x5) != E_V2SImode)
                return -1;
              x8 = XEXP (x3, 1);
              if (pattern667 (x8, 
2, 
E_V2SImode) != 0)
                return -1;
              x9 = XEXP (x8, 1);
              x12 = XVECEXP (x9, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x13 = XVECEXP (x9, 0, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x7 = XEXP (x2, 1);
              if (GET_CODE (x7) != CONST_VECTOR
                  || XVECLEN (x7, 0) != 2
                  || GET_MODE (x7) != E_V2SImode)
                return -1;
              x14 = XVECEXP (x7, 0, 0);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x15 = XVECEXP (x7, 0, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x2) != E_V4SImode
                  || GET_MODE (x3) != E_V2SImode
                  || !nonimmediate_operand (operands[1], E_V2DFmode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!nonimm_or_0_operand (operands[2], E_V4SImode))
                return -1;
              operands[3] = x4;
              if (!
#line 9621 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 5046; /* unspec_fixuns_truncv2dfv2si2_mask */

            case 253:
              if (pattern921 (x2) != 0
                  || !
#line 31905 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10502; /* *vcvtph2bf8v8hf_mask */

            case 254:
              if (pattern921 (x2) != 0
                  || !
#line 31905 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10503; /* *vcvtph2bf8sv8hf_mask */

            case 255:
              if (pattern921 (x2) != 0
                  || !
#line 31905 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10504; /* *vcvtph2hf8v8hf_mask */

            case 256:
              if (pattern921 (x2) != 0
                  || !
#line 31905 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10505; /* *vcvtph2hf8sv8hf_mask */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x3, 1);
          if (pattern667 (x8, 
8, 
E_V8QImode) != 0)
            return -1;
          x9 = XEXP (x8, 1);
          x12 = XVECEXP (x9, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XVECEXP (x9, 0, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x16 = XVECEXP (x9, 0, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern1413 (x9, 
7, 
6, 
5, 
4, 
3) != 0
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x5) != E_V8QImode)
            return -1;
          x11 = XVECEXP (x5, 0, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          x17 = XVECEXP (x5, 0, 1);
          operands[2] = x17;
          if (!nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[3] = x10;
          if (!nonimm_or_0_operand (operands[3], E_V16QImode))
            return -1;
          operands[4] = x4;
          x7 = XEXP (x2, 1);
          operands[5] = x7;
          if (!const0_operand (operands[5], E_V8QImode))
            return -1;
          switch (XINT (x5, 1))
            {
            case 245:
              if (!
#line 31817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10478; /* *vcvtbiasph2bf8v8hf_mask */

            case 246:
              if (!
#line 31817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10479; /* *vcvtbiasph2bf8sv8hf_mask */

            case 247:
              if (!
#line 31817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10480; /* *vcvtbiasph2hf8v8hf_mask */

            case 248:
              if (!
#line 31817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
                return -1;
              return 10481; /* *vcvtbiasph2hf8sv8hf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern502 (x2))
        {
        case 0:
          if (!
#line 9637 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5047; /* fixuns_truncv2dfv2si2_mask */

        case 1:
          if (!
#line 9651 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5048; /* *fixuns_truncv2dfv2si2_mask_1 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern502 (x2))
        {
        case 0:
          if (!
#line 9988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5166; /* sse2_cvttpd2dq_mask */

        case 1:
          if (!
#line 10002 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5167; /* *sse2_cvttpd2dq_mask_1 */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern508 (x2))
        {
        case 0:
          if (!
#line 15449 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7305; /* avx512vl_ss_truncatev2div2qi2_mask */

        case 1:
          if (!
#line 15891 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7420; /* avx512vl_ss_truncatev2div2hi2_mask */

        case 2:
          if (!
#line 16039 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7439; /* avx512vl_ss_truncatev2div2si2_mask */

        case 3:
          if (!
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7326; /* avx512vl_ss_truncatev4siv4qi2_mask */

        case 4:
          if (!
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7329; /* avx512vl_ss_truncatev4div4qi2_mask */

        case 5:
          if (!
#line 15800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7396; /* avx512vl_ss_truncatev4siv4hi2_mask */

        case 6:
          if (!
#line 15800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7399; /* avx512vl_ss_truncatev4div4hi2_mask */

        case 7:
          if (!(
#line 15642 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7356; /* avx512vl_ss_truncatev8hiv8qi2_mask */

        case 8:
          if (!
#line 15642 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7359; /* avx512vl_ss_truncatev8siv8qi2_mask */

        case 9:
          if (!
#line 16158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7457; /* avx512f_ss_truncatev8div16qi2_mask */

        case 10:
          if (!
#line 15470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7308; /* *avx512vl_ss_truncatev2div2qi2_mask_1 */

        case 11:
          if (!
#line 15908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7423; /* *avx512vl_ss_truncatev2div2hi2_mask_1 */

        case 12:
          if (!
#line 16054 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7442; /* *avx512vl_ss_truncatev2div2si2_mask_1 */

        case 13:
          if (!
#line 15565 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7332; /* *avx512vl_ss_truncatev4siv4qi2_mask_1 */

        case 14:
          if (!
#line 15565 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7335; /* *avx512vl_ss_truncatev4div4qi2_mask_1 */

        case 15:
          if (!
#line 15817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7402; /* *avx512vl_ss_truncatev4siv4hi2_mask_1 */

        case 16:
          if (!
#line 15817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7405; /* *avx512vl_ss_truncatev4div4hi2_mask_1 */

        case 17:
          if (!(
#line 15663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7362; /* *avx512vl_ss_truncatev8hiv8qi2_mask_1 */

        case 18:
          if (!
#line 15663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7365; /* *avx512vl_ss_truncatev8siv8qi2_mask_1 */

        case 19:
          if (!
#line 16179 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7460; /* *avx512f_ss_truncatev8div16qi2_mask_1 */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern508 (x2))
        {
        case 0:
          if (!
#line 15449 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7306; /* avx512vl_truncatev2div2qi2_mask */

        case 1:
          if (!
#line 15891 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7421; /* avx512vl_truncatev2div2hi2_mask */

        case 2:
          if (!
#line 16039 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7440; /* avx512vl_truncatev2div2si2_mask */

        case 3:
          if (!
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7327; /* avx512vl_truncatev4siv4qi2_mask */

        case 4:
          if (!
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7330; /* avx512vl_truncatev4div4qi2_mask */

        case 5:
          if (!
#line 15800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7397; /* avx512vl_truncatev4siv4hi2_mask */

        case 6:
          if (!
#line 15800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7400; /* avx512vl_truncatev4div4hi2_mask */

        case 7:
          if (!(
#line 15642 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7357; /* avx512vl_truncatev8hiv8qi2_mask */

        case 8:
          if (!
#line 15642 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7360; /* avx512vl_truncatev8siv8qi2_mask */

        case 9:
          if (!
#line 16158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7458; /* avx512f_truncatev8div16qi2_mask */

        case 10:
          if (!
#line 15470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7309; /* *avx512vl_truncatev2div2qi2_mask_1 */

        case 11:
          if (!
#line 15908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7424; /* *avx512vl_truncatev2div2hi2_mask_1 */

        case 12:
          if (!
#line 16054 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7443; /* *avx512vl_truncatev2div2si2_mask_1 */

        case 13:
          if (!
#line 15565 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7333; /* *avx512vl_truncatev4siv4qi2_mask_1 */

        case 14:
          if (!
#line 15565 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7336; /* *avx512vl_truncatev4div4qi2_mask_1 */

        case 15:
          if (!
#line 15817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7403; /* *avx512vl_truncatev4siv4hi2_mask_1 */

        case 16:
          if (!
#line 15817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7406; /* *avx512vl_truncatev4div4hi2_mask_1 */

        case 17:
          if (!(
#line 15663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7363; /* *avx512vl_truncatev8hiv8qi2_mask_1 */

        case 18:
          if (!
#line 15663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7366; /* *avx512vl_truncatev8siv8qi2_mask_1 */

        case 19:
          if (!
#line 16179 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7461; /* *avx512f_truncatev8div16qi2_mask_1 */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern508 (x2))
        {
        case 0:
          if (!
#line 15449 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7307; /* avx512vl_us_truncatev2div2qi2_mask */

        case 1:
          if (!
#line 15891 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7422; /* avx512vl_us_truncatev2div2hi2_mask */

        case 2:
          if (!
#line 16039 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7441; /* avx512vl_us_truncatev2div2si2_mask */

        case 3:
          if (!
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7328; /* avx512vl_us_truncatev4siv4qi2_mask */

        case 4:
          if (!
#line 15544 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7331; /* avx512vl_us_truncatev4div4qi2_mask */

        case 5:
          if (!
#line 15800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7398; /* avx512vl_us_truncatev4siv4hi2_mask */

        case 6:
          if (!
#line 15800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7401; /* avx512vl_us_truncatev4div4hi2_mask */

        case 7:
          if (!(
#line 15642 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7358; /* avx512vl_us_truncatev8hiv8qi2_mask */

        case 8:
          if (!
#line 15642 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7361; /* avx512vl_us_truncatev8siv8qi2_mask */

        case 9:
          if (!
#line 16158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7459; /* avx512f_us_truncatev8div16qi2_mask */

        case 10:
          if (!
#line 15470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7310; /* *avx512vl_us_truncatev2div2qi2_mask_1 */

        case 11:
          if (!
#line 15908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7425; /* *avx512vl_us_truncatev2div2hi2_mask_1 */

        case 12:
          if (!
#line 16054 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7444; /* *avx512vl_us_truncatev2div2si2_mask_1 */

        case 13:
          if (!
#line 15565 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7334; /* *avx512vl_us_truncatev4siv4qi2_mask_1 */

        case 14:
          if (!
#line 15565 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7337; /* *avx512vl_us_truncatev4div4qi2_mask_1 */

        case 15:
          if (!
#line 15817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7404; /* *avx512vl_us_truncatev4siv4hi2_mask_1 */

        case 16:
          if (!
#line 15817 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7407; /* *avx512vl_us_truncatev4div4hi2_mask_1 */

        case 17:
          if (!(
#line 15663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7364; /* *avx512vl_us_truncatev8hiv8qi2_mask_1 */

        case 18:
          if (!
#line 15663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7367; /* *avx512vl_us_truncatev8siv8qi2_mask_1 */

        case 19:
          if (!
#line 16179 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7462; /* *avx512f_us_truncatev8div16qi2_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x2, 1);
      switch (XVECLEN (x5, 0))
        {
        case 4:
          res = recog_276 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_278 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_280 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 2:
          res = recog_281 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 64:
          res = recog_282 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 32:
          res = recog_283 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x4;
      if (XVECLEN (x5, 0) < 1)
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern1414 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !
#line 28336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V8SImode)))
            return -1;
          return 9454; /* *avx_vperm2f128v8si_nozero */

        case E_V8SFmode:
          if (pattern1414 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 28336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V8SFmode)))
            return -1;
          return 9455; /* *avx_vperm2f128v8sf_nozero */

        case E_V4DFmode:
          if (pattern1414 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !
#line 28336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V4DFmode)))
            return -1;
          return 9456; /* *avx_vperm2f128v4df_nozero */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern806 (x2))
        {
        case 0:
          if (!
#line 24145 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8761; /* *avx2_zero_extendv16qiv16hi2_1 */

        case 1:
          if (!
#line 24198 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 8769; /* *avx512bw_zero_extendv32qiv32hi2_1 */

        case 2:
          if (!
#line 24294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8785; /* *sse4_1_zero_extendv8qiv8hi2_3 */

        case 3:
          if (!
#line 24542 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 8821; /* avx512f_zero_extendv16hiv16si2_1 */

        case 4:
          if (!
#line 24596 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8829; /* avx2_zero_extendv8hiv8si2_1 */

        case 5:
          if (!
#line 24701 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8845; /* *sse4_1_zero_extendv4hiv4si2_3 */

        case 6:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25098 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8916; /* *avx512f_zero_extendv8siv8di2_1 */
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9632; /* *vec_concatv16si_0_1 */

        case 7:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25150 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8922; /* *avx2_zero_extendv4siv4di2_1 */
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9633; /* *vec_concatv8si_0_1 */

        case 8:
          if (vector_operand (operands[1], E_V4SImode)
              && pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25235 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 8936; /* *sse4_1_zero_extendv2siv2di2_3 */
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !movq_parallel (operands[3], E_VOIDmode)
              || !
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9634; /* *vec_concatv4si_0_1 */

        case 9:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9635; /* *vec_concatv8di_0_1 */

        case 10:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9636; /* *vec_concatv4di_0_1 */

        case 11:
          if (!
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9637; /* *vec_concatv2di_0_1 */

        case 12:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9638; /* *vec_concatv32hf_0_1 */

        case 13:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9639; /* *vec_concatv16hf_0_1 */

        case 14:
          if (!
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9640; /* *vec_concatv8hf_0_1 */

        case 15:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9641; /* *vec_concatv32bf_0_1 */

        case 16:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9642; /* *vec_concatv16bf_0_1 */

        case 17:
          if (!
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9643; /* *vec_concatv8bf_0_1 */

        case 18:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9644; /* *vec_concatv16sf_0_1 */

        case 19:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9645; /* *vec_concatv8sf_0_1 */

        case 20:
          if (!
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 9646; /* *vec_concatv4sf_0_1 */

        case 21:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9647; /* *vec_concatv8df_0_1 */

        case 22:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9648; /* *vec_concatv4df_0_1 */

        case 23:
          if (!(
#line 29072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9649; /* *vec_concatv2df_0_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BFmode:
      if (GET_MODE (x2) != E_V16BFmode)
        return -1;
      if (register_operand (operands[0], E_V16BFmode)
          && vector_operand (operands[1], E_V16BFmode)
          && vector_operand (operands[2], E_V16BFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3713; /* *andv16bf3 */
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16BFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3768; /* *bit_and_float_vector_all_ones */

    case E_V8BFmode:
      if (GET_MODE (x2) != E_V8BFmode)
        return -1;
      if (register_operand (operands[0], E_V8BFmode)
          && vector_operand (operands[1], E_V8BFmode)
          && vector_operand (operands[2], E_V8BFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3716; /* *andv8bf3 */
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8BFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3769; /* *bit_and_float_vector_all_ones */

    case E_V16HFmode:
      if (GET_MODE (x2) != E_V16HFmode)
        return -1;
      if (register_operand (operands[0], E_V16HFmode)
          && vector_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[2], E_V16HFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3719; /* *andv16hf3 */
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16HFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3771; /* *bit_and_float_vector_all_ones */

    case E_V8HFmode:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      if (register_operand (operands[0], E_V8HFmode)
          && vector_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[2], E_V8HFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3722; /* *andv8hf3 */
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8HFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3772; /* *bit_and_float_vector_all_ones */

    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      if (register_operand (operands[0], E_V8SFmode)
          && vector_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[2], E_V8SFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3725; /* *andv8sf3 */
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8SFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3774; /* *bit_and_float_vector_all_ones */

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (register_operand (operands[0], E_V4SFmode)
          && vector_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[2], E_V4SFmode)
          && 
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 3731; /* *andv4sf3 */
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_operand (operands[1], E_V4SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()))
        return -1;
      return 3775; /* *bit_and_float_vector_all_ones */

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      if (register_operand (operands[0], E_V4DFmode)
          && vector_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[2], E_V4DFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 3737; /* *andv4df3 */
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V4DFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 3777; /* *bit_and_float_vector_all_ones */

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (register_operand (operands[0], E_V2DFmode)
          && vector_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[2], E_V2DFmode)
          && (
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 3743; /* *andv2df3 */
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_operand (operands[1], E_V2DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V2DFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3778; /* *bit_and_float_vector_all_ones */

    case E_V32BFmode:
      if (GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      if (register_operand (operands[0], E_V32BFmode)
          && nonimmediate_operand (operands[2], E_V32BFmode)
          && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3749; /* *andv32bf3 */
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32BFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3767; /* *bit_and_float_vector_all_ones */

    case E_V32HFmode:
      if (GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      if (register_operand (operands[0], E_V32HFmode)
          && nonimmediate_operand (operands[2], E_V32HFmode)
          && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 492 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3752; /* *andv32hf3 */
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !float_vector_all_ones_operand (operands[2], E_V32HFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3770; /* *bit_and_float_vector_all_ones */

    case E_V16SFmode:
      if (GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16SFmode)
          && nonimmediate_operand (operands[2], E_V16SFmode)
          && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 32 != 16)) && 
#line 493 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3755; /* *andv16sf3 */
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !float_vector_all_ones_operand (operands[2], E_V16SFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3773; /* *bit_and_float_vector_all_ones */

    case E_V8DFmode:
      if (GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      if (register_operand (operands[0], E_V8DFmode)
          && nonimmediate_operand (operands[2], E_V8DFmode)
          && (
#line 5432 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 64 != 16)) && 
#line 494 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 3761; /* *andv8df3 */
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !float_vector_all_ones_operand (operands[2], E_V8DFmode)
          || !(
#line 5470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 3776; /* *bit_and_float_vector_all_ones */

    case E_V16SImode:
      if (pattern180 (x2, 
E_V16SImode) != 0
          || !(
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8008; /* *andv16si3 */

    case E_V8SImode:
      if (pattern180 (x2, 
E_V8SImode) != 0
          || !(
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8014; /* *andv8si3 */

    case E_V4SImode:
      if (pattern180 (x2, 
E_V4SImode) != 0
          || !
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4SImode, operands)))
        return -1;
      return 8020; /* *andv4si3 */

    case E_V8DImode:
      if (pattern180 (x2, 
E_V8DImode) != 0
          || !(
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8026; /* *andv8di3 */

    case E_V4DImode:
      if (pattern180 (x2, 
E_V4DImode) != 0
          || !(
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 808 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8032; /* *andv4di3 */

    case E_V2DImode:
      if (pattern180 (x2, 
E_V2DImode) != 0
          || !
#line 18744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (AND, V2DImode, operands)))
        return -1;
      return 8038; /* *andv2di3 */

    case E_V64QImode:
      if (pattern25 (x2, 
E_V64QImode) != 0
          || !(
#line 18846 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8044; /* *andv64qi3 */

    case E_V32QImode:
      if (pattern25 (x2, 
E_V32QImode) != 0
          || !(
#line 18846 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8047; /* *andv32qi3 */

    case E_V16QImode:
      if (pattern25 (x2, 
E_V16QImode) != 0
          || !
#line 18846 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 8050; /* *andv16qi3 */

    case E_V32HImode:
      if (pattern25 (x2, 
E_V32HImode) != 0
          || !(
#line 18846 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8053; /* *andv32hi3 */

    case E_V16HImode:
      if (pattern25 (x2, 
E_V16HImode) != 0
          || !(
#line 18846 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8056; /* *andv16hi3 */

    case E_V8HImode:
      if (pattern25 (x2, 
E_V8HImode) != 0
          || !
#line 18846 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 8059; /* *andv8hi3 */

    case E_V1TImode:
      if (pattern669 (x2, 
E_V1TImode) != 0
          || !
#line 18943 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 8062; /* andv1ti3 */

    default:
      return -1;
    }
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern536 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5865; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5892; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5919; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5946; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5973; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6000; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6027; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6054; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6081; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6108; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6135; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6162; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5868; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5895; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5922; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5949; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5976; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6003; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6030; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6057; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6084; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6111; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6138; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6165; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5871; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5898; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5925; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5952; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5979; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6006; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6033; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6060; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6087; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6114; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6141; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6168; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6933; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6942; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6951; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6960; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6969; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6978; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6987; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6996; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 7005; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7014; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7023; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 7032; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6513; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6540; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6567; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6594; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6621; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6648; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6675; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6702; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6729; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6756; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6783; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6810; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6516; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6543; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6570; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6597; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6624; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6651; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6678; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6705; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6732; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6759; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6786; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6813; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6519; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6546; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6573; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6600; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6627; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6654; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6681; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6708; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6735; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6762; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6789; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6816; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_270 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          switch (pattern326 (x3, 
PLUS))
            {
            case 0:
              if (!
#line 3666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 3185; /* avx_haddv4df3 */

            case 1:
              if (!
#line 3842 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 3193; /* sse3_haddv4sf3 */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern326 (x3, 
MINUS))
            {
            case 0:
              if (!
#line 3666 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 3186; /* avx_hsubv4df3 */

            case 1:
              if (!
#line 3842 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 3194; /* sse3_hsubv4sf3 */

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (GET_MODE (x5) != E_V2SFmode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != VEC_CONCAT
              || GET_MODE (x6) != E_V2SFmode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != VEC_CONCAT
              || GET_MODE (x7) != E_V4SFmode
              || pattern1030 (x7, 
E_V2SFmode, 
VEC_CONCAT) != 0
              || !register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x4) != E_V4SFmode
              || pattern1554 (x3, 
E_SFmode) != 0)
            return -1;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern1815 (x3, 
PLUS) != 0
                  || !
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 3191; /* avx_haddv8sf3 */

            case MINUS:
              if (pattern1815 (x3, 
MINUS) != 0
                  || !
#line 3814 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 3192; /* avx_hsubv8sf3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (pattern408 (x3) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1483 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0
                  || !(
#line 30151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 10106; /* avx512f_si512_si */

            case E_V16SFmode:
              if (pattern1483 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_V16SFmode) != 0
                  || !(
#line 30151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 10107; /* avx512f_ps512_ps */

            case E_V8DFmode:
              if (pattern1483 (x3, 
E_V4DFmode, 
E_V2DFmode, 
E_V8DFmode) != 0
                  || !(
#line 30151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 10108; /* avx512f_pd512_pd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern95 (x3, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode)
          || pattern1848 (x3) != 0
          || !
#line 3705 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 3187; /* *sse3_haddv2df3 */

    case MINUS:
      if (pattern96 (x4, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x7) != E_DFmode
          || pattern1555 (x7, 
E_DFmode) != 0
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!vector_operand (operands[2], E_V2DFmode))
        return -1;
      x6 = XEXP (x4, 1);
      x11 = XEXP (x6, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x7, 1);
      x13 = XEXP (x12, 0);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE3))
        return -1;
      return 3188; /* sse3_hsubv2df3 */

    case FLOAT:
      switch (pattern178 (x3))
        {
        case 0:
          if (!
#line 7678 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4526; /* *avx512fp16_vcvtdq2ph_v4si */

        case 1:
          if (!
#line 7678 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4528; /* *avx512fp16_vcvtqq2ph_v4di */

        case 2:
          if (!
#line 7767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4540; /* *avx512fp16_vcvtqq2ph_v2di */

        case 3:
          if (!
#line 9217 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4989; /* *avx512dq_floatv2div2sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern178 (x3))
        {
        case 0:
          if (!
#line 7678 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4527; /* *avx512fp16_vcvtudq2ph_v4si */

        case 1:
          if (!
#line 7678 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4529; /* *avx512fp16_vcvtuqq2ph_v4di */

        case 2:
          if (!
#line 7767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4541; /* *avx512fp16_vcvtuqq2ph_v2di */

        case 3:
          if (!
#line 9217 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4990; /* *avx512dq_floatunsv2div2sf2 */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_269 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x3) != E_V8HFmode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V4HFmode:
                  if (!const0_operand (operands[2], E_V4HFmode))
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4DFmode:
                      if (!vector_operand (operands[1], E_V4DFmode)
                          || !
#line 8158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4752; /* *avx512fp16_vcvtpd2ph_v4df */

                    case E_V4SFmode:
                      if (!vector_operand (operands[1], E_V4SFmode)
                          || !
#line 8158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4753; /* *avx512fp16_vcvtps2ph_v4sf */

                    default:
                      return -1;
                    }

                case E_V2HFmode:
                  if (!vector_operand (operands[1], E_V2DFmode)
                      || !const0_operand (operands[2], E_V6HFmode)
                      || !
#line 8250 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4759; /* *avx512fp16_vcvtpd2ph_v2df */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V2SFmode
                  || !vector_operand (operands[1], E_V2DFmode)
                  || !const0_operand (operands[2], E_V2SFmode)
                  || !
#line 10146 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 5186; /* *sse2_cvtpd2ps */

            case E_V8BFmode:
              if (pattern177 (x3, 
E_V4BFmode, 
E_V4SFmode, 
E_V8BFmode) != 0
                  || !
#line 31061 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
                return -1;
              return 10347; /* *vcvtneps2bf16_v4sf */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V32BFmode:
              if (pattern792 (x3, 
E_V16SFmode, 
E_V16BFmode, 
E_V32BFmode) != 0
                  || !(
#line 31022 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 10341; /* avx512f_cvtne2ps2bf16_v32bf */

            case E_V16BFmode:
              if (pattern792 (x3, 
E_V8SFmode, 
E_V8BFmode, 
E_V16BFmode) != 0
                  || !(
#line 31022 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10343; /* avx512f_cvtne2ps2bf16_v16bf */

            case E_V8BFmode:
              if (pattern792 (x3, 
E_V4SFmode, 
E_V4BFmode, 
E_V8BFmode) != 0
                  || !(
#line 31022 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 30988 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 10345; /* avx512f_cvtne2ps2bf16_v8bf */

            case E_V32HFmode:
              if (pattern793 (x3, 
E_V16SFmode, 
E_V16HFmode, 
E_V32HFmode) != 0
                  || !(
#line 31719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
                return -1;
              return 10440; /* avx10_2_cvt2ps2phx_v32hf */

            case E_V16HFmode:
              if (pattern793 (x3, 
E_V8SFmode, 
E_V8HFmode, 
E_V16HFmode) != 0
                  || !
#line 31719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10444; /* avx10_2_cvt2ps2phx_v16hf */

            case E_V8HFmode:
              if (pattern793 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !
#line 31719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && 1))
                return -1;
              return 10448; /* avx10_2_cvt2ps2phx_v8hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_271 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || XVECLEN (x7, 0) != 2
          || GET_MODE (x7) != E_V2SImode
          || pattern275 (x3, 
E_V2DFmode, 
E_V4SImode, 
0) != 0
          || !
#line 9604 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 5045; /* *fixuns_truncv2dfv2si2 */

    case FIX:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_VECTOR
          || pattern509 (x7, 
E_V2SImode, 
2) != 0
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 9964 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 5165; /* sse2_cvttpd2dq */

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          res = recog_267 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_268 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          if (XVECLEN (x7, 0) == 1
              && XINT (x7, 1) == 147)
            {
              x14 = XVECEXP (x7, 0, 0);
              if (x14 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  operands[1] = x4;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SImode:
                      if (pattern1031 (x3, 
E_V4SImode, 
E_V8SImode) == 0
                          && 
#line 28824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 9553; /* avx_si256_si */
                      break;

                    case E_V8SFmode:
                      if (pattern1031 (x3, 
E_V4SFmode, 
E_V8SFmode) == 0
                          && 
#line 28824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 9554; /* avx_ps256_ps */
                      break;

                    case E_V4DFmode:
                      if (pattern1031 (x3, 
E_V2DFmode, 
E_V4DFmode) == 0
                          && 
#line 28824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 9555; /* avx_pd256_pd */
                      break;

                    case E_V16SImode:
                      if (pattern1031 (x3, 
E_V8SImode, 
E_V16SImode) == 0
                          && (
#line 30168 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 10109; /* avx512f_si512_256si */
                      break;

                    case E_V16SFmode:
                      if (pattern1031 (x3, 
E_V8SFmode, 
E_V16SFmode) == 0
                          && (
#line 30168 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 10110; /* avx512f_ps512_256ps */
                      break;

                    case E_V8DFmode:
                      if (pattern1031 (x3, 
E_V4DFmode, 
E_V8DFmode) == 0
                          && (
#line 30168 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 10111; /* avx512f_pd512_256pd */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern596 (x3) == 0)
        {
          x5 = XEXP (x4, 0);
          x15 = XVECEXP (x5, 0, 0);
          operands[1] = x15;
          if (memory_operand (operands[1], E_V16QImode))
            {
              x9 = XEXP (x7, 0);
              x16 = XVECEXP (x9, 0, 0);
              if (rtx_equal_p (x16, operands[1])
                  && 
#line 27921 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && ix86_pre_reload_split ()))
                return 9300; /* avx2_lddqu_inserti_to_bcasti */
            }
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      if (rtx_equal_p (x7, operands[1])
          && 
#line 28013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
        return 9318; /* avx_vbroadcastf128_v4di */
      operands[2] = x7;
      if (!nonimm_or_0_operand (operands[2], E_V2DImode)
          || !
#line 28958 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 9615; /* avx_vec_concatv4di */

    case ZERO_EXTEND:
      switch (pattern179 (x3))
        {
        case 0:
          if (!
#line 12110 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 5322; /* *vec_setv2di_0_zero_extendhi_1 */

        case 1:
          if (!
#line 12224 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 5334; /* *vec_setv2di_0_zero_extendsi_1 */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[2] = x7;
          switch (pattern511 (x3))
            {
            case 0:
              if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7283; /* avx512vl_ss_truncatev4div4qi2 */
              break;

            case 1:
              if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7292; /* avx512vl_ss_truncatev4siv4qi2 */
              break;

            case 2:
              if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7286; /* avx512vl_ss_truncatev2div2qi2 */
              break;

            case 3:
              if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7289; /* avx512vl_ss_truncatev8siv8qi2 */
              break;

            case 4:
              if ((
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 7295; /* avx512vl_ss_truncatev8hiv8qi2 */
              break;

            case 5:
              if ((
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15697 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return 7374; /* avx512vl_ss_truncatev4div4hi2 */
              break;

            case 6:
              if (
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7380; /* avx512vl_ss_truncatev4siv4hi2 */
              break;

            case 7:
              if (
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7377; /* avx512vl_ss_truncatev2div2hi2 */
              break;

            case 8:
              if (
#line 15976 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return 7429; /* avx512vl_ss_truncatev2div2si2 */
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != CONST_VECTOR
              || pattern509 (x7, 
E_V8QImode, 
8) != 0)
            return -1;
          x17 = XVECEXP (x7, 0, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x7, 0, 3);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x7, 0, 4);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x7, 0, 5);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x7, 0, 6);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x22 = XVECEXP (x7, 0, 7);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern607 (x3, 
E_V8DImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 16112 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7448; /* avx512f_ss_truncatev8div16qi2 */

        case SS_TRUNCATE:
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern798 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 19225 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 8305; /* sse2_packsswb */

            case E_V8HImode:
              if (pattern798 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 19319 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 8311; /* sse2_packssdw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern511 (x3))
        {
        case 0:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7284; /* avx512vl_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7293; /* avx512vl_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7287; /* avx512vl_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7290; /* avx512vl_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 7296; /* avx512vl_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15697 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 7375; /* avx512vl_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7381; /* avx512vl_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7378; /* avx512vl_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15976 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7430; /* avx512vl_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern512 (x3) != 0
          || !
#line 16112 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 7449; /* avx512f_truncatev8div16qi2 */

    case US_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (pattern511 (x3))
        {
        case 0:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7285; /* avx512vl_us_truncatev4div4qi2 */
          break;

        case 1:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7294; /* avx512vl_us_truncatev4siv4qi2 */
          break;

        case 2:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7288; /* avx512vl_us_truncatev2div2qi2 */
          break;

        case 3:
          if (
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7291; /* avx512vl_us_truncatev8siv8qi2 */
          break;

        case 4:
          if ((
#line 15380 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 7297; /* avx512vl_us_truncatev8hiv8qi2 */
          break;

        case 5:
          if ((
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15697 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 7376; /* avx512vl_us_truncatev4div4hi2 */
          break;

        case 6:
          if (
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7382; /* avx512vl_us_truncatev4siv4hi2 */
          break;

        case 7:
          if (
#line 15735 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7379; /* avx512vl_us_truncatev2div2hi2 */
          break;

        case 8:
          if (
#line 15976 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7431; /* avx512vl_us_truncatev2div2si2 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_V8DImode)
          || pattern512 (x3) != 0
          || !
#line 16112 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 7450; /* avx512f_us_truncatev8div16qi2 */

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern51 (x3))
        {
        case 0:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7514; /* *avx512bw_ssaddv64qi3 */

        case 1:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7522; /* *avx2_ssaddv32qi3 */

        case 2:
          if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands)))
            return -1;
          return 7530; /* *sse2_ssaddv16qi3 */

        case 3:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7538; /* *avx512bw_ssaddv32hi3 */

        case 4:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7546; /* *avx2_ssaddv16hi3 */

        case 5:
          if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands)))
            return -1;
          return 7554; /* *sse2_ssaddv8hi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern194 (x3))
        {
        case 0:
          if (!
#line 22580 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8592; /* avx2_phaddswv16hi3 */

        case 1:
          if (!
#line 22603 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 8596; /* ssse3_phaddswv8hi3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL)
            return -1;
          x11 = XEXP (x3, 1);
          if (GET_CODE (x11) != MULT)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != VEC_SELECT)
            return -1;
          x14 = XEXP (x13, 1);
          if (GET_CODE (x14) != PARALLEL)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != SIGN_EXTEND)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != VEC_SELECT)
            return -1;
          x17 = XEXP (x16, 1);
          if (GET_CODE (x17) != PARALLEL)
            return -1;
          x18 = XEXP (x6, 0);
          operands[1] = x18;
          x19 = XEXP (x9, 0);
          operands[2] = x19;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x16, 0);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 16:
              if (pattern1076 (x7, 
6, 
4, 
2, 
0) != 0)
                return -1;
              x22 = XVECEXP (x7, 0, 4);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              x23 = XVECEXP (x7, 0, 5);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
                return -1;
              x24 = XVECEXP (x7, 0, 6);
              if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
                return -1;
              x25 = XVECEXP (x7, 0, 7);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
                return -1;
              x26 = XVECEXP (x7, 0, 8);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x27 = XVECEXP (x7, 0, 9);
              if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x28 = XVECEXP (x7, 0, 10);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x29 = XVECEXP (x7, 0, 11);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x30 = XVECEXP (x7, 0, 12);
              if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x31 = XVECEXP (x7, 0, 13);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x32 = XVECEXP (x7, 0, 14);
              if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x33 = XVECEXP (x7, 0, 15);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1313 (x10, 
16) != 0)
                return -1;
              x34 = XVECEXP (x10, 0, 8);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x35 = XVECEXP (x10, 0, 9);
              if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x36 = XVECEXP (x10, 0, 10);
              if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x37 = XVECEXP (x10, 0, 11);
              if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x38 = XVECEXP (x10, 0, 12);
              if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x39 = XVECEXP (x10, 0, 13);
              if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x40 = XVECEXP (x10, 0, 14);
              if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x41 = XVECEXP (x10, 0, 15);
              if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 30]
                  || pattern1863 (x14, 
16) != 0)
                return -1;
              x42 = XVECEXP (x14, 0, 8);
              if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x43 = XVECEXP (x14, 0, 9);
              if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x44 = XVECEXP (x14, 0, 10);
              if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x45 = XVECEXP (x14, 0, 11);
              if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x46 = XVECEXP (x14, 0, 12);
              if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x47 = XVECEXP (x14, 0, 13);
              if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x48 = XVECEXP (x14, 0, 14);
              if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x49 = XVECEXP (x14, 0, 15);
              if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1880 (x17, 
16) != 0)
                return -1;
              x50 = XVECEXP (x17, 0, 8);
              if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x51 = XVECEXP (x17, 0, 9);
              if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x52 = XVECEXP (x17, 0, 10);
              if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x53 = XVECEXP (x17, 0, 11);
              if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x54 = XVECEXP (x17, 0, 12);
              if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x55 = XVECEXP (x17, 0, 13);
              if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x56 = XVECEXP (x17, 0, 14);
              if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x57 = XVECEXP (x17, 0, 15);
              if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || pattern1886 (x3, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0
                  || GET_MODE (x8) != E_V16HImode
                  || GET_MODE (x9) != E_V16QImode
                  || !nonimmediate_operand (operands[2], E_V32QImode)
                  || pattern331 (x11, 
E_V16QImode, 
E_V16HImode) != 0
                  || !
#line 22790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8609; /* avx2_pmaddubsw256 */

            case 8:
              if (pattern1314 (x4) != 0
                  || pattern1863 (x14, 
8) != 0
                  || pattern1880 (x17, 
8) != 0
                  || pattern1886 (x3, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0
                  || GET_MODE (x8) != E_V8HImode
                  || GET_MODE (x9) != E_V8QImode
                  || !vector_operand (operands[2], E_V16QImode)
                  || pattern331 (x11, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 22877 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3))
                return -1;
              return 8618; /* ssse3_pmaddubsw128 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern329 (x3))
            {
            case 0:
              if (!
#line 26118 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8990; /* xop_pmacssww */

            case 1:
              if (!
#line 26118 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8992; /* xop_pmacssdd */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern327 (x4) != 0)
            return -1;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 2:
              if (pattern1315 (x3) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V2DImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_MODE (x9) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              switch (pattern1827 (x4))
                {
                case 0:
                  if (!
#line 26137 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8994; /* xop_pmacssdql */

                case 1:
                  if (!
#line 26156 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8996; /* xop_pmacssdqh */

                default:
                  return -1;
                }

            case 4:
              if (pattern1076 (x7, 
7, 
5, 
3, 
1) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              x9 = XEXP (x8, 0);
              x10 = XEXP (x9, 1);
              if (pattern1619 (x10, 
7, 
5, 
3, 
1) != 0
                  || !register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_V4SImode
                  || GET_MODE (x5) != E_V4SImode
                  || GET_MODE (x6) != E_V4HImode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || GET_MODE (x8) != E_V4SImode
                  || GET_MODE (x9) != E_V4HImode
                  || !nonimmediate_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V4SImode)
                  || !
#line 26178 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8998; /* xop_pmacsswd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern330 (x5) != 0)
        return -1;
      x58 = XEXP (x5, 1);
      if (GET_MODE (x58) != E_V4SImode)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != VEC_SELECT
          || GET_MODE (x59) != E_V4HImode)
        return -1;
      x60 = XEXP (x59, 1);
      if (GET_CODE (x60) != PARALLEL
          || XVECLEN (x60, 0) != 4)
        return -1;
      x61 = XVECEXP (x60, 0, 0);
      if (x61 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x62 = XVECEXP (x60, 0, 1);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x63 = XVECEXP (x60, 0, 2);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x64 = XVECEXP (x60, 0, 3);
      if (x64 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_V4SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_V4SImode)
        return -1;
      x19 = XEXP (x9, 0);
      if (GET_CODE (x19) != VEC_SELECT
          || GET_MODE (x19) != E_V4HImode)
        return -1;
      x65 = XEXP (x19, 1);
      if (GET_CODE (x65) != PARALLEL
          || XVECLEN (x65, 0) != 4)
        return -1;
      x66 = XVECEXP (x65, 0, 0);
      if (x66 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x67 = XVECEXP (x65, 0, 1);
      if (x67 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x68 = XVECEXP (x65, 0, 2);
      if (x68 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x69 = XVECEXP (x65, 0, 3);
      if (x69 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x70 = XEXP (x8, 1);
      if (GET_CODE (x70) != SIGN_EXTEND
          || GET_MODE (x70) != E_V4SImode)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != VEC_SELECT
          || GET_MODE (x71) != E_V4HImode)
        return -1;
      x72 = XEXP (x71, 1);
      if (GET_CODE (x72) != PARALLEL
          || XVECLEN (x72, 0) != 4)
        return -1;
      x73 = XVECEXP (x72, 0, 0);
      if (x73 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x74 = XVECEXP (x72, 0, 1);
      if (x74 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x75 = XVECEXP (x72, 0, 2);
      if (x75 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x76 = XVECEXP (x72, 0, 3);
      if (x76 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || pattern1883 (x3) != 0
          || !
#line 26211 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9000; /* xop_pmadcsswd */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17107 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7612; /* *ashrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17121 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7622; /* ashrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28925 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9570; /* avx512vl_ashrvv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17107 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 793 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 7614; /* *ashrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17121 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7623; /* ashrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28925 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9568; /* avx512vl_ashrvv8hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17107 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7616; /* *ashrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17121 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7624; /* ashrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28914 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9558; /* avx2_ashrvv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17107 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7618; /* *ashrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17121 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7625; /* ashrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28914 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 9556; /* avx2_ashrvv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17107 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7620; /* *ashrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 26992 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()))
        return 9056; /* *ashrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 28914 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9562; /* avx2_ashrvv2di */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 788 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7630; /* *ashrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28925 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9572; /* avx512bw_ashrvv32hi */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7632; /* *ashrv4di3 */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 28914 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9564; /* avx2_ashrvv4di */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7634; /* *ashrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28914 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 680 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9560; /* avx512f_ashrvv16si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 789 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7636; /* *ashrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28914 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 682 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 9566; /* avx512f_ashrvv8di */

    case E_V1TImode:
      if (pattern30 (x3) != 0
          || !
#line 17525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return -1;
      return 7701; /* *ashrv1ti3_internal */

    default:
      return -1;
    }
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern180 (x3, 
E_V32HFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2785; /* *mulv32hf3 */

        case E_V16HFmode:
          if (pattern180 (x3, 
E_V16HFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2789; /* *mulv16hf3 */

        case E_V8HFmode:
          if (pattern180 (x3, 
E_V8HFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2793; /* *mulv8hf3 */

        case E_V16SFmode:
          if (pattern180 (x3, 
E_V16SFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2797; /* *mulv16sf3 */

        case E_V8SFmode:
          if (pattern180 (x3, 
E_V8SFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2801; /* *mulv8sf3 */

        case E_V4SFmode:
          if (pattern180 (x3, 
E_V4SFmode) != 0
              || !
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2805; /* *mulv4sf3 */

        case E_V8DFmode:
          if (pattern180 (x3, 
E_V8DFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2809; /* *mulv8df3 */

        case E_V4DFmode:
          if (pattern180 (x3, 
E_V4DFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2813; /* *mulv4df3 */

        case E_V2DFmode:
          if (pattern180 (x3, 
E_V2DFmode) != 0
              || !(
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2817; /* *mulv2df3 */

        case E_V32HImode:
          if (pattern25 (x3, 
E_V32HImode) != 0
              || !(
#line 16398 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7562; /* *mulv32hi3 */

        case E_V16HImode:
          if (pattern25 (x3, 
E_V16HImode) != 0
              || !(
#line 16398 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1) && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7564; /* *mulv16hi3 */

        case E_V8HImode:
          if (pattern25 (x3, 
E_V8HImode) != 0
              || !
#line 16398 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1 && 1))
            return -1;
          return 7566; /* *mulv8hi3 */

        case E_V8DImode:
          if (pattern180 (x3, 
E_V8DImode) != 0
              || !(
#line 16852 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7600; /* *avx512dq_mulv8di3 */

        case E_V4DImode:
          if (pattern180 (x3, 
E_V4DImode) != 0
              || !(
#line 16852 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7602; /* *avx512dq_mulv4di3 */

        case E_V2DImode:
          if (pattern180 (x3, 
E_V2DImode) != 0
              || !(
#line 16852 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7604; /* *avx512dq_mulv2di3 */

        case E_V16SImode:
          if (pattern180 (x3, 
E_V16SImode) != 0
              || !(
#line 16911 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && 1) && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7606; /* *avx512f_mulv16si3 */

        case E_V8SImode:
          if (pattern180 (x3, 
E_V8SImode) != 0
              || !(
#line 16911 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && 1) && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7608; /* *avx2_mulv8si3 */

        case E_V4SImode:
          if (pattern180 (x3, 
E_V4SImode) != 0
              || !
#line 16911 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && 1))
            return -1;
          return 7610; /* *sse4_1_mulv4si3 */

        case E_V32BFmode:
          if (pattern14 (x3, 
E_V32BFmode) != 0
              || !(
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10613; /* avx10_2_mulbf16_v32bf */

        case E_V16BFmode:
          if (pattern14 (x3, 
E_V16BFmode) != 0
              || !
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10621; /* avx10_2_mulbf16_v16bf */

        case E_V8BFmode:
          if (pattern14 (x3, 
E_V8BFmode) != 0
              || !
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10629; /* avx10_2_mulbf16_v8bf */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern192 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 16481 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7580; /* *vec_widen_umult_even_v16si */

        case 1:
          if (!
#line 16517 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7582; /* *vec_widen_umult_even_v8si */

        case 2:
          if (!
#line 16549 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7584; /* *vec_widen_umult_even_v4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern192 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 16597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7586; /* *vec_widen_smult_even_v16si */

        case 1:
          if (!
#line 16633 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7588; /* *vec_widen_smult_even_v8si */

        case 2:
          if (!
#line 16665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7590; /* *sse4_1_mulv2siv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4612; /* avx512fp16_fixuns_truncv8hi2 */

    case 1:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4618; /* avx512fp16_fixuns_truncv16hi2 */

    case 2:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4626; /* avx512fp16_fixuns_truncv32hi2 */

    case 3:
      x2 = XEXP (x1, 1);
      switch (pattern520 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4634; /* avx512fp16_fixuns_truncv8si2 */

        case 1:
          if (!
#line 9581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5040; /* fixuns_truncv8dfv8si2 */

        case 2:
          if (!(
#line 9926 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5159; /* *fixuns_truncv8sfv8si2 */

        default:
          return -1;
        }

    case 4:
      x2 = XEXP (x1, 1);
      switch (pattern519 (x2))
        {
        case 0:
          if (!(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4642; /* avx512fp16_fixuns_truncv16si2 */

        case 1:
          if (!
#line 8786 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4887; /* fixuns_truncv16sfv16si2 */

        default:
          return -1;
        }

    case 5:
      x2 = XEXP (x1, 1);
      switch (pattern520 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4650; /* avx512fp16_fixuns_truncv8di2 */

        case 1:
          if (!(
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5085; /* fixuns_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9755 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5139; /* fixuns_truncv8sfv8di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4676; /* *avx512fp16_fixuns_truncv4si2_load */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9691 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F))
            return -1;
          return 5059; /* fixuns_truncv4dfv4si2 */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 9926 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5161; /* *fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case 7:
      x2 = XEXP (x1, 1);
      switch (pattern521 (x2))
        {
        case 0:
          if (!
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4680; /* *avx512fp16_fixuns_truncv4di2_load */

        case 1:
          if (!(
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5093; /* fixuns_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9755 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5143; /* fixuns_truncv4sfv4di2 */

        default:
          return -1;
        }

    case 8:
      x2 = XEXP (x1, 1);
      switch (pattern522 (x2))
        {
        case 0:
          if (!
#line 7978 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4692; /* *avx512fp16_fixuns_truncv2di2_load */

        case 1:
          if (!(
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5099; /* fixuns_truncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 7918 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4668; /* avx512fp16_fixuns_truncv4si2 */

    case 10:
      if (!
#line 7918 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4672; /* avx512fp16_fixuns_truncv4di2 */

    case 11:
      if (!
#line 7968 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4688; /* avx512fp16_fixuns_truncv2di2 */

    case 12:
      if (!
#line 9778 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 5151; /* avx512dq_fixuns_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (
#line 17680 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7765; /* *avx2_uminv32qi3 */
      if (!(
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7844; /* *avx512bw_uminv32qi3 */

    case 1:
      if (
#line 17680 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7769; /* *avx2_uminv16hi3 */
      if (!(
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7860; /* *avx512bw_uminv16hi3 */

    case 2:
      if (
#line 17680 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7773; /* *avx2_uminv8si3 */
      if (!(
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7788; /* *avx512f_uminv8si3 */

    case 3:
      if (!(
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7780; /* *avx512f_uminv16si3 */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7796; /* *avx512f_uminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7886; /* *sse4_1_uminv4si3 */

    case 5:
      if (!(
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7804; /* *avx512f_uminv8di3 */

    case 6:
      if (!(
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7812; /* *avx512f_uminv4di3 */

    case 7:
      if (!(
#line 17721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7820; /* *avx512f_uminv2di3 */

    case 8:
      if (!(
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7828; /* *avx512bw_uminv64qi3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7836; /* *avx512bw_uminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17927 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7889; /* *uminv16qi3 */

    case 10:
      if (!(
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7852; /* *avx512bw_uminv32hi3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17732 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7868; /* *avx512bw_uminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17908 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7882; /* *sse4_1_uminv8hi3 */

    default:
      return -1;
    }
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern32 (x1))
    {
    case 0:
      if (!
#line 17595 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT
   && ix86_pre_reload_split ()))
        return -1;
      return 7703; /* *rotrv1ti3_internal */

    case 1:
      if (!(
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7740; /* avx512f_rorv16si */

    case 2:
      if (!(
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7744; /* avx512vl_rorv8si */

    case 3:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7748; /* avx512vl_rorv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26624 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9042; /* xop_rotrv4si3 */

    case 4:
      if (!(
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7752; /* avx512f_rorv8di */

    case 5:
      if (!(
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7756; /* avx512vl_rorv4di */

    case 6:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17662 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7760; /* avx512vl_rorv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26624 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9043; /* xop_rotrv2di3 */

    case 7:
      if (!
#line 26624 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9040; /* xop_rotrv16qi3 */

    case 8:
      if (!
#line 26624 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 9041; /* xop_rotrv8hi3 */

    case 9:
      if (!(
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7716; /* avx512f_rorvv16si */

    case 10:
      if (!(
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7720; /* avx512vl_rorvv8si */

    case 11:
      if (!(
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7724; /* avx512vl_rorvv4si */

    case 12:
      if (!(
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7728; /* avx512f_rorvv8di */

    case 13:
      if (!(
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7732; /* avx512vl_rorvv4di */

    case 14:
      if (!(
#line 17652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7736; /* avx512vl_rorvv2di */

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (pattern1147 (x1))
    {
    case 0:
      if (!(
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1867; /* stack_protect_set_1_si_si */

    case 1:
      if (!(
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1869; /* stack_protect_set_1_si_di */

    case 2:
      if (!(
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1868; /* stack_protect_set_1_di_si */

    case 3:
      if (!(
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1870; /* stack_protect_set_1_di_di */

    default:
      return -1;
    }
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 105:
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!push_operand (operands[0], E_TImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3928 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2 && TARGET_APX_PPX))
        return -1;
      return 163; /* push2p_di */

    case 40:
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          if (XWINT (x8, 0) == 0LL)
            {
              res = recog_362 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != NEG
              || GET_MODE (x6) != E_CCOmode
              || GET_MODE (x3) != E_CCOmode)
            return -1;
          operands[2] = x8;
          x10 = XEXP (x4, 0);
          operands[0] = x10;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (pattern1660 (x9, 
E_QImode) != 0
                  || !
#line 14543 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, QImode, operands)
   && mode_signbit_p (QImode, operands[2])))
                return -1;
              return 991; /* *negvqi3 */

            case E_HImode:
              if (pattern1660 (x9, 
E_HImode) != 0
                  || !
#line 14543 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, HImode, operands)
   && mode_signbit_p (HImode, operands[2])))
                return -1;
              return 992; /* *negvhi3 */

            case E_SImode:
              if (pattern1660 (x9, 
E_SImode) != 0
                  || !
#line 14543 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands)
   && mode_signbit_p (SImode, operands[2])))
                return -1;
              return 993; /* *negvsi3 */

            case E_DImode:
              if (pattern1660 (x9, 
E_DImode) != 0
                  || !(
#line 14543 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands)
   && mode_signbit_p (DImode, operands[2])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 994; /* *negvdi3 */

            default:
              return -1;
            }

        case AND:
          x12 = XEXP (x7, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x8, 0) != 0LL)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET
              || GET_MODE (x6) != E_CCCmode
              || GET_MODE (x3) != E_CCCmode)
            return -1;
          x13 = XEXP (x7, 0);
          operands[1] = x13;
          x10 = XEXP (x4, 0);
          operands[0] = x10;
          x9 = XEXP (x4, 1);
          switch (GET_CODE (x9))
            {
            case LSHIFTRT:
              switch (pattern1620 (x1))
                {
                case 0:
                  return 1387; /* lshrsi3_carry */

                case 1:
                  if (!
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 1389; /* lshrdi3_carry */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern1620 (x1))
                {
                case 0:
                  return 1388; /* ashrsi3_carry */

                case 1:
                  if (!
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 1390; /* ashrdi3_carry */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 98:
      if (pattern549 (x1) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1419 (x3, 
E_SImode) != 0
              || !
#line 21734 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1566; /* bmi_bextr_si */

        case E_DImode:
          if (pattern1419 (x3, 
E_DImode) != 0
              || !(
#line 21734 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1567; /* bmi_bextr_di */

        default:
          return -1;
        }

    case 66:
      if (GET_MODE (x3) != E_XFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_XFmode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      if (!scratch_operand (operands[3], E_XFmode)
          || !
#line 24127 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1721; /* atan2xf3 */

    case 67:
      if (pattern550 (x1) != 0
          || !
#line 24430 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1722; /* fyl2xxf3_i387 */

    case 68:
      if (pattern550 (x1) != 0
          || !
#line 24527 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1723; /* fyl2xp1xf3_i387 */

    case 84:
      if (GET_MODE (x3) != E_XFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern813 (x9, 
E_XFmode, 
85, 
2, 
UNSPEC) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_XFmode)
          || pattern1420 (x1) != 0
          || !
#line 24662 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1726; /* fscalexf4_i387 */

    case 93:
      if (GET_MODE (x3) != E_CCZmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!flags_reg_operand (operands[0], E_CCZmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !scratch_operand (operands[3], E_SImode)
              || !
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          return 1883; /* stack_protect_test_1_si */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          return 1884; /* stack_protect_test_1_di */

        default:
          return -1;
        }

    case 63:
      if (pattern551 (x1) != 0
          || !
#line 890 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2057; /* mmx_ieee_maxv2sf3 */

    case 62:
      if (pattern551 (x1) != 0
          || !
#line 890 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2058; /* mmx_ieee_minv2sf3 */

    case 160:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      operands[5] = x6;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != UNSPEC
          || XVECLEN (x14, 0) != 4
          || XINT (x14, 1) != 154)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      operands[0] = x15;
      x16 = XVECEXP (x14, 0, 1);
      operands[2] = x16;
      x17 = XVECEXP (x14, 0, 2);
      operands[4] = x17;
      if (!const1248_operand (operands[4], E_SImode))
        return -1;
      x18 = XVECEXP (x14, 0, 3);
      operands[6] = x18;
      x8 = XVECEXP (x3, 0, 1);
      operands[3] = x8;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x7, operands[6]))
        return -1;
      switch (GET_MODE (operands[5]))
        {
        case E_V16SImode:
          if (!vsib_mem_operator (operands[5], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (x14))
            {
            case E_SImode:
              switch (pattern1769 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9843; /* *avx512f_scattersiv16si */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9867; /* *avx512f_scatterdiv16si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1769 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9855; /* *avx512f_scattersiv16si */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9879; /* *avx512f_scatterdiv16si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V16SFmode:
          if (!vsib_mem_operator (operands[5], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (x14))
            {
            case E_SImode:
              switch (pattern1770 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9844; /* *avx512f_scattersiv16sf */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9868; /* *avx512f_scatterdiv16sf */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1770 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9856; /* *avx512f_scattersiv16sf */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9880; /* *avx512f_scatterdiv16sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1711 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9845; /* *avx512f_scattersiv8di */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9869; /* *avx512f_scatterdiv8di */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9857; /* *avx512f_scattersiv8di */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9881; /* *avx512f_scatterdiv8di */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern1711 (x2, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9846; /* *avx512f_scattersiv8df */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9870; /* *avx512f_scatterdiv8df */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9858; /* *avx512f_scattersiv8df */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9882; /* *avx512f_scatterdiv8df */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern1712 (x2, 
E_V8SImode))
            {
            case 0:
              switch (pattern1818 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9847; /* *avx512f_scattersiv8si */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9871; /* *avx512f_scatterdiv8si */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1818 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9859; /* *avx512f_scattersiv8si */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9883; /* *avx512f_scatterdiv8si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8SFmode:
          switch (pattern1712 (x2, 
E_V8SFmode))
            {
            case 0:
              switch (pattern1819 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9848; /* *avx512f_scattersiv8sf */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9872; /* *avx512f_scatterdiv8sf */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1819 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9860; /* *avx512f_scattersiv8sf */

                case 1:
                  if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9884; /* *avx512f_scatterdiv8sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1714 (x2, 
E_V4DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9849; /* *avx512f_scattersiv4di */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9873; /* *avx512f_scatterdiv4di */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9861; /* *avx512f_scattersiv4di */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9885; /* *avx512f_scatterdiv4di */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern1714 (x2, 
E_V4DFmode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9850; /* *avx512f_scattersiv4df */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9874; /* *avx512f_scatterdiv4df */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9862; /* *avx512f_scattersiv4df */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9886; /* *avx512f_scatterdiv4df */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern1716 (x2, 
E_V4SImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9851; /* *avx512f_scattersiv4si */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9875; /* *avx512f_scatterdiv4si */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9863; /* *avx512f_scattersiv4si */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9887; /* *avx512f_scatterdiv4si */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1716 (x2, 
E_V4SFmode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9852; /* *avx512f_scattersiv4sf */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9876; /* *avx512f_scatterdiv4sf */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9864; /* *avx512f_scattersiv4sf */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9888; /* *avx512f_scatterdiv4sf */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern1716 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9853; /* *avx512f_scattersiv2di */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9877; /* *avx512f_scatterdiv2di */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9865; /* *avx512f_scattersiv2di */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9889; /* *avx512f_scatterdiv2di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern1716 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9854; /* *avx512f_scattersiv2df */

            case 1:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9878; /* *avx512f_scatterdiv2df */

            case 2:
              if (!(
#line 29612 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9866; /* *avx512f_scattersiv2df */

            case 3:
              if (!(
#line 29652 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9890; /* *avx512f_scatterdiv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      if (bt_comparison_operator (x4, E_VOIDmode))
        {
          res = recog_392 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != NE)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ZERO_EXTRACT)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UMIN
              || GET_MODE (x8) != E_QImode)
            return -1;
          x9 = XEXP (x7, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x3, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern338 (x1) != 0
              || GET_MODE (x4) != E_QImode)
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          x12 = XEXP (x8, 1);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_QImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1429 (x3, 
E_SImode) != 0
                  || !
#line 22036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
                return -1;
              return 1590; /* *bmi2_bzhi_si3 */

            case E_DImode:
              if (pattern1429 (x3, 
E_DImode) != 0
                  || !(
#line 22036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1591; /* *bmi2_bzhi_di3 */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 35)
            return -1;
          x14 = XVECEXP (x6, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x10 = XEXP (x3, 2);
          if (GET_CODE (x10) != PC)
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_CODE (x15) != PC)
            return -1;
          x16 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x16) != SET)
            return -1;
          x17 = XEXP (x16, 1);
          if (pattern813 (x17, 
E_SImode, 
46, 
1, 
UNSPEC_VOLATILE) != 0)
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          x18 = XEXP (x16, 0);
          operands[0] = x18;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x19 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x19, operands[0])
              || !
#line 29624 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_RTM))
            return -1;
          return 1969; /* xbegin_1 */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      operands[1] = x4;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x10 = XEXP (x3, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern338 (x1) != 0)
        return -1;
      switch (pattern1568 (x3))
        {
        case 0:
          return 1795; /* *x86_movsicc_0_m1 */

        case 1:
          if (!
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1796; /* *x86_movdicc_0_m1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      res = recog_397 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x5;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x5, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern229 (x8, 
E_CCmode, 
17) != 0
              || GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          switch (pattern1623 (x2))
            {
            case 0:
              if (
#line 12768 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 731; /* *andqi_exthi_1_slp */
              break;

            case 1:
              if (
#line 12768 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 734; /* *andqi_extsi_1_slp */
              break;

            case 2:
              if ((
#line 12768 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 737; /* *andqi_extdi_1_slp */
              break;

            case 3:
              return 755; /* *andqi_exthi_0 */

            case 4:
              return 758; /* *andqi_extsi_0 */

            case 5:
              if (
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 761; /* *andqi_extdi_0 */
              break;

            default:
              break;
            }
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != SUBREG)
            return -1;
          switch (pattern1624 (x2))
            {
            case 0:
              if (!
#line 12801 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 740; /* *andqi_exthi_2_slp */

            case 1:
              if (!
#line 12801 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 743; /* *andqi_extsi_2_slp */

            case 2:
              if (!(
#line 12801 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 746; /* *andqi_extdi_2_slp */

            case 3:
              return 764; /* *andqi_ext2hi_0 */

            case 4:
              return 767; /* *andqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 770; /* *andqi_ext2di_0 */

            default:
              return -1;
            }

        case ROTATE:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern372 (x8) != 0)
            return -1;
          switch (pattern1431 (x2))
            {
            case 0:
              if (!
#line 18942 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1409; /* *btrqi_1 */

            case 1:
              if (!
#line 18942 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1410; /* *btrhi_1 */

            default:
              return -1;
            }

        case CTZ:
          switch (pattern819 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 21118 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT))
                return -1;
              return 1518; /* *ctzsi2_zext */

            case 1:
              if (!
#line 21148 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1519; /* *ctzsi2_zext_falsedep */

            default:
              return -1;
            }

        case CLZ:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x10 = XEXP (x3, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          x8 = XVECEXP (x1, 0, 1);
          switch (pattern818 (x8, pnum_clobbers))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 21557 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT))
                return -1;
              return 1540; /* *clzsi2_lzcnt_zext */

            case 1:
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!nonimmediate_operand (operands[1], E_SImode)
                      || !
#line 21585 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1541; /* *clzsi2_lzcnt_zext_falsedep */

                case E_DImode:
                  if (!nonimmediate_operand (operands[1], E_DImode)
                      || !(
#line 21585 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1542; /* *clzsi2_lzcnt_zext_falsedep */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case POPCOUNT:
          switch (pattern819 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 22382 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
                return -1;
              return 1632; /* *popcountsi2_zext */

            case 1:
              if (!
#line 22416 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1633; /* *popcountsi2_zext_falsedep */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          res = recog_398 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_QImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != LSHIFTRT)
            return -1;
          x10 = XEXP (x3, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern229 (x8, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1527 (x3))
            {
            case 0:
              if (!
#line 19344 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1436; /* *btsi_setncqi */

            case 1:
              if (!(
#line 19344 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1437; /* *btdi_setncqi */

            default:
              return -1;
            }

        case LSHIFTRT:
          x10 = XEXP (x3, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern229 (x8, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1244 (x3))
            {
            case 0:
              if (!
#line 19362 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1438; /* *btsi_setncsi */

            case 1:
              if (!(
#line 19362 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1439; /* *btdi_setncdi */

            default:
              return -1;
            }

        case ASHIFT:
          x9 = XEXP (x5, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (pattern229 (x8, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1246 (x3))
            {
            case 0:
              if (!
#line 22084 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2))
                return -1;
              return 1596; /* *bmi2_bzhi_si3_3 */

            case 1:
              if (!(
#line 22084 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1597; /* *bmi2_bzhi_di3_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern371 (x1, 
-2))
        {
        case 0:
          x12 = XEXP (x4, 1);
          operands[2] = x12;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern946 (x3))
                {
                case 0:
                  if (
#line 18873 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    return 1403; /* *btrsi */
                  break;

                case 1:
                  if ((
#line 18873 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1404; /* *btrdi */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x12) != SUBREG)
            return -1;
          switch (pattern1329 (x3))
            {
            case 0:
              if (!
#line 18892 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1405; /* *btrsi_mask */

            case 1:
              if (!(
#line 18892 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1406; /* *btrdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18920 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1407; /* *btrsi_mask_1 */

        case 2:
          if (!(
#line 18920 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1408; /* *btrdi_mask_1 */

        default:
          return -1;
        }

    case NEG:
      x8 = XVECEXP (x1, 0, 1);
      if (pattern372 (x8) != 0)
        return -1;
      switch (pattern952 (x2))
        {
        case 0:
          if (!
#line 21761 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1570; /* *bmi_blsi_si */

        case 1:
          if (!(
#line 21761 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1571; /* *bmi_blsi_di */

        default:
          return -1;
        }

    case PLUS:
      x12 = XEXP (x4, 1);
      if (GET_CODE (x12) != CONST_INT
          || pattern338 (x1) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          switch (XWINT (x12, 0))
            {
            case -1LL:
              switch (pattern1328 (x3))
                {
                case 0:
                  if (!
#line 21906 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  return 1582; /* *bmi_blsr_si */

                case 1:
                  if (!(
#line 21906 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1583; /* *bmi_blsr_di */

                case 2:
                  if (!
#line 22277 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1622; /* *tbm_tzmsk_si */

                case 3:
                  if (!(
#line 22277 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1623; /* *tbm_tzmsk_di */

                default:
                  return -1;
                }

            case 1LL:
              switch (pattern1328 (x3))
                {
                case 0:
                  if (!
#line 22168 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1606; /* *tbm_blcfill_si */

                case 1:
                  if (!(
#line 22168 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1607; /* *tbm_blcfill_di */

                case 2:
                  if (!
#line 22196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1610; /* *tbm_blcic_si */

                case 3:
                  if (!(
#line 22196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_TBM) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1611; /* *tbm_blcic_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          x9 = XEXP (x5, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x12, 0) != -1LL)
            return -1;
          switch (pattern1246 (x3))
            {
            case 0:
              if (!
#line 22070 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2))
                return -1;
              return 1594; /* *bmi2_bzhi_si3_2 */

            case 1:
              if (!(
#line 22070 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1595; /* *bmi2_bzhi_di3_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS
          || pattern693 (x5) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x13 = XEXP (x8, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 17
          || GET_MODE (x13) != E_CCmode)
        return -1;
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x5, 0);
      x14 = XEXP (x9, 1);
      operands[2] = x14;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !
#line 22116 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2))
        return -1;
      return 1599; /* *bmi2_bzhi_zero_extendsidi_5 */

    default:
      return -1;
    }
}

 int
recog_414 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17
              || GET_MODE (x7) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 22311 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT))
                return -1;
              return 1626; /* popcountsi2 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 22311 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1627; /* popcountdi2 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 22516 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT && true))
                return -1;
              return 1639; /* popcounthi2 */

            default:
              return -1;
            }

        case UNSPEC:
          switch (pattern704 (x1))
            {
            case 0:
              if (
#line 22342 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT))
                return 1628; /* *popcountsi2_falsedep_nf */
              if (pnum_clobbers == NULL
                  || !
#line 22361 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT))
                return -1;
              *pnum_clobbers = 1;
              return 1630; /* *popcountsi2_falsedep */

            case 1:
              if ((
#line 22342 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1629; /* *popcountdi2_falsedep_nf */
              if (pnum_clobbers == NULL
                  || !(
#line 22361 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1631; /* *popcountdi2_falsedep */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern229 (x6, 
E_CCmode, 
17) != 0
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !
#line 22481 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()))
        return -1;
      return 1636; /* *popcounthi2_1 */

    default:
      return -1;
    }
}

 int
recog_423 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (!register_operand (x4, E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case SMUL_HIGHPART:
      if (pattern826 (x1) != 0
          || !
#line 11150 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 631; /* *smulsi3_highpart_zext */

    case UMUL_HIGHPART:
      if (pattern826 (x1) != 0
          || !
#line 11150 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 632; /* *umulsi3_highpart_zext */

    case TRUNCATE:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER
          || pattern828 (x1) != 0)
        return -1;
      x10 = XEXP (x7, 0);
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x7, 1);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x9, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 11198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 635; /* *smulsi3_highpart_zext */

        case ZERO_EXTEND:
          if (GET_CODE (x11) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 11198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 636; /* *umulsi3_highpart_zext */

        default:
          return -1;
        }

    case DIV:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != MOD
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[0] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1632 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11485 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 643; /* divmodsi4_zext_1 */

        case 1:
          if (!
#line 11684 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 655; /* *divmodsi4_zext_1 */

        case 2:
          if (!
#line 11880 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 673; /* *divmodsi4_noext_zext_1 */

        default:
          return -1;
        }

    case UDIV:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != UMOD
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[0] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1572 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11521 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 644; /* udivmodsi4_zext_1 */

        case 1:
          if (!
#line 11719 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 656; /* *udivmodsi4_zext_1 */

        case 2:
          if (!
#line 11880 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 674; /* *udivmodsi4_noext_zext_1 */

        case 3:
          if (!
#line 11741 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          return 657; /* *udivmodsi4_pow2_zext_1 */

        default:
          return -1;
        }

    case MOD:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != DIV
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[1] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern1632 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11544 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 645; /* divmodsi4_zext_2 */

        case 1:
          if (!
#line 11767 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 658; /* *divmodsi4_zext_2 */

        case 2:
          if (!
#line 11894 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 675; /* *divmodsi4_noext_zext_2 */

        default:
          return -1;
        }

    case UMOD:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != UDIV
          || GET_MODE (x15) != E_SImode)
        return -1;
      operands[1] = x4;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[3] = x16;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern1572 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 11581 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 646; /* udivmodsi4_zext_2 */

        case 1:
          if (!
#line 11803 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 659; /* *udivmodsi4_zext_2 */

        case 2:
          if (!
#line 11894 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 676; /* *udivmodsi4_noext_zext_2 */

        case 3:
          if (!
#line 11825 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          return 660; /* *udivmodsi4_pow2_zext_2 */

        default:
          return -1;
        }

    case CTZ:
      if (pattern827 (x1) != 0
          || !
#line 21201 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      return 1523; /* *ctzsidi2_uext_falsedep */

    case CLZ:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 38)
        return -1;
      x17 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      operands[0] = x4;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x19 = XVECEXP (x9, 0, 0);
      switch (pattern1422 (x19))
        {
        case 0:
          if (!
#line 21621 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1544; /* *clzsi2_lzcnt_zext_2_falsedep */

        case 1:
          if (!(
#line 21621 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1545; /* *clzsi2_lzcnt_zext_2_falsedep */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pattern827 (x1) != 0
          || !
#line 22464 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
        return -1;
      return 1635; /* *popcountsi2_zext_2_falsedep */

    default:
      return -1;
    }
}

 int
recog_436 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case COMPARE:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_15 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_19 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      res = recog_21 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LSHIFTRT:
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFTRT:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FLOAT_EXTEND:
      res = recog_29 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FLOAT_TRUNCATE:
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FIX:
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSIGNED_FIX:
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FLOAT:
      res = recog_33 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSIGNED_FLOAT:
      res = recog_34 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case AND:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NOT:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NEG:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ABS:
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFT:
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATE:
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case POPCOUNT:
      res = recog_51 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case BSWAP:
      if (GET_MODE (x2) == E_HImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (nonimmediate_operand (operands[1], E_HImode)
              && nonimmediate_operand (operands[0], E_HImode)
              && 
#line 22595 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_MOVBE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return 1644; /* *bswaphi2_movbe */
          if (register_operand (operands[1], E_HImode)
              && register_operand (operands[0], E_HImode)
              && 
#line 22614 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_MOVBE))
            return 1645; /* *bswaphi2 */
        }
      break;

    case PLUS:
    case MINUS:
    case MULT:
    case DIV:
      res = recog_58 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SQRT:
      res = recog_354 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMAX:
      switch (pattern9 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 26723 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return 1815; /* smaxsf3 */
          break;

        case 1:
          if (
#line 26723 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return 1817; /* smaxdf3 */
          break;

        case 2:
          if (
#line 26737 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return 1819; /* smaxhf3 */
          break;

        case 3:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1835; /* *smaxti3_doubleword */
            }
          break;

        case 4:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1839; /* *smaxqi3_1 */
            }
          break;

        case 5:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1843; /* *smaxhi3_1 */
            }
          break;

        case 6:
          if (
#line 3659 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2168; /* smaxv8qi3 */
          break;

        case 7:
          if (
#line 3659 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2170; /* smaxv2si3 */
          break;

        case 8:
          if (
#line 3684 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (SMAX, V4HImode, operands)))
            return 2172; /* *mmx_smaxv4hi3 */
          break;

        case 9:
          if (
#line 3708 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2174; /* smaxv4qi3 */
          break;

        case 10:
          if (
#line 3708 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2176; /* smaxv2qi3 */
          break;

        case 11:
          if (
#line 3724 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2178; /* smaxv2hi3 */
          break;

        default:
          break;
        }
      break;

    case SMIN:
      switch (pattern9 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 26723 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
            return 1816; /* sminsf3 */
          break;

        case 1:
          if (
#line 26723 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
            return 1818; /* smindf3 */
          break;

        case 2:
          if (
#line 26737 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return 1820; /* sminhf3 */
          break;

        case 3:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1836; /* *sminti3_doubleword */
            }
          break;

        case 4:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1840; /* *sminqi3_1 */
            }
          break;

        case 5:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1844; /* *sminhi3_1 */
            }
          break;

        case 6:
          if (
#line 3659 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2169; /* sminv8qi3 */
          break;

        case 7:
          if (
#line 3659 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2171; /* sminv2si3 */
          break;

        case 8:
          if (
#line 3684 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (SMIN, V4HImode, operands)))
            return 2173; /* *mmx_sminv4hi3 */
          break;

        case 9:
          if (
#line 3708 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2175; /* sminv4qi3 */
          break;

        case 10:
          if (
#line 3708 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2177; /* sminv2qi3 */
          break;

        case 11:
          if (
#line 3724 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2179; /* sminv2hi3 */
          break;

        default:
          break;
        }
      break;

    case UMAX:
      switch (pattern10 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1837; /* *umaxti3_doubleword */
            }
          break;

        case 1:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1841; /* *umaxqi3_1 */
            }
          break;

        case 2:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1845; /* *umaxhi3_1 */
            }
          break;

        case 3:
          if (
#line 3737 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2180; /* umaxv4hi3 */
          break;

        case 4:
          if (
#line 3737 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2182; /* umaxv2si3 */
          break;

        case 5:
          if (
#line 3762 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (UMAX, V8QImode, operands)))
            return 2184; /* *mmx_umaxv8qi3 */
          break;

        case 6:
          if (
#line 3786 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2186; /* umaxv4qi3 */
          break;

        case 7:
          if (
#line 3786 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2188; /* umaxv2qi3 */
          break;

        case 8:
          if (
#line 3799 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2190; /* umaxv2hi3 */
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern10 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1838; /* *uminti3_doubleword */
            }
          break;

        case 1:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1842; /* *uminqi3_1 */
            }
          break;

        case 2:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1846; /* *uminhi3_1 */
            }
          break;

        case 3:
          if (
#line 3737 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2181; /* uminv4hi3 */
          break;

        case 4:
          if (
#line 3737 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2183; /* uminv2si3 */
          break;

        case 5:
          if (
#line 3762 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ix86_binary_operator_ok (UMIN, V8QImode, operands)))
            return 2185; /* *mmx_uminv8qi3 */
          break;

        case 6:
          if (
#line 3786 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2187; /* uminv4qi3 */
          break;

        case 7:
          if (
#line 3786 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2189; /* uminv2qi3 */
          break;

        case 8:
          if (
#line 3799 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2191; /* uminv2hi3 */
          break;

        default:
          break;
        }
      break;

    case UNSPEC_VOLATILE:
      res = recog_59 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_CONCAT:
      res = recog_60 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_MERGE:
      res = recog_61 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_SELECT:
      res = recog_63 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_DUPLICATE:
      res = recog_64 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SS_PLUS:
      res = recog_65 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (
#line 3323 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_PLUS, V8QImode, operands)))
            return 2139; /* *mmx_usaddv8qi3 */
          break;

        case 1:
          if (
#line 3323 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_PLUS, V4HImode, operands)))
            return 2143; /* *mmx_usaddv4hi3 */
          break;

        case 2:
          if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2147; /* usaddv4qi3 */
          break;

        case 3:
          if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2151; /* usaddv2qi3 */
          break;

        case 4:
          if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2155; /* usaddv2hi3 */
          break;

        default:
          break;
        }
      break;

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern45 (x2))
            {
            case 0:
              if (
#line 3323 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (SS_MINUS, V8QImode, operands)))
                return 2140; /* *mmx_sssubv8qi3 */
              break;

            case 1:
              if (
#line 3323 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (SS_MINUS, V4HImode, operands)))
                return 2144; /* *mmx_sssubv4hi3 */
              break;

            case 2:
              if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return 2148; /* sssubv4qi3 */
              break;

            case 3:
              if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return 2152; /* sssubv2qi3 */
              break;

            case 4:
              if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return 2156; /* sssubv2hi3 */
              break;

            default:
              break;
            }
          break;

        case VEC_SELECT:
          if (pattern101 (x2) == 0
              && 
#line 22628 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
            return 8602; /* ssse3_phsubswv4hi3 */
          break;

        default:
          break;
        }
      break;

    case US_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (
#line 3323 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_MINUS, V8QImode, operands)))
            return 2141; /* *mmx_ussubv8qi3 */
          break;

        case 1:
          if (
#line 3323 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (US_MINUS, V4HImode, operands)))
            return 2145; /* *mmx_ussubv4hi3 */
          break;

        case 2:
          if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2149; /* ussubv4qi3 */
          break;

        case 3:
          if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2153; /* ussubv2qi3 */
          break;

        case 4:
          if (
#line 3339 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return 2157; /* ussubv2hi3 */
          break;

        default:
          break;
        }
      break;

    case TRUNCATE:
      res = recog_66 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FMA:
      res = recog_67 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SS_TRUNCATE:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 15413 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7299; /* *avx512vl_ss_truncatev2div2qi2_store_1 */
          break;

        case 1:
          if (
#line 15508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7314; /* *avx512vl_ss_truncatev4siv4qi2_store_1 */
          break;

        case 2:
          if (
#line 15508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7317; /* *avx512vl_ss_truncatev4div4qi2_store_1 */
          break;

        case 3:
          if ((
#line 15606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 7344; /* *avx512vl_ss_truncatev8hiv8qi2_store_1 */
          break;

        case 4:
          if (
#line 15606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7347; /* *avx512vl_ss_truncatev8siv8qi2_store_1 */
          break;

        case 5:
          if (
#line 16122 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 7451; /* *avx512f_ss_truncatev8div16qi2_store_1 */
          break;

        case 6:
          if (
#line 15768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7384; /* *avx512vl_ss_truncatev4siv4hi2_store_1 */
          break;

        case 7:
          if (
#line 15768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7387; /* *avx512vl_ss_truncatev4div4hi2_store_1 */
          break;

        case 8:
          if (
#line 15859 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7414; /* *avx512vl_ss_truncatev2div2hi2_store_1 */
          break;

        case 9:
          if (
#line 16009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7433; /* *avx512vl_ss_truncatev2div2si2_store_1 */
          break;

        default:
          break;
        }
      break;

    case US_TRUNCATE:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 15413 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7301; /* *avx512vl_us_truncatev2div2qi2_store_1 */
          break;

        case 1:
          if (
#line 15508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7316; /* *avx512vl_us_truncatev4siv4qi2_store_1 */
          break;

        case 2:
          if (
#line 15508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7319; /* *avx512vl_us_truncatev4div4qi2_store_1 */
          break;

        case 3:
          if ((
#line 15606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 7346; /* *avx512vl_us_truncatev8hiv8qi2_store_1 */
          break;

        case 4:
          if (
#line 15606 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7349; /* *avx512vl_us_truncatev8siv8qi2_store_1 */
          break;

        case 5:
          if (
#line 16122 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 7453; /* *avx512f_us_truncatev8div16qi2_store_1 */
          break;

        case 6:
          if (
#line 15768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7386; /* *avx512vl_us_truncatev4siv4hi2_store_1 */
          break;

        case 7:
          if (
#line 15768 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7389; /* *avx512vl_us_truncatev4div4hi2_store_1 */
          break;

        case 8:
          if (
#line 15859 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7416; /* *avx512vl_us_truncatev2div2hi2_store_1 */
          break;

        case 9:
          if (
#line 16009 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return 7435; /* *avx512vl_us_truncatev2div2si2_store_1 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_XImode:
      if (nonimmediate_operand (operands[0], E_XImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_XImode)
          && 
#line 2453 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))))
        return 92; /* *movxi_internal_avx512f */
      break;

    case E_OImode:
      if (nonimmediate_operand (operands[0], E_OImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_OImode)
          && 
#line 2476 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))))
        return 93; /* *movoi_internal_avx */
      break;

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && address_no_seg_operand (operands[1], E_SImode)
          && 
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 264; /* *leasi */
      break;

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && address_no_seg_operand (operands[1], E_DImode)
          && (
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 265; /* *leadi */
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_68 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_76 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case COMPARE:
      res = recog_77 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      res = recog_81 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      res = recog_82 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_84 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IF_THEN_ELSE:
      res = recog_87 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_88 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMUL_HIGHPART:
      switch (pattern15 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 627; /* smulsi3_highpart */
            }
          break;

        case 1:
          if (
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 629; /* smuldi3_highpart */
            }
          break;

        default:
          break;
        }
      break;

    case UMUL_HIGHPART:
      switch (pattern15 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 628; /* umulsi3_highpart */
            }
          break;

        case 1:
          if (
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            {
              *pnum_clobbers = 2;
              return 630; /* umuldi3_highpart */
            }
          break;

        default:
          break;
        }
      break;

    case TRUNCATE:
      res = recog_89 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case AND:
      res = recog_91 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NOT:
      res = recog_92 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NEG:
      res = recog_93 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ABS:
      res = recog_94 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFT:
      res = recog_96 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LSHIFTRT:
      res = recog_98 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ASHIFTRT:
      res = recog_100 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_101 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATE:
      res = recog_102 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      res = recog_103 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_105 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_106 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_110 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CALL:
      res = recog_111 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FFS:
      if (pnum_clobbers != NULL
          && GET_MODE (x2) == E_SImode)
        {
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 20965 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_CMOVE))
                {
                  *pnum_clobbers = 2;
                  return 1507; /* ffssi2_no_cmove */
                }
            }
        }
      break;

    case CTZ:
      res = recog_112 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_113 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CLZ:
      res = recog_114 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case POPCOUNT:
      res = recog_115 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case BSWAP:
      res = recog_355 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTRACT:
      res = recog_116 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMAX:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1831; /* *smaxdi3_doubleword */
            }
          if ((
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1851; /* *smaxdi3_1 */
            }
          break;

        case 1:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1847; /* *smaxsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case SMIN:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1832; /* *smindi3_doubleword */
            }
          if ((
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1852; /* *smindi3_1 */
            }
          break;

        case 1:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1848; /* *sminsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case UMAX:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1833; /* *umaxdi3_doubleword */
            }
          if ((
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1853; /* *umaxdi3_1 */
            }
          break;

        case 1:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1849; /* *umaxsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern21 (x1, pnum_clobbers))
        {
        case 0:
          if ((
#line 26900 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1834; /* *umindi3_doubleword */
            }
          if ((
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1854; /* *umindi3_1 */
            }
          break;

        case 1:
          if (
#line 26958 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 1850; /* *uminsi3_1 */
            }
          break;

        default:
          break;
        }
      break;

    case UNSPEC_VOLATILE:
      res = recog_117 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_SELECT:
      res = recog_120 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case FIX:
      switch (pattern24 (x1))
        {
        case 0:
          if (
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4702; /* avx512fp16_fix_truncsi2 */
          break;

        case 1:
          if (
#line 8608 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4804; /* sse_cvttss2si */
          break;

        case 2:
          if (
#line 9154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4945; /* sse2_cvttsd2si */
          break;

        case 3:
          if ((
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4706; /* avx512fp16_fix_truncdi2 */
          break;

        case 4:
          if ((
#line 8608 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4806; /* sse_cvttss2siq */
          break;

        case 5:
          if ((
#line 9154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4947; /* sse2_cvttsd2siq */
          break;

        case 6:
          if (
#line 8011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4710; /* avx512fp16_fix_truncsi2_mem */
          break;

        case 7:
          if ((
#line 8011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4712; /* avx512fp16_fix_truncdi2_mem */
          break;

        default:
          break;
        }
      break;

    case UNSIGNED_FIX:
      switch (pattern24 (x1))
        {
        case 0:
          if (
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4704; /* avx512fp16_fixuns_truncsi2 */
          break;

        case 1:
          if (
#line 9059 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 4919; /* avx512f_vcvttss2usi */
          break;

        case 2:
          if (
#line 9095 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 4931; /* avx512f_vcvttsd2usi */
          break;

        case 3:
          if ((
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4708; /* avx512fp16_fixuns_truncdi2 */
          break;

        case 4:
          if ((
#line 9059 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4921; /* avx512f_vcvttss2usiq */
          break;

        case 5:
          if ((
#line 9095 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4933; /* avx512f_vcvttsd2usiq */
          break;

        case 6:
          if (
#line 8011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return 4711; /* avx512fp16_fixuns_truncsi2_mem */
          break;

        case 7:
          if ((
#line 8011 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 4713; /* avx512fp16_fixuns_truncdi2_mem */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  res = recog_324 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  switch (GET_CODE (x2))
    {
    case VEC_MERGE:
      return recog_321 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_317 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_318 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_319 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_345 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_332 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_350 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_338 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_341 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_342 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_353 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_325 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_331 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_337 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_336 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_340 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_326 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_348 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_320 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_322 (x1, insn, pnum_clobbers);

    case AND:
    case IOR:
    case XOR:
    case NOT:
      return recog_344 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      operands[0] = x3;
      switch (pattern50 (x2))
        {
        case 0:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7227; /* *avx512f_ss_truncatev16siv16qi2 */

        case 1:
          if (!(
#line 15263 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15237 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7269; /* *avx512vl_ss_truncatev16hiv16qi2 */

        case 2:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7230; /* *avx512f_ss_truncatev16siv16hi2 */

        case 3:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7233; /* *avx512f_ss_truncatev8div8si2 */

        case 4:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7236; /* *avx512f_ss_truncatev8div8hi2 */

        case 5:
          if (!
#line 15263 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7266; /* *avx512vl_ss_truncatev8siv8hi2 */

        case 6:
          if (!
#line 15174 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7256; /* avx512bw_ss_truncatev32hiv32qi2 */

        case 7:
          if (!
#line 15263 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7263; /* *avx512vl_ss_truncatev4div4si2 */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_339 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      operands[0] = x3;
      switch (pattern50 (x2))
        {
        case 0:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7229; /* *avx512f_us_truncatev16siv16qi2 */

        case 1:
          if (!(
#line 15263 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15237 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7271; /* *avx512vl_us_truncatev16hiv16qi2 */

        case 2:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7232; /* *avx512f_us_truncatev16siv16hi2 */

        case 3:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7235; /* *avx512f_us_truncatev8div8si2 */

        case 4:
          if (!
#line 15001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7238; /* *avx512f_us_truncatev8div8hi2 */

        case 5:
          if (!
#line 15263 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7268; /* *avx512vl_us_truncatev8siv8hi2 */

        case 6:
          if (!
#line 15174 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7258; /* avx512bw_us_truncatev32hiv32qi2 */

        case 7:
          if (!
#line 15263 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7265; /* *avx512vl_us_truncatev4div4si2 */

        default:
          return -1;
        }

    case SS_PLUS:
      return recog_323 (x1, insn, pnum_clobbers);

    case US_PLUS:
      operands[0] = x3;
      switch (pattern51 (x2))
        {
        case 0:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7516; /* *avx512bw_usaddv64qi3 */

        case 1:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7524; /* *avx2_usaddv32qi3 */

        case 2:
          if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V16QImode, operands)))
            return -1;
          return 7532; /* *sse2_usaddv16qi3 */

        case 3:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7540; /* *avx512bw_usaddv32hi3 */

        case 4:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7548; /* *avx2_usaddv16hi3 */

        case 5:
          if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_PLUS, V8HImode, operands)))
            return -1;
          return 7556; /* *sse2_usaddv8hi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern51 (x2))
            {
            case 0:
              if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7518; /* *avx512bw_sssubv64qi3 */

            case 1:
              if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7526; /* *avx2_sssubv32qi3 */

            case 2:
              if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V16QImode, operands)))
                return -1;
              return 7534; /* *sse2_sssubv16qi3 */

            case 3:
              if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7542; /* *avx512bw_sssubv32hi3 */

            case 4:
              if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7550; /* *avx2_sssubv16hi3 */

            case 5:
              if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (SS_MINUS, V8HImode, operands)))
                return -1;
              return 7558; /* *sse2_sssubv8hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          switch (pattern194 (x2))
            {
            case 0:
              if (!
#line 22580 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8594; /* avx2_phsubswv16hi3 */

            case 1:
              if (!
#line 22603 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSSE3))
                return -1;
              return 8598; /* ssse3_phsubswv8hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_MINUS:
      operands[0] = x3;
      switch (pattern51 (x2))
        {
        case 0:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7520; /* *avx512bw_ussubv64qi3 */

        case 1:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 739 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7528; /* *avx2_ussubv32qi3 */

        case 2:
          if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)))
            return -1;
          return 7536; /* *sse2_ussubv16qi3 */

        case 3:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7544; /* *avx512bw_ussubv32hi3 */

        case 4:
          if (!(
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 740 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7552; /* *avx2_ussubv16hi3 */

        case 5:
          if (!
#line 16331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)))
            return -1;
          return 7560; /* *sse2_ussubv8hi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_327 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_329 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_328 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_352 (x1, insn, pnum_clobbers);

    case ROTATERT:
      return recog_351 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_347 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_346 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_335 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_343 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_333 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_330 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_349 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      return recog_334 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_36 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (promotable_binary_operator (operands[3], E_VOIDmode)
      && pattern338 (x1) == 0
      && general_reg_operand (operands[0], E_VOIDmode))
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_VOIDmode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (aligned_operand (operands[2], E_VOIDmode)
              && 
#line 27650 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && ((GET_MODE (operands[0]) == HImode
	&& ((optimize_function_for_speed_p (cfun) && !TARGET_FAST_PREFIX)
            /* ??? next two lines just !satisfies_constraint_K (...) */
	    || !CONST_INT_P (operands[2])
	    || satisfies_constraint_K (operands[2])))
       || (GET_MODE (operands[0]) == QImode
	   && (TARGET_PROMOTE_QImode || optimize_function_for_size_p (cfun))))))
            return gen_split_983 (insn, operands);
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return NULL;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return NULL;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (GET_MODE (x3) != E_V2QImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_V2QImode)
          && general_reg_operand (operands[0], E_V2QImode)
          && general_reg_operand (operands[2], E_V2QImode)
          && 
#line 3260 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
        return gen_split_1048 (insn, operands);
      if (!sse_reg_operand (operands[1], E_V2QImode)
          || !sse_reg_operand (operands[0], E_V2QImode)
          || !sse_reg_operand (operands[2], E_V2QImode)
          || !
#line 3294 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_1050 (insn, operands);

    case MINUS:
      if (GET_MODE (x3) != E_V2QImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_V2QImode)
          && general_reg_operand (operands[0], E_V2QImode)
          && general_reg_operand (operands[2], E_V2QImode)
          && 
#line 3260 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
        return gen_split_1049 (insn, operands);
      if (!sse_reg_operand (operands[1], E_V2QImode)
          || !sse_reg_operand (operands[0], E_V2QImode)
          || !sse_reg_operand (operands[2], E_V2QImode)
          || !
#line 3294 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_1051 (insn, operands);

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern1250 (x3, 
E_V2QImode) != 0
              || !
#line 4009 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
            return NULL;
          return gen_split_1059 (insn, operands);

        case E_QImode:
          if (pattern1340 (x3, 
E_QImode) != 0
              || !
#line 2292 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1224 (insn, operands);

        case E_HImode:
          if (pattern1340 (x3, 
E_HImode) != 0
              || !
#line 2292 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1226 (insn, operands);

        case E_SImode:
          if (pattern1340 (x3, 
E_SImode) != 0
              || !(
#line 2292 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1228 (insn, operands);

        case E_DImode:
          if (pattern1340 (x3, 
E_DImode) != 0
              || !(
#line 2292 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1230 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NOT:
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4QImode:
              if (GET_MODE (x3) != E_V4QImode
                  || GET_MODE (x4) != E_V4QImode)
                return NULL;
              if (general_reg_operand (operands[0], E_V4QImode)
                  && general_reg_operand (operands[1], E_V4QImode)
                  && general_reg_operand (operands[2], E_V4QImode))
                {
                  if (
#line 4622 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_BMI && reload_completed))
                    return gen_split_1075 (insn, operands);
                  if (
#line 4639 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_BMI && reload_completed))
                    return gen_split_1078 (insn, operands);
                }
              if (!sse_reg_operand (operands[0], E_V4QImode)
                  || !sse_reg_operand (operands[1], E_V4QImode)
                  || !sse_reg_operand (operands[2], E_V4QImode)
                  || !
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_1081 (insn, operands);

            case E_V2QImode:
              if (GET_MODE (x3) != E_V2QImode
                  || GET_MODE (x4) != E_V2QImode)
                return NULL;
              if (general_reg_operand (operands[0], E_V2QImode)
                  && general_reg_operand (operands[1], E_V2QImode)
                  && general_reg_operand (operands[2], E_V2QImode))
                {
                  if (
#line 4622 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_BMI && reload_completed))
                    return gen_split_1076 (insn, operands);
                  if (
#line 4639 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_BMI && reload_completed))
                    return gen_split_1079 (insn, operands);
                }
              if (!sse_reg_operand (operands[0], E_V2QImode)
                  || !sse_reg_operand (operands[1], E_V2QImode)
                  || !sse_reg_operand (operands[2], E_V2QImode)
                  || !
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_1082 (insn, operands);

            case E_V2HImode:
              if (GET_MODE (x3) != E_V2HImode
                  || GET_MODE (x4) != E_V2HImode)
                return NULL;
              if (general_reg_operand (operands[0], E_V2HImode)
                  && general_reg_operand (operands[1], E_V2HImode)
                  && general_reg_operand (operands[2], E_V2HImode))
                {
                  if (
#line 4622 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_BMI && reload_completed))
                    return gen_split_1077 (insn, operands);
                  if (
#line 4639 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_BMI && reload_completed))
                    return gen_split_1080 (insn, operands);
                }
              if (!sse_reg_operand (operands[0], E_V2HImode)
                  || !sse_reg_operand (operands[1], E_V2HImode)
                  || !sse_reg_operand (operands[2], E_V2HImode)
                  || !
#line 4658 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_1083 (insn, operands);

            case E_QImode:
              if (pattern1507 (x3, 
E_QImode) != 0
                  || !
#line 2162 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_1207 (insn, operands);

            case E_HImode:
              if (pattern1507 (x3, 
E_HImode) != 0
                  || !
#line 2162 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_1208 (insn, operands);

            case E_SImode:
              if (pattern1507 (x3, 
E_SImode) != 0
                  || !(
#line 2162 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_1209 (insn, operands);

            case E_DImode:
              if (pattern1507 (x3, 
E_DImode) != 0
                  || !(
#line 2162 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_1210 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern1254 (x3))
            {
            case 0:
              if (nonimmediate_gr_operand (operands[0], E_V4QImode)
                  && nonimmediate_gr_operand (operands[1], E_V4QImode)
                  && reg_or_const_vector_operand (operands[2], E_V4QImode)
                  && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
                return gen_split_1084 (insn, operands);
              if (!sse_reg_operand (operands[0], E_V4QImode)
                  || !sse_reg_operand (operands[1], E_V4QImode)
                  || !sse_reg_operand (operands[2], E_V4QImode)
                  || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_1093 (insn, operands);

            case 1:
              if (nonimmediate_gr_operand (operands[0], E_V2QImode)
                  && nonimmediate_gr_operand (operands[1], E_V2QImode)
                  && reg_or_const_vector_operand (operands[2], E_V2QImode)
                  && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
                return gen_split_1087 (insn, operands);
              if (!sse_reg_operand (operands[0], E_V2QImode)
                  || !sse_reg_operand (operands[1], E_V2QImode)
                  || !sse_reg_operand (operands[2], E_V2QImode)
                  || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_1096 (insn, operands);

            case 2:
              if (nonimmediate_gr_operand (operands[0], E_V2HImode)
                  && nonimmediate_gr_operand (operands[1], E_V2HImode)
                  && reg_or_const_vector_operand (operands[2], E_V2HImode)
                  && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
                return gen_split_1090 (insn, operands);
              if (!sse_reg_operand (operands[0], E_V2HImode)
                  || !sse_reg_operand (operands[1], E_V2HImode)
                  || !sse_reg_operand (operands[2], E_V2HImode)
                  || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_1099 (insn, operands);

            case 3:
              if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_1195 (insn, operands);

            case 4:
              if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_1198 (insn, operands);

            case 5:
              if (!(
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_1201 (insn, operands);

            case 6:
              if (!(
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_1204 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      switch (pattern1254 (x3))
        {
        case 0:
          if (nonimmediate_gr_operand (operands[0], E_V4QImode)
              && nonimmediate_gr_operand (operands[1], E_V4QImode)
              && reg_or_const_vector_operand (operands[2], E_V4QImode)
              && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_1085 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V4QImode)
              || !sse_reg_operand (operands[1], E_V4QImode)
              || !sse_reg_operand (operands[2], E_V4QImode)
              || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1094 (insn, operands);

        case 1:
          if (nonimmediate_gr_operand (operands[0], E_V2QImode)
              && nonimmediate_gr_operand (operands[1], E_V2QImode)
              && reg_or_const_vector_operand (operands[2], E_V2QImode)
              && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_1088 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2QImode)
              || !sse_reg_operand (operands[1], E_V2QImode)
              || !sse_reg_operand (operands[2], E_V2QImode)
              || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1097 (insn, operands);

        case 2:
          if (nonimmediate_gr_operand (operands[0], E_V2HImode)
              && nonimmediate_gr_operand (operands[1], E_V2HImode)
              && reg_or_const_vector_operand (operands[2], E_V2HImode)
              && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_1091 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2HImode)
              || !sse_reg_operand (operands[1], E_V2HImode)
              || !sse_reg_operand (operands[2], E_V2HImode)
              || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1100 (insn, operands);

        case 3:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1196 (insn, operands);

        case 4:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1199 (insn, operands);

        case 5:
          if (!(
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1202 (insn, operands);

        case 6:
          if (!(
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1205 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern1254 (x3))
        {
        case 0:
          if (nonimmediate_gr_operand (operands[0], E_V4QImode)
              && nonimmediate_gr_operand (operands[1], E_V4QImode)
              && reg_or_const_vector_operand (operands[2], E_V4QImode)
              && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_1086 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V4QImode)
              || !sse_reg_operand (operands[1], E_V4QImode)
              || !sse_reg_operand (operands[2], E_V4QImode)
              || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1095 (insn, operands);

        case 1:
          if (nonimmediate_gr_operand (operands[0], E_V2QImode)
              && nonimmediate_gr_operand (operands[1], E_V2QImode)
              && reg_or_const_vector_operand (operands[2], E_V2QImode)
              && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_1089 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2QImode)
              || !sse_reg_operand (operands[1], E_V2QImode)
              || !sse_reg_operand (operands[2], E_V2QImode)
              || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1098 (insn, operands);

        case 2:
          if (nonimmediate_gr_operand (operands[0], E_V2HImode)
              && nonimmediate_gr_operand (operands[1], E_V2HImode)
              && reg_or_const_vector_operand (operands[2], E_V2HImode)
              && 
#line 4725 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_1092 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2HImode)
              || !sse_reg_operand (operands[1], E_V2HImode)
              || !sse_reg_operand (operands[2], E_V2HImode)
              || !
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_1101 (insn, operands);

        case 3:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1197 (insn, operands);

        case 4:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1200 (insn, operands);

        case 5:
          if (!(
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1203 (insn, operands);

        case 6:
          if (!(
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1206 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_53 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (XWINT (x6, 0) == 0LL)
        {
          switch (GET_MODE (operands[1]))
            {
            case E_V2SImode:
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 5774 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && TARGET_SSE2 && reload_completed))
                return gen_split_1119 (insn, operands);
              break;

            case E_V4SImode:
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 21251 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
                return gen_split_3392 (insn, operands);
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!memory_operand (operands[1], E_V2SImode)
              || !const_0_to_1_operand (operands[2], E_SImode)
              || !(
#line 5842 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_64BIT) && 
#line 5844 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
( reload_completed)))
            return NULL;
          return gen_split_1121 (insn, operands);

        case E_V4SImode:
          if (!memory_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_SImode)
              || !(
#line 21326 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 21328 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3393 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          operands[1] = x7;
          if (!mask_reg_operand (operands[1], E_SImode)
              || !mask_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode
              || !
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && reload_completed))
            return NULL;
          return gen_split_1215 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_HImode)
            return NULL;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 49
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return NULL;
          x9 = XVECEXP (x8, 0, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 22165 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return NULL;
          return gen_split_3441 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 49
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x10 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x10))
        {
        case LT:
          switch (pattern981 (x10))
            {
            case 0:
              if (!((
#line 22016 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22018 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3413 (insn, operands);

            case 1:
              if (!(
#line 22016 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 22018 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3415 (insn, operands);

            case 2:
              if (!((
#line 22016 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22018 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3417 (insn, operands);

            case 3:
              if (!((
#line 22016 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22018 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3419 (insn, operands);

            case 4:
              if (!((
#line 22276 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 629 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22278 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3450 (insn, operands);

            case 5:
              if (!(
#line 22276 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 22278 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3451 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
          switch (pattern1082 (x10))
            {
            case 0:
              if (!((
#line 22041 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22043 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3421 (insn, operands);

            case 1:
              if (!(
#line 22041 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 22043 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3423 (insn, operands);

            case 2:
              if (!((
#line 22041 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22043 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3425 (insn, operands);

            case 3:
              if (!((
#line 22041 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22043 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3427 (insn, operands);

            case 4:
              if (!((
#line 22080 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22082 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3433 (insn, operands);

            case 5:
              if (!(
#line 22080 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 22082 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3435 (insn, operands);

            case 6:
              if (!((
#line 22080 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22082 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3437 (insn, operands);

            case 7:
              if (!((
#line 22080 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22082 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3439 (insn, operands);

            default:
              return NULL;
            }

        case VEC_MERGE:
          switch (pattern983 (x10))
            {
            case 0:
              if (!((
#line 22305 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 629 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3452 (insn, operands);

            case 1:
              if (!(
#line 22305 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_64BIT && TARGET_SSE2) && 
#line 22307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3453 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SUBREG:
      if (pattern111 (x3) != 0
          || !(
#line 22151 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22153 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3440 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_61 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern835 (x3) != 0)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode)
              || !(
#line 12554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1561 (insn, operands);

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 12955 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1570 (insn, operands);

        default:
          return NULL;
        }

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode)
              || !(
#line 12554 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1562 (insn, operands);

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !
#line 12955 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1569 (insn, operands);

        default:
          return NULL;
        }

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 12619 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || (REG_P (operands[0]) && !EXT_REX_SSE_REG_P (operands[1])))) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1563 (insn, operands);

    case E_V4DImode:
      if (!nonimmediate_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 12619 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || (REG_P (operands[0]) && !EXT_REX_SSE_REG_P (operands[1])))) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1564 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern532 (x2))
        {
        case 0:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1677 (insn, operands);

        case 1:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1704 (insn, operands);

        case 2:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1731 (insn, operands);

        case 3:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1758 (insn, operands);

        case 4:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1785 (insn, operands);

        case 5:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1812 (insn, operands);

        case 6:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1839 (insn, operands);

        case 7:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1866 (insn, operands);

        case 8:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1893 (insn, operands);

        case 9:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1920 (insn, operands);

        case 10:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1947 (insn, operands);

        case 11:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1974 (insn, operands);

        case 12:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1680 (insn, operands);

        case 13:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1707 (insn, operands);

        case 14:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1734 (insn, operands);

        case 15:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1761 (insn, operands);

        case 16:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1788 (insn, operands);

        case 17:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1815 (insn, operands);

        case 18:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 19:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 20:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1896 (insn, operands);

        case 21:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1923 (insn, operands);

        case 22:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1950 (insn, operands);

        case 23:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1977 (insn, operands);

        case 24:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1683 (insn, operands);

        case 25:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1710 (insn, operands);

        case 26:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1737 (insn, operands);

        case 27:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1764 (insn, operands);

        case 28:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1791 (insn, operands);

        case 29:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 30:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1845 (insn, operands);

        case 31:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1872 (insn, operands);

        case 32:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1899 (insn, operands);

        case 33:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1926 (insn, operands);

        case 34:
          if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1953 (insn, operands);

        case 35:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1980 (insn, operands);

        case 36:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2961 (insn, operands);

        case 37:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2970 (insn, operands);

        case 38:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2979 (insn, operands);

        case 39:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2988 (insn, operands);

        case 40:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2997 (insn, operands);

        case 41:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3006 (insn, operands);

        case 42:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3015 (insn, operands);

        case 43:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3024 (insn, operands);

        case 44:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3033 (insn, operands);

        case 45:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3042 (insn, operands);

        case 46:
          if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3051 (insn, operands);

        case 47:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3060 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2325 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2352 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2379 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2406 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2433 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2460 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2487 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2514 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2541 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2568 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2595 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2622 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2328 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2355 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2382 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2409 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2436 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2463 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2490 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2517 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2544 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2571 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2598 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2625 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2331 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2358 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2385 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2412 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2439 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2466 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2493 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2520 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2547 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2574 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2601 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2628 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return split_72 (x1, insn);

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1994 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2021 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2075 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2129 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2156 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2183 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2210 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2237 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2264 (insn, operands);

            case 11:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2291 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1997 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2024 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2078 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2105 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2132 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2159 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2186 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2213 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2240 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2267 (insn, operands);

            case 23:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2294 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2000 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2027 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2054 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2081 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2108 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2135 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2162 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2189 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2216 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2243 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2270 (insn, operands);

            case 35:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2297 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3068 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3077 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3086 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3095 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3104 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3113 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3122 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3131 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3140 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3149 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3158 (insn, operands);

            case 47:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3167 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern537 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2642 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2669 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2696 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2723 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2750 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2777 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2804 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2831 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2858 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2885 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2912 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2939 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern537 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2645 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2672 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2699 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2726 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2753 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2780 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2807 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2834 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2861 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2888 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2915 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2942 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern537 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2648 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2675 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2702 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2729 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2756 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2783 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2810 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2837 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2864 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2891 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2918 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2945 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2003 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2030 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2057 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2084 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2111 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2138 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2165 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2192 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2219 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2246 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2273 (insn, operands);

            case 11:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2300 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2006 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2033 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2114 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2141 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2168 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2195 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2222 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2249 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2276 (insn, operands);

            case 23:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2009 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2036 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2117 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2144 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2171 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2198 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2225 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2252 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2279 (insn, operands);

            case 35:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2306 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3071 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3080 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3089 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3098 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3107 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3116 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3125 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3134 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3143 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3152 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3161 (insn, operands);

            case 47:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3170 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern537 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2651 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2678 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2705 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2732 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2759 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2786 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2813 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2840 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2867 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2894 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2921 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2948 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern537 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2654 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2681 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2708 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2735 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2762 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2789 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2816 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2843 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2870 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2897 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2924 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2951 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern537 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2657 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2684 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2711 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2738 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2765 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2792 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2819 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2846 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2873 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2900 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2927 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2954 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
