/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern14 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern14 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern22 (x3, 
E_SImode); /* [-1, 2] */

        case E_DImode:
          res = pattern22 (x3, 
E_DImode);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HFmode))
        return -1;
      res = pattern23 (x3);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], i1))
        return -1;
      return 0;

    case SIGN_EXTEND:
      if (GET_MODE (x3) != i1)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!nonimmediate_operand (operands[2], i2))
        return -1;
      return 1;

    case ZERO_EXTEND:
      if (GET_MODE (x3) != i1)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!nonimmediate_operand (operands[2], i2))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      return 0;

    case STRICT_LOW_PART:
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      res = pattern39 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern8 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern7 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V2QImode:
      if (pattern7 (x1, 
E_V2QImode) != 0)
        return -1;
      return 3;

    case E_V2HImode:
      if (pattern7 (x1, 
E_V2HImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V8HImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 4)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_CONCAT
      || GET_MODE (x11) != E_V8HImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 4)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x12, 0, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x15 = XVECEXP (x12, 0, 2);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x16 = XVECEXP (x12, 0, 3);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x17 = XEXP (x1, 0);
  operands[0] = x17;
  if (!register_operand (operands[0], E_V4HImode)
      || pattern53 (x2) != 0)
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!nonimmediate_operand (operands[0], E_QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!general_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern97 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V4QImode:
      res = pattern98 (x1, 
E_V4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_V8QImode:
      if (!memory_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      res = pattern99 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      res = pattern98 (x1, 
E_V4HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_V2HImode:
      if (pattern97 (x1, 
E_V2HImode) != 0)
        return -1;
      return 8;

    case E_V2SImode:
      if (pattern97 (x1, 
E_V2SImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern127 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern127 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern127 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern127 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern127 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern127 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern127 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern127 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern127 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        case E_V16SImode:
          if (pattern128 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 9;

        case E_V8SImode:
          if (pattern128 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern129 (x1, 
E_QImode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8DImode:
          if (pattern128 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern128 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern128 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V64QImode:
          if (pattern128 (x1, 
E_V64QImode, 
E_DImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern129 (x1, 
E_HImode, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern128 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 17;

        case E_V32HImode:
          if (pattern128 (x1, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern128 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_V8HImode:
          if (pattern128 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 20;

        case E_V32BFmode:
          if (pattern130 (x1, 
E_V32BFmode, 
E_SImode) != 0)
            return -1;
          return 21;

        case E_V16BFmode:
          if (pattern130 (x1, 
E_V16BFmode, 
E_HImode) != 0)
            return -1;
          return 22;

        case E_V8BFmode:
          if (pattern130 (x1, 
E_V8BFmode, 
E_QImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern132 (x1);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8DImode:
      return pattern170 (x3, 
E_V8DImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern170 (x3, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern170 (x3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern185 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 0;

    case AND:
      if (GET_MODE (x4) != E_QImode)
        return -1;
      res = pattern195 (x1);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    case PLUS:
      if (GET_MODE (x4) != E_QImode)
        return -1;
      res = pattern197 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case MINUS:
      if (GET_MODE (x4) != E_QImode)
        return -1;
      res = pattern198 (x1);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return pattern209 (x4, 
E_DImode); /* [-1, 0] */

        case E_TImode:
          if (pattern209 (x4, 
E_TImode) != 0)
            return -1;
          return 1;

        case E_QImode:
          if (pattern209 (x4, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern209 (x4, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_SImode:
          if (pattern209 (x4, 
E_SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern211 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != ZERO_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern256 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      return 0;

    case STRICT_LOW_PART:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      x4 = XEXP (x1, 1);
      res = pattern39 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern261 (); /* [-1, 2] */
}

int
pattern267 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (pnum_clobbers == NULL
          || maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int248_register_operand (operands[2], E_VOIDmode))
            return -1;
          return pattern266 (x1); /* [-1, 1] */

        case PLUS:
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern266 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case MINUS:
          x4 = XEXP (x3, 0);
          operands[3] = x4;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
            return -1;
          res = pattern2 (x1);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        default:
          return -1;
        }

    case CONST_INT:
      return 6;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LTU:
    case UNLT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!flags_reg_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_mmxmem_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !const0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 59)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[5] = x6;
      if (!const_0_to_31_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          return pattern316 (x1, 
E_V8SFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern316 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V4DFmode:
          if (pattern316 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 2;

        case E_V2DFmode:
          if (pattern316 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 3
          || XINT (x7, 1) != 59
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[4] = x9;
      x10 = XVECEXP (x7, 0, 2);
      operands[5] = x10;
      if (!const_0_to_31_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern317 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern317 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V4DFmode:
          if (pattern317 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern317 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[2] = x4;
      return 0;

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern334 (x1, 
E_V16SImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern334 (x1, 
E_V8DImode) != 0)
            return -1;
          return 2;

        case E_V64QImode:
          if (pattern334 (x1, 
E_V64QImode) != 0)
            return -1;
          return 3;

        case E_V32QImode:
          if (pattern334 (x1, 
E_V32QImode) != 0)
            return -1;
          return 4;

        case E_V16QImode:
          if (pattern334 (x1, 
E_V16QImode) != 0)
            return -1;
          return 5;

        case E_V32HImode:
          if (pattern334 (x1, 
E_V32HImode) != 0)
            return -1;
          return 6;

        case E_V16HImode:
          if (pattern334 (x1, 
E_V16HImode) != 0)
            return -1;
          return 7;

        case E_V8HImode:
          if (pattern334 (x1, 
E_V8HImode) != 0)
            return -1;
          return 8;

        case E_V8SImode:
          if (pattern334 (x1, 
E_V8SImode) != 0)
            return -1;
          return 9;

        case E_V4SImode:
          if (pattern334 (x1, 
E_V4SImode) != 0)
            return -1;
          return 10;

        case E_V4DImode:
          if (pattern334 (x1, 
E_V4DImode) != 0)
            return -1;
          return 11;

        case E_V2DImode:
          if (pattern334 (x1, 
E_V2DImode) != 0)
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern346 (x1, 
E_QImode, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !memory_operand (operands[0], i1)
      || !nonmemory_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 110)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern382 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern388 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern395 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern404 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  switch (GET_CODE (x6))
    {
    case AND:
      if (GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      return pattern205 (x5); /* [-1, 3] */

    case PLUS:
      if (GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      res = pattern206 (x5);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case MINUS:
      if (GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      res = pattern207 (x5);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 12;

    default:
      return -1;
    }
}

int
pattern420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern454 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern454 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern454 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern454 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern454 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern454 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern454 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern454 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern454 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x5, 0) != 1LL)
        return -1;
      res = pattern456 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern481 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XEXP (x1, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return pattern478 (x1, 
E_V32HImode, 
E_SImode); /* [-1, 0] */

        case E_V16SImode:
          if (pattern478 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern478 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16HImode:
          if (pattern478 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SImode:
          if (pattern478 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4DImode:
          if (pattern478 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8HImode:
          if (pattern478 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern478 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DImode:
          if (pattern478 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x6;
      x7 = XEXP (x1, 2);
      operands[5] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern480 (x1, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 9;

        case E_V16SImode:
          if (pattern480 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 10;

        case E_V8DImode:
          if (pattern480 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 11;

        case E_V16HImode:
          if (pattern480 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 12;

        case E_V8SImode:
          if (pattern480 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V4DImode:
          if (pattern480 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern480 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 15;

        case E_V4SImode:
          if (pattern480 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 16;

        case E_V2DImode:
          if (pattern480 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern509 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i2
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern514 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!vector_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!vector_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!vector_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern521 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HFmode:
      if (!memory_operand (operands[1], E_V4HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern530 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern529 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern529 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern529 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern529 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern529 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern529 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern529 (x1, 
E_V16SImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern529 (x1, 
E_V8SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern529 (x1, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern529 (x1, 
E_V8DImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern529 (x1, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern529 (x1, 
E_V2DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V4QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern544 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 38)
        return -1;
      res = pattern543 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern558 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x2;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_BLKmode
      || !memory_operand (operands[0], E_BLKmode)
      || !register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !const_int_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !const_int_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !const_int_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !const_int_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern388 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern388 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SUBREG
      || maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      return 0;

    default:
      return -1;
    }
}

int
pattern605 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[3] = x4;
  if (!nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern612 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern619 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern626 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern632 (x1, 
E_V16SImode, 
E_HImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern632 (x1, 
E_V8SImode, 
E_QImode, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern632 (x1, 
E_V4SImode, 
E_QImode, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern640 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern644 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern659 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern658 (x1, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern658 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern667 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != i1)
    return -1;
  return 0;
}

int
pattern671 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern679 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (XVECLEN (x7, 0))
    {
    case 4:
      return pattern676 (x1, 
E_V16QImode, 
E_V4QImode); /* [-1, 1] */

    case 2:
      if (pattern677 (x1, 
E_V2HImode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern687 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    case E_SImode:
      return 2;

    case E_DImode:
      return 3;

    default:
      return -1;
    }
}

int
pattern695 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern702 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case STRICT_LOW_PART:
      return 1;

    default:
      return -1;
    }
}

int
pattern710 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  return 0;
}

int
pattern715 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return pattern713 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

        case E_TImode:
          if (pattern713 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern714 (x1, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_TImode:
          if (pattern714 (x1, 
E_TImode, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern730 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[4] = x4;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  return pattern729 (x6, 
i1); /* [-1, 0] */
}

int
pattern739 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern745 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern753 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return pattern278 (x1); /* [-1, 4] */
}

int
pattern760 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 64LL:
      return pattern759 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

    case 32LL:
      if (pattern759 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern771 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  x9 = XEXP (x1, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern770 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern770 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern770 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern783 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern790 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x2, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern789 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern789 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern789 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern789 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern789 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern789 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern789 (x1, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern789 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern789 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern789 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern789 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern789 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      if (pattern789 (x1, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_V16HFmode:
      if (pattern789 (x1, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      return 13;

    case E_V8HFmode:
      if (pattern789 (x1, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      return 14;

    case E_V32BFmode:
      if (pattern789 (x1, 
E_V32BFmode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_V16BFmode:
      if (pattern789 (x1, 
E_V16BFmode, 
E_HImode) != 0)
        return -1;
      return 16;

    case E_V8BFmode:
      if (pattern789 (x1, 
E_V8BFmode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V16SFmode:
      if (pattern789 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 18;

    case E_V8SFmode:
      if (pattern789 (x1, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4SFmode:
      if (pattern789 (x1, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8DFmode:
      if (pattern789 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern789 (x1, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V2DFmode:
      if (pattern789 (x1, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern833 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_TFmode
      || !vector_operand (operands[1], E_TFmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!vector_operand (operands[2], E_TFmode))
    return -1;
  return 0;
}

int
pattern841 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[0]))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      return 0;

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern848 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != EQ)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != EQ)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 1);
  operands[5] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4HImode:
          return pattern847 (x4, 
E_V4HImode); /* [-1, 0] */

        case E_V2SImode:
          if (pattern847 (x4, 
E_V2SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !register_operand (operands[2], E_V4QImode)
          || GET_MODE (x2) != E_V4QImode
          || GET_MODE (x3) != E_V2HImode
          || pattern847 (x4, 
E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern864 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern871 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern877 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern876 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern876 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern883 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern893 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!nonimmediate_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!nonimmediate_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern902 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_V4QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern911 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern917 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern921 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_V8QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 8)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x10 = XVECEXP (x5, 0, 4);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x11 = XVECEXP (x5, 0, 5);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x12 = XVECEXP (x5, 0, 6);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x13 = XVECEXP (x5, 0, 7);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || GET_MODE (x2) != E_V8QImode
      || !nonimmediate_operand (operands[1], E_V8HFmode))
    return -1;
  x14 = XEXP (x4, 0);
  operands[2] = x14;
  if (!nonimm_or_0_operand (operands[2], E_V16QImode))
    return -1;
  x15 = XEXP (x2, 2);
  operands[3] = x15;
  x16 = XEXP (x1, 1);
  operands[4] = x16;
  if (!const0_operand (operands[4], E_V8QImode))
    return -1;
  return 0;
}

int
pattern937 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern818 (x6, pnum_clobbers); /* [-1, 1] */
}

int
pattern945 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern952 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern201 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern201 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern959 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 4)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != ASHIFTRT
          || GET_MODE (x6) != i1)
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x9 = XEXP (x6, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], i1))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      return 0;

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x15 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ASHIFTRT
          || GET_MODE (x16) != i1)
        return -1;
      x17 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x20 = XEXP (x16, 1);
      operands[4] = x20;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x21 = XEXP (x16, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != SET)
        return -1;
      x22 = XEXP (x4, 0);
      operands[3] = x22;
      if (!memory_operand (operands[3], i1))
        return -1;
      x23 = XEXP (x4, 1);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern982 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern988 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[2], E_V32HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !nonimmediate_operand (operands[2], E_V32QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern999 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1001 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern1012 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case NOT:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!const_0_to_7_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern1011 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 1;

        case E_V16QImode:
          if (pattern1011 (x1, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1028 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1038 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], E_V64QImode)
      || !nonimmediate_operand (operands[2], E_V64QImode)
      || !register_operand (operands[4], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  return 0;
}

int
pattern1041 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!const_0_to_7_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x8, 1);
  x11 = XVECEXP (x10, 0, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XVECEXP (x10, 0, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x10, 0, 2);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  switch (XINT (x4, 1))
    {
    case 59:
      if (XINT (x10, 1) != 59)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern1039 (x1, 
E_HImode); /* [-1, 20] */

        case E_SImode:
          res = pattern1039 (x1, 
E_SImode);
          if (res >= 0)
            return res + 21; /* [21, 41] */
          return -1;

        case E_DImode:
          res = pattern1039 (x1, 
E_DImode);
          if (res >= 0)
            return res + 42; /* [42, 62] */
          return -1;

        default:
          return -1;
        }

    case 157:
      if (XINT (x10, 1) != 157)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          res = pattern1040 (x1, 
E_HImode);
          if (res >= 0)
            return res + 63; /* [63, 74] */
          return -1;

        case E_SImode:
          res = pattern1040 (x1, 
E_SImode);
          if (res >= 0)
            return res + 75; /* [75, 86] */
          return -1;

        case E_DImode:
          res = pattern1040 (x1, 
E_DImode);
          if (res >= 0)
            return res + 87; /* [87, 98] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1058 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern1057 (x2); /* [-1, 3] */
}

int
pattern1061 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!sse_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !sse_reg_operand (operands[2], i2)
      || !sse_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1067 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1078 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ix86_carry_flag_unset_operator (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1087 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1093 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1101 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  x4 = XEXP (x2, 2);
  operands[5] = x4;
  if (!register_operand (operands[5], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1106 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1106 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1106 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1116 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (XWINT (x3, 0) != 1LL)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const48_operand (operands[5], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1123 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1123 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1123 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0LL:
      x3 = XVECEXP (x1, 0, 1);
      switch (XWINT (x3, 0))
        {
        case 1LL:
          return 0;

        case 2LL:
          return 1;

        default:
          return -1;
        }

    case 1LL:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3LL)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (XWINT (x4, 0) != 5LL)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (XWINT (x5, 0) != 7LL)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 19
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern203 (x1); /* [-1, 3] */
}

int
pattern1174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1182 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1181 (); /* [-1, 3] */
}

int
pattern1188 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1195 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != LTU
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x3, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 17
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  x13 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x13) != PARALLEL
      || XVECLEN (x13, 0) != 2)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (GET_CODE (x14) != SET)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != NEG
      || GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x13, 0, 1);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 17
      || GET_MODE (x17) != E_CCmode)
    return -1;
  x18 = XEXP (x15, 0);
  if (!rtx_equal_p (x18, operands[0]))
    return -1;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[0]))
    return -1;
  return 0;
}

int
pattern1220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1231 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_MODE (x7))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern374 (x4); /* [-1, 1] */
}

int
pattern1257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern1261 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[0], i1)
      || !const0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x1, 0);
  switch (GET_CODE (x9))
    {
    case STRICT_LOW_PART:
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return pattern1266 (); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      res = pattern1266 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1293 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1303 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1331 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  return pattern405 (x1); /* [-1, 1] */
}

int
pattern1343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CALL)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  return 0;
}

int
pattern1351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1357 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return pattern1364 (); /* [-1, 3] */
}

int
pattern1368 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1385 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1372 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1394 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1403 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1413 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1424 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1430 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1437 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1444 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vm_operator (operands[6], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1451 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1461 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1469 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 2);
  return pattern1468 (x2, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V4DImode
      || !nonimm_or_0_operand (operands[2], E_V4DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1481 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1500 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 64LL:
      return pattern1499 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

    case 32LL:
      if (pattern1499 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1510 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[2], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[2], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1525 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1532 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 2);
  return pattern1468 (x2, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1536 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  return 0;
}

int
pattern1543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1552 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1565 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_unset_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SFmode
      || !vector_operand (operands[1], E_V4SFmode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!nonimm_or_0_operand (operands[2], E_V4SFmode))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern1592 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 2);
  return pattern1592 (x5, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1609 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  switch (GET_MODE (operands[6]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      return pattern1608 (x3, 
E_V16SImode, 
E_HImode); /* [-1, 1] */

    case E_QImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      res = pattern1608 (x3, 
E_V8DImode, 
E_QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[3]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1631 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1641 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1658 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1657 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1657 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1672 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[4], E_VOIDmode)
      || !const_0_to_7_operand (operands[5], E_VOIDmode)
      || !const_0_to_7_operand (operands[6], E_VOIDmode)
      || !const_8_to_15_operand (operands[7], E_VOIDmode)
      || !const_8_to_15_operand (operands[8], E_VOIDmode)
      || !const_8_to_15_operand (operands[9], E_VOIDmode)
      || !const_8_to_15_operand (operands[10], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1681 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1691 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = PATTERN (peep2_next_insn (2));
  return pattern1536 (x11); /* [-1, 0] */
}

int
pattern1702 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1709 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !const_4_to_7_operand (operands[7], E_VOIDmode)
      || !const_4_to_7_operand (operands[8], E_VOIDmode)
      || !const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1720 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1719 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1719 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1732 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1738 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1746 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1754 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[11], i1))
    return -1;
  return 0;
}

int
pattern1763 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1772 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1780 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern1790 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1789 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1789 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1801 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern1808 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !const_4_to_7_operand (operands[7], E_VOIDmode)
      || !const_4_to_7_operand (operands[8], E_VOIDmode)
      || !const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1816 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_V2QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 2)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V2QImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 2)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x14 = XEXP (x2, 1);
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != i1)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != VEC_SELECT
      || GET_MODE (x16) != E_V2QImode)
    return -1;
  x17 = XEXP (x16, 1);
  if (GET_CODE (x17) != PARALLEL
      || XVECLEN (x17, 0) != 2)
    return -1;
  x18 = XVECEXP (x17, 0, 0);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x19 = XVECEXP (x17, 0, 1);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x20 = XEXP (x14, 1);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != VEC_SELECT
      || GET_MODE (x21) != E_V2QImode)
    return -1;
  x22 = XEXP (x21, 1);
  if (GET_CODE (x22) != PARALLEL
      || XVECLEN (x22, 0) != 2)
    return -1;
  x23 = XVECEXP (x22, 0, 0);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x24 = XVECEXP (x22, 0, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x25 = XEXP (x1, 1);
  x26 = XEXP (x25, 0);
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != i1)
    return -1;
  x28 = XEXP (x27, 0);
  if (GET_CODE (x28) != VEC_SELECT
      || GET_MODE (x28) != E_V2QImode)
    return -1;
  x29 = XEXP (x28, 1);
  if (GET_CODE (x29) != PARALLEL
      || XVECLEN (x29, 0) != 2)
    return -1;
  x30 = XVECEXP (x29, 0, 0);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x31 = XVECEXP (x29, 0, 1);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x32 = XEXP (x26, 1);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != VEC_SELECT
      || GET_MODE (x33) != E_V2QImode)
    return -1;
  x34 = XEXP (x33, 1);
  if (GET_CODE (x34) != PARALLEL
      || XVECLEN (x34, 0) != 2)
    return -1;
  x35 = XVECEXP (x34, 0, 0);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x36 = XVECEXP (x34, 0, 1);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x37 = XEXP (x25, 1);
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != VEC_SELECT
      || GET_MODE (x39) != E_V2QImode)
    return -1;
  x40 = XEXP (x39, 1);
  if (GET_CODE (x40) != PARALLEL
      || XVECLEN (x40, 0) != 2)
    return -1;
  x41 = XVECEXP (x40, 0, 0);
  if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x42 = XVECEXP (x40, 0, 1);
  if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x43 = XEXP (x37, 1);
  if (GET_CODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != VEC_SELECT
      || GET_MODE (x44) != E_V2QImode)
    return -1;
  x45 = XEXP (x44, 1);
  if (GET_CODE (x45) != PARALLEL
      || XVECLEN (x45, 0) != 2)
    return -1;
  x46 = XVECEXP (x45, 0, 0);
  if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x47 = XVECEXP (x45, 0, 1);
  if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  x48 = XEXP (x5, 0);
  operands[1] = x48;
  if (!nonimmediate_operand (operands[1], E_V16QImode))
    return -1;
  x49 = XEXP (x10, 0);
  if (!rtx_equal_p (x49, operands[1]))
    return -1;
  x50 = XEXP (x16, 0);
  if (!rtx_equal_p (x50, operands[1]))
    return -1;
  x51 = XEXP (x21, 0);
  if (!rtx_equal_p (x51, operands[1]))
    return -1;
  x52 = XEXP (x28, 0);
  if (!rtx_equal_p (x52, operands[1]))
    return -1;
  x53 = XEXP (x33, 0);
  if (!rtx_equal_p (x53, operands[1]))
    return -1;
  x54 = XEXP (x39, 0);
  if (!rtx_equal_p (x54, operands[1]))
    return -1;
  x55 = XEXP (x44, 0);
  if (!rtx_equal_p (x55, operands[1]))
    return -1;
  return 0;
}

int
pattern1871 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !sext_operand (operands[2], i1)
      || pattern1870 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1878 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_int_operand (operands[6], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1
      || !ix86_carry_flag_operator (operands[5], i1))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  return pattern1873 (x11, 
i1); /* [-1, 0] */
}

int
pattern1888 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 24);
  if (XWINT (x2, 0) != 28LL)
    return -1;
  x3 = XVECEXP (x1, 0, 25);
  if (XWINT (x3, 0) != 60LL)
    return -1;
  x4 = XVECEXP (x1, 0, 26);
  if (XWINT (x4, 0) != 29LL)
    return -1;
  x5 = XVECEXP (x1, 0, 27);
  if (XWINT (x5, 0) != 61LL)
    return -1;
  x6 = XVECEXP (x1, 0, 28);
  if (XWINT (x6, 0) != 30LL)
    return -1;
  x7 = XVECEXP (x1, 0, 29);
  if (XWINT (x7, 0) != 62LL)
    return -1;
  x8 = XVECEXP (x1, 0, 30);
  if (XWINT (x8, 0) != 31LL)
    return -1;
  x9 = XVECEXP (x1, 0, 31);
  if (XWINT (x9, 0) != 63LL)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (!const48_operand (x3, E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (XVECLEN (x4, 0))
    {
    case 3:
      if (XINT (x4, 1) != 59)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[2] = x7;
      x8 = XVECEXP (x4, 0, 2);
      operands[3] = x8;
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !nonimmediate_operand (operands[2], E_V16SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3282; /* avx512f_cmpv16si3_round */

            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[2], E_V16HFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 310 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3306; /* avx512vl_cmpv16hf3_round */

            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[2], E_V16SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 312 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3312; /* avx512f_cmpv16sf3_round */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !nonimmediate_operand (operands[2], E_V8SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 307 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3286; /* avx512vl_cmpv8si3_round */

            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !nonimmediate_operand (operands[2], E_V8DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3292; /* avx512f_cmpv8di3_round */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !nonimmediate_operand (operands[2], E_V4DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3296; /* avx512vl_cmpv4di3_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[2], E_V8SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 312 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3316; /* avx512vl_cmpv8sf3_round */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[2], E_V8DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3322; /* avx512f_cmpv8df3_round */

            case E_V4DFmode:
              if (!register_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[2], E_V4DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3326; /* avx512vl_cmpv4df3_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 61
          || GET_MODE (x4) != E_CCFPmode
          || pattern846 (x4) != 0
          || pattern44 (x1, 
E_CCFPmode) != 0)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      x7 = XVECEXP (x4, 0, 1);
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      operands[2] = x3;
      switch (GET_MODE (x6))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x7) != E_HFmode
              || !register_operand (operands[1], E_V8HFmode)
              || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4853 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3671; /* avx10_2_comxhf_round */

        case E_SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x7) != E_SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 3675; /* avx10_2_comxsf_round */

        case E_DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x7) != E_DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 3679; /* avx10_2_comxdf_round */

        default:
          return -1;
        }

    case 1:
      if (XINT (x4, 1) != 26
          || GET_MODE (x4) != E_CCFPmode
          || pattern44 (x1, 
E_CCFPmode) != 0)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      if (GET_MODE (x6) != E_CCFPmode)
        return -1;
      operands[2] = x3;
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 61)
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x11) != VEC_SELECT)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x14) != VEC_SELECT)
            return -1;
          x15 = XEXP (x14, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x16 = XVECEXP (x15, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x17 = XEXP (x11, 0);
          operands[0] = x17;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          switch (GET_MODE (x11))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x14) != E_HFmode
                  || !register_operand (operands[1], E_V8HFmode)
                  || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4853 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3673; /* avx10_2_ucomxhf_round */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x14) != E_SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 3677; /* avx10_2_ucomxsf_round */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x14) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 3681; /* avx10_2_ucomxdf_round */

            default:
              return -1;
            }

        case COMPARE:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x19 = XEXP (x9, 1);
          if (GET_CODE (x19) != PARALLEL
              || XVECLEN (x19, 0) != 1)
            return -1;
          x20 = XVECEXP (x19, 0, 0);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XEXP (x6, 1);
          if (GET_CODE (x21) != VEC_SELECT)
            return -1;
          x22 = XEXP (x21, 1);
          if (GET_CODE (x22) != PARALLEL
              || XVECLEN (x22, 0) != 1)
            return -1;
          x23 = XVECEXP (x22, 0, 0);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x24 = XEXP (x9, 0);
          operands[0] = x24;
          x25 = XEXP (x21, 0);
          operands[1] = x25;
          switch (GET_MODE (x9))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x21) != E_HFmode
                  || !register_operand (operands[1], E_V8HFmode)
                  || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3685; /* avx512fp16_ucomi_round */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x21) != E_SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode)))
                return -1;
              return 3689; /* sse_ucomi_round */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x21) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !(
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode)))
                return -1;
              return 3693; /* sse2_ucomi_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1, pnum_clobbers))
    {
    case 0:
      if (!(
#line 16643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1128; /* *lshrti3_doubleword_mask_1 */

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          switch (pattern255 (x1))
            {
            case 0:
              return 137; /* *insvqi_3 */

            case 1:
              return 139; /* *insvqi_3 */

            case 2:
              if (
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return 141; /* *insvqi_3 */
              break;

            default:
              break;
            }
          break;

        case SUBREG:
          if (pnum_clobbers != NULL
              && pattern421 (x1, 
E_TImode) == 0
              && (
#line 16582 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1124; /* *lshrti3_doubleword_mask */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      switch (pattern256 (x1, pnum_clobbers))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pnum_clobbers == NULL
                  || pattern738 (x2, 
E_TImode, 
E_QImode) != 0
                  || !
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1132; /* lshrti3_doubleword */

            case E_QImode:
              if (pattern623 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 17561 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 1212; /* *lshrqi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17561 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 1213; /* *lshrqi3_1 */

            case E_HImode:
              if (pattern623 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 17599 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 1214; /* *lshrhi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17599 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 1215; /* *lshrhi3_1 */

            case E_V4HImode:
              if (pattern738 (x2, 
E_V4HImode, 
E_DImode) != 0
                  || !
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 2203; /* mmx_lshrv4hi3 */

            case E_V2SImode:
              if (pattern738 (x2, 
E_V2SImode, 
E_DImode) != 0
                  || !
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 2205; /* mmx_lshrv2si3 */

            case E_V1DImode:
              if (pattern738 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 2207; /* mmx_lshrv1di3 */

            case E_V1SImode:
              if (pattern738 (x2, 
E_V1SImode, 
E_DImode) != 0
                  || !
#line 3928 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2209; /* mmx_lshrv1si3 */

            case E_V2HImode:
              if (pattern738 (x2, 
E_V2HImode, 
E_DImode) != 0
                  || !
#line 3945 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 2211; /* lshrv2hi3 */

            case E_V2QImode:
              if (pnum_clobbers == NULL
                  || pattern738 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 4007 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return -1;
              *pnum_clobbers = 1;
              return 2215; /* lshrv2qi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 17638 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1216; /* *lshrqi3_1_slp */

        case 2:
          if (!
#line 17638 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1218; /* *lshrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 4660 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 174; /* zero_extendditi2 */

        case E_DImode:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          if (nonimmediate_operand (operands[0], E_DImode)
              && x86_64_zext_operand (operands[1], E_SImode))
            return 175; /* *zero_extendsidi2 */
          if (!register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 4812 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 176; /* zero_extendqidi2 */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 4812 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 177; /* zero_extendhidi2 */

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode))
                return -1;
              if (pnum_clobbers != NULL
                  && 
#line 4839 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 178; /* zero_extendqisi2_and */
                }
              if (!
#line 4867 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun))))
                return -1;
              return 180; /* *zero_extendqisi2 */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode))
                return -1;
              if (pnum_clobbers != NULL
                  && 
#line 4839 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 179; /* zero_extendhisi2_and */
                }
              if (!
#line 4867 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun))))
                return -1;
              return 181; /* *zero_extendhisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4893 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 182; /* zero_extendqihi2_and */
            }
          if (!
#line 4921 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun))))
            return -1;
          return 183; /* *zero_extendqihi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !
#line 5170 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 190; /* *extendhisi2_zext */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !
#line 5205 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 192; /* *extendqisi2_zext */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!nonimmediate_operand (operands[1], E_HFmode)
              || !
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_AVX512FP16))
            return -1;
          return 220; /* *fixuns_trunchfsi2zext */

        case E_SFmode:
          if (!nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 5898 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_AVX512F && TARGET_SSE_MATH))
            return -1;
          return 221; /* *fixuns_truncsfsi2_avx512f_zext */

        case E_DFmode:
          if (!nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 5898 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_AVX512F && TARGET_SSE_MATH))
            return -1;
          return 222; /* *fixuns_truncdfsi2_avx512f_zext */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!general_operand (operands[2], E_QImode))
            return -1;
          if (
#line 6677 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 286; /* *addqi_1_zexthi_nf */
          if (pnum_clobbers == NULL
              || !
#line 6677 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 287; /* *addqi_1_zexthi */

        case PLUS:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_QImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (!ix86_carry_flag_operator (x7, E_QImode))
            return -1;
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 1);
          operands[1] = x10;
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!x86_64_general_operand (operands[2], E_QImode)
              || !
#line 8895 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 465; /* *addqi3_carry_zexthi */

        case LTU:
        case UNLT:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || pattern1068 (x4) != 0
              || !
#line 8952 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          *pnum_clobbers = 1;
          return 471; /* *addqi3_carry_zexthi_0 */

        case GE:
        case GEU:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || pattern1068 (x4) != 0
              || !
#line 8997 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          *pnum_clobbers = 1;
          return 477; /* *addqi3_carry_zexthi_0r */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (!x86_64_general_operand (operands[2], E_QImode))
                return -1;
              if (
#line 8144 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 392; /* *subqi_1_zexthi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 8144 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 393; /* *subqi_1_zexthi */

            case LTU:
            case UNLT:
              if (pnum_clobbers == NULL
                  || !ix86_carry_flag_operator (operands[2], E_QImode))
                return -1;
              x11 = XEXP (x6, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 17)
                return -1;
              x12 = XEXP (x6, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 9440 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 505; /* *subqi3_carry_zexthi_0 */

            case GE:
            case GEU:
              if (pnum_clobbers == NULL
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode))
                return -1;
              x11 = XEXP (x6, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 17)
                return -1;
              x12 = XEXP (x6, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 9488 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 511; /* *subqi3_carry_zexthi_0r */

            default:
              return -1;
            }

        case MINUS:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_QImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (!ix86_carry_flag_operator (x10, E_QImode))
            return -1;
          operands[3] = x10;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 17)
            return -1;
          x14 = XEXP (x10, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !x86_64_general_operand (operands[2], E_QImode)
              || !
#line 9380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *subqi3_carry_zexthi */

        default:
          return -1;
        }

    case AND:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_QImode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!x86_64_general_operand (operands[2], E_QImode))
            return -1;
          if (
#line 12626 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 708; /* *andqi_1_zexthi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12626 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 709; /* *andqi_1_zexthi */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2)
            return -1;
          x15 = XVECEXP (x5, 0, 0);
          operands[1] = x15;
          x16 = XVECEXP (x5, 0, 1);
          operands[2] = x16;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (XINT (x5, 1))
            {
            case 158:
              switch (pattern1079 (x4))
                {
                case 0:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8199; /* *avx512bw_testmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 505 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8202; /* *avx512vl_testmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8208; /* *avx512bw_testmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8205; /* *avx512vl_testmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8211; /* *avx512vl_testmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8217; /* *avx512f_testmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 509 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8214; /* *avx512vl_testmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8220; /* *avx512vl_testmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8223; /* *avx512vl_testmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8226; /* *avx512f_testmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8229; /* *avx512vl_testmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19104 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8232; /* *avx512vl_testmv2di3_zext_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern1079 (x4))
                {
                case 0:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8271; /* *avx512bw_testnmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 505 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8274; /* *avx512vl_testnmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 8280; /* *avx512bw_testnmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8277; /* *avx512vl_testnmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8283; /* *avx512vl_testnmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8289; /* *avx512f_testnmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 509 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 8286; /* *avx512vl_testnmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8292; /* *avx512vl_testnmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8295; /* *avx512vl_testnmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 8298; /* *avx512f_testnmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8301; /* *avx512vl_testnmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19134 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 8304; /* *avx512vl_testnmv2di3_zext_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      if (pattern79 (x3) != 0)
        return -1;
      if (
#line 13715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 843; /* *iorqi_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 13715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      *pnum_clobbers = 1;
      return 844; /* *iorqi_1_zexthi */

    case XOR:
      if (pattern79 (x3) != 0)
        return -1;
      if (
#line 13715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 845; /* *xorqi_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 13715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      *pnum_clobbers = 1;
      return 846; /* *xorqi_1_zexthi */

    case NEG:
      if (pattern80 (x3) != 0)
        return -1;
      if (
#line 14360 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 962; /* *negqi_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 14360 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 963; /* *negqi_1_zexthi */

    case NOT:
      if (pattern80 (x3) != 0
          || !
#line 15002 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
        return -1;
      return 1035; /* *one_cmplqi2_1_zexthi */

    case ASHIFT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 16008 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1093; /* *ashlqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 16008 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1094; /* *ashlqi3_1_zexthi */

    case LSHIFTRT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 17455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1186; /* *lshrqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 17455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1187; /* *lshrqi3_1_zexthi */

    case ASHIFTRT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 17455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1188; /* *ashrqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 17455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1189; /* *ashrqi3_1_zexthi */

    case ROTATE:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 18570 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1351; /* *rotlqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 18570 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1352; /* *rotlqi3_1_zexthi */

    case ROTATERT:
      if (pattern81 (x3) != 0)
        return -1;
      if (
#line 18570 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF))
        return 1353; /* *rotrqi3_1_zexthi_nf */
      if (pnum_clobbers == NULL
          || !
#line 18570 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
        return -1;
      *pnum_clobbers = 1;
      return 1354; /* *rotrqi3_1_zexthi */

    case VEC_SELECT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (XVECLEN (x6, 0))
        {
        case 4:
          if (pattern608 (x3) != 0
              || !
#line 5011 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return -1;
          return 2305; /* sse4_1_zero_extendv4qiv4hi2 */

        case 2:
          switch (pattern609 (x3))
            {
            case 0:
              if (!
#line 5043 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2307; /* sse4_1_zero_extendv2hiv2si2 */

            case 1:
              if (!
#line 5075 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2309; /* sse4_1_zero_extendv2qiv2si2 */

            case 2:
              if (!
#line 5101 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return -1;
              return 2311; /* sse4_1_zero_extendv2qiv2hi2 */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x17 = XVECEXP (x6, 0, 0);
          operands[2] = x17;
          switch (pattern984 ())
            {
            case 0:
              if (!
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
                return -1;
              return 2327; /* *mmx_pextrb_zext */

            case 1:
              if (!
#line 6130 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return -1;
              return 2365; /* *pextrb_zext */

            case 2:
              if (!
#line 21147 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8468; /* *vec_extractv16qi_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_26 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x3, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (register_operand (operands[0], E_V2SFmode)
              && GET_MODE (x3) == E_V2SFmode
              && register_operand (operands[2], E_V2SFmode)
              && register_operand (operands[1], E_V2SFmode)
              && const_0_to_3_operand (operands[3], E_SImode)
              && 
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2074; /* *mmx_blendps */
          break;

        case E_V4HFmode:
          if (pattern860 (x3, 
E_V4HFmode) == 0
              && 
#line 5597 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2336; /* *mmx_pblendw64 */
          break;

        case E_V4BFmode:
          if (pattern860 (x3, 
E_V4BFmode) == 0
              && 
#line 5597 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2337; /* *mmx_pblendw64 */
          break;

        case E_V4HImode:
          if (pattern860 (x3, 
E_V4HImode) == 0
              && 
#line 5597 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE))
            return 2338; /* *mmx_pblendw64 */
          break;

        case E_V2HFmode:
          if (pattern861 (x3, 
E_V2HFmode) == 0
              && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2339; /* *mmx_pblendw32 */
          break;

        case E_V2BFmode:
          if (pattern861 (x3, 
E_V2BFmode) == 0
              && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2340; /* *mmx_pblendw32 */
          break;

        case E_V2HImode:
          if (pattern861 (x3, 
E_V2HImode) == 0
              && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
            return 2341; /* *mmx_pblendw32 */
          break;

        default:
          break;
        }
      if (XWINT (x5, 0) != 1LL)
        return -1;
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern862 (x3, 
E_V2SFmode) != 0
              || !
#line 1741 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2090; /* *mmx_movss_v2sf */

        case E_V2SImode:
          if (pattern862 (x3, 
E_V2SImode) != 0
              || !
#line 1741 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2091; /* *mmx_movss_v2si */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern863 (x3, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 5262 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2SImode))))
            return -1;
          return 2316; /* *mmx_pinsrd */

        case E_V4HFmode:
          if (pattern863 (x3, 
E_V4HFmode, 
E_HFmode) != 0
              || !
#line 5292 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4HImode))))
            return -1;
          return 2317; /* *mmx_pinsrw */

        case E_V4BFmode:
          if (pattern863 (x3, 
E_V4BFmode, 
E_BFmode) != 0
              || !
#line 5292 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4HImode))))
            return -1;
          return 2318; /* *mmx_pinsrw */

        case E_V4HImode:
          if (pattern863 (x3, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 5292 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4HImode))))
            return -1;
          return 2319; /* *mmx_pinsrw */

        case E_V8QImode:
          if (pattern863 (x3, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 5347 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && TARGET_MMX_WITH_SSE
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8QImode))))
            return -1;
          return 2320; /* *mmx_pinsrb */

        case E_V2HFmode:
          if (pattern863 (x3, 
E_V2HFmode, 
E_HFmode) != 0
              || !
#line 5960 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2HImode))))
            return -1;
          return 2355; /* *pinsrw */

        case E_V2BFmode:
          if (pattern863 (x3, 
E_V2BFmode, 
E_BFmode) != 0
              || !
#line 5960 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2HImode))))
            return -1;
          return 2356; /* *pinsrw */

        case E_V2HImode:
          if (pattern863 (x3, 
E_V2HImode, 
E_HImode) != 0
              || !
#line 5960 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2HImode))))
            return -1;
          return 2357; /* *pinsrw */

        case E_V4QImode:
          if (pattern863 (x3, 
E_V4QImode, 
E_QImode) != 0
              || !
#line 6013 "../../gcc-15.0.1-20250313/gcc/config/i386/mmx.md"
(TARGET_SSE4_1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4QImode))))
            return -1;
          return 2358; /* *pinsrb */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern100 (x3))
        {
        case 0:
          if (!
#line 15483 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7311; /* avx512vl_ss_truncatev2div2qi2_mask_store_1 */

        case 1:
          if (!
#line 15578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7338; /* avx512vl_ss_truncatev4siv4qi2_mask_store_1 */

        case 2:
          if (!
#line 15578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7341; /* avx512vl_ss_truncatev4div4qi2_mask_store_1 */

        case 3:
          if (!(
#line 15676 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7368; /* avx512vl_ss_truncatev8hiv8qi2_mask_store_1 */

        case 4:
          if (!
#line 15676 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7371; /* avx512vl_ss_truncatev8siv8qi2_mask_store_1 */

        case 5:
          if (!
#line 16192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7463; /* avx512f_ss_truncatev8div16qi2_mask_store_1 */

        case 6:
          if (!
#line 15830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7408; /* avx512vl_ss_truncatev4siv4hi2_mask_store_1 */

        case 7:
          if (!
#line 15830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7411; /* avx512vl_ss_truncatev4div4hi2_mask_store_1 */

        case 8:
          if (!
#line 15921 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7426; /* avx512vl_ss_truncatev2div2hi2_mask_store_1 */

        case 9:
          if (!
#line 16067 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7445; /* avx512vl_ss_truncatev2div2si2_mask_store_1 */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern100 (x3))
        {
        case 0:
          if (!
#line 15483 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7312; /* avx512vl_truncatev2div2qi2_mask_store_1 */

        case 1:
          if (!
#line 15578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7339; /* avx512vl_truncatev4siv4qi2_mask_store_1 */

        case 2:
          if (!
#line 15578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7342; /* avx512vl_truncatev4div4qi2_mask_store_1 */

        case 3:
          if (!(
#line 15676 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7369; /* avx512vl_truncatev8hiv8qi2_mask_store_1 */

        case 4:
          if (!
#line 15676 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7372; /* avx512vl_truncatev8siv8qi2_mask_store_1 */

        case 5:
          if (!
#line 16192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7464; /* avx512f_truncatev8div16qi2_mask_store_1 */

        case 6:
          if (!
#line 15830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7409; /* avx512vl_truncatev4siv4hi2_mask_store_1 */

        case 7:
          if (!
#line 15830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7412; /* avx512vl_truncatev4div4hi2_mask_store_1 */

        case 8:
          if (!
#line 15921 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7427; /* avx512vl_truncatev2div2hi2_mask_store_1 */

        case 9:
          if (!
#line 16067 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7446; /* avx512vl_truncatev2div2si2_mask_store_1 */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern100 (x3))
        {
        case 0:
          if (!
#line 15483 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7313; /* avx512vl_us_truncatev2div2qi2_mask_store_1 */

        case 1:
          if (!
#line 15578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7340; /* avx512vl_us_truncatev4siv4qi2_mask_store_1 */

        case 2:
          if (!
#line 15578 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7343; /* avx512vl_us_truncatev4div4qi2_mask_store_1 */

        case 3:
          if (!(
#line 15676 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15600 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7370; /* avx512vl_us_truncatev8hiv8qi2_mask_store_1 */

        case 4:
          if (!
#line 15676 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7373; /* avx512vl_us_truncatev8siv8qi2_mask_store_1 */

        case 5:
          if (!
#line 16192 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7465; /* avx512f_us_truncatev8div16qi2_mask_store_1 */

        case 6:
          if (!
#line 15830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7410; /* avx512vl_us_truncatev4siv4hi2_mask_store_1 */

        case 7:
          if (!
#line 15830 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7413; /* avx512vl_us_truncatev4div4hi2_mask_store_1 */

        case 8:
          if (!
#line 15921 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7428; /* avx512vl_us_truncatev2div2hi2_mask_store_1 */

        case 9:
          if (!
#line 16067 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7447; /* avx512vl_us_truncatev2div2si2_mask_store_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern107 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 8144 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 394; /* *subqi_1_zextsi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 8144 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 395; /* *subqi_1_zextsi */

            case 1:
              if (
#line 8158 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 398; /* *subhi_1_zextsi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 8158 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 399; /* *subhi_1_zextsi */

            case 2:
              if (
#line 8144 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 396; /* *subqi_1_zextdi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 8144 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 397; /* *subqi_1_zextdi */

            case 3:
              if (
#line 8158 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 400; /* *subhi_1_zextdi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 8158 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 401; /* *subhi_1_zextdi */

            case 4:
              if (!
#line 8173 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 402; /* *subsi_1_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          switch (pattern753 (x2, pnum_clobbers))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_operator (operands[2], E_QImode)
                  || !
#line 9440 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 506; /* *subqi3_carry_zextsi_0 */

            case 1:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_operator (operands[2], E_HImode)
                  || !
#line 9455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 508; /* *subhi3_carry_zextsi_0 */

            case 2:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_operator (operands[2], E_QImode)
                  || !
#line 9440 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 507; /* *subqi3_carry_zextdi_0 */

            case 3:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_operator (operands[2], E_HImode)
                  || !
#line 9455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 509; /* *subhi3_carry_zextdi_0 */

            case 4:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !ix86_carry_flag_operator (operands[2], E_SImode)
                  || !
#line 9470 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 510; /* *subsi3_carry_zext_0 */

            default:
              return -1;
            }

        case GE:
        case GEU:
          switch (pattern753 (x2, pnum_clobbers))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
                  || !
#line 9488 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 512; /* *subqi3_carry_zextsi_0r */

            case 1:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_HImode)
                  || !
#line 9503 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 514; /* *subhi3_carry_zextsi_0r */

            case 2:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
                  || !
#line 9488 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 513; /* *subqi3_carry_zextdi_0r */

            case 3:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_HImode)
                  || !
#line 9503 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 515; /* *subhi3_carry_zextdi_0r */

            case 4:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !ix86_carry_flag_unset_operator (operands[2], E_SImode)
                  || !
#line 9518 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 516; /* *subsi3_carry_zext_0r */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case LTU:
        case UNLT:
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (pattern278 (x2))
            {
            case 0:
              if (pattern1540 (x4, 
E_QImode) != 0
                  || !
#line 9380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 500; /* *subqi3_carry_zextsi */

            case 1:
              if (pattern1540 (x4, 
E_HImode) != 0
                  || !
#line 9400 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 502; /* *subhi3_carry_zextsi */

            case 2:
              if (pattern1540 (x4, 
E_QImode) != 0
                  || !
#line 9380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 501; /* *subqi3_carry_zextdi */

            case 3:
              if (pattern1540 (x4, 
E_HImode) != 0
                  || !
#line 9400 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 503; /* *subhi3_carry_zextdi */

            case 4:
              if (pattern1540 (x4, 
E_SImode) != 0
                  || !
#line 9420 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 504; /* *subsi3_carry_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (XWINT (x4, 0))
        {
        case 63LL:
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0))
            return -1;
          x10 = XEXP (x5, 0);
          if (GET_CODE (x10) != CLZ
              || GET_MODE (x10) != E_DImode)
            return -1;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 21250 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1526; /* bsr_rex64_1_zext */

        case 31LL:
          if (GET_CODE (x5) != CLZ)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21290 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_LZCNT && TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1529; /* bsr_zext_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      switch (pattern434 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 8069 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 380; /* *subdi3_doubleword */
            }
          if (!x86_64_general_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 390; /* *subdi_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 391; /* *subdi_1 */

        case 1:
          if (
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 388; /* *subsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 389; /* *subsi_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode
          || pattern758 (x2, 
E_SImode, 
E_DImode) != 0
          || !(
#line 8103 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 382; /* *subdi3_doubleword_zext */

    case LTU:
    case UNLT:
      switch (pattern442 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1204 (x2, 
E_SImode) != 0
              || !
#line 9349 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *subsi3_carry_0 */

        case 1:
          if (pattern1204 (x2, 
E_DImode) != 0
              || !(
#line 9349 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *subdi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern442 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1205 (x2, 
E_SImode) != 0
              || !
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 497; /* *subsi3_carry_0r */

        case 1:
          if (pattern1205 (x2, 
E_DImode) != 0
              || !(
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 498; /* *subdi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern444 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 10307 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 584; /* *subsi3_eq_0 */

        case 1:
          if (!(
#line 10307 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 585; /* *subdi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern444 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 10328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 588; /* *subsi3_ne_0 */

        case 1:
          if (!(
#line 10328 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 589; /* *subdi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      operands[1] = x3;
      if (bt_comparison_operator (operands[1], E_VOIDmode))
        {
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x3) != NE
          || GET_MODE (x3) != E_QImode
          || XWINT (x4, 0) != 0LL)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ZERO_EXTRACT)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UMIN
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x3, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[1] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x13 = XEXP (x7, 0);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern871 (x2, 
E_SImode) != 0
              || !
#line 22036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
            return -1;
          *pnum_clobbers = 1;
          return 1590; /* *bmi2_bzhi_si3 */

        case E_DImode:
          if (pattern871 (x2, 
E_DImode) != 0
              || !(
#line 22036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1591; /* *bmi2_bzhi_di3 */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      operands[1] = x3;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || XWINT (x4, 0) != 0LL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern23 (x2))
        {
        case 0:
          *pnum_clobbers = 1;
          return 1795; /* *x86_movsicc_0_m1 */

        case 1:
          if (!
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1796; /* *x86_movdicc_0_m1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pnum_clobbers != NULL)
        {
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern241 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1275 (x2, 
E_SImode) != 0
                  || !
#line 26319 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
                return -1;
              return 1804; /* *movsicc_noc */

            case E_DImode:
              if (pattern1275 (x2, 
E_DImode) != 0
                  || !(
#line 26319 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1805; /* *movdicc_noc */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x2, 2);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!nonimmediate_operand (operands[3], E_SImode)
              || !
#line 26337 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1806; /* *movsicc_noc_zext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (pattern434 (x2))
    {
    case 0:
      if (pnum_clobbers != NULL
          && x86_64_hilo_general_operand (operands[2], E_DImode)
          && (
#line 12501 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 703; /* *anddi3_doubleword */
        }
      if (x86_64_szext_general_operand (operands[2], E_DImode))
        {
          if (
#line 12543 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 705; /* *anddi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 12543 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)
   && true))
            {
              *pnum_clobbers = 1;
              return 706; /* *anddi_1 */
            }
        }
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_DImode)
          || !
#line 12576 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_USE_BT
   && ix86_binary_operator_ok (AND, DImode, operands)
   && IN_RANGE (exact_log2 (~INTVAL (operands[2])), 31, 63)))
        return -1;
      *pnum_clobbers = 1;
      return 707; /* *anddi_1_btr */

    case 1:
      if (
#line 12671 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 721; /* *andsi_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 12671 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 722; /* *andsi_1 */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern115 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && (
#line 14237 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 952; /* *negdi2_doubleword */
            }
          if ((
#line 14346 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 960; /* *negdi_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 14346 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 961; /* *negdi_1 */

        case 1:
          if (
#line 14346 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 958; /* *negsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 14346 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 959; /* *negsi_1 */

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern614 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 14644 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 997; /* *nabsdi2_doubleword */
            }
          if (!(
#line 14715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1006; /* *nabsdi2_1 */

        case E_SImode:
          if (pattern614 (x3, 
E_SImode) != 0
              || !
#line 14715 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1005; /* *nabssi2_1 */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern23 (x3))
        {
        case 0:
          *pnum_clobbers = 1;
          return 1801; /* *x86_movsicc_0_m1_neg */

        case 1:
          if (!
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1802; /* *x86_movdicc_0_m1_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern118 (x3, pnum_clobbers))
        {
        case 0:
          if (pnum_clobbers != NULL
              && pattern621 (x3) == 0
              && (
#line 15203 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1052; /* *ashldi3_doubleword_mask */
            }
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          res = recog_95 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern622 (x3))
            {
            case 0:
              if (!
#line 17840 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1244; /* *ashlsi3_mask */

            case 1:
              if (!(
#line 17840 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1247; /* *ashldi3_mask */

            case 2:
              if (!
#line 17888 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1256; /* *ashlsi3_add */

            case 3:
              if (!(
#line 17888 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1259; /* *ashldi3_add */

            case 4:
              if (!
#line 17934 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1268; /* *ashlsi3_sub */

            case 5:
              if (!(
#line 17934 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1271; /* *ashldi3_sub */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 15264 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1054; /* *ashldi3_doubleword_mask_1 */
            }
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17865 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1253; /* *ashldi3_mask_1 */

        case 2:
          if (!
#line 17865 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1250; /* *ashlsi3_mask_1 */

        case 3:
          if (!
#line 17912 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1262; /* *ashlsi3_add_1 */

        case 4:
          if (!(
#line 17912 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1265; /* *ashldi3_add_1 */

        case 5:
          if (!
#line 17964 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1274; /* *ashlsi3_sub_1 */

        case 6:
          if (!(
#line 17964 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1277; /* *ashldi3_sub_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern119 (x3, pnum_clobbers) != 0
          || !(
#line 15365 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1058; /* *ashldi3_doubleword_highpart */

    case ZERO_EXTEND:
      if (pattern119 (x3, pnum_clobbers) != 0
          || !(
#line 15365 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1059; /* *ashldi3_doubleword_highpart */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !ix86_comparison_operator (operands[1], E_SImode))
        return -1;
      if (
#line 19473 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_ZU))
        return 1445; /* *setcc_si_zu */
      if (pnum_clobbers != NULL
          && 
#line 19497 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
        {
          *pnum_clobbers = 1;
          return 1449; /* *setcc_si_1_and */
        }
      if (!
#line 19514 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))))
        return -1;
      return 1451; /* *setcc_si_1_movzbl */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !ix86_comparison_operator (operands[1], E_DImode))
        return -1;
      if ((
#line 19473 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_ZU) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 1446; /* *setcc_di_zu */
      if (!
#line 19481 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL))
        return -1;
      return 1447; /* *setcc_di_1 */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 45:
      if (pattern296 (x3) != 0
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 19556 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 1454; /* *setcc_si_slp */

    case 98:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern783 (x3, 
E_SImode) != 0
              || !
#line 21734 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1566; /* bmi_bextr_si */

        case E_DImode:
          if (pattern783 (x3, 
E_DImode) != 0
              || !(
#line 21734 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1567; /* bmi_bextr_di */

        default:
          return -1;
        }

    case 99:
      switch (pattern297 (x3))
        {
        case 0:
          if (!
#line 22127 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1600; /* bmi2_pdep_si3 */

        case 1:
          if (!(
#line 22127 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1601; /* bmi2_pdep_di3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern297 (x3))
        {
        case 0:
          if (!
#line 22138 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1602; /* bmi2_pext_si3 */

        case 1:
          if (!(
#line 22138 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1603; /* bmi2_pext_di3 */

        default:
          return -1;
        }

    case 93:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_CCZmode
          || !flags_reg_operand (operands[0], E_CCZmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          *pnum_clobbers = 1;
          return 1883; /* stack_protect_test_1_si */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          *pnum_clobbers = 1;
          return 1884; /* stack_protect_test_1_di */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !
#line 29036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1891; /* sse4_2_crc32qi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !
#line 29036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1892; /* sse4_2_crc32hi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 29036 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CRC32))
            return -1;
          return 1893; /* sse4_2_crc32si */

        default:
          return -1;
        }

    case 178:
      x5 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          switch (XVECLEN (x5, 0))
            {
            case 3:
              if (XINT (x5, 1) != 59
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x6 = XVECEXP (x5, 0, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_V32HFmode))
                return -1;
              x7 = XVECEXP (x5, 0, 1);
              operands[2] = x7;
              if (!nonimmediate_operand (operands[2], E_V32HFmode))
                return -1;
              x8 = XVECEXP (x5, 0, 2);
              operands[3] = x8;
              if (!const_0_to_31_operand (operands[3], E_SImode))
                return -1;
              x4 = XVECEXP (x3, 0, 1);
              operands[4] = x4;
              if (!const48_operand (operands[4], E_SImode)
                  || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3302; /* avx512bw_cmpv32hf3_round */

            case 1:
              x4 = XVECEXP (x3, 0, 1);
              operands[2] = x4;
              switch (XINT (x5, 1))
                {
                case 156:
                  switch (pattern875 (x3))
                    {
                    case 0:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4547; /* avx512fp16_vcvtsh2usi_round */

                    case 1:
                      if (!
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4912; /* avx512f_vcvtss2usi_round */

                    case 2:
                      if (!
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4924; /* avx512f_vcvtsd2usi_round */

                    case 3:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4551; /* avx512fp16_vcvtsh2usiq_round */

                    case 4:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9036 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4914; /* avx512f_vcvtss2usiq_round */

                    case 5:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9072 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4926; /* avx512f_vcvtsd2usiq_round */

                    default:
                      return -1;
                    }

                case 46:
                  switch (pattern875 (x3))
                    {
                    case 0:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4549; /* avx512fp16_vcvtsh2si_round */

                    case 1:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
                        return -1;
                      return 4795; /* sse_cvtss2si_round */

                    case 2:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9108 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 4936; /* sse2_cvtsd2si_round */

                    case 3:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7824 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4553; /* avx512fp16_vcvtsh2siq_round */

                    case 4:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4797; /* sse_cvtss2siq_round */

                    case 5:
                      if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9108 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4938; /* sse2_cvtsd2siq_round */

                    default:
                      return -1;
                    }

                case 172:
                  switch (pattern877 (x3))
                    {
                    case 0:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4695; /* unspec_avx512fp16_fix_truncsi2_round */

                    case 1:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8592 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
                        return -1;
                      return 4801; /* unspec_sse_cvttss2si_round */

                    case 2:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9137 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 4942; /* unspec_sse2_cvttsd2si_round */

                    case 3:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4699; /* unspec_avx512fp16_fix_truncdi2_round */

                    case 4:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8592 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4803; /* unspec_sse_cvttss2siq_round */

                    case 5:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9137 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4944; /* unspec_sse2_cvttsd2siq_round */

                    default:
                      return -1;
                    }

                case 173:
                  switch (pattern877 (x3))
                    {
                    case 0:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 4697; /* unspec_avx512fp16_fixuns_truncsi2_round */

                    case 1:
                      if (!
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4916; /* unspec_avx512f_vcvttss2usi_round */

                    case 2:
                      if (!
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return -1;
                      return 4928; /* unspec_avx512f_vcvttsd2usi_round */

                    case 3:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7989 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4701; /* unspec_avx512fp16_fixuns_truncdi2_round */

                    case 4:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9047 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4918; /* unspec_avx512f_vcvttss2usiq_round */

                    case 5:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9083 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 4930; /* unspec_avx512f_vcvttsd2usiq_round */

                    default:
                      return -1;
                    }

                case 275:
                  switch (pattern879 (x3))
                    {
                    case 0:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32610 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                        return -1;
                      return 10920; /* avx10_2_vcvttsd2sissi_round */

                    case 1:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                        return -1;
                      return 10928; /* avx10_2_vcvttss2sissi_round */

                    case 2:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32610 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10924; /* avx10_2_vcvttsd2sisdi_round */

                    case 3:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10932; /* avx10_2_vcvttss2sisdi_round */

                    default:
                      return -1;
                    }

                case 276:
                  switch (pattern879 (x3))
                    {
                    case 0:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32610 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                        return -1;
                      return 10922; /* avx10_2_vcvttsd2usissi_round */

                    case 1:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                        return -1;
                      return 10930; /* avx10_2_vcvttss2usissi_round */

                    case 2:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32610 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10926; /* avx10_2_vcvttsd2usisdi_round */

                    case 3:
                      if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32623 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                        return -1;
                      return 10934; /* avx10_2_vcvttss2usisdi_round */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != UNSPEC
              || XVECLEN (x9, 0) != 3
              || XINT (x9, 1) != 59
              || GET_MODE (x9) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V32HFmode))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          operands[3] = x12;
          if (!const_0_to_31_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x5, 1);
          operands[4] = x13;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 1);
          operands[5] = x4;
          if (!const48_operand (operands[5], E_SImode)
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 309 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 3304; /* avx512bw_cmpv32hf3_mask_round */

        case FIX:
          switch (pattern450 (x3))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4703; /* avx512fp16_fix_truncsi2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8608 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 4805; /* sse_cvttss2si_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 4946; /* sse2_cvttsd2si_round */

            case 3:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4707; /* avx512fp16_fix_truncdi2_round */

            case 4:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8608 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4807; /* sse_cvttss2siq_round */

            case 5:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9154 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4948; /* sse2_cvttsd2siq_round */

            default:
              return -1;
            }

        case UNSIGNED_FIX:
          switch (pattern450 (x3))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4705; /* avx512fp16_fixuns_truncsi2_round */

            case 1:
              if (!
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 4920; /* avx512f_vcvttss2usi_round */

            case 2:
              if (!
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 4932; /* avx512f_vcvttsd2usi_round */

            case 3:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4709; /* avx512fp16_fixuns_truncdi2_round */

            case 4:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9059 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4922; /* avx512f_vcvttss2usiq_round */

            case 5:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9095 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
                return -1;
              return 4934; /* avx512f_vcvttsd2usiq_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 158:
      switch (pattern299 (x3))
        {
        case 0:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8113; /* avx512bw_testmv64qi3 */

        case 1:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8115; /* avx512vl_testmv32qi3 */

        case 2:
          if (!(
#line 19065 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8119; /* avx512bw_testmv32hi3 */

        default:
          return -1;
        }

    case 159:
      switch (pattern299 (x3))
        {
        case 0:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8137; /* avx512bw_testnmv64qi3 */

        case 1:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 8139; /* avx512vl_testnmv32qi3 */

        case 2:
          if (!(
#line 19076 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8143; /* avx512bw_testnmv32hi3 */

        default:
          return -1;
        }

    case 193:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!vector_operand (operands[1], E_V32HFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode)
          || !(
#line 29867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V32HFmode)) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 9991; /* avx512dq_fpclassv32hf */

    case 214:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern161 (x3, 
E_DImode, 
E_V64QImode) != 0
              || !(
#line 30934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 10327; /* avx512vl_vpshufbitqmbv64qi */

        case E_SImode:
          if (pattern161 (x3, 
E_SImode, 
E_V32QImode) != 0
              || !(
#line 30934 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 10331; /* avx512vl_vpshufbitqmbv32qi */

        default:
          return -1;
        }

    case 262:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_V32BFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode)
          || !(
#line 32448 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10723; /* avx10_2_fpclassbf16_v32bf */

    case 288:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x4 = XVECEXP (x3, 0, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !x86_64_nonmemory_operand (operands[1], E_SImode))
            return -1;
          return 11020; /* atomic_storesi_1 */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !x86_64_nonmemory_operand (operands[1], E_DImode)
              || !
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 11021; /* atomic_storedi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 2);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 1LL)
            return -1;
          switch (pattern1009 (x2))
            {
            case 0:
              if (!
#line 12050 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5307; /* *vec_setv8hi_0_1 */

            case 1:
              if (!
#line 12050 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5308; /* *vec_setv8hf_0_1 */

            case 2:
              if (!
#line 12050 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 5309; /* *vec_setv8bf_0_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x7;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1287 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9190; /* avx512f_vec_dupv16si_mask */

            case E_V8SImode:
              if (pattern1287 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9192; /* avx512vl_vec_dupv8si_mask */

            case E_V4SImode:
              if (pattern1288 (x2, 
E_V4SImode, 
E_SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9194; /* avx512vl_vec_dupv4si_mask */

            case E_V8DImode:
              if (pattern1287 (x2, 
E_V8DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9196; /* avx512f_vec_dupv8di_mask */

            case E_V4DImode:
              if (pattern1287 (x2, 
E_V4DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9198; /* avx512vl_vec_dupv4di_mask */

            case E_V2DImode:
              if (pattern1288 (x2, 
E_V2DImode, 
E_DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9200; /* avx512vl_vec_dupv2di_mask */

            case E_V16SFmode:
              if (pattern1287 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9202; /* avx512f_vec_dupv16sf_mask */

            case E_V8SFmode:
              if (pattern1287 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9204; /* avx512vl_vec_dupv8sf_mask */

            case E_V4SFmode:
              if (pattern1288 (x2, 
E_V4SFmode, 
E_SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9206; /* avx512vl_vec_dupv4sf_mask */

            case E_V8DFmode:
              if (pattern1287 (x2, 
E_V8DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9208; /* avx512f_vec_dupv8df_mask */

            case E_V4DFmode:
              if (pattern1287 (x2, 
E_V4DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9210; /* avx512vl_vec_dupv4df_mask */

            case E_V2DFmode:
              if (pattern1288 (x2, 
E_V2DFmode, 
E_DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27726 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9212; /* avx512vl_vec_dupv2df_mask */

            case E_V64QImode:
              if (pattern1287 (x2, 
E_V64QImode, 
E_DImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9214; /* avx512bw_vec_dupv64qi_mask */

            case E_V16QImode:
              if (pattern1288 (x2, 
E_V16QImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9216; /* avx512vl_vec_dupv16qi_mask */

            case E_V32QImode:
              if (pattern1287 (x2, 
E_V32QImode, 
E_SImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9218; /* avx512vl_vec_dupv32qi_mask */

            case E_V32HImode:
              if (pattern1287 (x2, 
E_V32HImode, 
E_SImode, 
E_V8HImode, 
E_HImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9220; /* avx512bw_vec_dupv32hi_mask */

            case E_V16HImode:
              if (pattern772 (x2, 
E_HImode, 
E_V16HImode) != 0
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !nonimm_or_0_operand (operands[2], E_V16HImode)
                  || !register_operand (operands[3], E_HImode)
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9222; /* avx512vl_vec_dupv16hi_mask */

            case E_V8HImode:
              if (pattern1288 (x2, 
E_V8HImode, 
E_HImode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9224; /* avx512vl_vec_dupv8hi_mask */

            case E_V32HFmode:
              if (pattern1287 (x2, 
E_V32HFmode, 
E_SImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9226; /* avx512bw_vec_dupv32hf_mask */

            case E_V16HFmode:
              if (pattern1287 (x2, 
E_V16HFmode, 
E_HImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9228; /* avx512vl_vec_dupv16hf_mask */

            case E_V8HFmode:
              if (pattern1288 (x2, 
E_V8HFmode, 
E_HFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9230; /* avx512fp16_vec_dupv8hf_mask */

            case E_V32BFmode:
              if (pattern1287 (x2, 
E_V32BFmode, 
E_SImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9232; /* avx512bw_vec_dupv32bf_mask */

            case E_V16BFmode:
              if (pattern1287 (x2, 
E_V16BFmode, 
E_HImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9234; /* avx512vl_vec_dupv16bf_mask */

            case E_V8BFmode:
              if (pattern1288 (x2, 
E_V8BFmode, 
E_BFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9236; /* avx512vl_vec_dupv8bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x5, 0, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1287 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9324; /* avx512dq_broadcastv16si_mask */

        case E_V8SImode:
          if (pattern1287 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9326; /* avx512dq_broadcastv8si_mask */

        case E_V4SImode:
          if (pattern1288 (x2, 
E_V4SImode, 
E_V2SImode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9328; /* avx512dq_broadcastv4si_mask */

        case E_V16SFmode:
          if (pattern1287 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28036 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9330; /* avx512dq_broadcastv16sf_mask */

        case E_V8SFmode:
          if (pattern1287 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28051 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28036 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9332; /* avx512dq_broadcastv8sf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      x2 = XEXP (x1, 1);
      switch (pattern1290 (x2))
        {
        case 0:
          if ((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3241; /* *avx_cmpv8sf3_1 */
          break;

        case 1:
          if (
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return 3242; /* *avx_cmpv4sf3_1 */
          break;

        case 2:
          if ((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3243; /* *avx_cmpv4df3_1 */
          break;

        case 3:
          if ((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 3244; /* *avx_cmpv2df3_1 */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 2);
      x4 = XVECEXP (x3, 0, 2);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1469 (x2, 
E_V32HImode, 
E_SImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 7638; /* *avx512_ashrv32hi3_1 */
              break;

            case E_V16HImode:
              if (pattern1469 (x2, 
E_V16HImode, 
E_HImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                return 7639; /* *avx512_ashrv16hi3_1 */
              break;

            case E_V8HImode:
              if (pattern1469 (x2, 
E_V8HImode, 
E_QImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                return 7640; /* *avx512_ashrv8hi3_1 */
              break;

            case E_V16SImode:
              if (pattern1469 (x2, 
E_V16SImode, 
E_HImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7641; /* *avx512_ashrv16si3_1 */
              break;

            case E_V8SImode:
              if (pattern1469 (x2, 
E_V8SImode, 
E_QImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7642; /* *avx512_ashrv8si3_1 */
              break;

            case E_V4SImode:
              if (pattern1469 (x2, 
E_V4SImode, 
E_QImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7643; /* *avx512_ashrv4si3_1 */
              break;

            case E_V8DImode:
              if (pattern1469 (x2, 
E_V8DImode, 
E_QImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7644; /* *avx512_ashrv8di3_1 */
              break;

            case E_V4DImode:
              if (pattern1469 (x2, 
E_V4DImode, 
E_QImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7645; /* *avx512_ashrv4di3_1 */
              break;

            case E_V2DImode:
              if (pattern1469 (x2, 
E_V2DImode, 
E_QImode) == 0
                  && (
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 7646; /* *avx512_ashrv2di3_1 */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  x4 = XVECEXP (x3, 0, 2);
  operands[5] = x4;
  switch (pattern1291 (x2))
    {
    case 0:
      if (vector_all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V16QImode)
              && nonimm_or_0_operand (operands[4], E_V16QImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7894; /* *avx2_pcmpv16qi3_1 */
          if (nonimmediate_operand (operands[3], E_V16QImode)
              && nonimmediate_operand (operands[4], E_V16QImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7916; /* *avx2_pcmpv16qi3_6 */
        }
      if (!const0_operand (operands[1], E_V16QImode)
          || !vector_all_ones_operand (operands[2], E_V16QImode)
          || !nonimmediate_operand (operands[3], E_V16QImode)
          || !nonimmediate_operand (operands[4], E_V16QImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7932; /* *avx2_pcmpv16qi3_7 */

    case 1:
      if (vector_all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V8HImode)
              && nonimm_or_0_operand (operands[4], E_V8HImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7895; /* *avx2_pcmpv8hi3_1 */
          if (nonimmediate_operand (operands[3], E_V8HImode)
              && nonimmediate_operand (operands[4], E_V8HImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7918; /* *avx2_pcmpv8hi3_6 */
        }
      if (!const0_operand (operands[1], E_V8HImode)
          || !vector_all_ones_operand (operands[2], E_V8HImode)
          || !nonimmediate_operand (operands[3], E_V8HImode)
          || !nonimmediate_operand (operands[4], E_V8HImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7933; /* *avx2_pcmpv8hi3_7 */

    case 2:
      if (vector_all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V4SImode)
              && nonimm_or_0_operand (operands[4], E_V4SImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7896; /* *avx2_pcmpv4si3_1 */
          if (nonimmediate_operand (operands[3], E_V4SImode)
              && nonimmediate_operand (operands[4], E_V4SImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7920; /* *avx2_pcmpv4si3_6 */
        }
      if (!const0_operand (operands[1], E_V4SImode)
          || !vector_all_ones_operand (operands[2], E_V4SImode)
          || !nonimmediate_operand (operands[3], E_V4SImode)
          || !nonimmediate_operand (operands[4], E_V4SImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7934; /* *avx2_pcmpv4si3_7 */

    case 3:
      if (vector_all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V2DImode)
              && nonimm_or_0_operand (operands[4], E_V2DImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7897; /* *avx2_pcmpv2di3_1 */
          if (nonimmediate_operand (operands[3], E_V2DImode)
              && nonimmediate_operand (operands[4], E_V2DImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7922; /* *avx2_pcmpv2di3_6 */
        }
      if (!const0_operand (operands[1], E_V2DImode)
          || !vector_all_ones_operand (operands[2], E_V2DImode)
          || !nonimmediate_operand (operands[3], E_V2DImode)
          || !nonimmediate_operand (operands[4], E_V2DImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7935; /* *avx2_pcmpv2di3_7 */

    case 4:
      if (vector_all_ones_operand (operands[1], E_V32QImode)
          && const0_operand (operands[2], E_V32QImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V32QImode)
              && nonimm_or_0_operand (operands[4], E_V32QImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7898; /* *avx2_pcmpv32qi3_1 */
          if (nonimmediate_operand (operands[3], E_V32QImode)
              && nonimmediate_operand (operands[4], E_V32QImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7924; /* *avx2_pcmpv32qi3_6 */
        }
      if (!const0_operand (operands[1], E_V32QImode)
          || !vector_all_ones_operand (operands[2], E_V32QImode)
          || !nonimmediate_operand (operands[3], E_V32QImode)
          || !nonimmediate_operand (operands[4], E_V32QImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7936; /* *avx2_pcmpv32qi3_7 */

    case 5:
      if (vector_all_ones_operand (operands[1], E_V16HImode)
          && const0_operand (operands[2], E_V16HImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V16HImode)
              && nonimm_or_0_operand (operands[4], E_V16HImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7899; /* *avx2_pcmpv16hi3_1 */
          if (nonimmediate_operand (operands[3], E_V16HImode)
              && nonimmediate_operand (operands[4], E_V16HImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7926; /* *avx2_pcmpv16hi3_6 */
        }
      if (!const0_operand (operands[1], E_V16HImode)
          || !vector_all_ones_operand (operands[2], E_V16HImode)
          || !nonimmediate_operand (operands[3], E_V16HImode)
          || !nonimmediate_operand (operands[4], E_V16HImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7937; /* *avx2_pcmpv16hi3_7 */

    case 6:
      if (vector_all_ones_operand (operands[1], E_V8SImode)
          && const0_operand (operands[2], E_V8SImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V8SImode)
              && nonimm_or_0_operand (operands[4], E_V8SImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7900; /* *avx2_pcmpv8si3_1 */
          if (nonimmediate_operand (operands[3], E_V8SImode)
              && nonimmediate_operand (operands[4], E_V8SImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7928; /* *avx2_pcmpv8si3_6 */
        }
      if (!const0_operand (operands[1], E_V8SImode)
          || !vector_all_ones_operand (operands[2], E_V8SImode)
          || !nonimmediate_operand (operands[3], E_V8SImode)
          || !nonimmediate_operand (operands[4], E_V8SImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7938; /* *avx2_pcmpv8si3_7 */

    case 7:
      if (vector_all_ones_operand (operands[1], E_V4DImode)
          && const0_operand (operands[2], E_V4DImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V4DImode)
              && nonimm_or_0_operand (operands[4], E_V4DImode)
              && 
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))))
            return 7901; /* *avx2_pcmpv4di3_1 */
          if (nonimmediate_operand (operands[3], E_V4DImode)
              && nonimmediate_operand (operands[4], E_V4DImode)
              && 
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7930; /* *avx2_pcmpv4di3_6 */
        }
      if (!const0_operand (operands[1], E_V4DImode)
          || !vector_all_ones_operand (operands[2], E_V4DImode)
          || !nonimmediate_operand (operands[3], E_V4DImode)
          || !nonimmediate_operand (operands[4], E_V4DImode)
          || !
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)))
        return -1;
      return 7939; /* *avx2_pcmpv4di3_7 */

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (pattern899 (x4) != 0)
    return -1;
  x5 = XVECEXP (x4, 0, 32);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 33);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x4, 0, 34);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x4, 0, 35);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x4, 0, 36);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x4, 0, 37);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x4, 0, 38);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x4, 0, 39);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x4, 0, 40);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x4, 0, 41);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x4, 0, 42);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x4, 0, 43);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x4, 0, 44);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x4, 0, 45);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x4, 0, 46);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x4, 0, 47);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x4, 0, 48);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x4, 0, 49);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x4, 0, 50);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x4, 0, 51);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x4, 0, 52);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x4, 0, 53);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x4, 0, 54);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x4, 0, 55);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x4, 0, 56);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x4, 0, 57);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x4, 0, 58);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x4, 0, 59);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x4, 0, 60);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  x34 = XVECEXP (x4, 0, 61);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XVECEXP (x4, 0, 62);
  if (GET_CODE (x35) != CONST_INT)
    return -1;
  x36 = XVECEXP (x4, 0, 63);
  if (GET_CODE (x36) != CONST_INT
      || pattern1214 (x2, 
E_V64QImode, 
E_V128QImode) != 0)
    return -1;
  x37 = XEXP (x2, 1);
  operands[3] = x37;
  if (!nonimm_or_0_operand (operands[3], E_V64QImode))
    return -1;
  x38 = XEXP (x2, 2);
  operands[4] = x38;
  if (!register_operand (operands[4], E_DImode))
    return -1;
  x39 = XVECEXP (x4, 0, 0);
  switch (XWINT (x39, 0))
    {
    case 8LL:
      x40 = XVECEXP (x4, 0, 1);
      if (XWINT (x40, 0) != 72LL)
        return -1;
      x41 = XVECEXP (x4, 0, 2);
      if (XWINT (x41, 0) != 9LL)
        return -1;
      x42 = XVECEXP (x4, 0, 3);
      if (XWINT (x42, 0) != 73LL)
        return -1;
      x43 = XVECEXP (x4, 0, 4);
      if (XWINT (x43, 0) != 10LL)
        return -1;
      x44 = XVECEXP (x4, 0, 5);
      if (XWINT (x44, 0) != 74LL)
        return -1;
      x45 = XVECEXP (x4, 0, 6);
      if (XWINT (x45, 0) != 11LL)
        return -1;
      x46 = XVECEXP (x4, 0, 7);
      if (XWINT (x46, 0) != 75LL)
        return -1;
      x47 = XVECEXP (x4, 0, 8);
      if (XWINT (x47, 0) != 12LL)
        return -1;
      x48 = XVECEXP (x4, 0, 9);
      if (XWINT (x48, 0) != 76LL)
        return -1;
      x49 = XVECEXP (x4, 0, 10);
      if (XWINT (x49, 0) != 13LL)
        return -1;
      x50 = XVECEXP (x4, 0, 11);
      if (XWINT (x50, 0) != 77LL)
        return -1;
      x51 = XVECEXP (x4, 0, 12);
      if (XWINT (x51, 0) != 14LL)
        return -1;
      x52 = XVECEXP (x4, 0, 13);
      if (XWINT (x52, 0) != 78LL)
        return -1;
      x53 = XVECEXP (x4, 0, 14);
      if (XWINT (x53, 0) != 15LL)
        return -1;
      x54 = XVECEXP (x4, 0, 15);
      if (XWINT (x54, 0) != 79LL)
        return -1;
      x55 = XVECEXP (x4, 0, 16);
      if (XWINT (x55, 0) != 24LL)
        return -1;
      x56 = XVECEXP (x4, 0, 17);
      if (XWINT (x56, 0) != 88LL)
        return -1;
      x57 = XVECEXP (x4, 0, 18);
      if (XWINT (x57, 0) != 25LL)
        return -1;
      x58 = XVECEXP (x4, 0, 19);
      if (XWINT (x58, 0) != 89LL)
        return -1;
      x59 = XVECEXP (x4, 0, 20);
      if (XWINT (x59, 0) != 26LL)
        return -1;
      x60 = XVECEXP (x4, 0, 21);
      if (XWINT (x60, 0) != 90LL)
        return -1;
      x61 = XVECEXP (x4, 0, 22);
      if (XWINT (x61, 0) != 27LL)
        return -1;
      x62 = XVECEXP (x4, 0, 23);
      if (XWINT (x62, 0) != 91LL)
        return -1;
      x63 = XVECEXP (x4, 0, 24);
      if (XWINT (x63, 0) != 28LL)
        return -1;
      x64 = XVECEXP (x4, 0, 25);
      if (XWINT (x64, 0) != 92LL)
        return -1;
      x65 = XVECEXP (x4, 0, 26);
      if (XWINT (x65, 0) != 29LL)
        return -1;
      x66 = XVECEXP (x4, 0, 27);
      if (XWINT (x66, 0) != 93LL)
        return -1;
      x67 = XVECEXP (x4, 0, 28);
      if (XWINT (x67, 0) != 30LL)
        return -1;
      x68 = XVECEXP (x4, 0, 29);
      if (XWINT (x68, 0) != 94LL)
        return -1;
      x69 = XVECEXP (x4, 0, 30);
      if (XWINT (x69, 0) != 31LL)
        return -1;
      x70 = XVECEXP (x4, 0, 31);
      if (XWINT (x70, 0) != 95LL
          || XWINT (x5, 0) != 40LL
          || XWINT (x6, 0) != 104LL
          || XWINT (x7, 0) != 41LL
          || XWINT (x8, 0) != 105LL
          || XWINT (x9, 0) != 42LL
          || XWINT (x10, 0) != 106LL
          || XWINT (x11, 0) != 43LL
          || XWINT (x12, 0) != 107LL
          || XWINT (x13, 0) != 44LL
          || XWINT (x14, 0) != 108LL
          || XWINT (x15, 0) != 45LL
          || XWINT (x16, 0) != 109LL
          || XWINT (x17, 0) != 46LL
          || XWINT (x18, 0) != 110LL
          || XWINT (x19, 0) != 47LL
          || XWINT (x20, 0) != 111LL
          || XWINT (x21, 0) != 56LL
          || XWINT (x22, 0) != 120LL
          || XWINT (x23, 0) != 57LL
          || XWINT (x24, 0) != 121LL
          || XWINT (x25, 0) != 58LL
          || XWINT (x26, 0) != 122LL
          || XWINT (x27, 0) != 59LL
          || XWINT (x28, 0) != 123LL
          || XWINT (x29, 0) != 60LL
          || XWINT (x30, 0) != 124LL
          || XWINT (x31, 0) != 61LL
          || XWINT (x32, 0) != 125LL
          || XWINT (x33, 0) != 62LL
          || XWINT (x34, 0) != 126LL
          || XWINT (x35, 0) != 63LL
          || XWINT (x36, 0) != 127LL
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19437 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8324; /* avx512bw_interleave_highv64qi_mask */

    case 0LL:
      x40 = XVECEXP (x4, 0, 1);
      if (XWINT (x40, 0) != 64LL)
        return -1;
      x41 = XVECEXP (x4, 0, 2);
      if (XWINT (x41, 0) != 1LL)
        return -1;
      x42 = XVECEXP (x4, 0, 3);
      if (XWINT (x42, 0) != 65LL)
        return -1;
      x43 = XVECEXP (x4, 0, 4);
      if (XWINT (x43, 0) != 2LL)
        return -1;
      x44 = XVECEXP (x4, 0, 5);
      if (XWINT (x44, 0) != 66LL)
        return -1;
      x45 = XVECEXP (x4, 0, 6);
      if (XWINT (x45, 0) != 3LL)
        return -1;
      x46 = XVECEXP (x4, 0, 7);
      if (XWINT (x46, 0) != 67LL)
        return -1;
      x47 = XVECEXP (x4, 0, 8);
      if (XWINT (x47, 0) != 4LL)
        return -1;
      x48 = XVECEXP (x4, 0, 9);
      if (XWINT (x48, 0) != 68LL)
        return -1;
      x49 = XVECEXP (x4, 0, 10);
      if (XWINT (x49, 0) != 5LL)
        return -1;
      x50 = XVECEXP (x4, 0, 11);
      if (XWINT (x50, 0) != 69LL)
        return -1;
      x51 = XVECEXP (x4, 0, 12);
      if (XWINT (x51, 0) != 6LL)
        return -1;
      x52 = XVECEXP (x4, 0, 13);
      if (XWINT (x52, 0) != 70LL)
        return -1;
      x53 = XVECEXP (x4, 0, 14);
      if (XWINT (x53, 0) != 7LL)
        return -1;
      x54 = XVECEXP (x4, 0, 15);
      if (XWINT (x54, 0) != 71LL)
        return -1;
      x55 = XVECEXP (x4, 0, 16);
      if (XWINT (x55, 0) != 16LL)
        return -1;
      x56 = XVECEXP (x4, 0, 17);
      if (XWINT (x56, 0) != 80LL)
        return -1;
      x57 = XVECEXP (x4, 0, 18);
      if (XWINT (x57, 0) != 17LL)
        return -1;
      x58 = XVECEXP (x4, 0, 19);
      if (XWINT (x58, 0) != 81LL)
        return -1;
      x59 = XVECEXP (x4, 0, 20);
      if (XWINT (x59, 0) != 18LL)
        return -1;
      x60 = XVECEXP (x4, 0, 21);
      if (XWINT (x60, 0) != 82LL)
        return -1;
      x61 = XVECEXP (x4, 0, 22);
      if (XWINT (x61, 0) != 19LL)
        return -1;
      x62 = XVECEXP (x4, 0, 23);
      if (XWINT (x62, 0) != 83LL)
        return -1;
      x63 = XVECEXP (x4, 0, 24);
      if (XWINT (x63, 0) != 20LL)
        return -1;
      x64 = XVECEXP (x4, 0, 25);
      if (XWINT (x64, 0) != 84LL)
        return -1;
      x65 = XVECEXP (x4, 0, 26);
      if (XWINT (x65, 0) != 21LL)
        return -1;
      x66 = XVECEXP (x4, 0, 27);
      if (XWINT (x66, 0) != 85LL)
        return -1;
      x67 = XVECEXP (x4, 0, 28);
      if (XWINT (x67, 0) != 22LL)
        return -1;
      x68 = XVECEXP (x4, 0, 29);
      if (XWINT (x68, 0) != 86LL)
        return -1;
      x69 = XVECEXP (x4, 0, 30);
      if (XWINT (x69, 0) != 23LL)
        return -1;
      x70 = XVECEXP (x4, 0, 31);
      if (XWINT (x70, 0) != 87LL
          || XWINT (x5, 0) != 32LL
          || XWINT (x6, 0) != 96LL
          || XWINT (x7, 0) != 33LL
          || XWINT (x8, 0) != 97LL
          || XWINT (x9, 0) != 34LL
          || XWINT (x10, 0) != 98LL
          || XWINT (x11, 0) != 35LL
          || XWINT (x12, 0) != 99LL
          || XWINT (x13, 0) != 36LL
          || XWINT (x14, 0) != 100LL
          || XWINT (x15, 0) != 37LL
          || XWINT (x16, 0) != 101LL
          || XWINT (x17, 0) != 38LL
          || XWINT (x18, 0) != 102LL
          || XWINT (x19, 0) != 39LL
          || XWINT (x20, 0) != 103LL
          || XWINT (x21, 0) != 48LL
          || XWINT (x22, 0) != 112LL
          || XWINT (x23, 0) != 49LL
          || XWINT (x24, 0) != 113LL
          || XWINT (x25, 0) != 50LL
          || XWINT (x26, 0) != 114LL
          || XWINT (x27, 0) != 51LL
          || XWINT (x28, 0) != 115LL
          || XWINT (x29, 0) != 52LL
          || XWINT (x30, 0) != 116LL
          || XWINT (x31, 0) != 53LL
          || XWINT (x32, 0) != 117LL
          || XWINT (x33, 0) != 54LL
          || XWINT (x34, 0) != 118LL
          || XWINT (x35, 0) != 55LL
          || XWINT (x36, 0) != 119LL
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19533 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8330; /* avx512bw_interleave_lowv64qi_mask */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      return recog_145 (x1, insn, pnum_clobbers);

    case 2:
      return recog_144 (x1, insn, pnum_clobbers);

    case 3:
      return recog_143 (x1, insn, pnum_clobbers);

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 164:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1454 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 13664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 5464; /* avx512f_vternlogv16si_maskz_1 */

                case E_V8SImode:
                  if (pattern1454 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5466; /* avx512vl_vternlogv8si_maskz_1 */

                case E_V4SImode:
                  if (pattern1454 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5468; /* avx512vl_vternlogv4si_maskz_1 */

                case E_V8DImode:
                  if (pattern1454 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 5470; /* avx512f_vternlogv8di_maskz_1 */

                case E_V4DImode:
                  if (pattern1454 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5472; /* avx512vl_vternlogv4di_maskz_1 */

                case E_V2DImode:
                  if (pattern1454 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 5474; /* avx512vl_vternlogv2di_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x2, 2);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1455 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7035; /* *avx512f_vternlogv16si_mask */

                case E_V8SImode:
                  if (pattern1455 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7036; /* *avx512vl_vternlogv8si_mask */

                case E_V4SImode:
                  if (pattern1455 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7037; /* *avx512vl_vternlogv4si_mask */

                case E_V8DImode:
                  if (pattern1455 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7038; /* *avx512f_vternlogv8di_mask */

                case E_V4DImode:
                  if (pattern1455 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7039; /* *avx512vl_vternlogv4di_mask */

                case E_V2DImode:
                  if (pattern1455 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7040; /* *avx512vl_vternlogv2di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 163:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1456 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7105; /* avx512f_fixupimmv16sf_maskz_1 */

                case E_V8SFmode:
                  if (pattern1456 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7109; /* avx512vl_fixupimmv8sf_maskz_1 */

                case E_V4SFmode:
                  if (pattern1456 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7112; /* avx512vl_fixupimmv4sf_maskz_1 */

                case E_V8DFmode:
                  if (pattern1456 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7115; /* avx512f_fixupimmv8df_maskz_1 */

                case E_V4DFmode:
                  if (pattern1456 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7119; /* avx512vl_fixupimmv4df_maskz_1 */

                case E_V2DFmode:
                  if (pattern1456 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7122; /* avx512vl_fixupimmv2df_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              x9 = XEXP (x2, 2);
              switch (GET_CODE (x9))
                {
                case REG:
                case SUBREG:
                  operands[5] = x9;
                  if (!rtx_equal_p (x8, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16SFmode:
                      if (pattern1515 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                          || !(
#line 14175 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 7123; /* avx512f_fixupimmv16sf_mask */

                    case E_V8SFmode:
                      if (pattern1515 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7125; /* avx512vl_fixupimmv8sf_mask */

                    case E_V4SFmode:
                      if (pattern1515 (x2, 
E_V4SImode, 
E_V4SFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7127; /* avx512vl_fixupimmv4sf_mask */

                    case E_V8DFmode:
                      if (pattern1515 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 7128; /* avx512f_fixupimmv8df_mask */

                    case E_V4DFmode:
                      if (pattern1515 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7130; /* avx512vl_fixupimmv4df_mask */

                    case E_V2DFmode:
                      if (pattern1515 (x2, 
E_V2DImode, 
E_V2DFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 7132; /* avx512vl_fixupimmv2df_mask */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x9, 0) != 1LL
                      || !rtx_equal_p (x8, operands[2]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern1516 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                          || !
#line 14207 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                        return -1;
                      return 7133; /* avx512f_sfixupimmv4sf */

                    case E_V2DFmode:
                      if (pattern1516 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                          || !(
#line 14207 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 7137; /* avx512f_sfixupimmv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern140 (x2))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17303 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7648; /* ashlv16hi3_mask */
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28947 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9603; /* avx512vl_ashlvv16hi_mask */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17303 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7652; /* ashlv8hi3_mask */
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28947 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9599; /* avx512vl_ashlvv8hi_mask */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7656; /* ashlv8si3_mask */
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9579; /* avx2_ashlvv8si_mask */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7660; /* ashlv4si3_mask */
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9583; /* avx2_ashlvv4si_mask */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7664; /* ashlv4di3_mask */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9591; /* avx2_ashlvv4di_mask */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7668; /* ashlv2di3_mask */
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9595; /* avx2_ashlvv2di_mask */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17391 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
        return 7688; /* ashlv32hi3_mask */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28947 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9607; /* avx512bw_ashlvv32hi_mask */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17391 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7692; /* ashlv16si3_mask */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28936 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 803 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9575; /* avx512f_ashlvv16si_mask */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17391 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7696; /* ashlv8di3_mask */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28936 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 804 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 9587; /* avx512f_ashlvv8di_mask */

    default:
      return -1;
    }
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern136 (x2))
    {
    case 0:
      if (pattern774 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4611; /* avx512fp16_fix_truncv8hi2_mask */

    case 1:
      if (pattern774 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4616; /* avx512fp16_fix_truncv16hi2_mask */

    case 2:
      if (pattern774 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4624; /* avx512fp16_fix_truncv32hi2_mask */

    case 3:
      if (pattern773 (x2, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4632; /* avx512fp16_fix_truncv8si2_mask */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8806 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4896; /* fix_truncv8sfv8si2_mask */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5038; /* fix_truncv8dfv8si2_mask */

        default:
          return -1;
        }

    case 4:
      switch (pattern895 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4640; /* avx512fp16_fix_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4885; /* fix_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern896 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4648; /* avx512fp16_fix_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5083; /* fix_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 5138; /* fix_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern773 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4675; /* *avx512fp16_fix_truncv4si2_load_mask */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8836 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 4900; /* fix_truncv4sfv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9671 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F))))
            return -1;
          return 5054; /* fix_truncv4dfv4si2_mask */

        default:
          return -1;
        }

    case 7:
      switch (pattern897 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4679; /* *avx512fp16_fix_truncv4di2_load_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5091; /* fix_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5142; /* fix_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case 8:
      switch (pattern898 (x2))
        {
        case 0:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7978 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4691; /* *avx512fp16_fix_truncv2di2_load_mask */

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5098; /* fix_truncv2dfv2di2_mask */

        default:
          return -1;
        }

    case 9:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4667; /* avx512fp16_fix_truncv4si2_mask */

    case 10:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4671; /* avx512fp16_fix_truncv4di2_mask */

    case 11:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7968 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4687; /* avx512fp16_fix_truncv2di2_mask */

    case 12:
      if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9778 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 5150; /* avx512dq_fix_truncv2sfv2di2_mask */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      switch (pattern132 (x2))
        {
        case 0:
          if (!(
#line 2800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2831; /* avx512fp16_vmdivv8hf3 */

        case 1:
          if (!
#line 2800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2839; /* sse_vmdivv4sf3 */

        case 2:
          if (!(
#line 2800 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2847; /* sse2_vmdivv2df3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1010 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2853; /* avx512fp16_divv32hf3_mask */

        case E_V16HFmode:
          if (pattern1010 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2857; /* avx512fp16_divv16hf3_mask */

        case E_V8HFmode:
          if (pattern1010 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2860; /* avx512fp16_divv8hf3_mask */

        case E_V16SFmode:
          if (pattern1010 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2863; /* avx512f_divv16sf3_mask */

        case E_V8SFmode:
          if (pattern1010 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2867; /* avx_divv8sf3_mask */

        case E_V4SFmode:
          if (pattern1010 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1)))
            return -1;
          return 2870; /* sse_divv4sf3_mask */

        case E_V8DFmode:
          if (pattern1010 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2873; /* avx512f_divv8df3_mask */

        case E_V4DFmode:
          if (pattern1010 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2877; /* avx_divv4df3_mask */

        case E_V2DFmode:
          if (pattern1010 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2880; /* sse2_divv2df3_mask */

        case E_V32BFmode:
          if (pattern130 (x2, 
E_V32BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10616; /* avx10_2_divbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern130 (x2, 
E_V16BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10624; /* avx10_2_divbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern130 (x2, 
E_V8BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32123 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10632; /* avx10_2_divbf16_v8bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4568; /* unspec_avx512fp16_fixuns_truncv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4574; /* unspec_avx512fp16_fixuns_truncv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4582; /* unspec_avx512fp16_fixuns_truncv32hi2 */

    case E_V8SImode:
      switch (pattern642 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4590; /* unspec_avx512fp16_fixuns_truncv8si2 */

        case 1:
          if (!
#line 9571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5032; /* unspec_fixuns_truncv8dfv8si2 */

        case 2:
          if (!(
#line 9916 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && 1) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5153; /* *unspec_fixuns_truncv8sfv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern641 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4598; /* unspec_avx512fp16_fixuns_truncv16si2 */

        case 1:
          if (!
#line 8776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4879; /* unspec_fixuns_truncv16sfv16si2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern642 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4606; /* unspec_avx512fp16_fixuns_truncv8di2 */

        case 1:
          if (!(
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5065; /* unspec_fixuns_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5125; /* unspec_fixuns_truncv8sfv8di2 */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern643 (x2, 
E_V4SImode))
        {
        case 0:
          if (!
#line 7906 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4656; /* unspec_avx512fp16_fixuns_truncv4si2 */

        case 1:
          if (!
#line 9681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F
  && (!false || TARGET_AVX10_2_256)))
            return -1;
          return 5055; /* unspec_fixuns_truncv4dfv4si2 */

        case 2:
          if (!
#line 9916 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && 1))
            return -1;
          return 5157; /* *unspec_fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern643 (x2, 
E_V4DImode))
        {
        case 0:
          if (!
#line 7906 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
            return -1;
          return 4662; /* unspec_avx512fp16_fixuns_truncv4di2 */

        case 1:
          if (!(
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5073; /* unspec_fixuns_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5133; /* unspec_fixuns_truncv4sfv4di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern644 (x2))
        {
        case 0:
          if (!
#line 7956 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4684; /* unspec_avx512fp16_fixuns_truncv2di2 */

        case 1:
          if (!(
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5079; /* unspec_fixuns_truncv2dfv2di2 */

        case 2:
          if (!
#line 9766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 5147; /* unspec_avx512dq_fixuns_truncv2sfv2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SQRT:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1403 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 444 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3101 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2953; /* *avx512fp16_vmsqrtv8hf2_round */

        case E_V4SFmode:
          if (pattern1403 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 444 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3101 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2957; /* *sse_vmsqrtv4sf2_round */

        case E_V2DFmode:
          if (pattern1403 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 444 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3101 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2961; /* *sse2_vmsqrtv2df2_round */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern909 (x2))
        {
        case 0:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7851 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4559; /* avx512fp16_vcvtsi2sh_round */

        case 1:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7851 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 4563; /* avx512fp16_vcvtsi2shq_round */

        case 2:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8530 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 4791; /* sse_cvtsi2ss_round */

        case 3:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8530 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 4793; /* sse_cvtsi2ssq_round */

        case 4:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9014 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_64BIT)))
            return -1;
          return 4910; /* sse2_cvtsi2sdq_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern909 (x2))
        {
        case 0:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7851 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4561; /* avx512fp16_vcvtusi2sh_round */

        case 1:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7851 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return -1;
          return 4565; /* avx512fp16_vcvtusi2shq_round */

        case 2:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V4SFmode == V4SFmode))))
            return -1;
          return 4809; /* cvtusi2ss32_round */

        case 3:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8640 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_64BIT)))
            return -1;
          return 4812; /* cvtusi2ss64_round */

        case 4:
          if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8640 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_64BIT) && 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 4814; /* cvtusi2sd64_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XEXP (x6, 0);
      if (pattern907 (x7, 
1, 
E_HFmode) != 0)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const48_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1670 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 486 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4764; /* avx512fp16_vcvtsh2sd_round */

        case E_V4SFmode:
          if (pattern1670 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 486 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4768; /* avx512fp16_vcvtsh2ss_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != PARALLEL
              || XVECLEN (x11, 0) != 1)
            return -1;
          x12 = XVECEXP (x11, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern1404 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !(
#line 444 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8341 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4775; /* avx512fp16_vcvtsd2sh_round */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 444 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8341 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4779; /* avx512fp16_vcvtss2sh_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2DFmode)
              || pattern1404 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0)
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10016 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5169; /* sse2_cvtsd2ss_round */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 94)
        return -1;
      x13 = XVECEXP (x6, 0, 0);
      operands[2] = x13;
      x14 = XVECEXP (x6, 0, 1);
      operands[3] = x14;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[4] = x9;
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1585 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14268 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 7188; /* *avx512f_rndscalev8hf_round */

        case E_V4SFmode:
          if (pattern1585 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F))
            return -1;
          return 7190; /* *avx512f_rndscalev4sf_round */

        case E_V2DFmode:
          if (pattern1585 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14268 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 7192; /* *avx512f_rndscalev2df_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (XINT (x3, 1))
    {
    case 156:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4423; /* avx512fp16_vcvtph2uw_v32hi_round */

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4431; /* avx512fp16_vcvtph2udq_v16si_round */

            case E_V16SFmode:
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4846; /* *avx512f_fixuns_notruncv16sfv16si_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1219 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4439; /* avx512fp16_vcvtph2uqq_v8di_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8752 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4866; /* *avx512dq_cvtps2uqqv8di_round */

            case 2:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9734 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5112; /* fixuns_notruncv8dfv8di2_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4447; /* avx512fp16_vcvtph2uw_v16hi_round */

        case E_V8SImode:
          switch (pattern1219 (x2, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4455; /* avx512fp16_vcvtph2udq_v8si_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8719 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4850; /* *avx512vl_fixuns_notruncv8sfv8si_round */

            case 2:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5018; /* fixuns_notruncv8dfv8si2_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1220 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4463; /* avx512fp16_vcvtph2uqq_v4di_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8752 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4870; /* *avx512dq_cvtps2uqqv4di_round */

            case 2:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9734 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 5116; /* fixuns_notruncv4dfv4di2_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 5022; /* fixuns_notruncv4dfv4si2_round */

        default:
          return -1;
        }

    case 46:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4427; /* avx512fp16_vcvtph2w_v32hi_round */

        case E_V16SImode:
          switch (pattern1221 (x2))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4435; /* avx512fp16_vcvtph2dq_v16si_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8708 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4842; /* avx512f_fix_notruncv16sfv16si_round */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4443; /* avx512fp16_vcvtph2qq_v8di_round */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8729 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4856; /* *avx512dq_cvtps2qqv8di_round */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5102; /* fix_notruncv8dfv8di2_round */

            default:
              return -1;
            }

        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4451; /* avx512fp16_vcvtph2w_v16hi_round */

        case E_V8SImode:
          switch (pattern1222 (x2))
            {
            case 0:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 758 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4459; /* avx512fp16_vcvtph2dq_v8si_round */

            case 1:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8692 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 665 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 4836; /* avx_fix_notruncv8sfv8si_round */

            case 2:
              if (!(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5006; /* avx512f_cvtpd2dq512_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1220 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7630 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 759 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4467; /* avx512fp16_vcvtph2qq_v4di_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8729 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4860; /* *avx512dq_cvtps2qqv4di_round */

            case 2:
              if (!register_operand (operands[1], E_V4DFmode)
                  || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9723 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 5106; /* fix_notruncv4dfv4di2_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1019 (x2, 
E_V4DFmode, 
E_V4SImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!true || TARGET_AVX10_2_256))))
            return -1;
          return 5010; /* avx_cvtpd2dq256_round */

        default:
          return -1;
        }

    case 172:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4571; /* unspec_avx512fp16_fix_truncv16hi2_round */

        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4579; /* unspec_avx512fp16_fix_truncv32hi2_round */

        case E_V8SImode:
          switch (pattern1222 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4587; /* unspec_avx512fp16_fix_truncv8si2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8796 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1
  && (!true || TARGET_AVX10_2_256))))
                return -1;
              return 4892; /* unspec_fix_truncv8sfv8si2_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5029; /* unspec_fix_truncv8dfv8si2_round */

            default:
              return -1;
            }

        case E_V16SImode:
          switch (pattern1221 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4595; /* unspec_avx512fp16_fix_truncv16si2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4876; /* unspec_fix_truncv16sfv16si2_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1223 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4603; /* unspec_avx512fp16_fix_truncv8di2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5062; /* unspec_fix_truncv8dfv8di2_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5122; /* unspec_fix_truncv8sfv8di2_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1224 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7906 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode))))))
                return -1;
              return 4659; /* unspec_avx512fp16_fix_truncv4di2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 5070; /* unspec_fix_truncv4dfv4di2_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 5130; /* unspec_fix_truncv4sfv4di2_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1019 (x2, 
E_V4DFmode, 
E_V4SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && (!true || TARGET_AVX10_2_256))))
            return -1;
          return 5050; /* unspec_fix_truncv4dfv4si2_round */

        default:
          return -1;
        }

    case 173:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4575; /* unspec_avx512fp16_fixuns_truncv16hi2_round */

        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4583; /* unspec_avx512fp16_fixuns_truncv32hi2_round */

        case E_V8SImode:
          switch (pattern1223 (x2, 
E_V8SImode))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4591; /* unspec_avx512fp16_fixuns_truncv8si2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5033; /* unspec_fixuns_truncv8dfv8si2_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9916 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 5154; /* *unspec_fixuns_truncv8sfv8si2_round */

            default:
              return -1;
            }

        case E_V16SImode:
          switch (pattern1221 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4599; /* unspec_avx512fp16_fixuns_truncv16si2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4880; /* unspec_fixuns_truncv16sfv16si2_round */

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1223 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7868 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4607; /* unspec_avx512fp16_fixuns_truncv8di2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5066; /* unspec_fixuns_truncv8dfv8di2_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 5126; /* unspec_fixuns_truncv8sfv8di2_round */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1224 (x2))
            {
            case 0:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7906 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode))))))
                return -1;
              return 4663; /* unspec_avx512fp16_fixuns_truncv4di2_round */

            case 1:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9702 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 5074; /* unspec_fixuns_truncv4dfv4di2_round */

            case 2:
              if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9745 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 5134; /* unspec_fixuns_truncv4sfv4di2_round */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern1019 (x2, 
E_V4DFmode, 
E_V4SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9681 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F
  && (!true || TARGET_AVX10_2_256))))
            return -1;
          return 5056; /* unspec_fixuns_truncv4dfv4si2_round */

        default:
          return -1;
        }

    case 165:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1225 (x2, 
E_V32HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 7042; /* avx512bw_getexpv32hf_round */

        case E_V16HFmode:
          if (pattern1225 (x2, 
E_V16HFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 7046; /* avx512vl_getexpv16hf_round */

        case E_V16SFmode:
          if (pattern1225 (x2, 
E_V16SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7052; /* avx512f_getexpv16sf_round */

        case E_V8SFmode:
          if (pattern1225 (x2, 
E_V8SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7056; /* avx512vl_getexpv8sf_round */

        case E_V8DFmode:
          if (pattern1225 (x2, 
E_V8DFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7062; /* avx512f_getexpv8df_round */

        case E_V4DFmode:
          if (pattern1225 (x2, 
E_V4DFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14044 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7066; /* avx512vl_getexpv4df_round */

        default:
          return -1;
        }

    case 149:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1019 (x2, 
E_V8HImode, 
E_V8SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29109 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL)
   && (!true || TARGET_AVX10_2_256))))
            return -1;
          return 9655; /* vcvtph2ps256_round */

        case E_V16SFmode:
          if (pattern1019 (x2, 
E_V16HImode, 
E_V16SFmode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29122 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9659; /* *avx512f_vcvtph2ps512_round */

        default:
          return -1;
        }

    case 265:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10760; /* avx10_2_cvtph2ibsv32hf_round */

        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode))))))
            return -1;
          return 10768; /* avx10_2_cvtph2ibsv16hf_round */

        default:
          return -1;
        }

    case 266:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10764; /* avx10_2_cvtph2iubsv32hf_round */

        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32511 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode))))))
            return -1;
          return 10772; /* avx10_2_cvtph2iubsv16hf_round */

        default:
          return -1;
        }

    case 271:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10780; /* avx10_2_cvttph2ibsv32hf_round */

        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode))))))
            return -1;
          return 10788; /* avx10_2_cvttph2ibsv16hf_round */

        default:
          return -1;
        }

    case 272:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1019 (x2, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 561 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10784; /* avx10_2_cvttph2iubsv32hf_round */

        case E_V16HImode:
          if (pattern1019 (x2, 
E_V16HFmode, 
E_V16HImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode))))))
            return -1;
          return 10792; /* avx10_2_cvttph2iubsv16hf_round */

        default:
          return -1;
        }

    case 267:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1019 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10800; /* avx10_2_cvtps2ibsv16sf_round */

        case E_V8SImode:
          if (pattern1019 (x2, 
E_V8SFmode, 
E_V8SImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode))))))
            return -1;
          return 10808; /* avx10_2_cvtps2ibsv8sf_round */

        default:
          return -1;
        }

    case 268:
      if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1019 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10804; /* avx10_2_cvtps2iubsv16sf_round */

        case E_V8SImode:
          if (pattern1019 (x2, 
E_V8SFmode, 
E_V8SImode) != 0
              || !(
#line 234 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32541 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode))))))
            return -1;
          return 10812; /* avx10_2_cvtps2iubsv8sf_round */

        default:
          return -1;
        }

    case 273:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1019 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10820; /* avx10_2_cvttps2ibsv16sf_round */

        case E_V8SImode:
          if (pattern1019 (x2, 
E_V8SFmode, 
E_V8SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode))))))
            return -1;
          return 10828; /* avx10_2_cvttps2ibsv8sf_round */

        default:
          return -1;
        }

    case 274:
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1019 (x2, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10824; /* avx10_2_cvttps2iubsv16sf_round */

        case E_V8SImode:
          if (pattern1019 (x2, 
E_V8SFmode, 
E_V8SImode) != 0
              || !(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32556 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode))))))
            return -1;
          return 10832; /* avx10_2_cvttps2iubsv8sf_round */

        default:
          return -1;
        }

    case 275:
      switch (pattern1020 (x2))
        {
        case 0:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10840; /* avx10_2_vcvttps2dqsv16sf_round */

        case 1:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode))))))
            return -1;
          return 10848; /* avx10_2_vcvttps2dqsv8sf_round */

        case 2:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10860; /* avx10_2_vcvttpd2dqsv8df_round */

        case 3:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode))))))
            return -1;
          return 10868; /* avx10_2_vcvttpd2dqsv4df_round */

        case 4:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10880; /* avx10_2_vcvttpd2qqsv8df_round */

        case 5:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 617 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10900; /* avx10_2_vcvttps2qqsv8di_round */

        case 6:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode))))))
            return -1;
          return 10888; /* avx10_2_vcvttpd2qqsv4df_round */

        case 7:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode))))))
            return -1;
          return 10908; /* avx10_2_vcvttps2qqsv4di_round */

        default:
          return -1;
        }

    case 276:
      switch (pattern1020 (x2))
        {
        case 0:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10844; /* avx10_2_vcvttps2udqsv16sf_round */

        case 1:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode))))))
            return -1;
          return 10852; /* avx10_2_vcvttps2udqsv8sf_round */

        case 2:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10864; /* avx10_2_vcvttpd2udqsv8df_round */

        case 3:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode))))))
            return -1;
          return 10872; /* avx10_2_vcvttpd2udqsv4df_round */

        case 4:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10884; /* avx10_2_vcvttpd2uqqsv8df_round */

        case 5:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 617 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10904; /* avx10_2_vcvttps2uqqsv8di_round */

        case 6:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32586 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode))))))
            return -1;
          return 10892; /* avx10_2_vcvttpd2uqqsv4df_round */

        case 7:
          if (!(
#line 286 "../../gcc-15.0.1-20250313/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32597 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode))))))
            return -1;
          return 10912; /* avx10_2_vcvttps2uqqsv4di_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 46:
          if (GET_MODE (x3) == E_V4SImode
              && pattern794 (x2, 
E_V4SImode, 
E_V4DFmode, 
E_V8SImode) == 0
              && 
#line 9443 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 5013; /* *avx_cvtpd2dq256_2 */
          if (GET_MODE (x3) != E_V2SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != CONST_VECTOR
              || pattern509 (x5, 
E_V2SImode, 
2) != 0
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vector_operand (operands[1], E_V2DFmode)
              || !
#line 9456 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 5014; /* sse2_cvtpd2dq */

        case 156:
          if (pattern668 (x2) != 0
              || !
#line 9526 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5025; /* fixuns_notruncv2dfv2si2 */

        case 173:
          if (pattern668 (x2) != 0
              || !
#line 9593 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 5044; /* *unspec_fixuns_truncv2dfv2si2 */

        case 253:
          if (GET_MODE (x3) != E_V8QImode
              || pattern794 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10498; /* *vcvtph2bf8v8hf */

        case 254:
          if (GET_MODE (x3) != E_V8QImode
              || pattern794 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10499; /* *vcvtph2bf8sv8hf */

        case 255:
          if (GET_MODE (x3) != E_V8QImode
              || pattern794 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10500; /* *vcvtph2hf8v8hf */

        case 256:
          if (GET_MODE (x3) != E_V8QImode
              || pattern794 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31867 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10501; /* *vcvtph2hf8sv8hf */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_255_operand (operands[2], E_SImode)
              || !const0_operand (operands[3], E_V4HImode)
              || !
#line 29158 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL) && 1))
            return -1;
          return 9662; /* *vcvtps2ph */

        case 245:
          if (pattern922 (x2) != 0
              || !
#line 31777 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10474; /* *vcvtbiasph2bf8v8hf */

        case 246:
          if (pattern922 (x2) != 0
              || !
#line 31777 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10475; /* *vcvtbiasph2bf8sv8hf */

        case 247:
          if (pattern922 (x2) != 0
              || !
#line 31777 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10476; /* *vcvtbiasph2hf8v8hf */

        case 248:
          if (pattern922 (x2) != 0
              || !
#line 31777 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10477; /* *vcvtbiasph2hf8sv8hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern799 (
E_V8SFmode) == 0)
            {
              if ((
#line 4329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE
   && GET_RTX_CLASS (GET_CODE (operands[3])) == RTX_COMM_COMPARE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 3271; /* *avx_maskcmpv8sf3_comm */
              if ((
#line 4346 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 3275; /* avx_maskcmpv8sf3 */
            }
          break;

        case E_V4SFmode:
          if (pattern799 (
E_V4SFmode) == 0)
            {
              if (
#line 4329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE
   && GET_RTX_CLASS (GET_CODE (operands[3])) == RTX_COMM_COMPARE))
                return 3272; /* *sse_maskcmpv4sf3_comm */
              if (
#line 4346 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE))
                return 3276; /* sse_maskcmpv4sf3 */
            }
          break;

        case E_V4DFmode:
          if (pattern799 (
E_V4DFmode) == 0)
            {
              if ((
#line 4329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE
   && GET_RTX_CLASS (GET_CODE (operands[3])) == RTX_COMM_COMPARE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 3273; /* *avx_maskcmpv4df3_comm */
              if ((
#line 4346 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 3277; /* avx_maskcmpv4df3 */
            }
          break;

        case E_V2DFmode:
          if (pattern799 (
E_V2DFmode) == 0)
            {
              if ((
#line 4329 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE
   && GET_RTX_CLASS (GET_CODE (operands[3])) == RTX_COMM_COMPARE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return 3274; /* *sse2_maskcmpv2df3_comm */
              if ((
#line 4346 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return 3278; /* sse2_maskcmpv2df3 */
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern233 (x2, 
E_V16HImode) != 0
              || !(
#line 17140 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 743 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7626; /* *ashrv16hi3_1 */

        case E_V8HImode:
          if (pattern233 (x2, 
E_V8HImode) != 0
              || !
#line 17140 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 7627; /* *ashrv8hi3_1 */

        case E_V8SImode:
          if (pattern233 (x2, 
E_V8SImode) != 0
              || !(
#line 17140 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 744 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7628; /* *ashrv8si3_1 */

        case E_V4SImode:
          if (pattern233 (x2, 
E_V4SImode) != 0
              || !
#line 17140 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 7629; /* *ashrv4si3_1 */

        default:
          return -1;
        }

    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern5 (x2, 
E_V32QImode) != 0
              || !
#line 17948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7890; /* *avx2_eqv32qi3 */

        case E_V16HImode:
          if (pattern5 (x2, 
E_V16HImode) != 0
              || !
#line 17948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7891; /* *avx2_eqv16hi3 */

        case E_V8SImode:
          if (pattern5 (x2, 
E_V8SImode) != 0
              || !
#line 17948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7892; /* *avx2_eqv8si3 */

        case E_V4DImode:
          if (pattern5 (x2, 
E_V4DImode) != 0
              || !
#line 17948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7893; /* *avx2_eqv4di3 */

        case E_V2DImode:
          if (pattern25 (x2, 
E_V2DImode) != 0
              || !
#line 18231 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7948; /* *sse4_1_eqv2di3 */

        case E_V16QImode:
          if (pattern25 (x2, 
E_V16QImode) != 0
              || !
#line 18248 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7949; /* *sse2_eqv16qi3 */

        case E_V8HImode:
          if (pattern25 (x2, 
E_V8HImode) != 0
              || !
#line 18248 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7950; /* *sse2_eqv8hi3 */

        case E_V4SImode:
          if (pattern25 (x2, 
E_V4SImode) != 0
              || !
#line 18248 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 7951; /* *sse2_eqv4si3 */

        default:
          return -1;
        }

    case GT:
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern669 (x2, 
E_V2DImode) != 0
              || !
#line 18264 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 7952; /* sse4_2_gtv2di3 */

        case E_V32QImode:
          if (pattern14 (x2, 
E_V32QImode) != 0
              || !
#line 18281 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7953; /* avx2_gtv32qi3 */

        case E_V16HImode:
          if (pattern14 (x2, 
E_V16HImode) != 0
              || !
#line 18281 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7954; /* avx2_gtv16hi3 */

        case E_V8SImode:
          if (pattern14 (x2, 
E_V8SImode) != 0
              || !
#line 18281 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7955; /* avx2_gtv8si3 */

        case E_V4DImode:
          if (pattern14 (x2, 
E_V4DImode) != 0
              || !
#line 18281 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7956; /* avx2_gtv4di3 */

        case E_V16QImode:
          if (pattern669 (x2, 
E_V16QImode) != 0
              || !
#line 18313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 7957; /* *sse2_gtv16qi3 */

        case E_V8HImode:
          if (pattern669 (x2, 
E_V8HImode) != 0
              || !
#line 18313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 7958; /* *sse2_gtv8hi3 */

        case E_V4SImode:
          if (pattern669 (x2, 
E_V4SImode) != 0
              || !
#line 18313 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 7959; /* *sse2_gtv4si3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_274 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  res = recog_275 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT
      || pattern1316 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 2LL:
      if (XWINT (x5, 0) != 6LL
          || XWINT (x6, 0) != 3LL
          || XWINT (x7, 0) != 7LL
          || !
#line 19772 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 8375; /* vec_interleave_highv4si */

    case 0LL:
      if (XWINT (x5, 0) != 4LL
          || XWINT (x6, 0) != 1LL
          || XWINT (x7, 0) != 5LL
          || !
#line 19826 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 8381; /* vec_interleave_lowv4si */

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_277 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern1414 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_8_to_11_operand (operands[5], E_VOIDmode)
          && const_8_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_12_to_15_operand (operands[9], E_VOIDmode)
          && const_12_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 11490 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX
   && 1
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4))))
        return 5275; /* avx_shufps256_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1672 () != 0
          || !
#line 20347 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 8431; /* avx512vl_shuf_f32x4_1 */

    case E_V8DFmode:
      if (pattern1414 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_8_to_9_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_10_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_5_operand (operands[7], E_VOIDmode)
          && const_12_to_13_operand (operands[8], E_VOIDmode)
          && const_6_to_7_operand (operands[9], E_VOIDmode)
          && const_14_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 14362 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 7195; /* avx512f_shufpd512_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1672 () != 0
          || !(
#line 20249 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8421; /* avx512f_shuf_f64x2_1 */

    case E_V8DImode:
      if (pattern1673 (x2, 
E_V8DImode, 
E_V16DImode) != 0
          || !(
#line 20249 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8423; /* avx512f_shuf_i64x2_1 */

    case E_V8SImode:
      if (pattern1673 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !
#line 20347 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 8429; /* avx512vl_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      x6 = XEXP (x2, 0);
      x7 = XEXP (x6, 1);
      operands[2] = x7;
      switch (XWINT (x4, 0))
        {
        case 1LL:
          if (XWINT (x5, 0) == 3LL)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1485 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13425 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 1)))
                    return 5410; /* *vec_interleave_highv2df */
                  break;

                case E_V2DImode:
                  if (pattern1486 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14508 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 7204; /* vec_interleave_highv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        case 0LL:
          if (XWINT (x5, 0) == 2LL)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1485 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13568 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 0)))
                    return 5420; /* *vec_interleave_lowv2df */
                  break;

                case E_V2DImode:
                  if (pattern1486 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14558 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 7210; /* vec_interleave_lowv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  operands[3] = x4;
  if (!const_0_to_1_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  if (!const_2_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern1486 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 14576 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7212; /* sse2_shufpd_v2di */

    case E_V2DFmode:
      if (pattern1486 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 14576 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7213; /* sse2_shufpd_v2df */

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern672 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 32);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 33);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 34);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 35);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 36);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 37);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 38);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 39);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x3, 0, 40);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x3, 0, 41);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x3, 0, 42);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x3, 0, 43);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x3, 0, 44);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x3, 0, 45);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x3, 0, 46);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x3, 0, 47);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x3, 0, 48);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x3, 0, 49);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x3, 0, 50);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x3, 0, 51);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x3, 0, 52);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x3, 0, 53);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x3, 0, 54);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x3, 0, 55);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x3, 0, 56);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x3, 0, 57);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x3, 0, 58);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x3, 0, 59);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x3, 0, 60);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x3, 0, 61);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  x34 = XVECEXP (x3, 0, 62);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XVECEXP (x3, 0, 63);
  if (GET_CODE (x35) != CONST_INT
      || pattern1618 (x2, 
E_V64QImode, 
E_V128QImode) != 0)
    return -1;
  x36 = XVECEXP (x3, 0, 0);
  switch (XWINT (x36, 0))
    {
    case 8LL:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 72LL)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 9LL)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 73LL)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 10LL)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 74LL)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 11LL)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 75LL)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 12LL)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 76LL)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 13LL)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 77LL)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 14LL)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 78LL)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 15LL)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 79LL)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 24LL)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 88LL)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 25LL)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 89LL)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 26LL)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 90LL)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 27LL)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 91LL)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 28LL)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 92LL)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 29LL)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 93LL)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 30LL)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 94LL)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 31LL)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 95LL
          || XWINT (x4, 0) != 40LL
          || XWINT (x5, 0) != 104LL
          || XWINT (x6, 0) != 41LL
          || XWINT (x7, 0) != 105LL
          || XWINT (x8, 0) != 42LL
          || XWINT (x9, 0) != 106LL
          || XWINT (x10, 0) != 43LL
          || XWINT (x11, 0) != 107LL
          || XWINT (x12, 0) != 44LL
          || XWINT (x13, 0) != 108LL
          || XWINT (x14, 0) != 45LL
          || XWINT (x15, 0) != 109LL
          || XWINT (x16, 0) != 46LL
          || XWINT (x17, 0) != 110LL
          || XWINT (x18, 0) != 47LL
          || XWINT (x19, 0) != 111LL
          || XWINT (x20, 0) != 56LL
          || XWINT (x21, 0) != 120LL
          || XWINT (x22, 0) != 57LL
          || XWINT (x23, 0) != 121LL
          || XWINT (x24, 0) != 58LL
          || XWINT (x25, 0) != 122LL
          || XWINT (x26, 0) != 59LL
          || XWINT (x27, 0) != 123LL
          || XWINT (x28, 0) != 60LL
          || XWINT (x29, 0) != 124LL
          || XWINT (x30, 0) != 61LL
          || XWINT (x31, 0) != 125LL
          || XWINT (x32, 0) != 62LL
          || XWINT (x33, 0) != 126LL
          || XWINT (x34, 0) != 63LL
          || XWINT (x35, 0) != 127LL
          || !
#line 19437 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8323; /* avx512bw_interleave_highv64qi */

    case 0LL:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 64LL)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 1LL)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 65LL)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 2LL)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 66LL)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 3LL)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 67LL)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 4LL)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 68LL)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 5LL)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 69LL)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 6LL)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 70LL)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 7LL)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 71LL)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 16LL)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 80LL)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 17LL)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 81LL)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 18LL)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 82LL)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 19LL)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 83LL)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 20LL)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 84LL)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 21LL)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 85LL)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 22LL)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 86LL)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 23LL)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 87LL
          || XWINT (x4, 0) != 32LL
          || XWINT (x5, 0) != 96LL
          || XWINT (x6, 0) != 33LL
          || XWINT (x7, 0) != 97LL
          || XWINT (x8, 0) != 34LL
          || XWINT (x9, 0) != 98LL
          || XWINT (x10, 0) != 35LL
          || XWINT (x11, 0) != 99LL
          || XWINT (x12, 0) != 36LL
          || XWINT (x13, 0) != 100LL
          || XWINT (x14, 0) != 37LL
          || XWINT (x15, 0) != 101LL
          || XWINT (x16, 0) != 38LL
          || XWINT (x17, 0) != 102LL
          || XWINT (x18, 0) != 39LL
          || XWINT (x19, 0) != 103LL
          || XWINT (x20, 0) != 48LL
          || XWINT (x21, 0) != 112LL
          || XWINT (x22, 0) != 49LL
          || XWINT (x23, 0) != 113LL
          || XWINT (x24, 0) != 50LL
          || XWINT (x25, 0) != 114LL
          || XWINT (x26, 0) != 51LL
          || XWINT (x27, 0) != 115LL
          || XWINT (x28, 0) != 52LL
          || XWINT (x29, 0) != 116LL
          || XWINT (x30, 0) != 53LL
          || XWINT (x31, 0) != 117LL
          || XWINT (x32, 0) != 54LL
          || XWINT (x33, 0) != 118LL
          || XWINT (x34, 0) != 55LL
          || XWINT (x35, 0) != 119LL
          || !
#line 19533 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8329; /* avx512bw_interleave_lowv64qi */

    default:
      return -1;
    }
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern532 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5541; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5568; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5595; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5622; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5649; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5676; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5703; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5730; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5757; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5784; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5811; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5838; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5544; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5571; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5598; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5625; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5652; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5679; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5706; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5733; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5760; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5787; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5814; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5841; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5547; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5574; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5601; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5628; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5655; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5682; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5709; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5736; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5763; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5790; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5817; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5844; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6825; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6834; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6843; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6852; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6861; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6870; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6879; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6888; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6897; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6906; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6915; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6924; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6189; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6216; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6243; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6270; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6297; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6324; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6351; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6378; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6405; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6432; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6459; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6486; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6192; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6219; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6246; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6273; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6300; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6327; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6354; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6381; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6408; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6435; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6462; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6489; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern534 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6195; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6222; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6249; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6276; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6303; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6330; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6357; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6384; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6411; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6438; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6465; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6492; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern536 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5867; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5894; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5921; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5948; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5975; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6002; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6029; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6056; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6083; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6110; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6137; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6164; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5870; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5897; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5924; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5951; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5978; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6005; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6032; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6059; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6086; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6113; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6140; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6167; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5873; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5900; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5927; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5954; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5981; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6008; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6035; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6062; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6089; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6116; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6143; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6170; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6935; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6944; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6953; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6962; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6971; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6980; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6989; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6998; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 7007; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7016; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7025; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 7034; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6515; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6542; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6569; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6596; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6623; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6650; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6677; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6704; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6731; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6758; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6785; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6812; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6518; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6545; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6572; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6599; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6626; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6653; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6680; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6707; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6734; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6761; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6788; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6815; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern537 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6521; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6548; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6575; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6602; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6629; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6656; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6683; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6710; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6737; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6764; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6791; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6818; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4714; /* avx512fp16_float_extend_phv8df2 */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 10234 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1 && 1) && 
#line 467 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5190; /* avx512f_cvtps2pd512 */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode
              || !vector_operand (operands[1], E_V16HFmode)
              || !(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4718; /* avx512fp16_float_extend_phv16sf2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !vector_operand (operands[1], E_V8HFmode)
              || !(
#line 8031 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4722; /* avx512fp16_float_extend_phv8sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode)
                  || !
#line 8070 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                return -1;
              return 4732; /* *avx512fp16_float_extend_phv4df2_load */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !
#line 10234 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1 && 1))
                return -1;
              return 5194; /* avx_cvtps2pd256 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_V4HFmode)
              || !
#line 8070 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4734; /* *avx512fp16_float_extend_phv4sf2_load */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode)
                  || !
#line 8109 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                return -1;
              return 4738; /* *avx512fp16_float_extend_phv2df2_load */

            case E_V2SFmode:
              if (!memory_operand (operands[1], E_V2SFmode)
                  || !
#line 10416 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                return -1;
              return 5244; /* sse2_cvtps2pd_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 4:
          x7 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x5, 0, 3);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          switch (pattern1142 (x5))
            {
            case 0:
              if (XWINT (x9, 0) != 2LL
                  || XWINT (x10, 0) != 3LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || GET_MODE (x3) != E_V4DFmode)
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_V4HFmode:
                      if (!register_operand (operands[1], E_V8HFmode)
                          || !
#line 8060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
                        return -1;
                      return 4726; /* avx512fp16_float_extend_phv4df2 */

                    case E_V4SFmode:
                      if (!nonimmediate_operand (operands[1], E_V8SFmode)
                          || !
#line 10247 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
                        return -1;
                      return 5198; /* *avx_cvtps2pd256_2 */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (pattern607 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_V4SFmode) != 0
                      || !
#line 8060 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && 1))
                    return -1;
                  return 4730; /* avx512fp16_float_extend_phv4sf2 */

                default:
                  return -1;
                }

            case 1:
              if (XWINT (x9, 0) != 4LL
                  || XWINT (x10, 0) != 6LL)
                return -1;
              switch (pattern1484 (x3))
                {
                case 0:
                  if (!
#line 31663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10432; /* vcvtneeph2ps_v8hf */

                case 1:
                  if (!
#line 31663 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10433; /* vcvtneebf162ps_v8bf */

                default:
                  return -1;
                }

            case 2:
              switch (pattern1484 (x3))
                {
                case 0:
                  if (!
#line 31691 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10436; /* vcvtneoph2ps_v8hf */

                case 1:
                  if (!
#line 31691 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10437; /* vcvtneobf162ps_v8bf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_V2HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !
#line 8099 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                return -1;
              return 4736; /* avx512fp16_float_extend_phv2df2 */

            case E_V2SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 10402 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                return -1;
              return 5242; /* sse2_cvtps2pd */

            default:
              return -1;
            }

        case 8:
          x7 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x8) != CONST_INT
              || pattern929 (x5) != 0)
            return -1;
          switch (pattern1142 (x5))
            {
            case 0:
              if (pattern1557 (x5) != 0
                  || pattern928 (x3, 
E_V16SFmode, 
E_V8SFmode, 
E_V8DFmode) != 0
                  || !
#line 10262 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 5199; /* vec_unpacks_lo_v16sf */

            case 1:
              x9 = XVECEXP (x5, 0, 2);
              if (XWINT (x9, 0) != 4LL)
                return -1;
              x10 = XVECEXP (x5, 0, 3);
              if (XWINT (x10, 0) != 6LL)
                return -1;
              x11 = XVECEXP (x5, 0, 4);
              if (XWINT (x11, 0) != 8LL)
                return -1;
              x12 = XVECEXP (x5, 0, 5);
              if (XWINT (x12, 0) != 10LL)
                return -1;
              x13 = XVECEXP (x5, 0, 6);
              if (XWINT (x13, 0) != 12LL)
                return -1;
              x14 = XVECEXP (x5, 0, 7);
              if (XWINT (x14, 0) != 14LL)
                return -1;
              switch (pattern1756 (x3))
                {
                case 0:
                  if (!
#line 31678 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10434; /* vcvtneeph2ps_v16hf */

                case 1:
                  if (!
#line 31678 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10435; /* vcvtneebf162ps_v16bf */

                default:
                  return -1;
                }

            case 2:
              x11 = XVECEXP (x5, 0, 4);
              if (XWINT (x11, 0) != 9LL)
                return -1;
              x12 = XVECEXP (x5, 0, 5);
              if (XWINT (x12, 0) != 11LL)
                return -1;
              x13 = XVECEXP (x5, 0, 6);
              if (XWINT (x13, 0) != 13LL)
                return -1;
              x14 = XVECEXP (x5, 0, 7);
              if (XWINT (x14, 0) != 15LL)
                return -1;
              switch (pattern1756 (x3))
                {
                case 0:
                  if (!
#line 31706 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10438; /* vcvtneoph2ps_v16hf */

                case 1:
                  if (!
#line 31706 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 10439; /* vcvtneobf162ps_v16bf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern514 (x3))
            {
            case 0:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4482; /* avx512fp16_vcvtw2ph_v8hi */

            case 1:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4502; /* avx512fp16_vcvtdq2ph_v8si */

            case 2:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4518; /* avx512fp16_vcvtqq2ph_v8di */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern515 (x3))
            {
            case 0:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4486; /* avx512fp16_vcvtw2ph_v16hi */

            case 1:
              if (!(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4510; /* avx512fp16_vcvtdq2ph_v16si */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HImode)
              || !(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4494; /* avx512fp16_vcvtw2ph_v32hi */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode
              || !vector_operand (operands[1], E_V16SImode)
              || !(
#line 8650 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 433 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4815; /* floatv16siv16sf2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!vector_operand (operands[1], E_V8SImode)
                  || !(
#line 8650 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 433 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4819; /* floatv8siv8sf2 */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 9198 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4973; /* floatv8div8sf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!vector_operand (operands[1], E_V4SImode)
                  || !
#line 8650 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 4823; /* floatv4siv4sf2 */

            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 9198 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4981; /* floatv4div4sf2 */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern516 (x3))
            {
            case 0:
              if (!
#line 8880 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4901; /* sse2_cvtpi2pd */

            case 1:
              if (!(
#line 9184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4969; /* floatv2div2df2 */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern517 (x3, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 9174 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 467 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4949; /* floatv8siv8df2 */

            case 1:
              if (!(
#line 9184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4953; /* floatv8div8df2 */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern518 (x3, 
E_V4DFmode))
            {
            case 0:
              if (!
#line 9174 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                return -1;
              return 4951; /* floatv4siv4df2 */

            case 1:
              if (!(
#line 9184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4961; /* floatv4div4df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 8:
          if (pattern670 (x5) != 0
              || pattern928 (x3, 
E_V16SImode, 
E_V8SImode, 
E_V8DFmode) != 0
              || !
#line 9375 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5001; /* avx512f_cvtdq2pd512_2 */

        case 4:
          if (pattern671 (x5, 
3, 
2, 
1) != 0
              || pattern928 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V4DFmode) != 0
              || !
#line 9388 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 5002; /* avx_cvtdq2pd256_2 */

        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern928 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DFmode) != 0
              || !
#line 9400 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 5003; /* sse2_cvtdq2pd */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4610; /* avx512fp16_fix_truncv8hi2 */

    case 1:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4614; /* avx512fp16_fix_truncv16hi2 */

    case 2:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4622; /* avx512fp16_fix_truncv32hi2 */

    case 3:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4630; /* avx512fp16_fix_truncv8si2 */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 8806 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4895; /* fix_truncv8sfv8si2 */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9581 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5036; /* fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case 4:
      x2 = XEXP (x1, 1);
      switch (pattern519 (x2))
        {
        case 0:
          if (!(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4638; /* avx512fp16_fix_truncv16si2 */

        case 1:
          if (!
#line 8786 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4883; /* fix_truncv16sfv16si2 */

        default:
          return -1;
        }

    case 5:
      x2 = XEXP (x1, 1);
      switch (pattern520 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4646; /* avx512fp16_fix_truncv8di2 */

        case 1:
          if (!(
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5081; /* fix_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9755 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5137; /* fix_truncv8sfv8di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4674; /* *avx512fp16_fix_truncv4si2_load */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8836 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4899; /* fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9671 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 5053; /* fix_truncv4dfv4si2 */

        default:
          return -1;
        }

    case 7:
      x2 = XEXP (x1, 1);
      switch (pattern521 (x2))
        {
        case 0:
          if (!
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4678; /* *avx512fp16_fix_truncv4di2_load */

        case 1:
          if (!(
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5089; /* fix_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9755 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5141; /* fix_truncv4sfv4di2 */

        default:
          return -1;
        }

    case 8:
      x2 = XEXP (x1, 1);
      switch (pattern522 (x2))
        {
        case 0:
          if (!
#line 7978 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4690; /* *avx512fp16_fix_truncv2di2_load */

        case 1:
          if (!(
#line 9712 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5097; /* fix_truncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 7918 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4666; /* avx512fp16_fix_truncv4si2 */

    case 10:
      if (!
#line 7918 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4670; /* avx512fp16_fix_truncv4di2 */

    case 11:
      if (!
#line 7968 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4686; /* avx512fp16_fix_truncv2di2 */

    case 12:
      if (!
#line 9778 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 5149; /* avx512dq_fix_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (!
#line 24130 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8757; /* avx2_sign_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24184 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8765; /* avx512bw_sign_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24254 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8777; /* *sse4_1_sign_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24379 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8789; /* *avx512f_sign_extendv16qiv16si2 */

    case 4:
      if (!
#line 24522 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8817; /* avx512f_sign_extendv16hiv16si2 */

    case 5:
      if (!
#line 24411 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8797; /* *avx2_sign_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24575 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8825; /* avx2_sign_extendv8hiv8si2 */

    case 7:
      if (!
#line 24472 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8809; /* *sse4_1_sign_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24645 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8837; /* *sse4_1_sign_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24776 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8853; /* *avx512f_sign_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24947 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8884; /* avx512f_sign_extendv8hiv8di2 */

    case 11:
      if (!
#line 25084 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8912; /* avx512f_sign_extendv8siv8di2 */

    case 12:
      if (!
#line 24834 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8865; /* *avx2_sign_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24977 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8892; /* *avx2_sign_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25135 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8918; /* avx2_sign_extendv4siv4di2 */

    case 15:
      if (!
#line 24896 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8877; /* *sse4_1_sign_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25035 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8904; /* *sse4_1_sign_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25201 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8928; /* *sse4_1_sign_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern540 (x2))
        {
        case 0:
          if (
#line 24242 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8773; /* sse4_1_sign_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24400 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8793; /* avx2_sign_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8849; /* avx512f_sign_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24460 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8805; /* sse4_1_sign_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24633 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8833; /* sse4_1_sign_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24823 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8861; /* avx2_sign_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24966 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8888; /* avx2_sign_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24884 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8873; /* sse4_1_sign_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25023 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8900; /* sse4_1_sign_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25189 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8924; /* sse4_1_sign_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (pattern680 (x2))
        {
        case 0:
          if (!
#line 24278 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8781; /* *sse4_1_sign_extendv8qiv8hi2_2 */

        case 1:
          if (!
#line 24430 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8801; /* *avx2_sign_extendv8qiv8si2_2 */

        case 2:
          if (!
#line 24794 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 8857; /* *avx512f_sign_extendv8qiv8di2_2 */

        case 3:
          if (!
#line 24664 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8841; /* *sse4_1_sign_extendv4hiv4si2_2 */

        case 4:
          if (!
#line 24994 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8896; /* *avx2_sign_extendv4hiv4di2_2 */

        case 5:
          if (!
#line 25219 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8932; /* *sse4_1_sign_extendv2siv2di2_2 */

        case 6:
          if (!
#line 24495 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8813; /* *sse4_1_sign_extendv4qiv4si2_2 */

        case 7:
          if (!
#line 24855 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8869; /* *avx2_sign_extendv4qiv4di2_2 */

        case 8:
          if (!
#line 25057 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8908; /* *sse4_1_sign_extendv2hiv2di2_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !nonimmediate_operand (operands[1], E_V16SImode)
          || !(
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10063; /* clzv16si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !(
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10065; /* clzv8si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode)
          || !(
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10067; /* clzv4si2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 10069; /* clzv8di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || !(
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10071; /* clzv4di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode)
          || !(
#line 29948 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 10073; /* clzv2di2 */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  res = recog_272 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[1] = x3;
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_CODE (operands[1]))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern800 (
E_V16QImode) == 0
              && 
#line 27042 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return 9065; /* xop_maskcmpv16qi3 */
          break;

        case E_V8HImode:
          if (pattern800 (
E_V8HImode) == 0
              && 
#line 27042 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return 9066; /* xop_maskcmpv8hi3 */
          break;

        case E_V4SImode:
          if (pattern800 (
E_V4SImode) == 0
              && 
#line 27042 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return 9067; /* xop_maskcmpv4si3 */
          break;

        case E_V2DImode:
          if (pattern800 (
E_V2DImode) == 0
              && 
#line 27042 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return 9068; /* xop_maskcmpv2di3 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (operands[1]))
    {
    case NE:
    case EQ:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern801 (
E_V16QImode) != 0
              || !
#line 27052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9069; /* xop_maskcmp_unsv16qi3 */

        case E_V8HImode:
          if (pattern801 (
E_V8HImode) != 0
              || !
#line 27052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9070; /* xop_maskcmp_unsv8hi3 */

        case E_V4SImode:
          if (pattern801 (
E_V4SImode) != 0
              || !
#line 27052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9071; /* xop_maskcmp_unsv4si3 */

        case E_V2DImode:
          if (pattern801 (
E_V2DImode) != 0
              || !
#line 27052 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9072; /* xop_maskcmp_unsv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (pattern229 (x5, 
E_CCmode, 
17) != 0)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  res = recog_359 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 8LL
      || pattern717 (x2) != 0)
    return -1;
  switch (pattern1418 (x2))
    {
    case 0:
      if (!
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 800; /* *andqi_exthi_3 */

    case 1:
      if (!
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 803; /* *andqi_extsi_3 */

    case 2:
      if (!(
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 806; /* *andqi_extdi_3 */

    case 3:
      if (!
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 801; /* *iorqi_exthi_3 */

    case 4:
      if (!
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 804; /* *iorqi_extsi_3 */

    case 5:
      if (!(
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 807; /* *iorqi_extdi_3 */

    case 6:
      if (!
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 802; /* *xorqi_exthi_3 */

    case 7:
      if (!
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 805; /* *xorqi_extsi_3 */

    case 8:
      if (!(
#line 13228 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 808; /* *xorqi_extdi_3 */

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 106:
      if (pattern541 (x1) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!pop_operand (operands[1], E_TImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3901 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2))
        return -1;
      return 160; /* pop2_di */

    case 14:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern351 (x6) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0LL
              || !
#line 20753 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1498; /* *set_got */

        case LABEL_REF:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!
#line 20775 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1499; /* *set_got_labelled */

        default:
          return -1;
        }

    case 97:
      switch (pattern544 (x1))
        {
        case 0:
          if (!
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1550; /* tzcnt_si */

        case 1:
          if (!(((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return -1;
          return 1552; /* tzcnt_di */

        case 2:
          if (!(
#line 21718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(true) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return -1;
          return 1563; /* tzcnt_hi */

        case 3:
          if ((
#line 21692 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return 1554; /* *tzcnt_si_falsedep_nf */
          if (pnum_clobbers == NULL
              || !
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          *pnum_clobbers = 1;
          return 1558; /* *tzcnt_si_falsedep */

        case 4:
          if ((
#line 21692 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF) && ((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return 1556; /* *tzcnt_di_falsedep_nf */
          if (pnum_clobbers == NULL
              || !((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21628 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1560; /* *tzcnt_di_falsedep */

        default:
          return -1;
        }

    case 96:
      switch (pattern544 (x1))
        {
        case 0:
          if (!
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1551; /* lzcnt_si */

        case 1:
          if (!(((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return -1;
          return 1553; /* lzcnt_di */

        case 2:
          if (!(
#line 21718 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(true) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return -1;
          return 1565; /* lzcnt_hi */

        case 3:
          if ((
#line 21692 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return 1555; /* *lzcnt_si_falsedep_nf */
          if (pnum_clobbers == NULL
              || !
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          *pnum_clobbers = 1;
          return 1559; /* *lzcnt_si_falsedep */

        case 4:
          if ((
#line 21692 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_APX_NF) && ((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))))
            return 1557; /* *lzcnt_di_falsedep_nf */
          if (pnum_clobbers == NULL
              || !((
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21629 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1561; /* *lzcnt_di_falsedep */

        default:
          return -1;
        }

    case 27:
      if (GET_MODE (x3) != E_CCmode
          || pattern681 (x1, 
CLOBBER, 
E_CCmode) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[0]))
        return -1;
      return 1647; /* parityhi2_cmp */

    case 80:
      if (pattern545 (x1, 
81) != 0
          || !
#line 24052 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1719; /* sincosxf3 */

    case 82:
      if (pattern545 (x1, 
83) != 0
          || !
#line 24567 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1724; /* fxtractxf3_i387 */

    case 70:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_XFmode)
          || !
#line 25113 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1733; /* lrintxfdi2 */

    case 74:
      if (pattern546 (x1) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1736; /* frndintxf2_roundeven */

    case 75:
      if (pattern546 (x1) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1737; /* frndintxf2_floor */

    case 76:
      if (pattern546 (x1) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1738; /* frndintxf2_ceil */

    case 77:
      if (pattern546 (x1) != 0
          || !
#line 25212 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      return 1739; /* frndintxf2_trunc */

    case 78:
      switch (pattern548 (x1))
        {
        case 0:
          if (!
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1744; /* *fisthi2_floor_1 */

        case 1:
          if (!
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1746; /* *fistsi2_floor_1 */

        case 2:
          if (!
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1748; /* *fistdi2_floor_1 */

        default:
          return -1;
        }

    case 79:
      switch (pattern548 (x1))
        {
        case 0:
          if (!
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1745; /* *fisthi2_ceil_1 */

        case 1:
          if (!
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1747; /* *fistsi2_ceil_1 */

        case 2:
          if (!
#line 25329 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          return 1749; /* *fistdi2_ceil_1 */

        default:
          return -1;
        }

    case 18:
      if (pattern549 (x1) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == SImode))
            return -1;
          return 1861; /* probe_stack_1_si */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !const0_operand (operands[1], E_DImode)
              || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(word_mode == DImode))
            return -1;
          return 1862; /* probe_stack_1_di */

        default:
          return -1;
        }

    case 92:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      if (pnum_clobbers != NULL)
        {
          res = recog_361 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[3] = x5;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern1234 (x3, 
E_SImode))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && (
#line 27455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return 1871; /* *stack_protect_set_2_si_si */
              if (address_no_seg_operand (operands[2], E_SImode)
                  && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return 1875; /* *stack_protect_set_3_si_si */
              break;

            case 1:
              if (general_operand (operands[2], E_DImode)
                  && (
#line 27474 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return 1873; /* *stack_protect_set_2_si_di */
              if (address_no_seg_operand (operands[2], E_DImode)
                  && ((
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1876; /* *stack_protect_set_3_si_di */
              break;

            default:
              break;
            }
          break;

        case E_DImode:
          switch (pattern1234 (x3, 
E_DImode))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && (
#line 27455 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return 1872; /* *stack_protect_set_2_di_si */
              if (address_no_seg_operand (operands[2], E_SImode)
                  && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return 1877; /* *stack_protect_set_3_di_si */
              break;

            case 1:
              if (general_operand (operands[2], E_DImode)
                  && (
#line 27474 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return 1874; /* *stack_protect_set_2_di_di */
              if (address_no_seg_operand (operands[2], E_DImode)
                  && ((
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1878; /* *stack_protect_set_3_di_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_DImode)
          || GET_MODE (x9) != E_DImode)
        return -1;
      switch (GET_CODE (x9))
        {
        case ZERO_EXTEND:
          switch (pattern1320 (x1))
            {
            case 0:
              if (!(
#line 27568 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return -1;
              return 1879; /* *stack_protect_set_4z_si_di */

            case 1:
              if (!(
#line 27568 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return -1;
              return 1880; /* *stack_protect_set_4z_di_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1320 (x1))
            {
            case 0:
              if (!(
#line 27586 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                return -1;
              return 1881; /* *stack_protect_set_4s_si_di */

            case 1:
              if (!(
#line 27586 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && reload_completed) && 
#line 1408 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                return -1;
              return 1882; /* *stack_protect_set_4s_di_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 118:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_V4SImode)
          || !
#line 1877 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
        return -1;
      return 2558; /* movdi_to_sse */

    case 282:
      if (GET_MODE (x3) != E_BLKmode
          || pattern338 (x1) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 11016; /* mfence_nosse */

    case 287:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!memory_operand (operands[2], E_DImode)
          || !
#line 196 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
        return -1;
      *pnum_clobbers = 1;
      return 11017; /* atomic_loaddi_fpu */

    case 288:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!memory_operand (operands[2], E_DImode)
          || !
#line 295 "../../gcc-15.0.1-20250313/gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
        return -1;
      *pnum_clobbers = 1;
      return 11022; /* atomic_storedi_fpu */

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (XWINT (x4, 0) != 0LL)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case PLUS:
          switch (pattern1425 (x1))
            {
            case 0:
              if (!
#line 7128 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 309; /* *addqi_2 */

            case 1:
              if (!
#line 7128 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 310; /* *addhi_2 */

            case 2:
              if (!
#line 7128 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 311; /* *addsi_2 */

            case 3:
              if (!(
#line 7128 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 312; /* *adddi_2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1426 (x1, 
PLUS) != 0
              || !
#line 7178 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 313; /* *addsi_2_zext */

        default:
          return -1;
        }

    case CLOBBER:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x8 = XEXP (x3, 0);
      switch (pattern950 (x8))
        {
        case 0:
          if (!
#line 7410 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 323; /* *addqi_5 */

        case 1:
          if (!
#line 7410 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 324; /* *addhi_5 */

        case 2:
          if (!
#line 7410 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 325; /* *addsi_5 */

        case 3:
          if (!(
#line 7410 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 326; /* *adddi_5 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x4, 1);
  switch (GET_CODE (x9))
    {
    case ZERO_EXTEND:
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      x11 = XEXP (x3, 0);
      switch (GET_MODE (x11))
        {
        case E_DImode:
          if (pattern1757 (x4, 
E_SImode, 
E_DImode) != 0
              || !
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 517; /* subsi3_carry_ccc */

        case E_TImode:
          if (pattern1757 (x4, 
E_DImode, 
E_TImode) != 0
              || !
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 518; /* subdi3_carry_ccc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x9;
      x11 = XEXP (x3, 0);
      switch (GET_MODE (x11))
        {
        case E_DImode:
          if (pattern1758 (x4, 
E_SImode, 
E_DImode) != 0
              || !
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 519; /* *subsi3_carry_ccc_1 */

        case E_TImode:
          if (pattern1758 (x4, 
E_DImode, 
E_TImode) != 0
              || !
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 520; /* *subdi3_carry_ccc_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          res = recog_377 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_378 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CCCmode
          || GET_MODE (x4) != E_CCCmode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          if (!rtx_equal_p (x8, operands[2]))
            return -1;
          switch (pattern950 (x5))
            {
            case 0:
              if (!
#line 10025 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 543; /* *addqi3_cconly_overflow_2 */

            case 1:
              if (!
#line 10025 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 544; /* *addhi3_cconly_overflow_2 */

            case 2:
              if (!
#line 10025 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 545; /* *addsi3_cconly_overflow_2 */

            case 3:
              if (!(
#line 10025 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 546; /* *adddi3_cconly_overflow_2 */

            default:
              return -1;
            }

        case SET:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x9, 1);
          switch (GET_CODE (x11))
            {
            case PLUS:
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              switch (GET_MODE (x5))
                {
                case E_QImode:
                  if (pattern1627 (x1, 
E_QImode) != 0
                      || !
#line 10043 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 547; /* *addqi3_cc_overflow_2 */

                case E_HImode:
                  if (pattern1627 (x1, 
E_HImode) != 0
                      || !
#line 10043 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 548; /* *addhi3_cc_overflow_2 */

                case E_SImode:
                  if (!nonimmediate_operand (operands[1], E_SImode)
                      || !x86_64_general_operand (operands[2], E_SImode)
                      || !nonimmediate_operand (operands[0], E_SImode)
                      || GET_MODE (x11) != E_SImode
                      || !rtx_equal_p (x8, operands[2])
                      || !
#line 10043 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 549; /* *addsi3_cc_overflow_2 */

                case E_DImode:
                  if (!nonimmediate_operand (operands[1], E_DImode)
                      || !nonimmediate_operand (operands[0], E_DImode)
                      || GET_MODE (x11) != E_DImode)
                    return -1;
                  if (x86_64_general_operand (operands[2], E_DImode)
                      && rtx_equal_p (x8, operands[2])
                      && (
#line 10043 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 550; /* *adddi3_cc_overflow_2 */
                  if (!x86_64_hilo_general_operand (operands[2], E_DImode)
                      || !rtx_equal_p (x8, operands[1])
                      || !(
#line 10081 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return -1;
                  return 552; /* *adddi3_doubleword_cc_overflow_1 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != PLUS
                  || GET_MODE (x12) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !rtx_equal_p (x8, operands[2]))
                return -1;
              x14 = XEXP (x12, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x12, 1);
              if (!rtx_equal_p (x15, operands[2])
                  || !
#line 10062 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 551; /* *addsi3_zext_cc_overflow_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 110)
        return -1;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      switch (pattern1235 (x1, 
PLUS))
        {
        case 0:
          return 11082; /* atomic_add_fetch_cmp_0qi_1 */

        case 1:
          return 11083; /* atomic_add_fetch_cmp_0hi_1 */

        case 2:
          return 11084; /* atomic_add_fetch_cmp_0si_1 */

        case 3:
          if (!
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 11085; /* atomic_add_fetch_cmp_0di_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      return recog_383 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_386 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      res = recog_379 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case CTZ:
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_CCCmode:
              if (GET_MODE (x3) != E_CCCmode)
                return -1;
              switch (pattern1492 (x9))
                {
                case 0:
                  if (!
#line 20994 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  return 1508; /* *tzcntsi_1 */

                case 1:
                  if (!(
#line 20994 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1509; /* *tzcntdi_1 */

                default:
                  return -1;
                }

            case E_CCZmode:
              if (GET_MODE (x3) != E_CCZmode)
                return -1;
              switch (pattern1492 (x9))
                {
                case 0:
                  return 1512; /* *bsfsi_1 */

                case 1:
                  if (!
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 1513; /* *bsfdi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != CLZ
              || GET_MODE (x5) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (XWINT (x10, 0))
            {
            case 63LL:
              if (pattern1628 (x9, 
E_DImode) != 0
                  || !
#line 21223 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 1524; /* bsr_rex64 */

            case 31LL:
              if (pattern1628 (x9, 
E_SImode) != 0)
                return -1;
              return 1527; /* bsr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pattern224 (x1) != 0)
        return -1;
      x13 = XEXP (x4, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x13;
          x14 = XEXP (x4, 1);
          operands[2] = x14;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          switch (GET_CODE (x9))
            {
            case MINUS:
              switch (pattern1425 (x1))
                {
                case 0:
                  if (!
#line 8276 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 411; /* *subqi_2 */

                case 1:
                  if (!
#line 8276 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 412; /* *subhi_2 */

                case 2:
                  if (!
#line 8276 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 413; /* *subsi_2 */

                case 3:
                  if (!(
#line 8276 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 414; /* *subdi_2 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1426 (x1, 
MINUS) != 0
                  || !
#line 8297 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 415; /* *subsi_2_zext */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x13, 0) != 2
              || XINT (x13, 1) != 110)
            return -1;
          switch (pattern1235 (x1, 
MINUS))
            {
            case 0:
              return 11086; /* atomic_sub_fetch_cmp_0qi_1 */

            case 1:
              return 11087; /* atomic_sub_fetch_cmp_0hi_1 */

            case 2:
              return 11088; /* atomic_sub_fetch_cmp_0si_1 */

            case 3:
              if (!
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 11089; /* atomic_sub_fetch_cmp_0di_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_384 (x1, insn, pnum_clobbers);

    case AND:
      return recog_385 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern364 (x1, 
IOR))
        {
        case 0:
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern949 (x1, 
IOR))
                {
                case 0:
                  if (
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 783; /* *iorqi_exthi_1_cc */
                  break;

                case 1:
                  if (
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 786; /* *iorqi_extsi_1_cc */
                  break;

                case 2:
                  if ((
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 789; /* *iorqi_extdi_1_cc */
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern951 (x1))
            {
            case 0:
              x7 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x7, 1);
              switch (GET_CODE (x9))
                {
                case IOR:
                  switch (pattern1428 (x1))
                    {
                    case 0:
                      if (!
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 872; /* *iorqi_2 */

                    case 1:
                      if (!
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 874; /* *iorhi_2 */

                    case 2:
                      if (!
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 876; /* *iorsi_2 */

                    case 3:
                      if (!(
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      return 878; /* *iordi_2 */

                    case 4:
                      if (!
#line 13919 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 882; /* *iorsi_2_zext_imm */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (pattern1426 (x1, 
IOR) != 0
                      || !
#line 13901 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 880; /* *iorsi_2_zext */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 884; /* *iorqi_3 */

            case 2:
              if (!
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 886; /* *iorhi_3 */

            case 3:
              if (!
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 888; /* *iorsi_3 */

            case 4:
              if (!(
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 890; /* *iordi_3 */

            default:
              return -1;
            }

        case 1:
          return 11091; /* atomic_or_fetch_cmp_0qi_1 */

        case 2:
          return 11094; /* atomic_or_fetch_cmp_0hi_1 */

        case 3:
          return 11097; /* atomic_or_fetch_cmp_0si_1 */

        case 4:
          if (!
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 11100; /* atomic_or_fetch_cmp_0di_1 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern364 (x1, 
XOR))
        {
        case 0:
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern949 (x1, 
XOR))
                {
                case 0:
                  if (
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 784; /* *xorqi_exthi_1_cc */
                  break;

                case 1:
                  if (
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                    return 787; /* *xorqi_extsi_1_cc */
                  break;

                case 2:
                  if ((
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 790; /* *xorqi_extdi_1_cc */
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern951 (x1))
            {
            case 0:
              x7 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x7, 1);
              switch (GET_CODE (x9))
                {
                case XOR:
                  switch (pattern1428 (x1))
                    {
                    case 0:
                      if (!
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 873; /* *xorqi_2 */

                    case 1:
                      if (!
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 875; /* *xorhi_2 */

                    case 2:
                      if (!
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 877; /* *xorsi_2 */

                    case 3:
                      if (!(
#line 13881 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      return 879; /* *xordi_2 */

                    case 4:
                      if (!
#line 13919 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
                        return -1;
                      return 883; /* *xorsi_2_zext_imm */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (pattern1426 (x1, 
XOR) != 0
                      || !
#line 13901 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 881; /* *xorsi_2_zext */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 885; /* *xorqi_3 */

            case 2:
              if (!
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 887; /* *xorhi_3 */

            case 3:
              if (!
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 889; /* *xorsi_3 */

            case 4:
              if (!(
#line 13935 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 891; /* *xordi_3 */

            default:
              return -1;
            }

        case 1:
          return 11092; /* atomic_xor_fetch_cmp_0qi_1 */

        case 2:
          return 11095; /* atomic_xor_fetch_cmp_0hi_1 */

        case 3:
          return 11098; /* atomic_xor_fetch_cmp_0si_1 */

        case 4:
          if (!
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 11101; /* atomic_xor_fetch_cmp_0di_1 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x13 = XEXP (x4, 0);
      operands[1] = x13;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case NOT:
          switch (pattern1238 (x1))
            {
            case 0:
              if (!
#line 15078 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1044; /* *one_cmplqi2_2 */

            case 1:
              if (!
#line 15078 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1045; /* *one_cmplhi2_2 */

            case 2:
              if (!
#line 15078 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1046; /* *one_cmplsi2_2 */

            case 3:
              if (!(
#line 15078 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1047; /* *one_cmpldi2_2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern1239 (x1, 
NOT) != 0
              || !
#line 15105 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_match_ccmode (insn, CCNOmode)
   && ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 1048; /* *one_cmplsi2_2_zext */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern365 (x1))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          switch (GET_CODE (x9))
            {
            case ASHIFT:
              switch (pattern1322 (x1))
                {
                case 0:
                  if (!
#line 16341 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1110; /* *ashlqi3_cmp */

                case 1:
                  if (!
#line 16341 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1111; /* *ashlhi3_cmp */

                case 2:
                  if (!
#line 16341 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1112; /* *ashlsi3_cmp */

                case 3:
                  if (!(
#line 16341 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || (TARGET_DOUBLE_WITH_ADD && REG_P (operands[0])))))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1113; /* *ashldi3_cmp */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1323 (x1, 
ASHIFT) != 0
                  || !
#line 16395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && (optimize_function_for_size_p (cfun)
       || !TARGET_PARTIAL_FLAG_REG_STALL
       || (operands[2] == const1_rtx
	   && (TARGET_SHIFT1
	       || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1114; /* *ashlsi3_cmp_zext */

            default:
              return -1;
            }

        case 1:
          if (!
#line 16448 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1115; /* *ashlqi3_cconly */

        case 2:
          if (!
#line 16448 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1116; /* *ashlhi3_cconly */

        case 3:
          if (!
#line 16448 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1117; /* *ashlsi3_cconly */

        case 4:
          if (!(
#line 16448 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& (TARGET_SHIFT1
	    || TARGET_DOUBLE_WITH_ADD)))
   && ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1118; /* *ashldi3_cconly */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern365 (x1))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          switch (GET_CODE (x9))
            {
            case LSHIFTRT:
              switch (pattern1322 (x1))
                {
                case 0:
                  if (!
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1220; /* *lshrqi3_cmp */

                case 1:
                  if (!
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1222; /* *lshrhi3_cmp */

                case 2:
                  if (!
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1224; /* *lshrsi3_cmp */

                case 3:
                  if (!(
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1226; /* *lshrdi3_cmp */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1323 (x1, 
LSHIFTRT) != 0
                  || !
#line 17714 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && (optimize_function_for_size_p (cfun)
       || !TARGET_PARTIAL_FLAG_REG_STALL
       || (operands[2] == const1_rtx
	   && TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1228; /* *lshrsi3_cmp_zext */

            default:
              return -1;
            }

        case 1:
          if (!
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1230; /* *lshrqi3_cconly */

        case 2:
          if (!
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1232; /* *lshrhi3_cconly */

        case 3:
          if (!
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1234; /* *lshrsi3_cconly */

        case 4:
          if (!(
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1236; /* *lshrdi3_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern365 (x1))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          switch (GET_CODE (x9))
            {
            case ASHIFTRT:
              switch (pattern1322 (x1))
                {
                case 0:
                  if (!
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, QImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1221; /* *ashrqi3_cmp */

                case 1:
                  if (!
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, HImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1223; /* *ashrhi3_cmp */

                case 2:
                  if (!
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
                    return -1;
                  return 1225; /* *ashrsi3_cmp */

                case 3:
                  if (!(
#line 17679 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 1227; /* *ashrdi3_cmp */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1323 (x1, 
ASHIFTRT) != 0
                  || !
#line 17714 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && (optimize_function_for_size_p (cfun)
       || !TARGET_PARTIAL_FLAG_REG_STALL
       || (operands[2] == const1_rtx
	   && TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1229; /* *ashrsi3_cmp_zext */

            default:
              return -1;
            }

        case 1:
          if (!
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1231; /* *ashrqi3_cconly */

        case 2:
          if (!
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1233; /* *ashrhi3_cconly */

        case 3:
          if (!
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)))
            return -1;
          return 1235; /* *ashrsi3_cconly */

        case 4:
          if (!(
#line 17750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun)
    || !TARGET_PARTIAL_FLAG_REG_STALL
    || (operands[2] == const1_rtx
	&& TARGET_SHIFT1))
   && ix86_match_ccmode (insn, CCGOCmode)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1237; /* *ashrdi3_cconly */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 98
          || pattern683 (x1) != 0)
        return -1;
      x15 = XVECEXP (x4, 0, 0);
      operands[1] = x15;
      x16 = XVECEXP (x4, 0, 1);
      operands[2] = x16;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode)
              || !
#line 21748 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1568; /* *bmi_bextr_si_ccz */

        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode)
              || !(
#line 21748 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1569; /* *bmi_bextr_di_ccz */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x13 = XEXP (x4, 0);
      if (GET_CODE (x13) != NE
          || GET_MODE (x13) != E_QImode)
        return -1;
      x17 = XEXP (x13, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != ZERO_EXTRACT)
        return -1;
      x18 = XEXP (x14, 1);
      if (GET_CODE (x18) != UMIN
          || GET_MODE (x18) != E_QImode)
        return -1;
      x19 = XEXP (x14, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x4, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern683 (x1) != 0)
        return -1;
      x21 = XEXP (x13, 0);
      operands[2] = x21;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x22 = XEXP (x14, 0);
      operands[1] = x22;
      x23 = XEXP (x18, 1);
      operands[3] = x23;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x24 = XEXP (x18, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x14) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !scratch_operand (operands[0], E_SImode)
              || !
#line 22055 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
            return -1;
          return 1592; /* *bmi2_bzhi_si3_1_ccz */

        case E_DImode:
          if (GET_MODE (x14) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !scratch_operand (operands[0], E_DImode)
              || !(
#line 22055 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1593; /* *bmi2_bzhi_di3_1_ccz */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 110)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      res = recog_382 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (XWINT (x6, 0) != 0LL)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x25 = XEXP (x8, 1);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x3) != E_CCCmode)
        return -1;
      x15 = XVECEXP (x4, 0, 0);
      operands[0] = x15;
      x16 = XVECEXP (x4, 0, 1);
      operands[2] = x16;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x26 = XEXP (x8, 2);
      operands[1] = x26;
      x27 = XEXP (x8, 0);
      if (!rtx_equal_p (x27, operands[0]))
        return -1;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          switch (XWINT (x9, 0))
            {
            case 1LL:
              switch (pattern1759 (x1))
                {
                case 0:
                  return 11073; /* atomic_bit_test_and_sethi_1 */

                case 1:
                  return 11074; /* atomic_bit_test_and_setsi_1 */

                case 2:
                  if (!
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 11075; /* atomic_bit_test_and_setdi_1 */

                default:
                  return -1;
                }

            case 0LL:
              switch (pattern1759 (x1))
                {
                case 0:
                  return 11079; /* atomic_bit_test_and_resethi_1 */

                case 1:
                  return 11080; /* atomic_bit_test_and_resetsi_1 */

                case 2:
                  if (!
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  return 11081; /* atomic_bit_test_and_resetdi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != ZERO_EXTRACT)
            return -1;
          x28 = XEXP (x10, 1);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x29 = XEXP (x10, 0);
          if (!rtx_equal_p (x29, operands[0]))
            return -1;
          x30 = XEXP (x10, 2);
          if (!rtx_equal_p (x30, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (pattern1824 (x7, 
E_HImode) != 0)
                return -1;
              return 11076; /* atomic_bit_test_and_complementhi_1 */

            case E_SImode:
              if (pattern1824 (x7, 
E_SImode) != 0)
                return -1;
              return 11077; /* atomic_bit_test_and_complementsi_1 */

            case E_DImode:
              if (pattern1824 (x7, 
E_DImode) != 0
                  || !
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 11078; /* atomic_bit_test_and_complementdi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_427 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCOmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != ZERO_EXTEND)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != MULT)
    return -1;
  x9 = XEXP (x2, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCOmode)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MULT)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x5, 0);
  operands[1] = x13;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  x15 = XEXP (x10, 0);
  operands[0] = x15;
  x16 = XEXP (x12, 0);
  operands[3] = x16;
  x17 = XEXP (x8, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x8, 1);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  x19 = XEXP (x11, 0);
  if (!rtx_equal_p (x19, operands[1]))
    return -1;
  x20 = XEXP (x11, 1);
  if (!rtx_equal_p (x20, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (pattern1799 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 10872 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 610; /* *umulvhi4 */

    case E_DImode:
      if (pattern1799 (x1, 
E_SImode, 
E_DImode) != 0
          || !
#line 10872 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 611; /* *umulvsi4 */

    case E_TImode:
      if (pattern1799 (x1, 
E_DImode, 
E_TImode) != 0
          || !(
#line 10872 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 612; /* *umulvdi4 */

    default:
      return -1;
    }
}

 int
recog_431 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0LL)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x7) != USE)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case ASHIFT:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          switch (XWINT (x10, 0))
            {
            case 3LL:
              switch (pattern1442 (x1, 
3, 
E_DImode))
                {
                case 0:
                  if (!(
#line 25704 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1769; /* *rep_movdi_rex64 */

                case 1:
                  if (!(
#line 25704 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1770; /* *rep_movdi_rex64 */

                case 2:
                  if (!(
#line 25903 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1783; /* *rep_stosdi_rex64 */

                case 3:
                  if (!(
#line 25903 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1784; /* *rep_stosdi_rex64 */

                default:
                  return -1;
                }

            case 2LL:
              switch (pattern1442 (x1, 
2, 
E_SImode))
                {
                case 0:
                  if (!(
#line 25725 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1771; /* *rep_movsi */

                case 1:
                  if (!(
#line 25725 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1772; /* *rep_movsi */

                case 2:
                  if (!(
#line 25922 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1785; /* *rep_stossi */

                case 3:
                  if (!(
#line 25922 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1786; /* *rep_stossi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x9;
          x12 = XEXP (x6, 1);
          switch (GET_CODE (x12))
            {
            case PLUS:
              x13 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x13) != SET)
                return -1;
              x14 = XEXP (x13, 1);
              if (GET_CODE (x14) != MEM
                  || GET_MODE (x14) != E_BLKmode)
                return -1;
              x15 = XEXP (x13, 0);
              if (GET_CODE (x15) != MEM
                  || GET_MODE (x15) != E_BLKmode)
                return -1;
              x16 = XEXP (x2, 0);
              operands[2] = x16;
              x11 = XEXP (x5, 1);
              operands[5] = x11;
              x17 = XEXP (x6, 0);
              operands[1] = x17;
              x18 = XEXP (x12, 0);
              operands[4] = x18;
              x19 = XEXP (x12, 1);
              if (!rtx_equal_p (x19, operands[5]))
                return -1;
              x20 = XEXP (x14, 0);
              if (!rtx_equal_p (x20, operands[4]))
                return -1;
              x21 = XEXP (x15, 0);
              if (!rtx_equal_p (x21, operands[3]))
                return -1;
              x22 = XEXP (x7, 0);
              if (!rtx_equal_p (x22, operands[5]))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_SImode:
                  if (pattern1826 (x1, 
E_SImode) != 0
                      || !(
#line 25743 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1773; /* *rep_movqi */

                case E_DImode:
                  if (pattern1826 (x1, 
E_DImode) != 0
                      || !(
#line 25743 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1774; /* *rep_movqi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x12, 0) != 0LL)
                return -1;
              x17 = XEXP (x6, 0);
              if (GET_CODE (x17) != MEM
                  || GET_MODE (x17) != E_BLKmode)
                return -1;
              x13 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x13) != USE)
                return -1;
              x16 = XEXP (x2, 0);
              operands[1] = x16;
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              x15 = XEXP (x13, 0);
              operands[2] = x15;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x23 = XEXP (x17, 0);
              if (!rtx_equal_p (x23, operands[3]))
                return -1;
              x22 = XEXP (x7, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pattern1778 (x5, 
E_SImode) != 0
                      || !(
#line 25939 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1787; /* *rep_stosqi */

                case E_DImode:
                  if (pattern1778 (x5, 
E_DImode) != 0
                      || !(
#line 25939 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1788; /* *rep_stosqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      if (pattern230 (x1) != 0)
        return -1;
      x24 = XEXP (x3, 1);
      x25 = XEXP (x24, 0);
      x26 = XEXP (x25, 0);
      operands[4] = x26;
      x27 = XEXP (x24, 1);
      x28 = XEXP (x27, 0);
      operands[5] = x28;
      x4 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x17 = XEXP (x6, 0);
      operands[0] = x17;
      x13 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x13, 0);
      operands[1] = x15;
      x7 = XVECEXP (x1, 0, 4);
      x22 = XEXP (x7, 0);
      operands[2] = x22;
      switch (GET_MODE (operands[6]))
        {
        case E_SImode:
          if (pattern1847 (
E_SImode) != 0
              || !(
#line 26070 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1791; /* *cmpstrnqi_1 */

        case E_DImode:
          if (pattern1847 (
E_DImode) != 0
              || !(
#line 26070 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1792; /* *cmpstrnqi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 2);
  operands[2] = x9;
  if (!register_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x2, 1);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      switch (pattern1529 (x2, 
E_HImode))
        {
        case 0:
          if (!
#line 19300 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_830 (insn, operands);

        case 1:
          if (!(
#line 19300 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_831 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern1529 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 19300 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_832 (insn, operands);

        case 1:
          if (!(
#line 19300 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_833 (insn, operands);

        default:
          return NULL;
        }

    case E_DImode:
      switch (pattern1529 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 19300 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_834 (insn, operands);

        case 1:
          if (!(
#line 19300 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_BT && TARGET_CMOVE
   && !(MEM_P (operands[3]) && MEM_P (operands[4]))
   && ix86_pre_reload_split ()) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_835 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern70 (x3))
        {
        case 0:
          if (!(
#line 3704 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == -1
   && CONST_WIDE_INT_ELT (operands[3], 1) == 0) && 
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_24 (insn, operands);

        case 1:
          if (!(
#line 3726 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && CONST_WIDE_INT_P (operands[3])
   && CONST_WIDE_INT_NUNITS (operands[3]) == 2
   && CONST_WIDE_INT_ELT (operands[3], 0) == 0
   && CONST_WIDE_INT_ELT (operands[3], 1) == -1) && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_27 (insn, operands);

        case 2:
          if (!(
#line 3748 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_30 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern603 (x3, 
E_QImode) != 0
                      || !(
#line 8015 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case E_HImode:
                  if (pattern603 (x3, 
E_HImode) != 0
                      || !(
#line 8015 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case E_SImode:
                  if (pattern603 (x3, 
E_SImode) != 0
                      || !(
#line 8039 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 8042 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case E_DImode:
                  if (GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  if (register_operand (operands[0], E_DImode)
                      && register_no_SP_operand (operands[1], E_DImode)
                      && const_0_to_3_operand (operands[2], E_VOIDmode)
                      && const_int_operand (operands[3], E_VOIDmode)
                      && ((
#line 8039 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 8042 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return gen_split_167 (insn, operands);
                  if (!nonimmediate_operand (operands[0], E_DImode)
                      || !register_operand (operands[1], E_DImode)
                      || !const_int_operand (operands[2], E_QImode)
                      || !const_scalar_int_operand (operands[3], E_DImode)
                      || !((
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14151 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_468 (insn, operands);

                case E_TImode:
                  if (pattern604 (x3, 
E_TImode) != 0
                      || !((
#line 14137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14151 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_471 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              switch (pattern955 (x3))
                {
                case 0:
                  if (!((
#line 14060 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14062 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_432 (insn, operands);

                case 1:
                  if (!((
#line 14060 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14062 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_435 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern715 (x3))
            {
            case 0:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_444 (insn, operands);

            case 1:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_450 (insn, operands);

            case 2:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_474 (insn, operands);

            case 3:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_480 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern715 (x3))
            {
            case 0:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_447 (insn, operands);

            case 1:
              if (!((
#line 14096 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14098 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_453 (insn, operands);

            case 2:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_477 (insn, operands);

            case 3:
              if (!((
#line 14169 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_483 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern402 (x3))
        {
        case 0:
          if (!((
#line 14077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14079 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_438 (insn, operands);

        case 1:
          if (!((
#line 14077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14079 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_441 (insn, operands);

        case 2:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_456 (insn, operands);

        case 3:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_462 (insn, operands);

        case 4:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_459 (insn, operands);

        case 5:
          if (!((
#line 14121 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 8 * BITS_PER_UNIT) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14123 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_465 (insn, operands);

        case 6:
          if (!((
#line 14198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14209 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_486 (insn, operands);

        case 7:
          if (!((
#line 14198 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14209 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_489 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (rtx_equal_p (x5, operands[0]))
    {
      x6 = XEXP (x4, 1);
      switch (XWINT (x6, 0))
        {
        case -65536LL:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x4) == E_SImode
              && 
#line 12860 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_FAST_PREFIX && !TARGET_PARTIAL_REG_STALL)
    || optimize_function_for_size_p (cfun)))
            return gen_split_314 (insn, operands);
          break;

        case -256LL:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (any_QIreg_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && 
#line 12870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_316 (insn, operands);
              break;

            case E_SImode:
              if (any_QIreg_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && 
#line 12870 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_317 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case -65281LL:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (QIreg_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && 
#line 12880 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_319 (insn, operands);
              break;

            case E_SImode:
              if (QIreg_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && 
#line 12880 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_320 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (GET_MODE (x4) != E_HImode
          || !const_int_operand (operands[2], E_HImode))
        return NULL;
      if (QIreg_operand (operands[0], E_HImode)
          && register_operand (operands[1], E_HImode)
          && 
#line 13261 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
        return gen_split_367 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 13290 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_370 (insn, operands);

    case E_SImode:
      if (GET_MODE (x4) != E_SImode
          || !const_int_operand (operands[2], E_SImode))
        return NULL;
      if (QIreg_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && 
#line 13261 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
        return gen_split_368 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 13290 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_371 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern581 (x1, 
PLUS, 
E_CCCmode) != 0
          || GET_MODE (x3) != E_CCCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x3, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return NULL;
      x10 = XEXP (x7, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return NULL;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return NULL;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern1663 (x10, 
E_DImode) != 0
              || !((
#line 10081 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 10083 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case E_TImode:
          if (pattern1663 (x10, 
E_TImode) != 0
              || !((
#line 10081 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10083 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SUBREG:
          switch (pattern816 (x1))
            {
            case 0:
              if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_340 (insn, operands);

            case 1:
              if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_343 (insn, operands);

            case 2:
              if (!((
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_346 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          if (!flags_reg_operand (operands[0], E_VOIDmode))
            return NULL;
          operands[1] = x3;
          if (!compare_operator (operands[1], E_VOIDmode)
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x14 = XEXP (x5, 0);
          operands[2] = x14;
          if (!general_reg_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_SImode))
            return NULL;
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 13416 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed
   && optimize_insn_for_size_p () && optimize_size > 1
   && LEGACY_INT_REG_P (operands[2])
   && !REX_INT_REG_P (operands[3])
   && !reg_overlap_mentioned_p (operands[2], operands[3])))
            return NULL;
          return gen_split_378 (insn, operands);

        case NEG:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return NULL;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != AND)
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != NEG)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[3] = x13;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return NULL;
          operands[4] = x3;
          if (!compare_operator (operands[4], E_VOIDmode))
            return NULL;
          switch (pattern1505 (x1))
            {
            case 0:
              if (!
#line 21805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI
   && TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
                return NULL;
              return gen_split_900 (insn, operands);

            case 1:
              if (!(
#line 21805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI
   && TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_901 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || pattern681 (x1, 
SET, 
E_CCZmode) != 0)
            return NULL;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != AND)
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != PLUS)
            return NULL;
          x16 = XEXP (x11, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || GET_MODE (x3) != E_CCZmode)
            return NULL;
          switch (pattern1505 (x1))
            {
            case 0:
              if (!(
#line 21942 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21944 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                return NULL;
              return gen_split_906 (insn, operands);

            case 1:
              if (!((
#line 21942 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21944 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                return NULL;
              return gen_split_907 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      switch (pattern584 (x1, 
IOR))
        {
        case 0:
          if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_341 (insn, operands);

        case 1:
          if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_344 (insn, operands);

        case 2:
          if (!((
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_347 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern584 (x1, 
XOR))
        {
        case 0:
          if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_342 (insn, operands);

        case 1:
          if (!(
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_345 (insn, operands);

        case 2:
          if (!((
#line 13137 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13141 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_348 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return NULL;
      x13 = XEXP (x2, 0);
      operands[0] = x13;
      if (!flags_reg_operand (operands[0], E_VOIDmode))
        return NULL;
      operands[2] = x3;
      if (!compare_operator (operands[2], E_VOIDmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return NULL;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[3], E_QImode)
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || GET_MODE (x10) != E_QImode
                  || !
#line 15092 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_544 (insn, operands);

            case E_HImode:
              if (!nonimmediate_operand (operands[3], E_HImode)
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || GET_MODE (x10) != E_HImode
                  || !
#line 15092 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_545 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || GET_MODE (x10) != E_SImode
                  || !
#line 15092 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_546 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[3], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || GET_MODE (x10) != E_DImode
                  || !(
#line 15092 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_547 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern1236 (x1, 
NOT) != 0
              || !nonimmediate_operand (operands[3], E_SImode)
              || !register_operand (operands[1], E_DImode))
            return NULL;
          x11 = XEXP (x10, 0);
          x17 = XEXP (x11, 0);
          if (!rtx_equal_p (x17, operands[3])
              || !
#line 15119 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return NULL;
          return gen_split_548 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern581 (x1, 
CTZ, 
E_CCCmode) != 0
          || GET_MODE (x3) != E_CCCmode)
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x10 = XEXP (x7, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return NULL;
      switch (pattern1492 (x10))
        {
        case 0:
          if (!(
#line 20994 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 20996 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( (TARGET_AVOID_FALSE_DEP_FOR_BMI || TARGET_AVOID_FALSE_DEP_FOR_TZCNT)
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_871 (insn, operands);

        case 1:
          if (!((
#line 20994 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 20996 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( (TARGET_AVOID_FALSE_DEP_FOR_BMI || TARGET_AVOID_FALSE_DEP_FOR_TZCNT)
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_872 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      switch (pattern694 (x7))
        {
        case 0:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !general_operand (operands[1], E_DImode))
            return NULL;
          if (((
#line 14600 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14603 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return gen_split_497 (insn, operands);
          if (!((
#line 14687 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_504 (insn, operands);

        case 1:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || !general_operand (operands[1], E_TImode)
              || !((
#line 14600 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14603 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_498 (insn, operands);

        case 2:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode
              || !general_operand (operands[1], E_QImode)
              || !(
#line 14687 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_501 (insn, operands);

        case 3:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !general_operand (operands[1], E_HImode)
              || !(
#line 14687 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_502 (insn, operands);

        case 4:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !general_operand (operands[1], E_SImode)
              || !(
#line 14687 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14691 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_503 (insn, operands);

        case 5:
          if (GET_MODE (x4) != E_SFmode)
            return NULL;
          if (fp_register_operand (operands[0], E_SFmode)
              && fp_register_operand (operands[1], E_SFmode)
              && 
#line 14817 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return gen_split_512 (insn, operands);
          if (!general_reg_operand (operands[0], E_SFmode)
              || !general_reg_operand (operands[1], E_SFmode)
              || !
#line 14824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return NULL;
          return gen_split_518 (insn, operands);

        case 6:
          if (GET_MODE (x4) != E_DFmode)
            return NULL;
          if (fp_register_operand (operands[0], E_DFmode)
              && fp_register_operand (operands[1], E_DFmode)
              && 
#line 14817 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return gen_split_514 (insn, operands);
          if (!general_reg_operand (operands[0], E_DFmode)
              || !general_reg_operand (operands[1], E_DFmode)
              || !
#line 14824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return NULL;
          return gen_split_520 (insn, operands);

        case 7:
          if (GET_MODE (x4) != E_XFmode)
            return NULL;
          if (fp_register_operand (operands[0], E_XFmode)
              && fp_register_operand (operands[1], E_XFmode)
              && 
#line 14817 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return gen_split_516 (insn, operands);
          if (!general_reg_operand (operands[0], E_XFmode)
              || !general_reg_operand (operands[1], E_XFmode)
              || !
#line 14824 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return NULL;
          return gen_split_522 (insn, operands);

        default:
          return NULL;
        }

    case USE:
      if (pattern833 (x1) != 0
          || !(
#line 14748 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_SSE) && 
#line 14750 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_509 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      return split_34 (x1, insn);

    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          if (pattern242 (x1) != 0)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[1], E_SImode))
                return NULL;
              if (memory_operand (operands[0], E_DImode)
                  && register_operand (operands[2], E_SImode)
                  && (
#line 5003 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return gen_split_60 (insn, operands);
              if (!register_operand (operands[0], E_DImode)
                  || !scratch_operand (operands[2], E_SImode)
                  || !(
#line 5077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              return gen_split_62 (insn, operands);

            case E_TImode:
              if (GET_MODE (x4) != E_TImode
                  || !register_operand (operands[1], E_DImode))
                return NULL;
              if (memory_operand (operands[0], E_TImode)
                  && register_operand (operands[2], E_DImode)
                  && (
#line 5003 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_61 (insn, operands);
              if (!register_operand (operands[0], E_TImode)
                  || !scratch_operand (operands[2], E_DImode)
                  || !(
#line 5077 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_63 (insn, operands);

            default:
              return NULL;
            }

        case UNSIGNED_FLOAT:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          switch (pattern572 (x1))
            {
            case 0:
              if (!(
#line 6297 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC) && 
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_91 (insn, operands);

            case 1:
              if (!(
#line 6297 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC) && 
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_92 (insn, operands);

            case 2:
              if (!(
#line 6297 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC) && 
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_93 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          if (pattern585 (x1, 
MOD) != 0)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          x6 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 1);
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return NULL;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return NULL;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern388 (x1, 
E_SImode) != 0)
                    return NULL;
                  if (
#line 11380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()))
                    return gen_split_240 (insn, operands);
                  if (!
#line 11604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                    return NULL;
                  return gen_split_257 (insn, operands);

                case E_DImode:
                  if (pattern388 (x1, 
E_DImode) != 0)
                    return NULL;
                  if ((
#line 11380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_242 (insn, operands);
                  if (!(
#line 11604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_258 (insn, operands);

                case E_HImode:
                  if (pattern388 (x1, 
E_HImode) != 0
                      || !(
#line 11604 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                    return NULL;
                  return gen_split_256 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
              if (!const_int_operand (operands[2], E_SImode)
                  || pattern1495 (x1) != 0
                  || !(
#line 11907 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!optimize_function_for_size_p (cfun)) && 
#line 11909 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_270 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          if (pattern585 (x1, 
UMOD) != 0)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          x6 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 1);
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return NULL;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return NULL;
          switch (GET_CODE (operands[3]))
            {
            case REG:
            case SUBREG:
            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern388 (x1, 
E_SImode) != 0)
                    return NULL;
                  if (
#line 11380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()))
                    return gen_split_241 (insn, operands);
                  if (!
#line 11639 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                    return NULL;
                  return gen_split_260 (insn, operands);

                case E_DImode:
                  if (pattern388 (x1, 
E_DImode) != 0)
                    return NULL;
                  if ((
#line 11380 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_243 (insn, operands);
                  if (!(
#line 11639 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_261 (insn, operands);

                case E_HImode:
                  if (pattern388 (x1, 
E_HImode) != 0
                      || !(
#line 11639 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                    return NULL;
                  return gen_split_259 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern1496 (x1, 
E_SImode) != 0
                      || !(
#line 11660 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 11662 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_262 (insn, operands);

                case E_DImode:
                  if (pattern1496 (x1, 
E_DImode) != 0
                      || !((
#line 11660 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 11662 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_263 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return NULL;
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 17
              || GET_MODE (x5) != E_CCmode)
            return NULL;
          switch (pattern1054 (x1))
            {
            case 0:
              if (pattern1530 (x1, 
MOD) != 0)
                return NULL;
              if (
#line 11395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()))
                return gen_split_244 (insn, operands);
              if (!(
#line 11684 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11686 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_264 (insn, operands);

            case 1:
              x11 = XEXP (x6, 1);
              if (GET_CODE (x11) != UMOD)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[0] = x7;
              x8 = XEXP (x4, 0);
              x14 = XEXP (x8, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x15 = XEXP (x8, 1);
              operands[3] = x15;
              x10 = XEXP (x6, 0);
              operands[1] = x10;
              switch (pattern1621 (x11))
                {
                case 0:
                  if (
#line 11395 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()))
                    return gen_split_245 (insn, operands);
                  if (!(
#line 11719 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11721 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_265 (insn, operands);

                case 1:
                  if (!(
#line 11741 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 11744 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_266 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              if (pattern1531 (x1, 
DIV) != 0)
                return NULL;
              if (
#line 11411 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()))
                return gen_split_246 (insn, operands);
              if (!(
#line 11767 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11769 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_267 (insn, operands);

            case 3:
              x11 = XEXP (x6, 1);
              if (GET_CODE (x11) != UDIV)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              x14 = XEXP (x8, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x15 = XEXP (x8, 1);
              operands[3] = x15;
              x10 = XEXP (x6, 0);
              operands[0] = x10;
              switch (pattern1621 (x11))
                {
                case 0:
                  if (
#line 11411 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && TARGET_USE_8BIT_IDIV
   && TARGET_QIMODE_MATH
   && can_create_pseudo_p ()
   && !optimize_insn_for_size_p ()))
                    return gen_split_247 (insn, operands);
                  if (!(
#line 11803 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11805 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_268 (insn, operands);

                case 1:
                  if (!(
#line 11825 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 11828 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_269 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ABS:
          switch (pattern586 (x1))
            {
            case 0:
              if (!(
#line 14834 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 14836 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_524 (insn, operands);

            case 1:
              if (sse_reg_operand (operands[0], E_SFmode)
                  && sse_reg_operand (operands[1], E_SFmode)
                  && vector_operand (operands[2], E_V4SFmode)
                  && 
#line 14871 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
   && reload_completed))
                return gen_split_526 (insn, operands);
              if (fp_register_operand (operands[0], E_SFmode)
                  && fp_register_operand (operands[1], E_SFmode)
                  && 
#line 14891 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_530 (insn, operands);
              if (!general_reg_operand (operands[0], E_SFmode)
                  || !general_reg_operand (operands[1], E_SFmode)
                  || !
#line 14899 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_534 (insn, operands);

            case 2:
              if (sse_reg_operand (operands[0], E_DFmode)
                  && sse_reg_operand (operands[1], E_DFmode)
                  && vector_operand (operands[2], E_V2DFmode)
                  && 
#line 14871 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
   && reload_completed))
                return gen_split_528 (insn, operands);
              if (fp_register_operand (operands[0], E_DFmode)
                  && fp_register_operand (operands[1], E_DFmode)
                  && 
#line 14891 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_532 (insn, operands);
              if (!general_reg_operand (operands[0], E_DFmode)
                  || !general_reg_operand (operands[1], E_DFmode)
                  || !
#line 14899 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_536 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          switch (pattern586 (x1))
            {
            case 0:
              if (!(
#line 14834 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 14836 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_525 (insn, operands);

            case 1:
              if (sse_reg_operand (operands[0], E_SFmode)
                  && sse_reg_operand (operands[1], E_SFmode)
                  && vector_operand (operands[2], E_V4SFmode)
                  && 
#line 14871 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
   && reload_completed))
                return gen_split_527 (insn, operands);
              if (fp_register_operand (operands[0], E_SFmode)
                  && fp_register_operand (operands[1], E_SFmode)
                  && 
#line 14891 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_531 (insn, operands);
              if (!general_reg_operand (operands[0], E_SFmode)
                  || !general_reg_operand (operands[1], E_SFmode)
                  || !
#line 14899 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_535 (insn, operands);

            case 2:
              if (sse_reg_operand (operands[0], E_DFmode)
                  && sse_reg_operand (operands[1], E_DFmode)
                  && vector_operand (operands[2], E_V2DFmode)
                  && 
#line 14871 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
   && reload_completed))
                return gen_split_529 (insn, operands);
              if (fp_register_operand (operands[0], E_DFmode)
                  && fp_register_operand (operands[1], E_DFmode)
                  && 
#line 14891 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_533 (insn, operands);
              if (!general_reg_operand (operands[0], E_DFmode)
                  || !general_reg_operand (operands[1], E_DFmode)
                  || !
#line 14899 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_537 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          switch (pattern587 (x1))
            {
            case 0:
              if (!(
#line 18357 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              return gen_split_774 (insn, operands);

            case 1:
              if (!(
#line 18357 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_775 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern587 (x1))
            {
            case 0:
              if (!(
#line 18394 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              return gen_split_776 (insn, operands);

            case 1:
              if (!(
#line 18394 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_777 (insn, operands);

            default:
              return NULL;
            }

        case FFS:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || pattern711 (x1) != 0
              || !(
#line 20965 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_CMOVE) && 
#line 20967 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_870 (insn, operands);

        default:
          return NULL;
        }

    case 4:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != CLOBBER)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case UNSIGNED_FIX:
          switch (pattern385 (x1))
            {
            case 0:
              if (!(
#line 5911 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)) && 
#line 5914 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_74 (insn, operands);

            case 1:
              if (!(
#line 5911 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_SSE_MATH
   && optimize_function_for_speed_p (cfun)) && 
#line 5914 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_75 (insn, operands);

            default:
              return NULL;
            }

        case FLOAT:
          switch (pattern387 (x1))
            {
            case 0:
              if (!(
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)) && 
#line 6210 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_84 (insn, operands);

            case 1:
              if (!(
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)) && 
#line 6210 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_85 (insn, operands);

            case 2:
              if (!(
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)) && 
#line 6210 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_86 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          switch (pattern589 (x1, 
MOD))
            {
            case 0:
              if (!
#line 11429 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                return NULL;
              return gen_split_248 (insn, operands);

            case 1:
              if (!(
#line 11429 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_249 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          switch (pattern589 (x1, 
UMOD))
            {
            case 0:
              if (!
#line 11464 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed))
                return NULL;
              return gen_split_250 (insn, operands);

            case 1:
              if (!(
#line 11464 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_251 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (pattern382 (x3, 
32) != 0)
            return NULL;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 17
              || GET_MODE (x17) != E_CCmode)
            return NULL;
          x7 = XEXP (x2, 0);
          if (!register_operand (x7, E_DImode))
            return NULL;
          x8 = XEXP (x4, 0);
          if (GET_MODE (x8) != E_SImode)
            return NULL;
          x10 = XEXP (x6, 0);
          if (!register_operand (x10, E_SImode))
            return NULL;
          x11 = XEXP (x6, 1);
          if (GET_MODE (x11) != E_SImode)
            return NULL;
          switch (GET_CODE (x8))
            {
            case DIV:
              if (pattern1530 (x1, 
MOD) != 0
                  || !(
#line 11485 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11487 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_252 (insn, operands);

            case UDIV:
              if (pattern1530 (x1, 
UMOD) != 0
                  || !(
#line 11521 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11523 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_253 (insn, operands);

            case MOD:
              if (pattern1531 (x1, 
DIV) != 0
                  || !(
#line 11544 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11546 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_254 (insn, operands);

            case UMOD:
              if (pattern1531 (x1, 
UDIV) != 0
                  || !(
#line 11581 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 11583 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_255 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (pattern393 (x1) != 0)
            return NULL;
          return gen_split_916 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      x2 = XEXP (x1, 1);
      switch (pattern1290 (x2))
        {
        case 0:
          if (((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4119 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1316 (insn, operands);
          break;

        case 1:
          if ((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4119 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1317 (insn, operands);
          break;

        case 2:
          if (((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4119 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1318 (insn, operands);
          break;

        case 3:
          if (((
#line 4117 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4119 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1319 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 2);
      x4 = XVECEXP (x3, 0, 2);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1532 (x2, 
E_V32HImode, 
E_SImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V32HImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3226 (insn, operands);
                  if (const1_operand (operands[1], E_V32HImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3245 (insn, operands);
                }
              break;

            case E_V16HImode:
              if (pattern1532 (x2, 
E_V16HImode, 
E_HImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V16HImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3227 (insn, operands);
                  if (const1_operand (operands[1], E_V16HImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 764 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return gen_split_3246 (insn, operands);
                }
              break;

            case E_V8HImode:
              if (pattern1532 (x2, 
E_V8HImode, 
E_QImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V8HImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3228 (insn, operands);
                  if (const1_operand (operands[1], E_V8HImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 765 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return gen_split_3247 (insn, operands);
                }
              break;

            case E_V16SImode:
              if (pattern1532 (x2, 
E_V16SImode, 
E_HImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V16SImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3229 (insn, operands);
                  if (const1_operand (operands[1], E_V16SImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return gen_split_3248 (insn, operands);
                }
              break;

            case E_V8SImode:
              if (pattern1532 (x2, 
E_V8SImode, 
E_QImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V8SImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3230 (insn, operands);
                  if (const1_operand (operands[1], E_V8SImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return gen_split_3249 (insn, operands);
                }
              break;

            case E_V4SImode:
              if (pattern1532 (x2, 
E_V4SImode, 
E_QImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V4SImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3231 (insn, operands);
                  if (const1_operand (operands[1], E_V4SImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 766 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return gen_split_3250 (insn, operands);
                }
              break;

            case E_V8DImode:
              if (pattern1532 (x2, 
E_V8DImode, 
E_QImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V8DImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3232 (insn, operands);
                  if (const1_operand (operands[1], E_V8DImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return gen_split_3251 (insn, operands);
                }
              break;

            case E_V4DImode:
              if (pattern1532 (x2, 
E_V4DImode, 
E_QImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V4DImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3233 (insn, operands);
                  if (const1_operand (operands[1], E_V4DImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return gen_split_3252 (insn, operands);
                }
              break;

            case E_V2DImode:
              if (pattern1532 (x2, 
E_V2DImode, 
E_QImode) == 0)
                {
                  if (vector_all_ones_operand (operands[1], E_V2DImode)
                      && ((
#line 17170 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 17172 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3234 (insn, operands);
                  if (const1_operand (operands[1], E_V2DImode)
                      && (
#line 17381 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 767 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return gen_split_3253 (insn, operands);
                }
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  x4 = XVECEXP (x3, 0, 2);
  operands[5] = x4;
  switch (pattern1291 (x2))
    {
    case 0:
      if (vector_all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V16QImode)
              && nonimm_or_0_operand (operands[4], E_V16QImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3274 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V16QImode)
              && nonimmediate_operand (operands[4], E_V16QImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3296 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V16QImode)
          || !vector_all_ones_operand (operands[2], E_V16QImode)
          || !nonimmediate_operand (operands[3], E_V16QImode)
          || !nonimmediate_operand (operands[4], E_V16QImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3312 (insn, operands);

    case 1:
      if (vector_all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V8HImode)
              && nonimm_or_0_operand (operands[4], E_V8HImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3275 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V8HImode)
              && nonimmediate_operand (operands[4], E_V8HImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3298 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V8HImode)
          || !vector_all_ones_operand (operands[2], E_V8HImode)
          || !nonimmediate_operand (operands[3], E_V8HImode)
          || !nonimmediate_operand (operands[4], E_V8HImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3313 (insn, operands);

    case 2:
      if (vector_all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V4SImode)
              && nonimm_or_0_operand (operands[4], E_V4SImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3276 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V4SImode)
              && nonimmediate_operand (operands[4], E_V4SImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3300 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V4SImode)
          || !vector_all_ones_operand (operands[2], E_V4SImode)
          || !nonimmediate_operand (operands[3], E_V4SImode)
          || !nonimmediate_operand (operands[4], E_V4SImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3314 (insn, operands);

    case 3:
      if (vector_all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V2DImode)
              && nonimm_or_0_operand (operands[4], E_V2DImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3277 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V2DImode)
              && nonimmediate_operand (operands[4], E_V2DImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3302 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V2DImode)
          || !vector_all_ones_operand (operands[2], E_V2DImode)
          || !nonimmediate_operand (operands[3], E_V2DImode)
          || !nonimmediate_operand (operands[4], E_V2DImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3315 (insn, operands);

    case 4:
      if (vector_all_ones_operand (operands[1], E_V32QImode)
          && const0_operand (operands[2], E_V32QImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V32QImode)
              && nonimm_or_0_operand (operands[4], E_V32QImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3278 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V32QImode)
              && nonimmediate_operand (operands[4], E_V32QImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3304 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V32QImode)
          || !vector_all_ones_operand (operands[2], E_V32QImode)
          || !nonimmediate_operand (operands[3], E_V32QImode)
          || !nonimmediate_operand (operands[4], E_V32QImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3316 (insn, operands);

    case 5:
      if (vector_all_ones_operand (operands[1], E_V16HImode)
          && const0_operand (operands[2], E_V16HImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V16HImode)
              && nonimm_or_0_operand (operands[4], E_V16HImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3279 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V16HImode)
              && nonimmediate_operand (operands[4], E_V16HImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3306 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V16HImode)
          || !vector_all_ones_operand (operands[2], E_V16HImode)
          || !nonimmediate_operand (operands[3], E_V16HImode)
          || !nonimmediate_operand (operands[4], E_V16HImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3317 (insn, operands);

    case 6:
      if (vector_all_ones_operand (operands[1], E_V8SImode)
          && const0_operand (operands[2], E_V8SImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V8SImode)
              && nonimm_or_0_operand (operands[4], E_V8SImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3280 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V8SImode)
              && nonimmediate_operand (operands[4], E_V8SImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3308 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V8SImode)
          || !vector_all_ones_operand (operands[2], E_V8SImode)
          || !nonimmediate_operand (operands[3], E_V8SImode)
          || !nonimmediate_operand (operands[4], E_V8SImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3318 (insn, operands);

    case 7:
      if (vector_all_ones_operand (operands[1], E_V4DImode)
          && const0_operand (operands[2], E_V4DImode))
        {
          if (nonimm_or_0_operand (operands[3], E_V4DImode)
              && nonimm_or_0_operand (operands[4], E_V4DImode)
              && (
#line 17969 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* EQ is commutative.  */
   && ((INTVAL (operands[5]) == 0
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* NLE aka GT, 3 must be register.  */
       || (INTVAL (operands[5]) == 6
	   && !MEM_P (operands[3]))
	  /* LT, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 1
	   && !MEM_P (operands[4])))) && 
#line 17980 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3281 (insn, operands);
          if (nonimmediate_operand (operands[3], E_V4DImode)
              && nonimmediate_operand (operands[4], E_V4DImode)
              && (
#line 18133 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18136 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3310 (insn, operands);
        }
      if (!const0_operand (operands[1], E_V4DImode)
          || !vector_all_ones_operand (operands[2], E_V4DImode)
          || !nonimmediate_operand (operands[3], E_V4DImode)
          || !nonimmediate_operand (operands[4], E_V4DImode)
          || !(
#line 18159 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && (INTVAL (operands[5]) == 4
	  /* LE, 3 must be register.  */
       || INTVAL (operands[5]) == 2
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || INTVAL (operands[5]) == 5)) && 
#line 18167 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3319 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern532 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1660 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1687 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1714 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1741 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1768 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1795 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1822 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1849 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1876 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1903 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1930 (insn, operands);

            case 11:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1957 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1663 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1690 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1717 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1744 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1771 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1798 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1825 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1852 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1879 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1906 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1933 (insn, operands);

            case 23:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1960 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1666 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1693 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1720 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1747 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1774 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1801 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1828 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1855 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1882 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1909 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1936 (insn, operands);

            case 35:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1963 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2956 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2965 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2974 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2983 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2992 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3001 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3010 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3019 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3028 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3037 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3046 (insn, operands);

            case 47:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3055 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2308 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2335 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2362 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2389 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2416 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2443 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2470 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2497 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2524 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2551 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2578 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2605 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2311 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2338 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2365 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2392 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2419 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2446 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2473 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2500 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2527 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2554 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2581 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2608 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2314 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2341 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2368 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2395 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2422 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2449 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2476 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2503 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2530 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2557 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2584 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2611 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern532 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1669 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1696 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1723 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1750 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1777 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1804 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1831 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1858 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1885 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1912 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1939 (insn, operands);

            case 11:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1966 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1672 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1699 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1726 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1753 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1780 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1807 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1834 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1861 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1888 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1915 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1942 (insn, operands);

            case 23:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1969 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1675 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1702 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1729 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1756 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1783 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1810 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1837 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1864 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1891 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1918 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1945 (insn, operands);

            case 35:
              if (!(
#line 13790 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1972 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2959 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2968 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2977 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2986 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2995 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3004 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3013 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3022 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3031 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3040 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3049 (insn, operands);

            case 47:
              if (!(
#line 13959 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3058 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2317 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2344 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2371 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2398 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2425 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2452 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2479 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2506 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2533 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2560 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2587 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2614 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2320 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2347 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2374 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2401 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2428 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2455 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2482 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2509 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2536 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2563 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2590 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2617 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern534 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2323 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2350 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2377 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2404 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2431 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2458 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2485 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2512 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2539 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2566 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2593 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2620 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      return split_67 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern595 (x2))
        {
        case 0:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3360 (insn, operands);

        case 1:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3361 (insn, operands);

        case 2:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3362 (insn, operands);

        case 3:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3363 (insn, operands);

        case 4:
          if (!
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3364 (insn, operands);

        case 5:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3365 (insn, operands);

        case 6:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3366 (insn, operands);

        case 7:
          if (!
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3367 (insn, operands);

        case 8:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3368 (insn, operands);

        case 9:
          if (!
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3369 (insn, operands);

        case 10:
          if (!(
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3370 (insn, operands);

        case 11:
          if (!
#line 18661 "../../gcc-15.0.1-20250313/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3371 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 2)
    {
      res = peephole2_24 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (memory_operand (operands[1], E_SImode)
      && push_operand (operands[0], E_SImode)
      && 
#line 27780 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!(TARGET_PUSH_MEMORY || optimize_insn_for_size_p ())
   && !RTX_FRAME_RELATED_P (peep2_next_insn (0))))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_253 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2)
    return NULL;
  if (general_reg_operand (operands[1], E_SImode))
    {
      x3 = PATTERN (peep2_next_insn (1));
      if (pattern412 (x3, 
E_SImode) == 0
          && 
#line 27980 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (SImode != QImode
       || any_QIreg_operand (operands[1], QImode))))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_281 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (peep2_current_count >= 3)
    {
      res = peephole2_25 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (mmx_reg_operand (operands[1], E_VOIDmode)
      && mmx_reg_operand (operands[0], E_VOIDmode))
    {
      x3 = PATTERN (peep2_next_insn (1));
      if (pattern598 (x3) == 0
          && 
#line 27999 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_283 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (sse_reg_operand (operands[1], E_VOIDmode)
      && sse_reg_operand (operands[0], E_VOIDmode))
    {
      x3 = PATTERN (peep2_next_insn (1));
      if (pattern598 (x3) == 0
          && 
#line 28011 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   /* Punt if operands[1] is %[xy]mm16+ and AVX512BW is not enabled,
      as EVEX encoded vpadd[bw], vpmullw, vpmin[su][bw] and vpmax[su][bw]
      instructions require AVX512BW and AVX512VL, but with the original
      instructions it might require just AVX512VL.
      AVX512VL is implied from TARGET_HARD_REGNO_MODE_OK.  */
   && (!EXT_REX_SSE_REGNO_P (REGNO (operands[1]))
       || TARGET_AVX512BW
       || GET_MODE_SIZE (GET_MODE_INNER (GET_MODE (operands[0]))) > 2
       || logic_operator (operands[3], VOIDmode))))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_284 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (peep2_current_count >= 3
      && peep2_current_count >= 4)
    {
      if (memory_operand (operands[1], E_QImode))
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (pattern730 (x3, 
E_QImode) == 0
              && 
#line 28136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && REGNO (operands[4]) == REGNO (operands[0])
   && REGNO (operands[5]) == REGNO (operands[3])
   && peep2_reg_dead_p (4, operands[3])
   && ((REGNO (operands[0]) == REGNO (operands[3]))
       || peep2_reg_dead_p (2, operands[0]))
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3), CCGOCmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_301 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (memory_operand (operands[1], E_HImode))
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (pattern730 (x3, 
E_HImode) == 0
              && 
#line 28136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && REGNO (operands[4]) == REGNO (operands[0])
   && REGNO (operands[5]) == REGNO (operands[3])
   && peep2_reg_dead_p (4, operands[3])
   && ((REGNO (operands[0]) == REGNO (operands[3]))
       || peep2_reg_dead_p (2, operands[0]))
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3), CCGOCmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_302 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (memory_operand (operands[1], E_SImode))
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (pattern731 (x3, 
E_SImode) == 0
              && 
#line 28136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && REGNO (operands[4]) == REGNO (operands[0])
   && REGNO (operands[5]) == REGNO (operands[3])
   && peep2_reg_dead_p (4, operands[3])
   && ((REGNO (operands[0]) == REGNO (operands[3]))
       || peep2_reg_dead_p (2, operands[0]))
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (SImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3), CCGOCmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_303 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (memory_operand (operands[1], E_DImode))
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (pattern731 (x3, 
E_DImode) == 0
              && (
#line 28136 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && REGNO (operands[4]) == REGNO (operands[0])
   && REGNO (operands[5]) == REGNO (operands[3])
   && peep2_reg_dead_p (4, operands[3])
   && ((REGNO (operands[0]) == REGNO (operands[3]))
       || peep2_reg_dead_p (2, operands[0]))
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (DImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3), CCGOCmode)) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_304 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (!memory_operand (operands[1], E_VOIDmode)
      || !register_operand (operands[0], E_VOIDmode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!memory_operand (operands[2], E_VOIDmode))
    return NULL;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[0])
      || !
#line 28469 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!MEM_VOLATILE_P (operands[1])
   && !MEM_VOLATILE_P (operands[2])
   && rtx_equal_p (operands[1], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_331 (insn, operands);
}

 rtx_insn *
peephole2_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
      if (peep2_current_count < 2)
        return NULL;
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1349 (x4, 
E_SImode))
            {
            case 0:
              if (!
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_29 (insn, operands);

            case 1:
              if (!
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_31 (insn, operands);

            case 2:
              if (!(
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1164 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_33 (insn, operands);

            case 3:
              if (!
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_41 (insn, operands);

            case 4:
              if (!
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_43 (insn, operands);

            case 5:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_SImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_133 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_145 (insn, operands);

            case 6:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_SImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_134 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_146 (insn, operands);

            case 7:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_SImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_135 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_147 (insn, operands);

            case 8:
              if (!
#line 14331 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_153 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1349 (x4, 
E_DImode))
            {
            case 0:
              if (!(
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_30 (insn, operands);

            case 1:
              if (!(
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_32 (insn, operands);

            case 2:
              if (!(
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_34 (insn, operands);

            case 3:
              if (!(
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_42 (insn, operands);

            case 4:
              if (!(
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_44 (insn, operands);

            case 5:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_DImode)
                  && (
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_136 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_148 (insn, operands);

            case 6:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_DImode)
                  && (
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_137 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_149 (insn, operands);

            case 7:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (x86_64_general_operand (operands[1], E_DImode)
                  && (
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_138 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_150 (insn, operands);

            case 8:
              if (!(
#line 14331 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])) && 
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_154 (insn, operands);

            default:
              return NULL;
            }

        case E_QImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1350 (x4, 
E_QImode))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_127 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_139 (insn, operands);

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_128 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_140 (insn, operands);

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_129 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_141 (insn, operands);

            default:
              return NULL;
            }

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1350 (x4, 
E_HImode))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_130 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_142 (insn, operands);

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_131 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_143 (insn, operands);

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14037 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_132 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!rtx_equal_p (x7, operands[0]))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_144 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      if (pattern1065 (x3) != 0
          || !
#line 19081 "../../gcc-15.0.1-20250313/gcc/config/i386/i386.md"
(TARGET_64BIT && !TARGET_USE_BT))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_166 (insn, operands);

    default:
      return NULL;
    }
}
